Package: gCrisprTools
Type: Package
Title: Suite of Functions for Pooled Crispr Screen QC and Analysis
Version: 2.16.0
Date: 2021-08-23
Author: Russell Bainer, Dariusz Ratman, Steve Lianoglou, Peter Haverty
Authors@R: c(
    person("Russell", "Bainer", , "russ.bainer@gmail.com", c("aut", "cre")),
    person("Dariusz", "Ratman", , "ratmand@roche.com", "aut"),
    person("Peter", "Haverty", , "havertypm@gmail.com", "aut"),
    person("Steve", "Lianoglou", , "slianoglou@gmail.com", "aut"),
    person("Maze Therapeutics", role = c("fnd"), comment = "2019+"),
    person("Genentech, Inc.", role = c("fnd"), comment = "2014 - 2018"))
Maintainer: Russell Bainer <russ.bainer@gmail.com>
Description: Set of tools for evaluating pooled high-throughput screening experiments,
    typically employing CRISPR/Cas9 or shRNA expression cassettes. Contains methods for interrogating
    library and cassette behavior within an experiment, identifying differentially abundant
    cassettes, aggregating signals to identify candidate targets for empirical validation,
    hypothesis testing, and comprehensive reporting. Version 2.0 extends these applications to include 
    a variety of tools for contextualizing and integrating signals across many experiments, incorporates 
    extended signal enrichment methodologies via the "sparrow" package, and 
    streamlines many formal requirements to aid in interpretablity. 
License: Artistic-2.0
Imports: Biobase, limma, RobustRankAggreg, ggplot2,
        SummarizedExperiment, grid, rmarkdown, grDevices, graphics,
        methods, ComplexHeatmap, stats, utils, parallel
Suggests: edgeR, knitr, AnnotationDbi, org.Mm.eg.db, org.Hs.eg.db,
        BiocGenerics, markdown, RUnit, sparrow, msigdbr, fgsea
RoxygenNote: 7.2.1
VignetteBuilder: knitr
Encoding: UTF-8
biocViews: ImmunoOncology, CRISPR, PooledScreens, ExperimentalDesign,
        BiomedicalInformatics, CellBiology, FunctionalGenomics,
        Pharmacogenomics, Pharmacogenetics, SystemsBiology,
        DifferentialExpression, GeneSetEnrichment, Genetics,
        MultipleComparison, Normalization, Preprocessing,
        QualityControl, RNASeq, Regression, Software, Visualization
NeedsCompilation: no
Depends: R (>= 4.1)
Packaged: 2025-10-30 04:06:32 UTC; biocbuild
git_url: https://git.bioconductor.org/packages/gCrisprTools
git_branch: RELEASE_3_22
git_last_commit: 7b3b1fd
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29

# gCrisprTools
An R/Bioconductor package for the integrated analysis of pooled high-throughput CRISPR/Cas9 or shRNA screening experiments.

The initial version of this package was created at Genentech, inc. Current maintenance, development, and extension is 
supervised by the team at Maze Therapeutics.

See vignettes for examples of screen design, processing, analysis, and integration. 

##' @title Compute Directional P-values from eBayes Output
##' @description This function produces two sets of one-sided P-values derived from the moderated t-statistics produced by eBayes.  
##' @param fit An object of class MArrayLM containing, at minimum, a \code{df.residual} slot containing the appropriate degres of freedom for each test, and a \code{t} slot containing t statistics. 
##' @return A matrix object with two numeric columns, indicating the p-values quantifying the evidence for enrichment and depletion of each feature in the relevant model contrast.   
##' @param contrast.term If a fit object with multiple coefficients is passed in, a string indiating the coefficient of interest.   
##' @author Russell Bainer
##' @examples data('fit')
##' ct.DirectionalTests(fit)
##' @export
ct.DirectionalTests <- function(fit, contrast.term = NULL) {

    if (ncol(fit$coefficients) > 1) {
        if (is.null(contrast.term)) {
            stop("The fit object contains multiple coefficients. Please specify a contrast.term.")
        }
        fit <- ct.preprocessFit(fit, contrast.term)
    }

    if (!methods::is(fit, "MArrayLM")) {
        stop(deparse(substitute(fit)), " is not an MArrayLM object.")
    }
    if (!("t" %in% names(fit))) {
        stop("No t statistics are present in the specified object.")
    }
    if (!("df.total" %in% names(fit))) {
        stop("Cannot find the appropriate degrees of freedom (df.total) in the specified object.")
    }

    out <- cbind(pt(fit$t, df = fit$df.total[1], lower.tail = TRUE), pt(fit$t, df = fit$df.total[1], lower.tail = FALSE))
    colnames(out) <- c("Depletion.P", "Enrichment.P")
    row.names(out) <- row.names(fit$t)
    return(out)
}

##' @title Generate a Receiver-Operator Characteristic (ROC) Curve from a CRISPR screen
##' @description Given a set of targets of interest, this function generates a ROC curve and associated statistics from the results of
##' a CRISPR screen. Specifically, it orders the elements targeted in the screen in the specified direction, and then plots the cumulative
##' proportion of positive hits on the y-axis. The corresponding vectors and Area Under the Curve (AUC) statistic are returned as a list.
##'
##' Note that ranking statistics in CRISPR screens are (usually) permutation-based, and so some granularity is expected. This
##' function does a little extra work to ensure that hits are counted as soon as the requisite value of the ranking statistic is reached
##' regardless of where the gene is located within the block of equally-significant genes. Functionally, this means that the drawn curve is
##' somewhat anticonservative in cases where the gene ranks are not well differentiated.
##'
##' @param summaryDF A dataframe summarizing the results of the screen, returned by the function \code{\link{ct.generateResults}}.
##' @param target.list A character vector containing the names of the targets to be tested. Only targets contained in the \code{geneSymbol}
##' column of the provided \code{summaryDF} are considered.
##' @param direction Direction by which to order target signals (`enrich` or `deplete`).  
##' @param condense Logical indicating whether the returned x and y coordinates should be 'condensed', returning only the points at which
##' the detected proportion of \code{target.list} changes. If set to \code{FALSE}, the returned \code{x} and \code{y} vectors will explicitly
##' indicate the curve value at every position (useful for performing curve arithmetic downstream).
##' @param plot.it Logical value indicating whether to plot the curves.
##' @param ... Additional parameters for `ct.simpleResult()`
##' @return A list containing the the x and y coordinates of the curve, and the AUC statistic (invisibly).
##' @author Russell Bainer
##' @examples data('resultsDF')
##' data('essential.genes') #Note that this is an artificial example.
##' roc <- ct.ROC(resultsDF, essential.genes, direction = 'deplete')
##' str(roc)
##' @export
ct.ROC <- function(summaryDF, target.list, direction = c("enrich", "deplete"), condense = TRUE, plot.it = TRUE, ...) {

    direction <- match.arg(direction)
    stopifnot(is(plot.it, "logical"), is(condense, "logical"))

    if (!is.character(target.list)) {
        warning("Supplied target.list is not a character vector. Coercing.")
        target.list <- as.character(target.list)
    }

    # Infer whether Gsdb is ID or feature centric
    gids <- sum(target.list %in% summaryDF$geneID)
    gsids <- sum(target.list %in% summaryDF$geneSymbol)

    if (all(c(gsids, gids) == 0)) {
        stop("None of the features in the GeneSetDb are present in either the geneID or geneSymbol slots of the first provided result.")
    }

    collapse <- ifelse(gids > gsids, "geneID", "geneSymbol")
    simpleDF <- ct.simpleResult(summaryDF, collapse)

    present <- intersect(target.list, row.names(simpleDF))

    if (length(present) != length(target.list)) {
        if (length(present) < 1) {
            stop("None of the genes in the input list are present in the ", collapse, " column of the input data.frame.")
        }
        warning(length(present), " of ", length(target.list), " genes are present in the supplied results data.frame. Ignoring the remainder of the target.list.")
    }

    # Subset signals
    values <- simpleDF[simpleDF$direction == direction, ]
    values <- c(values$best.p[order(values$best.p, decreasing = FALSE)], rep(1, times = sum(!(simpleDF$direction %in% direction))))

    targvals <- vapply(target.list, function(x) {
        ifelse(simpleDF[x, "direction"] %in% direction, simpleDF[x, "best.p"], 1)
    }, numeric(1))

    out <- list()
    values.unique <- sort(unique(values), decreasing = FALSE)
    out$sensitivity <- unlist(lapply(values.unique, function(x) {
        sum(targvals <= x, na.rm = TRUE)/length(targvals)
    }))
    out$specificity <- unlist(lapply(values.unique, function(x) {
        (sum(values > x) - sum(targvals > x, na.rm = TRUE))/(nrow(simpleDF) - length(present))
    }))

    # Calculate the AUC/Enrichment

    out$AUC <- sum(unlist(lapply(2:length(out$sensitivity), function(x) {
        (out$sensitivity[(x)]) * (values.unique[x] - values.unique[(x - 1)])
    })))


    enrich <- switch(direction, enrich = ct.targetSetEnrichment(simpleDF, target.list, enrich = TRUE, collapse = collapse), deplete = ct.targetSetEnrichment(simpleDF, 
        target.list, enrich = FALSE, collapse = collapse))
    out <- c(out, enrich)

    # Plot it?
    if (plot.it) {
        plot(c(0, (1 - out$specificity), 1), c(0, out$sensitivity, 1), xlim = c(0, 1), ylim = c(0, 1), type = "l", ylab = "Sensitivity", xlab = "1-Specificity", main = paste("AUC:", 
            round(out$AUC, 3)), col = "blue", lwd = 3)
        abline(0, 1, lty = "dashed", col = "red")
    }

    if (!condense) {
        out <- .rocXY(out)
    }

    return(invisible(out))
}


.rocXY <- function(roc) {
    elements <- 0:max(roc$specificity)
    y <- lapply(elements, function(value) {
        pos <- length(roc$specificity[roc$specificity <= value])
        return(roc$sensitivity[pos])
    })

    return(list(x = elements, y = unlist(y), AUC = roc$AUC, targets = roc$targets, P.values = roc$P.values, Q.values = roc$Q.values))
}

## This document contains functions for the RRAa algorithm.

##' @title Checks and Possibly Sets the Number of Cores to be Used in Parallel Processing
##' @description This function determines the number of cores that the user is expecting to 
##' use during parallel processing operations, and if absent, sets the \code{mc.cores} option
##' to the maximum value. Users who do not wish to use all available cores during parallel 
##' processing should do so by invoking \code{options()} from the command line prior to analysis. 
##' 
##' @return Nothing, but invisibly sets \code{options(mc.cores)} if currently \code{NULL}. 
##' @keywords internal
##' @author Russell Bainer, Pete Haverty
ct.numcores <- function() {
    .Deprecated()
    if (.Platform$OS.type == "windows") {
        options(mc.cores = 1)
    }
    if (is.null(getOption("mc.cores"))) {
        numcores = detectCores()
        options(mc.cores = numcores)
    }
    invisible()
}

##' @title Aggregation of P-value Ranks using a Beta Distribution and Alpha Cutoff  
##' @description This function calculates an alpha-modified rho statistic from a set of normalized ranks by comparing them to a uniform distribution. 
##' Specifically, the ranks are ordered and p-values calculated at each position in the ordered vector by comparison to a Beta distribution. The rho value 
##' returned is the smallest p-value identified in this way across all scores. Should not be used by end users.
##' @param p.in A single column matrix of rank scores, with row.names indicating the gRNA labels.
##' @return A numeric rho value corresponding to the minimum rank order P. 
##' @author Russell Bainer, modified from code from the \code{RobustRankAggreg} package. 
##' 
##' Citation: 
##' Kolde, R. et al, Bioinformatics. 2012 Feb 15;28(4):573-80. doi: 10.1093/bioinformatics/btr709.
##' @keywords internal
##' @examples
##' testp <- runif(20)
##'
##' ct.alphaBeta(testp)  
##' @export
ct.alphaBeta <- function(p.in) {
    n <- length(p.in)
    return(min(pbeta(p.in, seq_len(n), n - seq_len(n) + 1)))
}


##' @title Aggregation of P-value Ranks using a Beta Distribution and Alpha Cutoff  
##' @description This function is called internally as a single instance of the beta aggregation step in RRAa. Users should not interact with it directly. 
##' The expected input is a set of rank statistics, and a paired \code{alpha} argument defining which values to consider in downstream analyses (see below). 
##' 
##' As of gCrisprTools 2.0, this function does not consider `row.names` associated with the provided values, and the p-values are expected to be provided 
##' in register with the provided `g.key` object.
##' @param p A single column matrix of rank statistics. 
##' @param g.key data.frame with guide and gene names
##' @param shuffle Logical indicating whether to shuffle the rank statistics prior to calculating the rho statistics (useful for permutation).
##' @return Nothing, or a named list of target-level P-values, which are treated as a rho statistic in the permutation step. 
##' @author Russell Bainer
##' @keywords internal
##' @examples 
##' data('fit')
##' data('ann')
##' geneScores <- ct.RRAalpha(fit$p.value, ann, shuffle = FALSE)
##' @export
ct.RRAalpha <- function(p, g.key, shuffle = FALSE) {
    stopifnot(identical(nrow(p), nrow(g.key)))

    if (shuffle) {
        p <- sample(p, nrow(p))
    }

    symbol = g.key$geneSymbol
    ord = order(symbol, p)
    p.collect <- split(p[ord], symbol[ord])
    rhoscores <- vapply(p.collect, ct.alphaBeta, numeric(1))
    return(rhoscores)
}

##' @title gRNA signal aggregation via RRAa
##' @description This is a wrapper function implementing the RRAalpha p-value aggregation algorithm. Takes in a set of gRNA rank scores (formatted as a single-column 
##' numeric matrix with row.names indicating the guide names) and a list object of gRNA annotations (names are the gene targets, and each element of the list contains 
##' a vector of the corresponding guide names). The rank scores are converted to gene-level statistics that are thenm transformed into empirical p-values by permutation. 
##' @param p A single column matrix of ranking scores, with row.names indicating the gRNA labels
##' @param g.key An annotation data frame of gRNAs, minimally containing a factorized 'geneSymbol' column indicating the target names. This is typically generated by 
##' calling the \code{ct.buildKeyFromAnnotation()} function.  
##' @param permute Number of permutations to be used during empirical p-value estimation.
##' @param permutation.seed numeric seed for permutation reproducibility.
##'   Default: \code{NULL} means to not set any seed.
##' @param multi.core Deprecated, does nothing
##' @return A named list of target-level empirical P-values. 
##' @author Russell Bainer
##' @keywords internal
##' @examples 
##' data('fit')
##' data('ann')
##' genePvals <- ct.RRAaPvals(fit$p.value, ann, permute = 100)
##' @export
ct.RRAaPvals <- function(p, g.key, permute, permutation.seed = NULL, multi.core = NULL) {

    ## Input checks
    if (!is.null(multi.core)) {
        warning("The multi.core argument of ct.RRAaPvals is deprecated. This function is now sufficiently fast on one core.")
    }
    if (!(is.matrix(p) && ncol(p) == 1)) {
        stop("P-values should be input as a single-column matrix with row names contained in the gs.list")
    }
    if (ncol(p) > 1) {
        p = p[, 1, drop = FALSE]
        warning("Multiple columns are present in the p-value matrix. Using the first column: ", colnames(p))
    }
    if (!is.data.frame(g.key)) {
        stop("The annotation provided must be a data frame.")
    }
    if (!("geneSymbol" %in% names(g.key))) {
        stop("The provided annotation does not contain a geneSymbol column.")
    }
    if (!identical(nrow(g.key), nrow(p))) {
        stop("P-values and gene keys do not have the same number of rows!")
    }

    if (anyNA(p)) {
        notna = !is.na(p)
        p = p[notna]
        g.key = g.key[notna, ]
    }

    is.null(permutation.seed) || is.numeric(permutation.seed) || stop("'permutation.seed' must be numeric or NULL.")
    set.seed(permutation.seed)  # default NULL will have no effect

    ## Everything apparently ok, generate P-values.
    obs <- ct.RRAalpha(p, g.key)

    message("Permuting ", permute, " times, this may take a minute ...")

    n.guides = table(g.key$geneSymbol)
    n.guides.table = sort.int(unique(n.guides))
    rho.nulls = lapply(n.guides.table, ct.makeRhoNull, p, permute)
    names(rho.nulls) = as.character(n.guides.table)
    stopifnot(identical(names(n.guides), names(obs)))
    out = unlist(mapply(obs, as.character(n.guides), FUN = function(x, y) {
        mean(rho.nulls[[y]] <= x)
    }, SIMPLIFY = FALSE), recursive = FALSE)

    return(out)
}

##' Make null distribution for RRAalpha tests
##'
##' Makes random distribution of Rho value by taking nperm random samples of n rank stats, p.
##' @param n single integer, number of guides per gene
##' @param p numeric vector of rank statistics
##' @param nperm single integer, how many random samples to take.
##' @return numeric vector of Rho values
##' @examples 
##' ct.makeRhoNull(3, 1:9, 5)
##' @export 
ct.makeRhoNull <- function(n, p, nperm) {
    message("Making Rho null distribution for", n, "guides per gene.")
    vapply(seq_len(nperm), function(i) {
        p.in = sort.int(sample(p, n, replace = FALSE))
        ct.alphaBeta(p.in)
    }, numeric(1))
}

##' @title Create Batches of Null Permutations for a Crispr Screen
##' @description This is a wrapper function to partition batches of calls to \code{ct.RRAalpha()} for multicore processing. 
##' It is called internally as a single instance of the beta aggregation step in RRAa. Users should not interact with it directly. 
##' @param p A single column matrix of rank statistics, with row.names indicating the gRNA labels. 
##' @param g.key data.frame with guide and gene names
##' @param result.environment The target environment containing the quasi-global variables incremented during the permutations in the child functions. 
##' @param batch.size Number of iterations to deploy to each daughter process. 
##' @param permutation.seed numeric seed for permutation reproducibility. Default is \code{NULL}, in which case no seed is set.
##' @return An integer vector indicating the number of iterations in which each gene's score was better than those indicated in \code{result.environment$obs}. 
##' @keywords internal
##' @author Russell Bainer
ct.RRAalphaBatch <- function(p, g.key, result.environment, batch.size = 100, permutation.seed = NULL) {

    .Deprecated("ct.makeRhoNull", msg = "Constructing null distributions is now fast, so ct.RRAalphaBatch is unnecessary.")
    ## make a batch environment
    batch.env <- new.env()
    batch.env$obs <- result.environment$obs
    batch.env$target.positive.iterations <- rep.int(0, result.environment$ngenes)
    ## run permutations and increment as needed
    set.seed(permutation.seed)  # default NULL will have no effect

    invisible(replicate(batch.size, ct.RRAalpha(p, g.key, shuffle = TRUE)))

    return(batch.env$target.positive.iterations)
}

##' @title Generate a Figure Summarizing Overall Signal for One or More Targets
##' @description Given one or more targets of interest, this function generates a summary image contextualizing the 
##' corresponding signals within the provided contrast. This takes the form of an annotated ranking 
##' curve of target-level signals, supplemented with horizontal Q-value cutoffs and an inset volcano plot of gRNA 
##' behavior. 
##' 
##' Limited annotation is provided for the specified targets using the following logic: 
##' 
##' - If a character vector is provided, up to five targets are annotated; longer lists are highlighted without specifying individual elements.  
##' - If a list is provided, the `names` element is used as the annotation. This is similarly constrained to a total of 5 annotated elements. 
##' 
##' @param summaryDF A dataframe summarizing the results of the screen, returned by the function \code{\link{ct.generateResults}}. 
##' @param targets A list or character vector containing the names of the targets to be displayed. Only targets contained in the column 
##' specified by the `collapse` parameter to `ct.simpleResult()` will be displayed; default is `geneSymbol`. Plotting priority (e.g., 
##' the points to plot last in the case of overlapping signals) is given to earlier elements in the list. 
##' @param callout Logical indicating whether lines should be plotted indicating individual gene sets to augment the point highlighting.
##' @param ... Additional optional arguments to `ct.simpleResult()`
##' @return A summary plot on the current device. 
##' @author Russell Bainer
##' @examples data('resultsDF')
##' ct.signalSummary(resultsDF, list('CandidateA' = 'Target229', 'Pathway3' = resultsDF$geneSymbol[c(42,116,1138,5508)]))
##' @export
ct.signalSummary <-
  function(summaryDF,
           targets,
           callout = FALSE, 
           ...) {

    #Check the input: 
    ct.resultCheck(summaryDF)
    simpleDF <- ct.simpleResult(summaryDF, ...)

    if(!is.list(targets)){
      targets <- as.list(targets)
      names(targets) <- targets
    }
    
    if(length(targets) > 5){
      stop('Too many targets specified; suppressing annotation.')
      targets <- list(unique(unlist(targets)))
    }
    targets <- rev(targets)
    
    bad <- setdiff(unlist(targets), row.names(simpleDF))
    if(length(bad) > 0){
      stop(paste0('Cannot find the following supplied targets in the geneSymbol column of the supplied DF: ', paste(bad, collapse = ', ')))
    }
    id <- ifelse(unlist(targets)[1] %in% simpleDF$geneID, 'geneID', 'geneSymbol')
    
    #Prep data
    top <- simpleDF[simpleDF$direction == 'enrich',]
    top <- top[order(top$best.p, top$Rho_enrich, decreasing = FALSE),]
    bot <- simpleDF[simpleDF$direction == 'deplete',]
    bot <- bot[order(bot$best.p, bot$Rho_deplete, decreasing = TRUE),]
    simpleDF <- rbind(top, bot)

    gwp <- ct.softLog(simpleDF$best.p)
    gwp <- gwp*vapply(simpleDF$direction, function(x){ifelse(x == 'enrich', 1, -1)}, numeric(1))
    names(gwp) <- row.names(simpleDF)

    exes <- (seq_len(length(gwp)))/length(gwp)
    
    #qcut <- c(min(gwp[(simpleDF$direction == 'enrich') & (simpleDF$best.q <= 0.1)]), min(gwp[(simpleDF$direction == 'deplete') & (simpleDF$best.q <= 0.1)]))

    
    #Compose Plot
    plot(exes, gwp, 
         ylab = 'Target -log10 P', xaxt = 'n', xlab = 'Signal Rank, Most Enriched to Most Depleted', 
         pch = 19, cex = 0.5, col = rgb(14/255,41/255,56/255))
    #inset
    maxval <- max(gwp)
    glfc <- summaryDF$`gRNA Log2 Fold Change`
    gp <- rowMax(cbind(-log10(summaryDF$`gRNA Enrichment P`), -log10(summaryDF$`gRNA Depletion P`)))
    
    
    inset.x <- ((0.29/(max(glfc) - min(glfc))) * (glfc - min(glfc))) + 0.7
    inset.y <- ((((maxval - 0.1) - ((maxval)/2))/(max(gp) - min(gp))) * (gp - min(gp))) + ((maxval + 0.05)/2)
    inset.zero <- inset.x[which(abs(glfc) == min(abs(glfc), na.rm = TRUE))][1]
    
    polygon(x = c(0.7,1,1,0.7), y = (rep(maxval, 4) - rep(c(maxval/2, 0), each = 2)), col = 'white') 
    lines(rep(inset.zero, 2), c(maxval/2, maxval), lty = 2, col = 'lightgrey')
    points(inset.x, inset.y, pch = 19, cex = 0.2, col= rgb(14/255,41/255,56/255))
    graphics::text(0.85, maxval, 'gRNA', adj = c(0.5,1.5), cex = 1)
    graphics::text(0.85, (maxval/2), 'Log2 Fold Change', adj = c(0.5, 1.5), cex = 0.7)
    graphics::text(0.7, 3*(maxval/4), '-log10P', srt = 90, adj = c(0.7, -0.5), cex = 0.7)
    
    #add annotation
    t.col <- c(rgb(218/255, 111/255, 90/255), 
               'white', 
               rgb(111/255, 130/255, 138/255), 
               rgb(100/255, 190/255, 203/255),
               rgb(127/255, 47/255, 105/255))
   
    #Optionally add annotations
    if(length(targets) <= 5){ 
      ylocs <- rev(seq((maxval * 0.95), (maxval/2), length.out = 5)[seq_len(length(targets))]) 
      ybuff <- (maxval/20)/2
      
      invisible(
        lapply(seq_len(length(targets)),
               function(x){
                 selected <- intersect(row.names(simpleDF),targets[[x]])
                 gw.ranks <- vapply(selected, 
                                    #function(x){grep(x, summaryDF$geneSymbol[genewise], fixed = TRUE)},
                                    function(y){which(row.names(simpleDF) %in% y)},
                                    integer(1))
                 
                 if(callout){
                   segments(exes[gw.ranks], gwp[gw.ranks], 0.3, ylocs[x], col = rgb(78/255, 78/255, 76/255, 0.4))
                 }
                 graphics::text(0.3, ylocs[x], names(targets)[x], pos = 4)
                 points(0.3, ylocs[x], pch = 22, cex = 2, bg = t.col[x])
               })
      )
    }
    
    #Highlight Points
    invisible(lapply(seq_len(length(targets)), 
                     function(x){
                       picked <- intersect(row.names(simpleDF),targets[[x]])
                       gw.ranks <- vapply(picked, 
                                          #function(x){grep(x, summaryDF$geneSymbol[genewise], fixed = TRUE)},
                                          function(y){which(row.names(simpleDF) %in% y)},
                                          integer(1))
                       reagents <- which(summaryDF[,id] %in% picked)
                       points(inset.x[reagents], inset.y[reagents], col = rgb(14/255,41/255,56/255), bg = t.col[x], pch = 21, cex = 0.7, lwd = 1.2)
                       points(exes[gw.ranks], gwp[gw.ranks], pch = 21, bg = t.col[x], cex = 1.2, lwd = 1.2)
                     }))
  }


##' @title Visualize Signal Across A List of Contrasts 
##' @description Given a list of provided results `data.frame`s summarizing a series of contrasts from one or more pooled screens, 
##' this function visualizes their respective signals as a series of stacked barcharts. Enriched signals 
##' are represented in the positive direction, and depleted signals are represented in the negative direction.  Note that the 
##' provided contrast results are not regularized by this function.
##' 
##' This function may be used to compare signals across different screen contrasts, or to compare signals within interesting 
##' subsets of targets ascertained within a single experiment.  
##' 
##' @param dflist A named list of `data.frame`s summarizing the results of one or more screen contrasts, returned by the function 
##' \code{\link{ct.generateResults}}. 
##' @param background Logical indicating whether to represent the nonsignificant hits in the barchart.  
##' @param statistic Should cutoffs be calculated based on FDR (`best.q`) or P-value (`best.p`)?
##' @param ... Other parameters to lower functions, especially `ct.simpleResult()`
##' @return A summary plot on the current device. Invisibly, the data.frame tallying signals at various thresholds. 
##' @author Russell Bainer
##' @examples data('resultsDF')
##' ct.contrastBarchart(list('FirstResult' = resultsDF, 'SecondResult' = resultsDF))
##' ct.contrastBarchart(list('FirstResult' = resultsDF, 'SecondResult' = resultsDF), background = FALSE)
##' ct.contrastBarchart(list('FirstResult' = resultsDF[1:1000,], 'SecondResult' = resultsDF))
##' @export
ct.contrastBarchart <- function(dflist, background = TRUE, statistic = c('best.q', 'best.p'), ...){

  #Check input
  stopifnot(is(background, 'logical'))
  statistic <- match.arg(statistic)

  #listify results as needed
  if((!is(dflist, 'list'))){
    if(ct.resultCheck(dflist)){
      dflist <- list('result' = dflist)
    }
  }
  dflist <- lapply(dflist, 
                   function(x){ct.simpleResult(x, ...)})
  
  colors <- c('grey', colorRampPalette(c('white', 'orange', 'red', 'darkred'))(5)[2:5])
  names(colors) <- c('N/S', '< 0.1', '< 0.01', '< 0.001', '< 0.00001')
  
  #Collect values
  vals <- vapply(dflist, 
                 function(x){
                   c(sum((x$direction == 'enrich')), 
                     sum((x[,statistic] <= 0.1) & (x$direction == 'enrich')),
                     sum((x[,statistic] <= 0.01) & (x$direction == 'enrich')), 
                     sum((x[,statistic] <= 0.001) & (x$direction == 'enrich')), 
                     sum((x[,statistic] <= 0.00001) & (x$direction == 'enrich')), 
                     -sum((x[,statistic] <= 0.00001) & (x$direction == 'deplete')), 
                     -sum((x[,statistic] <= 0.001) & (x$direction == 'deplete')), 
                     -sum((x[,statistic] <= 0.01) & (x$direction == 'deplete')),
                     -sum((x[,statistic] <= 0.1) & (x$direction == 'deplete')),
                     -sum((x$direction == 'deplete'))) 
                   }, numeric(10))
  
  row.names(vals) <- paste0(rep(c('enrich', 'deplete'), each = 5), 
                            '_p', 
                            c('Other', '1', '01', '001', '00001', '00001', '001', '01', '1', 'Other'))
  
  if(!background){
    vals <- vals[2:9,]
    colors <- colors[2:5]
  }
  
  plot(NA, xlim = range(vals), ylim = c(0,(length(dflist))), 
       yaxt = "n",  
       ylab = '', xlab = 'Significant Target Signals', 
       main = switch(statistic, 'best.p' = 'Target P Values', 'best.q' = 'Target Q Values'))

  for(j in seq_along(dflist)){
    for(k in seq_len(5)){
     polygon(x = c(vals[k,j], vals[k,j], vals[(nrow(vals) - k + 1),j], vals[(nrow(vals) - k + 1),j]), 
             y = c((j-0.8), (j-0.2), (j-0.2), (j - 0.8)), col = colors[k])
    }
    text(range(vals)[1], j, names(dflist)[j], adj = c(0,1))
  }
  abline(v = 0, lty = 2, col = 'black')
  legend('bottom', names(colors), fill = colors, horiz = TRUE, cex = 0.7)
  text(range(vals)[1], 0, 'Depleted', col = 'grey', adj = c(0,0))
  text(range(vals)[2], 0, 'Enriched', col = 'grey', adj = c(1,0))
  
  return(invisible(vals))
}
  

##' @title Visualization of Raw gRNA Count Densities
##' @description This function plots the per-sample densities of raw gRNA read counts on the log10 scale. The curve colors are assigned based on a user-
##' specified sampleKey. This function is primarily useful to determine whether libraries are undersequenced (low mean raw gRNA counts), 
##' contaminated (many low-abundance gRNAs present), or if PCR artifacts may be present (subset of extremely abundant guides, multiple gRNA distribution modes). In most 
##' well-executed experiments the majority of gRNAs will form a tight distribution around some reasonably high average read count (hundreds of reads), 
##' at least among the control samples. Excessively low raw count values can compromise normalization steps and subsequent estimation of gRNA levels, especially 
##' in screens in which most gRNAs have minimal effects on cell viability. 
##' @param eset An ExpressionSet object containing, at minimum, count data accessible by exprs() and some phenoData. 
##' @param sampleKey A sample key, supplied as a (possibly ordered) factor linking the samples to experimental 
##' variables. The \code{names} attribute should exactly match those present in \code{eset}, and the control set 
##' is assumed to be the first \code{level}.
##' @param lib.size Optional named vector of library sizes (total reads within the library) to enable normalization
##' @return A density plot as specified on the default device. 
##' @author Russell Bainer
##' @examples 
##' data('es')
##' 
##' #Build the sample key
##' library(Biobase)
##' sk <- relevel(as.factor(pData(es)$TREATMENT_NAME), 'ControlReference')
##' names(sk) <- row.names(pData(es))
##' 
##' ct.rawCountDensities(es, sk)
##' @export
ct.rawCountDensities <- function(eset, sampleKey = NULL, lib.size = NULL) {

    if (!methods::is(eset, "ExpressionSet")) {
        stop(deparse(substitute(eset)), "is not an ExpressionSet.")
    }

    if (is.null(sampleKey)) {
        sampleKey <- colnames(eset)
        names(sampleKey) <- sampleKey
    } 
    
    sampleKey <- ct.keyCheck(sampleKey, eset)
    sampleKey <- sampleKey[order(sampleKey)]
    
    counts <- exprs(eset)
    if (!is.null(lib.size)) {
        stopifnot(setequal(names(lib.size), colnames(counts)), all(is.numeric(lib.size)))
        counts <- t(t(counts)/(lib.size[colnames(counts)]/1e+06))
        message("Valid lib.sizes provided. Results will be in CPM.")
    }
    e.dat <- log10(counts + 1)


    densities <- apply(e.dat, 2, density)

    y <- c(0, max(unlist(lapply(densities, function(dens) {
        max(dens$y)
    }))))
    x <- c(0, max(ceiling(unlist(lapply(densities, function(dens) {
        max(dens$x)
    })))))
    plot(x[1], y[1], xlim = x, ylim = y, xlab = "gRNA Read Counts (Log10 Scale)", ylab = "Density", pch = NA, main = "Raw gRNA Count Density", xaxt = "n")
    axis(1, at = 0:x[2], labels = 10^(0:x[2]))

    # Set up colors for the factor
    colors <- colorRampPalette(c("blue", "red"), alpha = TRUE)(length(levels(sampleKey)))
    colors <- gsub("FF$", "99", colors, perl = TRUE)

    invisible(lapply(seq_len(length(densities)), function(x) {
        lines(densities[[x]], col = colors[as.numeric(sampleKey[colnames(e.dat)[x]])])
    }))
    legend("topright", legend = levels(sampleKey), fill = colors)

}

##' @title Calculate results of a crispr screen from a contrast
##' @description This is a wrapper function that enables direct generation of target-level p-values from a crispr screen.  
##' @param fit An object of class \code{MArrayLM} containing, at minimum, a \code{t} slot with t-statistics from the comparison, 
##' a \code{df.residual} slot with the corresponding residuals fo the model fits, and an \code{Amean} slot with the respective mean abundances. 
##' @param annotation An annotation file for the experiment. gRNAs are annotated by 
##' row, and must minimally contain columns \code{geneSymbol} and \code{geneID}.
##' @param RRAalphaCutoff A cutoff to use when defining gRNAs with significantly altered abundance during the RRAa aggregation step, which may be specified
##' as a single numeric value on the unit interval or as a logical vector. When supplied as a logical vector (of length equal to \code{nrows(fit)}), 
##' this parameter directly indicates the gRNAs to include during RRAa aggregation. Otherwise, if \code{scoring} is set 
##' to \code{pvalue} or \code{combined}, this parameter is interpreted as the maximum nominal p-value required to consider a gRNA's abundance meaningfully 
##' altered during the aggregation step. If \code{scoring} is \code{fc}, this parameter is interpreted as the proportion of the list to be considered 
##' meaningfully altered in the experiment (e.g., if \code{RRAalphaCutoff} is set to 0.05, only consider the rankings of the 5% most upregulated 
##' (or downregulated) gRNAs for the purposes of RRAa calculations).
##' 
##' Note that this function uses directional tests to identify enriched or depleted targets, and when RRAalphaCutoff is 
##' provided as a logical vector the interpretation of the various aggregation statistics is going to be dependent on the specific criteria 
##' used to select reagents for inclusion. 
##' 
##' @param permutations The number of permutations to use during the RRAa aggregation step.
##' @param contrast.term If a fit object with multiple coefficients is passed in, a string indiating the coefficient of interest.   
##' @param scoring The gRNA ranking method to use in RRAa aggregation. May take one of three values: \code{pvalue}, \code{fc},
##' or '\code{combined}'. \code{pvalue} indicates that the gRNA ranking statistic should be created from the (one-sided) p-values in the 
##' fit object. \code{fc} indicates that the ranks of the gRNA coefficients should be used instead, and \code{combined} indicates that 
##' that the coefficents should be used as the ranking statistic but gRNAs are discarded in the aggregation step based on the corresponding nominal 
##' p-value in the fit object. 
##' @param alt.annotation Libraries targeting ambiguous biological elements (e.g., alternative promoters to a gene where the boundaries between
##' elelments is contested) may contain reagents that are plausibly annotated to a finite set of possible targets. To accomodate this, users may 
##' supply an alternative reagent annotation in the form of a named list of vectors, where each list element corresponds something coercible to a to
##' a character vector of associated targets that will ultimately be assembled into the `geneSymbol` column of the `resultsDF` object. Each of these 
##' character vectors should be named identically to a row of the supplied fit object (e.g., the `row.names`). It is assumed that the `geneID` values 
##' are assigned unambiguously to the reagents, and are passed through directly. 
##' @param permutation.seed numeric seed for permutation reproducibility. 
##'   Default: \code{NULL} means to not set any seed. This argument is passed
##'   through to \code{\link{ct.RRAaPvals}}.
##' @return A dataframe containing gRNA-level and target-level statistics. In addition to the information present in the supplied annotation object, 
##' the returned object indicates P-values and Q-values for the depletion and enrichment of each gRNA and associated target, the median log2 fold 
##' change estimate among all gRNAs associated with the target, and Rho statistics that are calculated internally by the RRAa algorithm that may be 
##' useful in ranking targets that are considered significant at a given alpha or false discovery threshold. 
##' @author Russell Bainer
##' @examples data('fit')
##' data('ann')
##' output <- ct.generateResults(fit, ann, permutations = 10)
##' head(output)
##' @return A `resultsDF` formatted dataframe containing gene-level statistics.
##' @examples
##'   p = seq(0, 1, length.out=20)
##'   fc = seq(-3, 3, length.out=20)
##'   fc[2] = NA
##'   fc[3] = -20
##'   stats = data.frame(
##'     Depletion.P=p,
##'     Enrichment.P=rev(p),
##'     fc=fc
##'   )
##'   ct.applyAlpha(stats,scoring='combined')
##' @export 
ct.generateResults <- function(fit, annotation, RRAalphaCutoff = 0.1, permutations = 1000, contrast.term = NULL, scoring = c("combined", "pvalue", "fc"), alt.annotation = NULL, 
    permutation.seed = NULL) {

    ## figure out the scoring method
    scoring <- match.arg(scoring)

    # make sure that the Fit has P-values.
    if (!("p.value" %in% names(fit))) {
        stop("Evidence for differential gRNA abundance (p-values) has not been estimated for the provided fit object. Please do so using eBayes(), treat(), or similar method.")
    }

    # Select relevant contrast
    if (ncol(fit$coefficients) > 1) {
        if (is.null(contrast.term)) {
            stop("The fit object contains multiple coefficients. Please specify a contrast.term.")
        }
        fit <- ct.preprocessFit(fit, contrast.term)
    }

    # Apply directional test to the model estimates
    pvals <- ct.DirectionalTests(fit)

    # prep the annotation
    key <- ct.prepareAnnotation(annotation, fit, throw.error = FALSE)
    if (!("ID" %in% names(key))) {
        key$ID <- row.names(key)
    }

    # If provided, check the alt.annotation and expand the fit/key as needed.
    if (!is.null(alt.annotation)) {
        stopifnot(is.list(alt.annotation), all(names(alt.annotation) %in% row.names(fit)))

        # Expand the annotation object
        key <- ct.expandAnnotation(key, alt.annotation)
    }

    ## Prepare the ranking values
    rra.input <- ct.applyAlpha(cbind(pvals[key$ID, ], FC = fit$coefficients[key$ID, 1]), RRAalphaCutoff, scoring)


    ## Add pvalues and qvalues
    geneP.depletion <- ct.RRAaPvals(rra.input[, "scores.deplete", drop = FALSE], g.key = key, permute = permutations, permutation.seed = permutation.seed)

    geneP.enrichment <- ct.RRAaPvals(rra.input[, "scores.enrich", drop = FALSE], g.key = key, permute = permutations, permutation.seed = permutation.seed)

    ## generate the Rho values and ranks: These are redundant with work done in ct.RRAPvals ...
    rhoEnrich <- ct.RRAalpha(rra.input[, "scores.enrich", drop = FALSE], g.key = key, shuffle = FALSE)

    rhoDeplete <- ct.RRAalpha(rra.input[, "scores.deplete", drop = FALSE], g.key = key, shuffle = FALSE)

    annotFields <- c("ID", "target", "geneID", "geneSymbol")
    if (!all(annotFields %in% names(key))) {
        message("Some expected columns are not present in the supplied annotation file.", call. = FALSE)
        annotFields <- intersect(annotFields, names(key))
        message(paste("Only the following information will be included in the output:", paste(annotFields, collapse = ",")))
    }

    ## make the DF
    summaryDF <- key[, annotFields]
    summaryDF$geneSymbol <- as.character(summaryDF$geneSymbol)
    summaryDF["gRNA Log2 Fold Change"] <- fit$coefficients[summaryDF$ID, 1]
    summaryDF["gRNA Depletion P"] <- signif(pvals[summaryDF$ID, 1], 5)
    summaryDF["gRNA Depletion Q"] <- signif(p.adjust(pvals[, "Depletion.P"], "fdr")[summaryDF$ID], 5)
    summaryDF["gRNA Enrichment P"] <- signif(pvals[summaryDF$ID, 2], 5)
    summaryDF["gRNA Enrichment Q"] <- signif(p.adjust(pvals[, "Enrichment.P"], "fdr")[summaryDF$ID], 5)
    summaryDF["Target-level Enrichment P"] <- geneP.enrichment[summaryDF$geneSymbol]
    summaryDF["Target-level Enrichment Q"] <- p.adjust(geneP.enrichment, "fdr")[summaryDF$geneSymbol]
    summaryDF["Target-level Depletion P"] <- geneP.depletion[summaryDF$geneSymbol]
    summaryDF["Target-level Depletion Q"] <- p.adjust(geneP.depletion, "fdr")[summaryDF$geneSymbol]

    ## Add a column for the median FC for each target:
    medianfc <- tapply(summaryDF[, "gRNA Log2 Fold Change"], summaryDF[, "geneSymbol"], median, na.rm = TRUE)
    summaryDF["Median log2 Fold Change"] <- as.numeric(medianfc[summaryDF$geneSymbol])  # One per gene rep'd out to one per guide
    summaryDF["Rho_enrich"] <- rhoEnrich[summaryDF$geneSymbol]
    summaryDF["Rho_deplete"] <- rhoDeplete[summaryDF$geneSymbol]

    ## order them summaryDF <- summaryDF[order(summaryDF[,'Rho_enrich'], decreasing = FALSE),] summaryDF <- summaryDF[order(summaryDF[,'Target-level Enrichment P'],
    ## decreasing = FALSE),]
    return(summaryDF)
}

##' Apply RRA 'alpha' cutoff to RRAalpha input
##'
##' The 'alpha' part of RRAalpha is used to consider only the top guide-level scores for gene-level
##'     statistics. Practically, all guides failing the cutoff get a pvalue of 1.  There are three ways of
##'     determining which guides fail. See 'scoring' below.
##' @param stats three-column numeric matrix with pvalues for down and up one-sided test with guide-level fold
##'     changes (coefficients from the relevant contrast).
##' @param RRAalphaCutoff A cutoff to use when defining gRNAs with significantly altered abundance during the RRAa aggregation step, which may be specified
##' as a single numeric value on the unit interval or as a logical vector. When supplied as a logical vector (of length equal to \code{nrows(fit)}), 
##' this parameter directly indicates the gRNAs to include during RRAa aggregation. Otherwise, if \code{scoring} is set 
##' to \code{pvalue} or \code{combined}, this parameter is interpreted as the maximum nominal p-value required to consider a gRNA's abundance meaningfully 
##' altered during the aggregation step. If \code{scoring} is \code{fc}, this parameter is interpreted as the proportion of the list to be considered 
##' meaningfully altered in the experiment (e.g., if \code{RRAalphaCutoff} is set to 0.05, only consider the rankings of the 5% most upregulated 
##' (or downregulated) gRNAs for the purposes of RRAa calculations).
##' @param scoring The gRNA ranking method to use in RRAa aggregation. May take one of three values: \code{pvalue}, \code{fc},
##' or '\code{combined}'. \code{pvalue} indicates that the gRNA ranking statistic should be created from the (one-sided) p-values in the 
##' fit object. \code{fc} indicates that the ranks of the gRNA coefficients should be used instead, and \code{combined} indicates that 
##' that the coefficents should be used as the ranking statistic but gRNAs are discarded in the aggregation step based on the corresponding nominal 
##' p-value in the fit object. 
##' @return data.frame with guide-level pvals, fold change, and scores.deplete and scores.enrich which are the input the RRAalpha
##' @examples 
##' fakestats <- matrix(runif(300), ncol = 3)
##' colnames(fakestats) = c('Depletion.P', 'Enrichment.P', 'lfc')
##' ct.applyAlpha(fakestats)
##' @author Russell Bainer
##' @export 
ct.applyAlpha <- function(stats, RRAalphaCutoff = 0.1, scoring = c("combined", "pvalue", "fc")) {
    scoring <- match.arg(scoring)
    pvals = stats[, seq_len(2)]
    foldchange <- cbind(stats[, 3], -stats[, 3])

    ## RRAalphaCutoff format
    if (length(RRAalphaCutoff) == 1) {
        rra.logic <- FALSE
        if (!is.numeric(RRAalphaCutoff) | (RRAalphaCutoff < 0) | (RRAalphaCutoff > 1)) {
            stop("When provided as a single value, RRAalphaCutoff must be a numeric value equal to 0, 1, or something in between.")
        }
    } else {
        rra.logic <- TRUE
        if ((sum(RRAalphaCutoff %in% c(TRUE, FALSE)) != nrow(pvals)) | (length(RRAalphaCutoff) != nrow(pvals))) {
            stop("When provided as a vector, RRAalphaCutoff must be the exact length of the p-value vectors in the fit object and must only contain TRUE or FALSE values.")
        }
    }

    if (scoring %in% "fc") {
        ## Normalize values to rank scores
        scores.deplete <- as.matrix(rank(foldchange[, 1])/nrow(foldchange))
        scores.enrich <- as.matrix(rank(foldchange[, 2])/nrow(foldchange))

        ## determine the fold-change significance cutoffs
        cut.deplete <- sort(scores.deplete[, 1])[round(nrow(scores.deplete) * RRAalphaCutoff)]
        cut.enrich <- sort(scores.enrich[, 1])[round(nrow(scores.enrich) * RRAalphaCutoff)]

        if (rra.logic) {
            cut.deplete <- RRAalphaCutoff
            cut.enrich <- RRAalphaCutoff
        }

    } else if (scoring %in% "pvalue") {

        ## Normalize values to rank scores
        scores.deplete <- as.matrix(rank(pvals[, "Depletion.P"])/nrow(pvals))
        scores.enrich <- as.matrix(rank(pvals[, "Enrichment.P"])/nrow(pvals))

        ## determine the significance cutoffs for the rank statistics on the basis of p-values
        cut.deplete <- (pvals[, "Depletion.P"] <= RRAalphaCutoff)
        cut.enrich <- (pvals[, "Enrichment.P"] <= RRAalphaCutoff)

        if (rra.logic) {
            cut.deplete <- RRAalphaCutoff
            cut.enrich <- RRAalphaCutoff
        }

    } else {

        cut.deplete <- (pvals[, "Depletion.P"] <= RRAalphaCutoff)
        cut.deplete[is.na(cut.deplete)] <- FALSE
        scores.deplete <- as.matrix(rank(foldchange[, 1])/nrow(foldchange))

        cut.enrich <- (pvals[, "Enrichment.P"] <= RRAalphaCutoff)
        cut.enrich[is.na(cut.enrich)] <- FALSE
        scores.enrich <- as.matrix(rank(foldchange[, 2])/nrow(foldchange))

        if (rra.logic) {
            cut.deplete <- RRAalphaCutoff
            cut.enrich <- RRAalphaCutoff
        }
    }
    ## nonsignificant gRNAs are set to 1. Implicitly, this means that the significance relative to alpha is treated as an inherent property of the gRNA.

    if (length(cut.deplete) == 1) 
        pass <- scores.deplete[, 1] <= cut.deplete else pass <- cut.deplete
    scores.deplete[!pass, 1] <- 1
    if (length(cut.enrich) == 1) 
        pass <- scores.enrich[, 1] <= cut.enrich else pass <- cut.enrich
    scores.enrich[!pass, 1] <- 1
    out = cbind(stats, scores.deplete = scores.deplete[, 1], scores.enrich = scores.enrich[, 1])
    return(out)
}

##' @title View a Barchart Summarizing Alignment Statistics for a Crispr Screen
##' @description This function displays the alignemnt statistics for a pooled Crispr screen, reported directly from an alignment statistic matrix. 
##' @param aln A numeric matrix of alignment statistics for a Crispr experiment. Corresponds to a 4xN matrix of read counts, with columns indicating 
##' samples and rows indicating the number of 'targets', 'nomatch', 'rejections', and 'double_match' reads. Details about these classes may be found 
##' in the best practices vignette or as part of the report generated with \code{ct.makeReport()}. 
##' @param sampleKey An optional ordered factor linking the samples to experimental variables. The \code{names} attribute should exactly match those present in \code{aln}. 
##' @return A grouped barplot displaying the alignment statistics for each sample included in the alignment matrix, which usually corresponds to all of 
##' the samples in the experiment.  
##' @author Russell Bainer
##' @examples 
##' data('aln')
##' ct.alignmentChart(aln)
##' @export
ct.alignmentChart <- function(aln, sampleKey = NULL) {

    # input checks
    if (!is.matrix(aln)) {
        stop("I don't think that the provided alignment matrix is actually an alignment matrix.")
    }

    plotnames <- NULL

    if (!is.null(sampleKey)) {
        sampleKey <- ct.keyCheck(sampleKey, aln) 
        aln <- aln[, names(sampleKey)[order(sampleKey)]]
        plotnames <- rep("", ncol(aln))
    }

    current.graphic.params <- par(no.readonly = TRUE)
    on.exit(suppressWarnings(par(current.graphic.params)))
    barcolors <- colorRampPalette(c("darkblue", "darkred", "grey", "purple"))(nrow(aln))
    par(mar = c(7, 5, 4, 2))
    barplot(aln, main = "Read Alignment Statistics by Sample", xlab = "", ylab = "Reads", col = barcolors, names.arg = plotnames, legend = row.names(aln), beside = TRUE, 
        las = 3, cex.names = 0.8, ylim = c(0, 1.3 * max(aln)))

    if (!is.null(sampleKey)) {
        axiscolors <- colorRampPalette(c("brown", "green", "orange", "black"))(length(levels(sampleKey)))
        axisloc <- seq(from = 3, by = 5, length.out = length(sampleKey))
        names(axisloc) <- colnames(aln)

        invisible(lapply(levels(sampleKey), function(x) {
            axis(1, axisloc[names(sampleKey)[sampleKey == x]], labels = names(sampleKey)[sampleKey == x], tick = FALSE, cex = 0.8, col.axis = axiscolors[match(x, levels(sampleKey))], 
                las = 2)
        }))
        legend("topleft", levels(sampleKey), fill = axiscolors)

    }
}

##' @title Normalize sample abundance estimates by a spline fit to specific shared elements
##' @description This function normalizes Crispr gRNA abundance estimates by fiting a smoothed spline to a subset of the gRNAs within each sample
##' and then equalizing these curves across the experiment. Specifically, the algorithm ranks the gRNA abundance estimates within each sample and 
##' uses a smoothed spline to determine a relationship between the ranks of the "anchor" guides and their abundance estimates. It then adjusts the 
##' spline trends from each sample to the mean of all of the sample spline fits in a manner analogous to quantile normalization, interpolating the
##' gRNA abundance values between the anchor points; these values are returned as normalized counts in the '\code{exprs}' slot of the input eset. 
##' @param eset An ExpressionSet object containing, at minimum, count data accessible by \code{exprs}. 
##' @param annotation An annotation dataframe indicating the nontargeting controls in the geneID column. 
##' @param geneSymb The \code{geneSymbol} identifier(s) in \code{annotation} that corresponds to the "anchor" gRNAs. If absent, the method will
##' attempt to infer nontargeting guides by searching for \code{'no_gid'} or \code{NA} in the appropriate columns.  
##' @param lib.size An optional vector of voom-appropriate library size adjustment factors, usually calculated with \code{\link[edgeR]{calcNormFactors}} 
##' and transformed to reflect the appropriate library size. These adjustment factors are interpreted as the total library sizes for each sample, 
##' and if absent will be extrapolated from the columnwise count sums of the \code{exprs} slot of the \code{eset}.
##' @return A normalized \code{eset}.
##' @author Russell Bainer
##' @examples data('es')
##' data('ann')
##' 
##' #Build the sample key and library sizes for visualization
##' library(Biobase)
##' sk <- (relevel(as.factor(pData(es)$TREATMENT_NAME), 'ControlReference'))
##' names(sk) <- row.names(pData(es))
##' ls <- colSums(exprs(es))
##' 
##' es.norm <- ct.normalizeSpline(es, ann, 'NoTarget', lib.size = ls)
##' ct.gRNARankByReplicate(es, sk, lib.size = ls)
##' ct.gRNARankByReplicate(es.norm, sk, lib.size = ls)
##' @export
ct.normalizeSpline <- function(eset, annotation, geneSymb = NULL, lib.size = NULL) {

    if (!methods::is(eset, "ExpressionSet")) {
        stop(deparse(substitute(eset)), " is not an ExpressionSet.")
    }

    # Check the annotation and find the NTC rows
    if (!is.data.frame(annotation)) {
        stop("An annotation dataframe must be supplied if controls is TRUE.")
    }
    annotation <- invisible(ct.prepareAnnotation(annotation, eset, throw.error = FALSE))

    if (!is.null(geneSymb)) {
        stopifnot(all(geneSymb %in% annotation$geneSymbol))
        ntc <- row.names(annotation)[annotation$geneSymbol %in% geneSymb]
    } else if ("NoTarget" %in% annotation$geneSymbol) {
        message("Using gRNAs targeting \"NoTarget\"")
        ntc <- row.names(annotation)[annotation$geneSymbol %in% "NoTarget"]
    } else {
        stop("I can't tell which guides are nontargeting. Please specify a geneSymbol that you would like for me to use.")
    }

    # log the data and fit curves to the NTCs.
    counts <- exprs(eset)

    if (is.null(lib.size)) {
        lib.size <- colSums(counts)
    }

    e.dat <- t(log2(t(counts + 0.5)/(lib.size + 1) * 1e+06))
    ntcVals <- e.dat[ntc, ]

    samRanks <- apply(e.dat, 2, rank)
    ntcRanks <- samRanks[ntc, ]

    fits <- lapply(colnames(e.dat), function(x) {
        smooth.spline(ntcRanks[, x], y = ntcVals[, x])
    })
    corrections <- lapply(fits, function(x) {
        predict(fits[[1]], seq_len(nrow(e.dat)))
    })
    names(fits) <- colnames(e.dat)
    # Subtract out the appropriate values
    corrected <- vapply(colnames(e.dat), function(x) {
        (e.dat[, x] - predict(fits[[x]], samRanks[, x])[[2]]) + median(e.dat)
    }, numeric(nrow(e.dat)))
    # colnames(corrected) <- names(fits)
    corrected <- 2^corrected
    corrected <- round(t(t(corrected) * ((lib.size + 1)/1e+06)) - 0.5)

    # update and return the eset
    exprs(eset) <- corrected
    return(eset)
}


##' @title Normalize sample abundance estimates by the median values of nontargeting control guides
##' @description This function normalizes Crispr gRNA abundance estimates by equalizing the median 
##' abundances of the nontargeting gRNAs within each sample. The normalized values are returned as normalized counts in 
##' the '\code{exprs}' slot of the input eset. Note that this method may be unstable if the screening library contains 
##' relatively few nontargeting gRNAs. 
##' @param eset An ExpressionSet object containing, at minimum, count data accessible by \code{exprs}. 
##' @param annotation An annotation dataframe indicating the nontargeting controls in the geneID column. 
##' @param lib.size An optional vector of voom-appropriate library size adjustment factors, usually calculated with \code{\link[edgeR]{calcNormFactors}} 
##' and transformed to reflect the appropriate library size. These adjustment factors are interpreted as the total library sizes for each sample, 
##' and if absent will be extrapolated from the columnwise count sums of the \code{exprs} slot of the \code{eset}.
##' @param geneSymb The \code{geneSymbol} identifier in \code{annotation} that corresponds to nontargeting gRNAs. If absent, \code{ct.gRNARankByReplicate} will
##' attempt to infer nontargeting guides by searching for \code{'no_gid'} or \code{NA} in the appropriate columns via \code{ct.prepareAnnotation()}.  
##' @return A normalized \code{eset}. 
##' @author Russell Bainer
##' @examples data('es')
##' data('ann')
##' 
##' #Build the sample key and library sizes for visualization
##' library(Biobase)
##' sk <- ordered(relevel(as.factor(pData(es)$TREATMENT_NAME), 'ControlReference'))
##' names(sk) <- row.names(pData(es))
##' ls <- colSums(exprs(es))
##' 
##' es.norm <- ct.normalizeNTC(es, ann, lib.size = ls, geneSymb = 'NoTarget')
##' 
##' ct.gRNARankByReplicate(es, sk, lib.size = ls)
##' ct.gRNARankByReplicate(es.norm, sk, lib.size = ls)
##' @export

ct.normalizeNTC <- function(eset, annotation, lib.size = NULL, geneSymb = NULL) {

    if (!methods::is(eset, "ExpressionSet")) {
        stop(deparse(substitute(eset)), " is not an ExpressionSet.")
    }

    # Check the annotation and find the NTC rows
    if (!is.data.frame(annotation)) {
        stop("An annotation dataframe must be supplied to normalize to nontargeting controls.")
    }
    annotation <- invisible(ct.prepareAnnotation(annotation, eset))

    if (!is.null(geneSymb)) {
        if (geneSymb %in% annotation$geneSymbol) {
            ntc <- row.names(annotation)[annotation$geneSymbol %in% geneSymb]
        } else {
            stop(deparse(substitute(geneSymb)), " is not present in the geneSymbol column of the annotation file.")
        }
    } else if ("NoTarget" %in% annotation$geneSymbol) {
        message("Using gRNAs targeting \"NoTarget\"")
        ntc <- row.names(annotation)[annotation$geneSymbol %in% "NoTarget"]
    } else {
        stop("I can't tell which guides are nontargeting. Please specify a geneSymbol that you would like for me to use.")
    }

    # Update the eset and return it.
    counts <- exprs(eset)

    if (is.null(lib.size)) {
        lib.size <- colSums(counts)
    }

    y <- t(log2(t(counts + 0.5)/(lib.size + 1) * 1e+06))
    ntcVals <- y[ntc, ]
    cmed <- rowMedians(t(ntcVals), na.rm = TRUE)
    cmed <- (cmed - mean(cmed))

    y <- t(t(y) - cmed)
    y <- 2^y
    y <- round(t(t(y) * ((lib.size + 1)/1e+06)) - 0.5)
    exprs(eset) <- y
    return(eset)
}


##' @title Normalize sample abundance estimates by the slope of the values in the central range
##' @description This function normalizes Crispr gRNA abundance estimates by equalizing the slopes of the middle (logged) values of the
##' distribution across samples. Specifically, the algorithm ranks the gRNA abundance estimates within each sample and determines a relationship between
##' rank change and gRNA within a trimmed region of the distribution via a linear fit. It then adjusts each sample such that the center of the logged
##' abundance distribution is strictly horizontal and returns these values as median-scaled counts in the appropriate slot of the input ExpressionObject.
##' @param ExpressionObject An ExpressionSet containing, at minimum, count data accessible by \code{exprs}, or an EList object with count data in the $E 
##' slot (usually returned by \link[limma]{voom}).
##' @param trim The proportion to be trimmed from each end of the distributionbefore performing the linear fit; algorithm defaults to 25% such that the
##' fit is performed on the interquartile range.
##' @param ... Other arguments to be passed to \code{ct.normalizeMedians()}, if desired.
##' @param lib.size An optional vector of size factor adjusted library size. 
##'   Default: \code{NULL} means to use sum of column counts as a lib.size.
##' @return A renormalized object of the same type as the provided object.
##' @author Russell Bainer
##' @import limma
##' @examples data('es')
##' data('ann')
##' 
##' #Build the sample key and library sizes for visualization
##' library(Biobase)
##' sk <- ordered(relevel(as.factor(pData(es)$TREATMENT_NAME), 'ControlReference'))
##' names(sk) <- row.names(pData(es))
##' ls <- colSums(exprs(es))
##' 
##' es.norm <- ct.normalizeBySlope(es, lib.size= ls)
##' ct.gRNARankByReplicate(es, sk, lib.size= ls)
##' ct.gRNARankByReplicate(es.norm, sk, lib.size= ls)
##' @export
ct.normalizeBySlope <- function(ExpressionObject, trim = 0.25, lib.size = NULL, ...) {

    if (!(class(ExpressionObject) %in% c("ExpressionSet", "EList"))) {
        stop(deparse(substitute(ExpressionObject)), "is not an ExpressionSet or Elist.")
    }

    # log them
    if (methods::is(ExpressionObject, "EList")) {
        e.dat <- ExpressionObject$E
    } else {
        counts <- exprs(ExpressionObject)
        if (is.null(lib.size)) {
            lib.size <- colSums(counts)
        } else if (!is.numeric(lib.size) | length(lib.size) != ncol(counts)) {
            stop("If specified, lib.size must be a numeric vector of the same length as the number of samples in the eset.")
        }
        e.dat <- t(log2(t(counts + 0.5)/(lib.size + 1) * 1e+06))
    }

    # extract the inner 50% and fit a lm
    shuffle <- apply(e.dat, 2, sort, decreasing = TRUE, index.return = TRUE)
    locs <- round((nrow(e.dat) * trim)):round(nrow(e.dat) * (1 - trim))
    slopes <- lapply(shuffle, function(x) {
        lm(unlist(x[[1]][locs]) ~ locs)$coefficients[2]
    })


    # correct the values
    corrected <- vapply(names(slopes), function(x) {
        outlist <- shuffle[[x]][[1]] + ((length(shuffle[[x]][[1]]):1) * slopes[[x]])
        return(outlist[row.names(e.dat)])
    }, numeric(nrow(e.dat)))

    # Back to counts:
    correctedCounts <- 2^corrected
    correctedCounts <- round(t(t(correctedCounts) * ((lib.size + 1)/1e+06)) - 0.5)

    # update and return the object
    if (is(ExpressionObject, "ExpressionSet")) {
        exprs(ExpressionObject) <- correctedCounts
        ExpressionObject <- ct.normalizeMedians(ExpressionObject, lib.size)
        return(ExpressionObject)
    } else {
        co <- 2^corrected
        new.v <- voom(correctedCounts, design = ExpressionObject$design, normalize.method = "scale")
        return(new.v)
    }
}


##' @title Normalize an ExpressionSet Containing a Crispr Screen
##' @description This function normalizes Crispr gRNA abundance estimates contained in an \code{ExpressionSet} object.
##' Currently four normalization methods are implemented: median scaling (via \code{normalizeMedianValues}), slope-based
##' normalization (via \code{ct.normalizeBySlope()}), scaling to the median of the nontargeting control values (via 
##' \code{ct.normalizeNTC()}), factored quantile normalization (via \code{ct.normalizeFQ()}), and spline fitting to the distribution of 
##' selected gRNAs (via \code{ct.normalizeSpline()}). Because of the peculiarities of pooled Crispr screening data, these 
##' implementations may be more stable than the endogenous methods used downstream by \link[limma]{voom}. See the respective 
##' man pages for further details about specific normalization approaches.
##' @param eset An ExpressionSet object with integer count data extractable with \code{exprs()}.
##' @param method The normalization method to use.
##' @param annotation The annotation object for the library, required for the methods employing nontargeting controls.
##' @param sampleKey An (optional) sample key, supplied as an ordered factor linking the samples to experimental
##' variables. The \code{names} attribute should exactly match those present in \code{eset}, and the control set is assumed to be
##' the first \code{level}. If `method` = `FQ`, the sampleKey is taken as the `sets` argument (and its format requirements are similarly 
##' relaxed; see `?ct.normalizeFC`).
##' @param lib.size An optional vector of voom-appropriate library size adjustment factors, usually calculated with \code{\link[edgeR]{calcNormFactors}} 
##' and transformed to reflect the appropriate library size. These adjustment factors are interpreted as the total library sizes for each sample, 
##' and if absent will be extrapolated from the columnwise count sums of the \code{exprs} slot of the \code{eset}.
##' @param plot.it Logical indicating whether to plot the ranked log2 gRNA count distributions before and after normalization. 
##' @param ... Other parameters to be passed to the individual normalization methods.
##' @return A renormalized ExpressionSet. If specified, the sample level counts will be scaled so as to maintain the validity 
##' of the specified \code{lib.size} values. 
##' @author Russell Bainer
##' @import limma
##' @seealso \code{\link{ct.normalizeMedians}}, \code{\link{ct.normalizeBySlope}}, \code{\link{ct.normalizeNTC}}, \code{\link{ct.normalizeSpline}}
##' @examples data('es')
##' data('ann')
##' 
##' #Build the sample key as needed
##' library(Biobase)
##' sk <- ordered(relevel(as.factor(pData(es)$TREATMENT_NAME), 'ControlReference'))
##' names(sk) <- row.names(pData(es))
##' 
##' es.norm <- ct.normalizeGuides(es, 'scale', annotation = ann, sampleKey = sk, plot.it = TRUE)
##' es.norm <- ct.normalizeGuides(es, 'slope', annotation = ann, sampleKey = sk, plot.it = TRUE)
##' es.norm <- ct.normalizeGuides(es, 'controlScale', annotation = ann, sampleKey = sk, plot.it = TRUE, geneSymb = 'NoTarget')
##' es.norm <- ct.normalizeGuides(es, 'controlSpline', annotation = ann, sampleKey = sk, plot.it = TRUE, geneSymb = 'NoTarget')
##' @export
ct.normalizeGuides <- function(eset, method = c("scale", "FQ", "slope", "controlScale", "controlSpline"), annotation = NULL, sampleKey = NULL, lib.size = NULL, plot.it = FALSE, 
    ...) {
    if (!methods::is(eset, "ExpressionSet")) {
        stop(deparse(substitute(eset)), "is not an ExpressionSet.")
    }

    choices <- c("scale", "FQ", "slope", "controlScale", "controlSpline")
    method <- match.arg(method, choices)

    if (method %in% c("controlScale", "controlSpline")) {
        if (is.null(annotation)) {
            stop("An annotation object must be provided to perform", deparse(substitute(method)), "normalization.")
        }
        annotation <- ct.prepareAnnotation(ann = annotation, object = eset, controls = TRUE, throw.error = FALSE)
    }

    if (is.null(lib.size)) {
        lib.size <- colSums(exprs(eset))
    } else if (!is.numeric(lib.size) | (length(lib.size) != ncol(eset))) {
        stop("If specified, lib.size must be a numeric vector of length equal to the number of samples.")
    }

    if(!is.null(sampleKey)){
        sampleKey <- ct.keyCheck(sampleKey, eset)
    }
    
    new.eset <- switch(method, 
                       scale = ct.normalizeMedians(eset, lib.size = lib.size), 
                       FQ = ct.normalizeFQ(eset, sets = sampleKey, lib.size = lib.size), 
                       slope = ct.normalizeBySlope(eset, lib.size = lib.size, ...), 
                       controlScale = ct.normalizeNTC(eset, annotation, lib.size = lib.size, ...), 
                       controlSpline = ct.normalizeSpline(eset, annotation, lib.size = lib.size, ...))
    # set negative counts to 0's if they happen to be present after normalization
    exprs(new.eset) <- apply(X = exprs(new.eset), MARGIN = 2, FUN = function(col) {
        col[col < 0] <- 0
        col
    })

    if (plot.it) {
        if(is.null(sampleKey)){
            message('sampleKey must be supplied for plotting normalization effects.')
        } else{
            par(mfrow = c(2, 1))
            
            if(is.null(names(sampleKey))){
                names(sampleKey) <- colnames(eset)  #Handle edge cases for normalizeFQ
            }
            
            ct.gRNARankByReplicate(eset, sampleKey, lib.size = lib.size)
            ct.gRNARankByReplicate(new.eset, sampleKey, lib.size = lib.size)
        }
    }
    return(new.eset)
}


##' @title Normalize sample abundance estimates by median gRNA counts
##' @description This function normalizes Crispr gRNA abundance estimates by equalizing the median gRNA abundance values after
##' correcting for library size. It does this by converting raw count values to log2 counts per million and optionally adjusting further in 
##' the usual way by dividing these values by user-specified library size factors. THis method should be more stable than the endogenous 
##' scaling functions used in \code{voom} in th especific case of Crispr screens or other cases where the median number of observed counts may be low. 
##' @param eset An \code{ExpressionSet} containing, at minimum, count data accessible by \code{exprs}.
##' @param lib.size An optional vector of voom-appropriate library size adjustment factors, usually calculated with \code{\link[edgeR]{calcNormFactors}} 
##' and transformed to reflect the appropriate library size. These adjustment factors are interpreted as the total library sizes for each sample, 
##' and if absent will be extrapolated from the columnwise count sums of the \code{exprs} slot of the \code{eset}.
##' @return A renormalized ExpressionSet object of the same type as the provided object.
##' @author Russell Bainer
##' @import limma
##' @examples data('es')
##' 
##' #Build the sample key and library sizes for visualization
##' library(Biobase)
##' sk <- ordered(relevel(as.factor(pData(es)$TREATMENT_NAME), 'ControlReference'))
##' names(sk) <- row.names(pData(es))
##' ls <- colSums(exprs(es))
##' 
##' es.norm <- ct.normalizeMedians(es, lib.size= ls)
##' ct.gRNARankByReplicate(es, sampleKey = sk, lib.size= ls)
##' ct.gRNARankByReplicate(es.norm, sampleKey = sk, lib.size= ls)
##' @export
ct.normalizeMedians <- function(eset, lib.size = NULL) {
    if (!methods::is(eset, "ExpressionSet")) {
        stop("Please provide an ExpressionSet object for normalization.")
    }

    counts <- exprs(eset)

    if (is.null(lib.size)) {
      lib.size <- rep(1000, ncol(counts))
    } else if (!is.numeric(lib.size) | length(lib.size) != ncol(counts)) {
        stop("If specified, lib.size must be a numeric vector of the same length as the number of samples in the eset.")
    }

    y <- t(log2(t(counts + 0.5)/(lib.size + 1) * 1e+06))
    cmed <- apply(y, 2, median, na.rm = TRUE)
    cmed <- cmed - mean(cmed)
    correctedCounts <- 2^t(t(y) - cmed)
    correctedCounts <- (t(t(correctedCounts) * ((lib.size + 1)/1e+06)) - 0.5)

    exprs(eset) <- round(correctedCounts)
    return(eset)
}

##' @title Apply Factored Quantile Normalization to an eset
##' @description This function applies quantile normalization to subsets of samples defined by a provided factor, correcting for library size. 
##' It does this by converting raw count values to log2 counts per million and optionally adjusting further in 
##' the usual way by dividing these values by user-specified library size factors; then this matrix is split into groups according to the 
##' provided factor that are quantile normalized, and then the groups are median scaled to each other before conversion back into 
##' raw counts. This method is best used in comparisons for long timecourse screens, where groupwise differences in growth rate 
##' cause uneven intrinsic dialation of construct distributions.
##' 
##' Note that this normalization strategy is not appropriate for experiments where significant distortion of the libraries is expected as a 
##' consequence of the screening strategy (e.g., strong selection screens). 
##' @param eset An \code{ExpressionSet} containing, at minimum, count data accessible by \code{exprs}.
##' @param sets A character or factor object delineating which samples should be grouped together during the normalization step. Must 
##' be the same length as the number of columns in the provided eset, and cannot contain `NA` or `NULL` values. 
##' @param lib.size An optional vector of voom-appropriate library size adjustment factors, usually calculated with \code{\link[edgeR]{calcNormFactors}} 
##' and transformed to reflect the appropriate library size. These adjustment factors are interpreted as the total library sizes for each sample, 
##' and if absent will be extrapolated from the columnwise count sums of the \code{exprs} slot of the \code{eset}.
##' @return A renormalized ExpressionSet object of the same type as the provided object.
##' @author Russell Bainer
##' @import limma
##' @examples data('es')
##' 
##' #Build the sample key and library sizes for visualization
##' library(Biobase)
##' sk <- relevel(as.factor(pData(es)$TREATMENT_NAME), 'ControlReference')
##' names(sk) <- row.names(pData(es))
##' ls <- colSums(exprs(es))
##' 
##' es.norm <- ct.normalizeFQ(es, sets = gsub('(Death|Control)', '', pData(es)$TREATMENT_NAME), lib.size= ls)
##' ct.gRNARankByReplicate(es, sampleKey = sk, lib.size= ls)
##' ct.gRNARankByReplicate(es.norm, sampleKey = sk, lib.size= ls)
##' @export
ct.normalizeFQ <- function(eset, sets, lib.size = NULL) {
    if (!methods::is(eset, "ExpressionSet")) {
        stop("Please provide an ExpressionSet object for normalization.")
    }

    stopifnot(length(na.omit(sets)) == ncol(eset), !any(vapply(sets, is.null, logical(1))))

    counts <- exprs(eset)

    if (is.null(lib.size)) {
        lib.size <- colSums(counts)
    } else if (!is.numeric(lib.size) | length(lib.size) != ncol(counts)) {
        stop("If specified, lib.size must be a numeric vector of the same length as the number of samples in the eset.")
    }

    y <- t(log2(t(counts + 0.5)/(lib.size + 1) * 1e+06))

    # Apply Factored Quantiles
    quant <- lapply(unique(sets), function(x) {
        limma::normalizeQuantiles(y[, (sets == x)])
    })
    y <- do.call("cbind", quant)

    cmed <- apply(y, 2, median, na.rm = TRUE)
    cmed <- cmed - mean(cmed)
    correctedCounts <- 2^t(t(y) - cmed)
    correctedCounts <- (t(t(correctedCounts) * ((lib.size + 1)/1e+06)) - 0.5)

    exprs(eset) <- round(correctedCounts)
    return(eset)
}

## ----------------------------------------------------------------------------- File Utilities


##' Initializes the output directory
##'
##' If outdir is NULL, then no directory is checked/created. This also implies
##' that creating plots is not possible.
##'
##' @param outdir character vector pointing to a directory to check/create
##' @return TRUE if the output directory was created, otherwise FALSE (it might
##' already exist).
##' @keywords internal
##' @author Steve Lianoglou, Russell Bainer
initOutDir <- function(outdir) {
    if (is.null(outdir)) {
        return(FALSE)
    }
    if (!is.character(outdir) && length(outdir) != 1) {
        stop("character required for `outdir`")
    }
    outdir.created <- FALSE
    if (dir.exists(outdir)) {
        if (!dir.writable(outdir)) {
            stop("Can't write to output directory: ", outdir)
        }
    } else {
        pdir <- dirname(outdir)
        if (!dir.exists(pdir)) {
            stop("Path to outdir does not exist: ", pdir)
        }
        if (!dir.writable(pdir)) {
            stop("Can't create output directory in: ", pdir)
        }
        dir.create(outdir)
        outdir.created <- TRUE
    }
    outdir.created
}


##' Checks that the directory provided is writable by the current user
##'
##' This works by testing to put a temporary file into an already existing
##' directory
##'
##' @param path The path to a directory to check.
##'
##' @return \code{logical}, \code{TRUE} if \code{path} is writable by the
##' current user, otherise \code{FALSE}
##' @keywords internal
##' @author Steve Lianoglou
dir.writable <- function(path) {
    if (!dir.exists(path)) {
        stop("The directory provided does not exist: ", path)
    }
    tmp.fn <- tempfile(tmpdir = path, fileext = ".test.tmp")
    on.exit({
        if (file.exists(tmp.fn)) unlink(tmp.fn)
    })

    tryCatch({
        suppressWarnings(writeLines("test", tmp.fn))
        TRUE
    }, error = function(e) FALSE)
}


##' @title Check compatibility of a sample key with a supplied object
##' @description For many gCrisprTools functions, a sample key must be provided that specifies 
##' sample mapping to experimental groups. The sample key should be provided as a single, named factor whose  
##' names exactly correspond to the `colnames()` of the `ExpressionSet` containing the count data to be 
##' processed (or coercible as such). By convention, the first level corresponds to the control sample group.
##'  
##' This function checks whether the specified sample key is of the proper format and has 
##' properties consistent with the specified object. 
##' @param sampleKey A named factor, where the \code{levels} indicate the experimental replicate 
##' groups and the \code{names} match the \code{colnames} of the expression matrix contained in \code{object}. 
##' The first \code{level} should correspond to the control samples, but obviously there is no 
##' way to algorithmically control this. 
##' @param object An \code{ExpressionSet}, \code{EList}, or matrix.  
##' @return A logical indicating whether the objects are compatible.
##' @import limma
##' @author Russell Bainer
ct.inputCheck <- function(sampleKey, object) {

    .Deprecated('ct.keyCheck', package = 'gCrisprTools', msg = 'Please use ct.keyCheck() instead of ct.inputCheck().')
    
    if (!(is.factor(sampleKey))) {
        sampleKey <- as.factor(sampleKey)
        warning("Coercing the provided sample key to a factor. Control group set to: ", levels(sampleKey)[1])
    }
    
    # Check input formats
    if (!any(is(object, "ExpressionSet"), is(object, "EList"), is(object, "matrix"))) {
        stop(deparse(substitute(object)), " is not an ExpressionSet, Elist, or matrix. Class is: ", class(object))
    }

    if (is.null(names(sampleKey))) {
        stop(deparse(substitute(sampleKey)), " must have a names attribute, specifying the sample assignments in ", deparse(substitute(object)), ".")
    }

    # Check to see if the names match properly
    if (methods::is(object, "EList")) {
        dat <- object$E
    } else if (methods::is(object, "ExpressionSet")) {
        dat <- exprs(object)
    } else {
        dat <- object
    }

    if (!setequal(colnames(dat), names(sampleKey))) {
        stop("The names of ", deparse(substitute(sampleKey)), " must exactly match the colnames of the data contained in ", deparse(substitute(object)), ".")
    }

    return(TRUE)
}

##' @title Check compatibility of a sample key with a supplied ExpressionSet or similar object
##' @description For many gCrisprTools functions, a sample key must be provided that specifies 
##' sample mapping to experimental groups. The sample key should be provided as a single, named factor whose  
##' names exactly correspond to the `colnames()` of the `ExpressionSet` containing the count data to be 
##' processed (or coercible as such). By convention, the first level corresponds to the control sample group.
##'  
##' This function checks whether the specified sample key is of the proper format and has 
##' properties consistent with the specified object. 
##' @param sampleKey A named factor, where the \code{levels} indicate the experimental replicate 
##' groups and the \code{names} match the \code{colnames} of the expression matrix contained in \code{object}. 
##' The first \code{level} should correspond to the control samples, but obviously there is no 
##' way to algorithmically control this. 
##' @param object An \code{ExpressionSet}, \code{EList}, or other matrix-like object with defined `colnames()`.  
##' @return Invisibly, a properly formatted `sampleKey`.
##' @import limma
##' @author Russell Bainer
##' @examples data('es')
##' library(limma)
##' library(Biobase)
##' 
##' #Build the sample key
##' sk <- relevel(as.factor(pData(es)$TREATMENT_NAME), 'ControlReference')
##' names(sk) <- row.names(pData(es))
##' ct.keyCheck(sk, es)
##' @export
ct.keyCheck <- function(sampleKey, object) {
    
    #check dimensions
    stopifnot(length(sampleKey) == ncol(object))
    
    if (!(is.factor(sampleKey))) {
        sampleKey <- as.factor(sampleKey)
        warning("Coercing the provided sample key to a factor. Control group set to: ", levels(sampleKey)[1])
    }
    
    #Check that names exist, are valid, and are equal
    stopifnot(!is.null(names(sampleKey)), !is.null(colnames(object)))
    stopifnot(setequal(names(sampleKey), colnames(object)))
    
    if(any(make.names(names(sampleKey)) != names(sampleKey))) {
        stop('sampleKey names are not syntactically valid!')
    }
    
    return(invisible(droplevels(sampleKey)))
}


##' @title Determine whether a supplied object contains the results of a Pooled Screen
##' @description Many gCrisprTools functions operate on a \code{data.frame} of results
##' generated by a CRISPR screen. This function takes in a supplied object and returns 
##' a logical indicating whether the object can be treated as one of these data.frames 
##' for the purposes of downstream analyses. This is largely used internally, but can 
##' be useful if a user needs to build a result object for some reason.  
##' 
##' @param summaryDF A \code{data.frame}, usually returned by \code{ct.generateResults}. 
##' if you need to generate one of these by hand for some reason, see the example 
##' \code{resultsDF} object loaded in the example below. 
##' @return A logical indicating whether the object is of the appropriate format.
##' @author Russell Bainer
##' @examples data('resultsDF')
##' ct.resultCheck(resultsDF)
##' @export
ct.resultCheck <- function(summaryDF) {

    # Check input formats
    if (!is.data.frame(summaryDF)) {
        summaryDF <- as.data.frame(summaryDF, stringsAsFactors = FALSE)
        message("The supplied screen results are not a data.frame.")
        return(FALSE)
    }

    expectedNames <- c("geneID", "geneSymbol", "gRNA Log2 Fold Change", "gRNA Depletion P", "gRNA Depletion Q", "gRNA Enrichment P", "gRNA Enrichment Q", "Target-level Enrichment P", 
        "Target-level Enrichment Q", "Target-level Depletion P", "Target-level Depletion Q", "Median log2 Fold Change", "Rho_enrich", "Rho_deplete")

    if (!all(expectedNames %in% names(summaryDF))) {
        missing <- setdiff(expectedNames, names(summaryDF))
        warning("The supplied result object seems to have some incorrect columns. I was expecting: ")
        print(missing)
        stop("Please supply a summaryDF object generated from ct.generateResults() in the gCrisprTools package.")
        return(FALSE)
    }

    if (!setequal(vapply(summaryDF, class, character(1)), rep(c("character", "numeric"), times = c(4, 12)))) {
        stop("Some of the columns in the supplied result object seem to be of the wrong type. Please supply a summaryDF object generated from ct.generateResults() in the gCrisprTools package.")
        return(FALSE)
    }

    return(TRUE)
}

##' @title Package Screen Data into a `SummarizedExperiment` Object 
##' @description Convenience function to package major components of a screen into a `SummarizedExperiment` container
##' for downstream visualization and analysis. All arguments are optional except for `es`. 
##' @param es An `ExpressionSet` of screen data. Required. 
##' @param sampleKey a gCrisprTools `sampleKey` object, to be added to the `colData`. 
##' @param ann Annotation object to be packaged into the `rowData`
##' @param vm A `voom`-derived normalized object
##' @param fit a `MArrayLM` object containing the contrast information and model results
##' @param summaryList A named list of \code{data.frame}s, returned by \code{ct.generateResults}. 
##' if you need to generate one of these by hand for some reason, see the example 
##' \code{resultsDF} object loaded in the example below. 
##' @return A `SummarizedExperiment` object. 
##' @importFrom SummarizedExperiment SummarizedExperiment
##' @author Russell Bainer
##' @examples 
##' data('ann', 'es', 'fit', 'resultsDF')
##' ct.buildSE(es, ann = ann, fit = 'fit', summaryList = list('resA' = resultsDF, 'resB' = resultsDF))
##' @export
ct.buildSE <- function(es, sampleKey = NULL, ann = NULL, vm = NULL, fit = NULL, summaryList = NULL) {
    stopifnot(methods::is(es, "ExpressionSet"))

    asy <- list(counts = exprs(es))
    met <- list()
    rd <- fData(es)
    cd <- pData(es)

    if (!is.null(sampleKey)) {
        cd$sampleKey <- sampleKey[row.names(cd)]
    }

    if (!is.null(vm)) {
        stopifnot(setequal(colnames(vm), colnames(es)), is(vm, "EList"), setequal(row.names(vm), row.names(es)))
        asy["voom"] <- vm$E
        asy["weights"] <- vm$weights
        met["design"] <- vm$design

        newCols <- (ncol(cd) + 1):(ncol(cd) + ncol(vm$targets))
        cd <- cbind(cd, vm$targets[row.names(cd), ])
        colnames(cd)[newCols] <- colnames(vm$targets)
    }

    if (!is.null(fit)) {
        met["fit"] <- fit
    }

    if (!is.null(summaryList)) {
        if ((!is(summaryList, "list")) | (is.null(names(summaryList)))) {
            stop("When supplied, results dataframes must be provided as a named list.")
        }
        invisible(lapply(summaryList, ct.resultCheck))
        met$results <- summaryList
    }

    if (!is.null(ann)) {
        ann <- ct.prepareAnnotation(ann, es)
        rd <- cbind(rd, ann[row.names(rd), ])
    }

    se <- SummarizedExperiment::SummarizedExperiment(assays = asy, rowData = rd, colData = cd, metadata = met)

    return(se)
}

##' @title Convert a verbose results DF object to a gene-level result object
##' 
##' @description Convenience function to reduce a full results object to a gene-level object 
##' that retains minimal statistics (or alternatively, check that a provided simple result object is valid). 
##' 
##' @param summaryDF A \code{data.frame}, usually returned by \code{ct.generateResults}. 
##' if you need to generate one of these by hand for some reason, see the example 
##' \code{resultsDF} object loaded in the example below. 
##' @param collapse Column of the provided resultsDF on which to collapse values; in most cases this should be 
##' `geneSymbol` or `geneID`.
##' @return A gene-level `data.frame`, with guide-level information omitted 
##' @author Russell Bainer
##' @examples data('resultsDF')
##' ct.simpleResult(resultsDF)
##' @export
ct.simpleResult <- function(summaryDF, collapse = c("geneSymbol", "geneID")) {

    # Check inputs
    collapse <- match.arg(collapse)
    stopifnot(is(summaryDF, "data.frame"), (collapse %in% names(summaryDF)))

    if (length(setdiff(c("geneID", "geneSymbol", "Rho_enrich", "Rho_deplete", "best.p", "best.q", "direction"), (names(summaryDF)))) == 0) {
        # already simplified
        stopifnot(all(vapply(names(summaryDF)[seq_len(7)], function(x) {
            class(summaryDF[, x])
        }, character(1)) == rep(c("character", "numeric", "character"), times = c(2, 4, 1))))
        out <- summaryDF

    } else {
        stopifnot(ct.resultCheck(summaryDF))
        out <- summaryDF

        out$direction <- vapply(seq_len(nrow(out)), function(x) {
            ifelse(out[x, "Target-level Enrichment P"] < out[x, "Target-level Depletion P"], "enrich", "deplete")
        }, character(1))

        out$best.p <- vapply(seq_len(nrow(out)), function(x) {
            ifelse(out$direction[x] %in% "enrich", out[x, "Target-level Enrichment P"], out[x, "Target-level Depletion P"])
        }, numeric(1))

        out$best.q <- vapply(seq_len(nrow(out)), function(x) {
            ifelse(out$direction[x] %in% "enrich", out[x, "Target-level Enrichment Q"], out[x, "Target-level Depletion Q"])
        }, numeric(1))
        out <- out[, c("geneID", "geneSymbol", "Rho_enrich", "Rho_deplete", "best.p", "best.q", "direction")]


    }

    # Cleanup duplicates - always keep strongest signals.
    out <- out[order(out$best.p, decreasing = FALSE), ]
    out <- out[!duplicated(out[, collapse]), ]
    if (any(is.na(out[, collapse]))) {
        warning(paste0("NA detected in column ", collapse, "! Omitting the associated entries."))
        out <- out[!is.na(out[, collapse]), ]
    }
    row.names(out) <- out[, collapse]

    return(out)
}


##' @title Regularize Two Screening Results Objects 
##' @description This function prepares multiple `gCrisprTools` results dataframes for comparison. Specifically, 
##' it checks that all provided data frames are valid result objects, converts each to the target-wise `simpleResult` format, 
##' removes signals that are not shared by all objects, places their rows in identical order, and then returns the simplified dataframes as a list. 
##' 
##' This function is largely meant to be used by other gCrisprtools functions, although there are occasions when an analyst may want to call it directly. 
##' Often, it is useful to pass the `collapse` argument to `ct.simpleresult()` in cases where libraries and technologies differ between screens. 
##' @param dflist A list of results dataframes. Names will be preserved.
##' @param collapse Column of the provided resultsDFs on which to collapse values; should be `geneSymbol` or `geneID`.
##' @return A list of the in-register `simpleResult` objects, with length and names identical to `dflist`.
##' @examples 
##' data('resultsDF')
##' lapply(ct.regularizeContrasts(list('df1' = resultsDF[1:300,], 'df2' = resultsDF[200:400,])), nrow)
##' @export
ct.regularizeContrasts <- function(dflist, collapse = c("geneSymbol", "geneID")) {

    # input check
    stopifnot(is.list(dflist))

    # convert to simple results
    dflist <- lapply(dflist, ct.simpleResult, collapse = collapse)

    # find common rows
    rowcounts <- table(unlist(lapply(dflist, row.names)))
    samerows <- names(rowcounts)[rowcounts == length(dflist)]

    if (length(samerows) == 0) {
        stop("The supplied DFs have no targets in common! Consider specifying `collapse` argument for ct.simpleResult().")
    } else if (!all(rowcounts == length(dflist))) {
        message(length(samerows), " targets in common. Omitting others.")
    }

    return(lapply(dflist, function(x) {
        x[samerows, ]
    }))
}

##' @title Rank Signals in a Simplified Pooled Screen Result Object 
##' @description This function takes in a supplied results data.frame, optionally transforms it into a `simplifiedResult`, 
##' and returns the ranks of the target-level signals. 
##' 
##' @param df A results data.frame, in either raw or simplified form. Will be converted to simplified form if necessary.
##' @param top Determines the directionality of the ranking. `enrich` defines ranks from the most enriched to the most 
##' depleted target; `deplete` does the opposite 
##' @return A numeric vector of ranks, with length equal to the number of rows in the simplified data.frame. 
##' @author Russell Bainer
##' @examples 
##' data('resultsDF')
##' df.simple <- ct.simpleResult(resultsDF) 
##' sr <- ct.rankSimple(resultsDF)
##' all((df.simple$best.p[sr == 1] == 0), (df.simple$direction[sr == 1] == 'enrich'))
##' 
##' sr <- ct.rankSimple(resultsDF, 'deplete')
##' all((df.simple$best.p[sr == 1] == 0), (df.simple$direction[sr == 1] == 'deplete'))
##' @export
ct.rankSimple <- function(df, top = c("enrich", "deplete")) {
    df.simple <- ct.simpleResult(df)
    top <- match.arg(top)

    ranktype <- switch(top, enrich = "min", deplete = "max")

    # rank the enriched:
    enr <- rank(df.simple$best.p[df.simple$direction %in% "enrich"], na.last = TRUE, ties.method = ranktype)

    # Depleted is trickier:
    dep <- rank(df.simple$best.p[df.simple$direction %in% "deplete"], na.last = TRUE, ties.method = ranktype)
    dep <- ((max(dep) + 1) - dep) + max(enr)

    # put them back in order:
    out <- rep(0, nrow(df.simple))
    out[df.simple$direction %in% "enrich"] <- enr
    out[df.simple$direction %in% "deplete"] <- dep

    # Switch the values if depletion
    if (top %in% "deplete") {
        out <- (max(out) + 1) - out
    }

    return(out)
}

##' @title Log10 transform empirical P-values with a pseudocount
##' @description This function -log10 transforms empirical P-values by adding a pseudocount of 1/2 the minimum nonzero value. 
##' @param x numeric vector. 
##' @return -log10-transformed version of X.
##' @examples ct.softLog(runif(20))
##' @export
ct.softLog <- function(x) {
    stopifnot(is.numeric(x), all(!is.na(x)), !all(x == 0))
    out <- -log10((x + (min(x[x != 0])/2)))
    out[out <= 0] <- 0 #Sometimes correction can deflate below zero 
    return(out)
}

library(RUnit)
library(gCrisprTools)

test.ct.applyAlpha <- function() {
    p = seq(0, 1, length.out=20)
    fc = seq(-3, 3, length.out=20)
    fc[2] = NA
    fc[3] = -20
    stats = data.frame(
        Depletion.P=p,
        Enrichment.P=rev(p),
        fc=fc
    )

    checkIdentical(
        data.frame(
            Depletion.P=p,
            Enrichment.P=rev(p),
            fc=fc,
            scores.deplete=c(0.10,rep(1.0,19)),
            scores.enrich=c(rep(1.0,18),0.10,0.05)
        ),
        ct.applyAlpha(stats,scoring="combined")
    )

    checkIdentical(
        data.frame(
            Depletion.P=p,
            Enrichment.P=rev(p),
            fc=fc,
            scores.deplete=c(0.05,0.10,rep(1.0,18)),
            scores.enrich=c(rep(1.0,18),0.10,0.05)
        ),
        ct.applyAlpha(stats,scoring="pvalue")
    )
    
    checkIdentical(
        data.frame(
            Depletion.P=p,
            Enrichment.P=rev(p),
            fc=fc,
            scores.deplete=c(0.10,1.0,0.05,rep(1.0,17)),
            scores.enrich=c(rep(1.0,18),0.10,0.05)
        ),
        ct.applyAlpha(stats,scoring="fc")
    )

}

##' @title Preprocess a 'MArrayLM' model fit object to include only one contrast. 
##' @description This function preprocesses a fit object returned from eBayes to include only the values relevant to the
##' \code{modelTerm} specified.  
##' @param fit An object of class MArrayLM to be processed. 
##' @param modelTerm The model coefficient to be isolated for downstream analyses. 
##' @return A \code{MArrayLM} object for downstream processing. 
##' @author Russell Bainer
##' @import limma
##' @keywords internal
##' @examples 
##' 
##' #Load and preprocess data
##' data('es')
##' library(Biobase)
##' library(limma)
##' 
##' #Make a multi-level contrast
##' design <- model.matrix(~ 0 + TREATMENT_NAME, pData(es))
##' colnames(design) <- gsub('TREATMENT_NAME', '', colnames(design))
##' contrasts <- makeContrasts((ControlExpansion - ControlReference), (DeathExpansion - ControlExpansion), levels = design)
##' 
##' #Make a multi-level fit object
##' vm <- voom(exprs(es), design)
##' fit <- lmFit(vm, design)
##' fit <- contrasts.fit(fit, contrasts)
##' fit <- eBayes(fit)  
##' 
##' #And trim it
##' fit2  <- ct.preprocessFit(fit, modelTerm = '(DeathExpansion - ControlExpansion)')
##' 
##' ncol(fit)
##' ncol(fit2)
##' @export 

ct.preprocessFit <- function(fit, modelTerm) {
    if (!methods::is(fit, "MArrayLM")) {
        stop(deparse(substitute(fit)), " is not an MArrayLM object.")
    }
    if (!(modelTerm %in% colnames(fit$coefficients))) {
        stop("Specified coefficient is not present in the fit object.")
    }
    if (!("p.value" %in% names(fit))) {
        warning(deparse(substitute(fit)), " does not contain p-values quantifying the evidence for differential gRNA abundance. Eventually, you will need to process it with eBayes(), treat(), or a similar function.")
    }

    fit$coefficients <- as.matrix(fit$coefficients[, modelTerm])
    colnames(fit$coefficients) <- modelTerm
    fit$stdev.unscaled <- as.matrix(fit$stdev.unscaled[, modelTerm])
    colnames(fit$stdev.unscaled) <- modelTerm
    fit$t <- as.matrix(fit$t[, modelTerm])
    colnames(fit$t) <- modelTerm
    fit$p.value <- as.matrix(fit$p.value[, modelTerm])
    colnames(fit$p.value) <- modelTerm
    if ("lods" %in% names(fit)) {
        fit$lods <- as.matrix(fit$lods[, modelTerm])
        colnames(fit$lods) <- modelTerm
    }

    return(fit)
}

##' @title Compare Two CRISPR Screen Contrasts via a Scatter Plot
##' @description This is a function for comparing the results of two screening experiments. Given two \code{summaryDF}, 
##' the function places them in register with one another, generates a simplified scatter plot where enrichment or depletion 
##' in each contrast is represented by the associated "signed" log10 (*P*/*Q*)-value (where enriched signals are represented 
##' in the positive direction and depleted signals are shown in the negative direction), and returns an invisible `data.frame`
##' containing the target X-axis and Y-axis coordinates and corresponding quadrant. 
##' 
##' This is a target-level analysis, and some minor simplifications are introduced to screen signals for the sake of clarity. 
##' Principal among these is the decision to collapse gene signals to a single directional enrichment statistic. Target-level
##' signals are typically aggregates of many guide-level signals, it is formally possible for targets to be both significantly 
##' enriched and significantly depleted within a single screen contrast as a result of substantially divergent reagent activity. 
##' This behavior is uncommon, however, and so targets are represented by selecting the direction of enrichment or depletion 
##' associated with the most significant (*P*/*Q*)-value. This directionality is then encoded into the X-axis and Y-axis 
##' position of the target as the sign of the signal as described above.
##'
##' @param dflist A (named) list of results dataframes, of length 2. See \code{\link{ct.generateResults}}. 
##' @param targets Column of the provided \code{summaryDF} to consider. Must be \code{geneID} or \code{geneSymbol}.
##' @param statistic Statistic to plot on each axis (after -log10 transformation). Must be 'p', 'q', or 'rho'.
##' @param cutoff significance cutoff used to define the significance quadrants (cannot be exactly zero).
##' @param plot.it Logical indicating whether to compose the plot on the default device. 
##' @return Invisibly, a list of length 4 containing the genes passing significance for the respective quadrants.
##' @author Russell Bainer
##' @examples 
##' data('resultsDF')
##' scat <- ct.scatter(list('FirstResult' = resultsDF[100:2100,], 'SecondResult' = resultsDF[1:2000,]))
##' head(scat)
##' @export
ct.scatter <- function(dflist, targets = c("geneSymbol", "geneID"), statistic = c("best.p", "best.q"), cutoff = 0.05, plot.it = TRUE) {

    # Check the input:
    targets <- match.arg(targets)
    statistic <- match.arg(statistic)
    stopifnot(is.numeric(cutoff), is.logical(plot.it), (cutoff > 0), is.list(dflist), (length(dflist) == 2))
    cutoff <- -log10(cutoff)

    dfs <- ct.regularizeContrasts(dflist, collapse = targets)
    dfs <- lapply(dfs, function(x) {
        x[, c("Rho_enrich", "Rho_deplete", "best.p", "best.q")] <- apply(x[, c("Rho_enrich", "Rho_deplete", "best.p", "best.q")], 2, ct.softLog)
        return(x)
    })
    
    # Form output & divide into quadrants:
    out <- cbind(dfs[[1]][, seq_len(6)], dfs[[2]][, 3:6])
    colnames(out) <- c("geneID", "geneSymbol", paste0(c("Rho.enrich.", "Rho.deplete.", "p.", "q."), names(dfs)[1]), paste0(c("Rho.enrich.", "Rho.deplete.", "p.", "q."), 
        names(dfs)[2]))


    c1.sig <- (dfs[[1]][, statistic] >= cutoff)  # & (dfs[[1]][,'direction'] == dfs[[2]][,'direction'])
    c2.sig <- (dfs[[2]][, statistic] >= cutoff)  # & (dfs[[1]][,'direction'] == dfs[[2]][,'direction'])

    maxval <- max(c(dfs[[1]][, statistic], dfs[[2]][, statistic]))

    out$quadrant <- 5
    out$quadrant[(c1.sig & c2.sig & (dfs[[1]]$direction == "deplete") & (dfs[[2]]$direction == "enrich"))] <- 1
    out$quadrant[(!c1.sig & c2.sig & (dfs[[2]]$direction == "enrich"))] <- 2
    out$quadrant[(c1.sig & c2.sig & (dfs[[1]]$direction == "enrich") & (dfs[[2]]$direction == "enrich"))] <- 3
    out$quadrant[(c1.sig & !c2.sig & (dfs[[1]]$direction == "deplete"))] <- 4
    out$quadrant[(c1.sig & !c2.sig & (dfs[[1]]$direction == "enrich"))] <- 6
    out$quadrant[(c1.sig & c2.sig & (dfs[[1]]$direction == "deplete") & (dfs[[2]]$direction == "deplete"))] <- 7
    out$quadrant[(!c1.sig & c2.sig & (dfs[[2]]$direction == "deplete"))] <- 8
    out$quadrant[(c1.sig & c2.sig & (dfs[[1]]$direction == "enrich") & (dfs[[2]]$direction == "deplete"))] <- 9

    out$x <- dfs[[1]][, statistic] * vapply(dfs[[1]]$direction, function(x) {
        ifelse(x == "enrich", 1, -1)
    }, numeric(1))
    out$y <- dfs[[2]][, statistic] * vapply(dfs[[2]]$direction, function(x) {
        ifelse(x == "enrich", 1, -1)
    }, numeric(1))

    # Plot it
    if (plot.it) {

        dims <- c(-maxval, maxval)

        plot(out$x, out$y, main = paste0(names(dfs)[1], " vs ", names(dfs)[2], " (", statistic, ")"), xlab = paste0(names(dfs)[1], " Signed log10(", statistic, ")"), ylab = paste0(names(dfs)[2], 
            " Signed log10(", statistic, ")"), xlim = dims, ylim = dims, pch = 19, col = rgb(0, 0, 0, 0.1), cex = 0.7)
        abline(v = c(-cutoff, cutoff), h = c(-cutoff, cutoff), lty = 2)

        points(out$x[out$quadrant %in% c(1, 3, 7, 9)], out$y[out$quadrant %in% c(1, 3, 7, 9)], pch = 19, col = rgb(0.5, 0, 0, 0.4), cex = 0.7)
        points(out$x[out$quadrant %in% c(2, 4, 6, 8)], out$y[out$quadrant %in% c(2, 4, 6, 8)], pch = 19, col = rgb(0, 0, 0.6, 0.4), cex = 0.7)

        maxval <- maxval * 1.05
        
        text(-maxval, maxval, sum(out$quadrant == 1), cex = 0.5, col = rgb(0, 0, 0, 0.4))
        text(maxval, maxval, sum(out$quadrant == 3), cex = 0.5, col = rgb(0, 0, 0, 0.4))
        text(-maxval, -maxval, sum(out$quadrant == 7), cex = 0.5, col = rgb(0, 0, 0, 0.4))
        text(maxval, -maxval, sum(out$quadrant == 9), cex = 0.5, col = rgb(0, 0, 0, 0.4))
        text(-maxval, maxval, sum(out$quadrant == 1), cex = 0.5, col = rgb(0, 0, 0, 0.4))
    }
    return(invisible(out))
}

# helper functions --------------------------------------------------------

# These are internal functions to re-use for report generation so I am am not sticking to the naming convention with a 'ct' prefix, which is used for API.


#' Add formatted timestamp and extension to a file name
#'
#' @param name character
#' @param ext character - extension including a '.'.
#'
#' @keywords internal
#' @return character
#'
appendDateAndExt <- function(name, ext) {
    paste0(name, format(Sys.time(), "_%b_%d_%Y_%H.%M.%S"), ext)
}

#' Internal wrapper to generate html markdown reports from existing templates
#'
#' @param reportNameBase character - name of the report's file.
#' @param templateName character - name of the rmarkdown template file in the
#'   standard location. Passed through to \code{template} argument of the
#'   \code{\link[rmarkdown]{draft}}.
#' @param rmdParamList list of named report parameters. Passed through to
#'   \code{params} argument of the \code{\link[rmarkdown]{render}}.
#' @param outdir An optional character string indicating the directory in which to 
#' generate the report. If \code{NULL}, a temporary directory will be automatically generated. 
#'
#' @keywords internal
#' @return  character with a path to html report in the temporary directory.
renderReport <- function(reportNameBase, templateName, rmdParamList, outdir = NULL) {

    if (is.null(outdir)) {
        # use a temp directory to make a draft
        dir.create(outdir <- tempfile())
    } else {
        if (!is.character(outdir)) {
            stop("`outdir` must be path to a directory used ot save results")
        }
        outdir.created <- initOutDir(outdir)  #True/false indicating whether the directory was created
        outdir <- normalizePath(outdir)
    }

    render(draft(file = file.path(outdir, reportNameBase), create_dir = TRUE, template = templateName, package = "gCrisprTools", edit = FALSE), params = rmdParamList)
}


# ## ----------------------------------------------------------------------


##' @title Generate a full experimental report from a pooled CRISPR screen
##' @description This is a function to generate an html report for a CRISPR screen, incorporating information about a specified contrast. 
##' The report contains a combination of experiment-level and contrast-specific analyses, largely collected from other functions in 
##' \code{gCrisprTools}. It is designed to be used 'as-is', and analysts interested in using different functionalities of the various 
##' functions should do that outside of this wrapper script.
##' @param fit An object of class \code{MArrayLM} containing, at minimum, a \code{coefficents} slot with coefficients from the comparison,
##' and a \code{stdev.unscaled} slot with the corresponding standard deviation of the coefficent estimates. The \code{row.names} attribute
##' should ideally match that which is found in \code{annotation}, but this will be checked internally.
##' @param eset An ExpressionSet object containing, at minimum, a matrix of gRNA abundances extractable with the \code{exprs()} function and some named
##' phenodata extractable with \code{pData()}.
##' @param sampleKey A sample key, supplied as an ordered factor linking the samples to experimental
##' variables. The \code{names} attribute should exactly match those present in \code{eset}, and the control set is assumed to be
##' the first \code{level}.
##' @param annotation An annotation object for the experiment. See the man page for \code{ct.prepareAnnotation()} for details and example format. 
##' @param results A data.frame summarizing the results of the screen, returned by the function \code{\link{ct.generateResults}}.
##' @param aln A numeric alignment matrix, where rows correspond to 'targets', 'nomatch', 'rejections', and 'double_match', and where columns 
##' correspond to experimentasl samples. Users may also pass `NULL` to suppress evaluation of alignment. 
##' @param outdir A directory in which to generate the report; if \code{NULL}, a temporary directory will be automatically generated. 
##' The report will be located in a subdirectory whose name is internally generated (see below). The path to the report itself is returned by the function.
##' @param contrast.term A parameter passed to \code{ct.preprocessFit} in the event that the fit object contains data from multiple contrasts. See
##' that man page for further details.
##' @param identifier A character string to name the report and corresponding subdirectories. If provided, the final report will be called
##' '\code{identifier}.html' and will be located in a directory called \code{identifier} in the \code{outdir}. If \code{NULL}, a generic name 
##' including the timestamp will be generated.
##' @return The path to the generated html report.
##' @author Russell Bainer
##' @examples 
##' data('fit')
##' data('es')
##' 
##' ##' #Build the sample key
##' library(Biobase)
##' sk <- relevel(as.factor(pData(es)$TREATMENT_NAME), 'ControlReference')
##' names(sk) <- row.names(pData(es))
##' 
##' data('ann')
##' data('resultsDF')
##' data('aln')
##' path2report <- ct.makeReport(fit, es, sk, ann, resultsDF, aln, outdir = '.') 
##' @export

ct.makeReport <- function(fit, eset, sampleKey, annotation, results, aln, outdir = NULL, contrast.term = NULL, identifier = NULL) {

    if (!methods::is(fit, "MArrayLM")) {
        stop("the provided fit does not appear to be a MArrayLM object.")
    }

    if (ncol(fit$coefficients) > 1) {
        if (is.null(contrast.term)) {
            stop("The fit object contains multiple coefficients. Please specify a contrast.term.")
        }
        fit <- ct.preprocessFit(fit, contrast.term)
    }

    # filter the annotation file as necessary for downstream processes
    annotation <- ct.prepareAnnotation(annotation, fit, throw.error = FALSE)

    if (!is.null(aln)) {
        if (!is.matrix(aln) | !setequal(row.names(aln), c("targets", "nomatch", "rejections", "double_match"))) {
            stop("I don't think that the provided alignment matrix is actually an alignment matrix.")
        }
    }

    if (!ct.resultCheck(results)) {
        stop("Execution halted.")
    }


    # Set up the path and folder for writing (heavily based on code from multiGSEA):
    if (is.null(outdir)) {
        outdir.created <- FALSE
        noutdir <- character()
    } else {
        if (!is.character(outdir)) {
            stop("`outdir` must be path to a directory used ot save results")
        }
        outdir.created <- initOutDir(outdir)  #True/false indicating whether the directory was created
        noutdir <- normalizePath(outdir)
    }

    # make the sample names and build the parameter list for the rmd.
    sampleKey <- ct.keyCheck(sampleKey, eset)
    sampleKey <- sampleKey[order(sampleKey)]

    rmdParamList <- list(fit = fit, eset = eset, sampleKey = sampleKey, results = results, annotation = annotation, aln = aln)

    # make the name of the rmd & output, and render it in the location of interest.
    if (!is.null(identifier)) {
        if (!is.character(identifier) | length(identifier) != 1) {
            stop("identifier must be a character string of length 1.")
        }
        namebase <- identifier
    } else {
        namebase <- paste0("CrisprReport", format(Sys.time(), "_%b_%d_%Y_%H.%M.%S"))
    }

    rmdname <- file.path(noutdir, paste0(namebase, ".Rmd"))
    outname <- file.path(noutdir, namebase, paste0(namebase, ".html"))

    print(names(rmdParamList))

    render(draft(rmdname, template = "CRISPR_report", package = "gCrisprTools", edit = FALSE), params = rmdParamList)

    return(outname)

}

##' @title Generate a QC report from a pooled CRISPR screen
##' @description This is a function to generate an html QC report for a CRISPR 
##'   screen, focusing on experiment-level and library-level analyses collected 
##'   from other functions in \code{gCrisprTools}. It is designed to be used 
##'   'as-is', and analysts interested in using different functionalities of the
##'   various functions should do that outside of this wrapper script.
##'   
##' @param eset An ExpressionSet object containing, at minimum, a matrix of gRNA
##'   abundances extractable with the \code{exprs()} function and some named 
##'   phenodata extractable with \code{pData()}.
##' @param trim The number of gRNAs to be trimmed from the top of the 
##'   distribution before estimating the abundance range. Empirically, this 
##'   usually should be equal to about 2 to 5 percent of the guides in the 
##'   library.
##' @param log2.ratio Maximum abundance of contaminant gRNAs, expressed on the
##'   log2 scale from the top of the trimmed range of each sample. That is,
##'   \code{log2.ratio = 4} means to discard all gRNAs whose abundance is
##'   (1/2)^4 of the trimmed maximum.
##' @param sampleKey A sample key, supplied as an ordered factor linking the 
##'   samples to experimental variables. The \code{names} attribute should 
##'   exactly match those present in \code{eset}, and the control set is assumed
##'   to be the first \code{level}.
##' @param annotation An annotation object for the experiment. See the man page 
##'   for \code{ct.prepareAnnotation} for details and example format.
##' @param aln A numeric alignment matrix, where rows correspond to 'targets', 
##'   'nomatch', 'rejections', and 'double_match', and where columns correspond 
##'   to experimentasl samples. May be `NULL`, to suppress alignment evaluation. 
##' @param identifier A character string to name the report and corresponding 
##'   subdirectories. If provided, the final report will be called 
##'   '\code{identifier}.html' and will be located in a directory called 
##'   \code{identifier}. If \code{NULL}, a generic name including the timestamp 
##'   will be generated.
##' @param lib.size An optional vector of voom-appropriate library size adjustment factors, usually calculated with \code{\link[edgeR]{calcNormFactors}} 
##' and transformed to reflect the appropriate library size. These adjustment factors are interpreted as the total library sizes for each sample, 
##' and if absent will be extrapolated from the columnwise count sums of the \code{exprs} slot of the \code{eset}.
##' @param geneSymb The \code{geneSymbol} identifier(s) in \code{annotation} 
##'   that corresponds to gRNAs to be plotted on the curves. Passed through to 
##'   \code{\link{ct.gRNARankByReplicate}}, \code{\link{ct.viewControls}} and 
##'   \code{\link{ct.prepareAnnotation}} (as \code{controls} argument if it's
##'   not \code{NULL}). Default \code{NULL}.
##' @param outdir An optional character string indicating the directory in which
##'   to generate the report. If \code{NULL}, a temporary directory will be
##'   automatically generated.
##' @return The path to the generated html report.
##' @author Russell Bainer, Dariusz Ratman
##' @examples 
##' data('es')
##' data('ann')
##' data('aln')
##' 
##' ##' #Build the sample key
##' library(Biobase)
##' sk <- ordered(relevel(as.factor(pData(es)$TREATMENT_NAME), 'ControlReference'))
##' names(sk) <- row.names(pData(es))
##' 
##' path2report <- ct.makeQCReport(es, trim = 1000, log2.ratio = 0.0625, sk, ann, aln, identifier = NULL, lib.size = NULL, geneSymb = 'NoTarget', outdir = '.') 
##' @export
ct.makeQCReport <- function(eset, trim, log2.ratio, sampleKey, annotation, aln, identifier = NULL, lib.size, geneSymb = NULL, outdir = NULL) {
    # check and preprocess inputs
    if (!is.null(sampleKey)) {
        sampleKey <- ct.keyCheck(sampleKey, eset)
        sampleKey <- sampleKey[order(sampleKey)]
    }

    annotation <- ct.prepareAnnotation(ann = annotation, object = eset, controls = ifelse(is.null(geneSymb), TRUE, geneSymb), throw.error = FALSE)

    # prepare params
    if (missing(identifier) | is.null(identifier)) {
        reportNameBase <- appendDateAndExt(name = "CRISPR_QC_report", ext = ".Rmd")
    } else {
        (is.character(identifier) & length(identifier) == 1) || stop("Identifier must be a character string of length 1.")
        reportNameBase <- identifier
    }

    rmdParamList <- list(eset = eset, sampleKey = sampleKey, trim = trim, log2.ratio = log2.ratio, annotation = annotation, aln = aln, lib.size = lib.size, geneSymb = geneSymb)

    # render and return the path to report
    renderReport(reportNameBase = reportNameBase, templateName = "CRISPR_QC_report", rmdParamList = rmdParamList, outdir = outdir)
}

##' @title Generate a Contrast report from a pooled CRISPR screen
##' @description This is a function to generate an html Contrast report for a 
##'   CRISPR screen, focusing on contrast-level analyses collected from other 
##'   functions in \code{gCrisprTools}. It is designed to be used 'as-is', and 
##'   analysts interested in using different functionalities of the various 
##'   functions should do that outside of this wrapper script.
##'   
##' @param eset An ExpressionSet object containing, at minimum, a matrix of gRNA
##'   abundances extractable with the \code{exprs()} function and some named 
##'   phenodata extractable with \code{pData()}.
##' @param fit A fit object for the contrast of interest, usually generated with
##'   \code{lmFit}.
##' @param sampleKey A sample key, supplied as an ordered factor linking the 
##'   samples to experimental variables. The \code{names} attribute should 
##'   exactly match those present in \code{eset}, and the control set is assumed
##'   to be the first \code{level}.
##' @param results A data.frame summarizing the results of the screen, returned 
##'   by the function \code{\link{ct.generateResults}}.
##' @param annotation An annotation object for the experiment. See the man page 
##'   for \code{ct.prepareAnnotation()} for details and example format.
##' @param comparison.id character with a name of the comparison.
##' @param identifier A character string to name the report and corresponding 
##'   subdirectories. If provided, the final report will be called 
##'   '\code{identifier}.html' and will be located in a directory called 
##'   \code{identifier} in the \code{outdir}. If \code{NULL}, a generic name
##' @param contrast.subset character vector containing the sample
##'   labels to be used in the analysis; all elements must be contained in the
##'   \code{colnames} of the specified \code{eset}. including the timestamp will
##'   be generated. Default: \code{colnames(eset)}.
##' @param outdir An optional character string indicating the directory in which to 
##'   generate the report. If \code{NULL}, a temporary directory will be automatically 
##'   generated. 
##' @return The path to the generated html report.
##' @author Russell Bainer, Dariusz Ratman
##' @examples 
##' data('es')
##' data('fit')
##' data('ann')
##' data('resultsDF')
##' 
##' ##' #Build the sample key
##' library(Biobase)
##' sk <- ordered(relevel(as.factor(pData(es)$TREATMENT_NAME), 'ControlReference'))
##' names(sk) <- row.names(pData(es))
##' 
##' path2report <- ct.makeContrastReport(es, fit, sk, resultsDF, ann, comparison.id = NULL, outdir = '.') 
##' @export
ct.makeContrastReport <- function(eset, fit, sampleKey, results, annotation, comparison.id, identifier, contrast.subset = colnames(eset), outdir = NULL) {
    # check and preprocess inputs
    annotation <- ct.prepareAnnotation(annotation, throw.error = FALSE)
    if (!is.null(sampleKey)) {
        sampleKey <- ct.keyCheck(sampleKey, eset)
        sampleKey <- sampleKey[order(sampleKey)]
    }

    if (!ct.resultCheck(results)) {
        stop("Execution halted.")
    }

    # prepare params
    if (missing(identifier)) {
        reportNameBase <- appendDateAndExt(name = "CRISPR_contrast_report", ext = ".Rmd")
    } else {
        (is.character(identifier) & length(identifier) == 1) || stop("Identifier must be a character string of length 1.")
        reportNameBase <- identifier
    }

    rmdParamList <- list(eset = eset, fit = fit, sampleKey = sampleKey, results = results, contrast.subset = contrast.subset, comparison.id = comparison.id, annotation = annotation)

    # render and return the path to report
    renderReport(reportNameBase = reportNameBase, templateName = "CRISPR_contrast_report", rmdParamList = rmdParamList, outdir = outdir)
}

##' @title Identify Replicated Signals in Pooled Screens Using Conditional Scoring
##' @description This function identifies signals that are present in one or more screening experiment contrasts using a conditional 
##' strategy. Specifically, this function identifies all significant signals (according to user definitions) in a set of provided 
##' results DF and returns a `simplifiedResult` dataframe derived from the first provided contrast with an appended logical column 
##' indicating whether there is evidence for signal replication in the other provided resultsDFs.
##' 
##' Signals are considered replicated if they cross the specified stringent threshold (default: Q = 0.1) in one or more of the provided 
##' contrasts, and are similarly enriched or depleted at the relaxed threshold (default: P = 0.1) in all of the remaining contrasts. If 
##' a single contrast is provided, all signals crossing the stringent threshold are considered replicated.
##' 
##' Signals are compared across screens on the basis of \code{\link{ct.regularizeContrasts}}, so users must provide an identifier 
##' with which to standardize targets (`geneID` by default). 
##' 
##' @param dflist A list of (possibly simplified) results data.frames produced by \code{\link{ct.generateResults}}. 
##' @param statistics Statistics to use to define congruence; may be a single value, but internally coerced to a vector of length 2 where the first 
##' value corresponds to the stringent cutoff annd the second value is used for the relaxed cutoff. Must be 'best.p' or 'best.q'. 
##' @param cutoffs Numeric value(s) corresponding to the significance cutoff(s) used to define stringent and relaxed values of `statistics`. 
##' Internally coerced to a vector of length 2.
##' @param same.dir Logical vector of the same length as `dflist` indicating whether replicating signals are expected to go in the same direction 
##' (e.g., enrich/deplete in their respective screens). For example, a `dflist` of length 3 could be specified as c(TRUE, TRUE, FALSE), indicating 
##' that replicating signals should be enriched in both of the first two contrasts and depleted in the third to be considered replicated (or 
##' vise-versa). Default is `rep(TRUE, length(dflist))`.
##' @param return.stats When TRUE, return the significance of overlap instead of the logical vector (by permutation).
##' @param nperm numeric indicating number of permutations when `return.stats` is true (default 10000).  
##' @param ... Other arguments to `ct.simpleResult()`, especially `collapse`.
##' @return If `return.stats` is `FALSE`, returns the first contrast as a `simplifiedResult` data.frame, with a `replicated` logical column 
##' indicating whether each signal replicates in all of the provided screens according to the specified logic. 
##' 
##' If `return.stats` is `TRUE`, returns a dataframe indicating the permutation-based test statistics summarizing the evidence for significantly 
##' enriched signal replication across the provided contrasts (enrich, deplete, and all together).   
##' @author Russell Bainer
##' @examples 
##' data('resultsDF')
##' summary(ct.compareContrasts(list(resultsDF, resultsDF[1:5000,]))$replicated)
##' ct.compareContrasts(list(resultsDF, resultsDF[1:5000,]), return.stats = TRUE)
##' @export
ct.compareContrasts <- function(dflist, statistics = c("best.q", "best.p"), cutoffs = c(0.1, 0.1), same.dir = rep(TRUE, length(dflist)), return.stats = FALSE, nperm = 10000, 
    ...) {

    # Check the input:
    dflist <- ct.regularizeContrasts(dflist, ...)
    stopifnot(all(statistics %in% c("best.p", "best.q")), (length(statistics) <= 2), (length(statistics) > 0), is(return.stats, "logical"), is(cutoffs, "numeric"), 
        (length(cutoffs) <= 2), (length(cutoffs) > 0), is.logical(same.dir), (length(same.dir) == length(dflist)))
    if (length(statistics) == 1) {
        statistics <- rep(statistics, 2)
    }
    if (length(cutoffs) == 1) {
        cutoffs <- rep(cutoffs, 2)
    }

    if (return.stats) {
        stopifnot(is(nperm, "numeric"))
    }

    # Find validated signals.
    stringent <- vapply(dflist, function(x) {
        x[, statistics[1]] <= cutoffs[1]
    }, logical(nrow(dflist[[1]])))
    lax <- vapply(dflist, function(x) {
        x[, statistics[2]] <= cutoffs[2]
    }, logical(nrow(dflist[[1]])))
    dirs <- vapply(dflist, function(x) {
        x$direction %in% "enrich"
    }, logical(nrow(dflist[[1]])))
    dirs[, !same.dir] <- !dirs[, !same.dir]
    valid <- (rowSums(dirs) %in% c(ncol(dirs), 0)) & (rowSums(stringent) > 0) & (rowSums(lax) == ncol(lax))

    mainresult <- dflist[[1]]
    mainresult$replicated <- valid

    if (return.stats) {
        obs <- c(sum((rowSums(dirs) == ncol(dirs)) & valid), sum((rowSums(dirs) == 0) & valid), sum(valid))

        if (length(dflist) == 1) {
            out <- data.frame(expected = obs, observed = obs, p = c(1, 1, 1))
            row.names(out) <- c("enrich", "deplete", "all")
            return(out)
        }

        perm <- t(replicate(nperm, expr = {
            pr <- lapply(seq_len(ncol(stringent)), function(x) {
                sample(seq_len(nrow(stringent)))
            })
            nr <- nrow(stringent)

            p.stringent <- vapply(seq_len(length(pr)), function(x) {
                stringent[pr[[x]], x]
            }, logical(nr))
            p.lax <- vapply(seq_len(length(pr)), function(x) {
                lax[pr[[x]], x]
            }, logical(nr))
            p.dirs <- vapply(seq_len(length(pr)), function(x) {
                dirs[pr[[x]], x]
            }, logical(nr))

            dn <- sum((rowSums(p.dirs) == 0) & (rowSums(p.stringent) > 0) & (rowSums(p.lax) == ncol(p.lax)))
            up <- sum((rowSums(p.dirs) == ncol(p.dirs)) & (rowSums(p.stringent) > 0) & (rowSums(p.lax) == ncol(p.lax)))
            return(c(up, dn, up + dn))
        }, simplify = TRUE))
        out <- data.frame(expected = colMeans(perm), observed = obs, p = c(sum(perm[, 1] > obs[1])/nperm, sum(perm[, 2] > obs[2])/nperm, sum(perm[, 3] > obs[3])/nperm))

        row.names(out) <- c("enrich", "deplete", "all")
        return(out)
    }
    return(mainresult)
}


##' @title Consolidate shared signals across many contrasts in an UpSet Plot
##' @description This function takes in a named list of `results` dataframes produced by `ct.generateResults()` or similar, 
##' harmonizes them, and identifies overlaps between them using the logic implemented in `ct.compareContrasts()`. It then uses the
##' overlaps of these sets to compose an UpSet plot summarizing shared overlaps of the provided contrasts. These overlaps can be 
##' specified with some detail via arguments passed to the `ct.compareContrasts()` function; see documentation for more details.
##' 
##' Note that the UpSet plot is constructed to respect signal directionality, and by default constructs overlaps conditionally, 
##' but in a *bidirectional* manner. That is, a signal is considered observed in two (or more) contrasts regardless of the 
##' contrast from which the stringent signal is observed, so a signal replicated in three contrasts is interpreted as a target 
##' for which the evidence crosses the stringent threshold in one or more of the contrasts and passes the lax contrast in the others. 
##' 
##' Note that multiple important parameters are passed directly to `ct.compareContrasts()` if not specified in the command. Users 
##' are advised to study the corresponding manual page to better understand their options regarding contrast thresholding, 
##' orientation, etc. 
##' 
##' @param dflist a named list of (possibly simplified) `resultsDf`s. 
##' @param add.stats Logical indicating whether the significance of set overlaps should be included in the visualization. 
##' @param nperm Number of permutations for P-value generation. Ignored if `add.stats` is `FALSE`.
##' @param ... Other named arguments to `ComplexHeatmap::UpSet()`, `ct.compareContrasts`, or `ct.simpleResult()`. 
##' @return An UpSet plot on the current device. Silently, a combination matrix appropriate for plotting that plot, 
##' containing useful information about the observed intersections.  
##' @author Russell Bainer
##' @importFrom ComplexHeatmap %v% 
##' @examples 
##' data('resultsDF')
##' sets <- ct.upSet(list('first' = resultsDF, 'second' = resultsDF[1:5000,]))
##' @export
ct.upSet <- function(dflist, add.stats = TRUE, nperm = 10000, ...) {
    stopifnot(length(dflist) > 1, is.numeric(nperm))

    if (is.null(names(dflist))) {
        stop("The names() attribute must be set on the provided dflist for this to make any sense.")
    }

    # Subfunction args: dflist <- ct.regularizeContrasts(dflist, ...)
    dots <- list(...)

    dirs <- rep(TRUE, length(dflist))
    if ("same.dir" %in% names(dots)) {
        dirs <- dots$same.dir
    }
    dots <- dots[!(names(dots) %in% c("dflist", "return.stats", "same.dir"))]
    collapse <- ifelse('collapse' %in% names(dots), dots$collapse, 'geneSymbol')

    #dflist <- do.call("ct.regularizeContrasts", args = list('dflist' = dflist, 'collapse' = collapse))
    dflist <- ct.regularizeContrasts(dflist, collapse)

    # Generate the relevant overlap counts
    combos <- unlist(lapply(seq_len(length(dflist)), function(x) {
        combn(seq_len(length(dflist)), x, simplify = FALSE)
    }), recursive = FALSE)

    # Calculate overlap counts
    overlaps <- lapply(combos, function(x) {
        funargs <- dots
        funargs$dflist <- dflist[x]
        funargs$same.dir <- dirs[x]
        funargs$return.stats <- FALSE
        return(do.call("ct.compareContrasts", args = funargs))
      
        #return(do.call("ct.compareContrasts", args = c(list(dflist = dflist[x], same.dir = dirs[x], return.stats = FALSE), dots[names(dots) %in% names(formals("ct.compareContrasts"))])))
    })
    # overlaps <- lapply(combos, function(x){ if(exists('same.dir')){ dirarg <- same.dir[x] } else {dirarg <- rep(TRUE, length(x))}
    # return(ct.compareContrasts(dflist[x], same.dir = dirarg, return.stats = FALSE)) })
    overlapct <- vapply(overlaps, function(x) {
        sum(x$replicated, na.rm = TRUE)
    }, numeric(1))

    # Create the comb mat object.
    n <- length(dflist)
    comb_mat <- matrix(FALSE, nrow = n, ncol = sum(choose(n, seq_len(n))))
    for (x in seq_len(length(combos))) {
        comb_mat[combos[[x]], x] <- TRUE
    }
    rownames(comb_mat) <- names(dflist)
    comb_mat <- comb_mat + 0
    colnames(comb_mat) <- apply(comb_mat, 2, paste, collapse = "")
    
    attributes(overlapct) <- NULL
    attr(comb_mat, "set_size") <- vapply(dflist, nrow, numeric(1))  
    #attr(comb_mat, "set_size") <- rep(nrow(dflist[[1]]), length(dflist))
    attr(comb_mat, "comb_size") <- overlapct
    attr(comb_mat, "data") <- lapply(overlaps, function(x) {
        x$geneID[x$replicated]
    })
    param <- list(mode = "conditional", value_fun = "gCrisprTools", universal_set = NULL, set_on_rows = TRUE)
    attr(comb_mat, "param") <- param
    class(comb_mat) <- c("comb_mat", "matrix")
    cmorder <- ComplexHeatmap::order.comb_mat(comb_mat)
    comb_mat <- comb_mat[cmorder]
    comb_mat <- comb_mat[overlapct[cmorder] != 0]

    # If appropriate, generate stats:
    if (add.stats) {
        combo_stats <- lapply(combos, function(x) {
          funargs <- dots
          funargs$dflist <- dflist[x]
          funargs$same.dir <- dirs[x]
          funargs$return.stats <- TRUE
          return(do.call("ct.compareContrasts", args = funargs))
        })
        # combo_stats <- lapply(combos, function(x){ if(exists('same.dir')){ dirarg <- same.dir[x] } else {dirarg <- rep(TRUE, length(x))}
        # return(ct.compareContrasts(dflist[x], same.dir = dirarg, return.stats = TRUE, nperm = nperm)) })
        lfc <- log2(vapply(combo_stats, function(x) {
            log2(x[3, 2]/x[3, 1])
        }, numeric(1))[cmorder])
        lfc[!is.finite(lfc)] <- 0
        pv <- ct.softLog(vapply(combo_stats, function(x) {
            x[3, 3]
        }, numeric(1))[cmorder])

        # Make the UpSet Plot us <- UpSet(comb_mat) %v%
        us <- do.call(getExportedValue("ComplexHeatmap", "UpSet"), args = c(list(m = comb_mat), dots[names(dots) %in% names(formals(getExportedValue("ComplexHeatmap", 
            "UpSet")))])) %v% ComplexHeatmap::HeatmapAnnotation(Log2FC = anno_points(lfc, ylim = (rep(max(abs(range(lfc))), 2) * c(-1, 1))), annotation_name_side = "left", 
            annotation_name_rot = 0) %v% ComplexHeatmap::HeatmapAnnotation(`-log10(P)` = anno_barplot(pv, ylim = c(0, (max(pv) + 1))), annotation_name_side = "left", 
            annotation_name_rot = 0)
        show(us)
        ComplexHeatmap::decorate_annotation("Log2FC", {
            pushViewport(viewport(xscale = c(0.5, 10.5), yscale = (rep(max(abs(range(lfc))), 2) * c(-1, 1))))
            grid.lines(c(0.5, 10.5), c(0, 0), gp = gpar(lty = 2), default.units = "native")
            popViewport()
        })
        ComplexHeatmap::decorate_annotation("-log10(P)", {
            pushViewport(viewport(xscale = c(0.5, 10.5), yscale = c(0, (max(pv) + 1))))
            grid.lines(c(0.5, 10.5), c(2, 2), gp = gpar(lty = 2), default.units = "native")
            popViewport()
        })
    } else {
        # show(UpSet(comb_mat))
        us <- do.call(getExportedValue("ComplexHeatmap", "UpSet"), args = c(list(m = comb_mat), dots[names(dots) %in% names(formals(getExportedValue("ComplexHeatmap", "UpSet")))]))
        show(us)
    }

    return(invisible(comb_mat))

}

##' @title Check and optionally subset an annotation file for use in a Crispr Screen
##' @description This function processes a supplied annotation object for use in a pooled screening experiment. 
##' Originally this was processed into something special, but now it essentially returns
##' the original annotation object in which the geneSymbol column has been factorized. This is primarily used 
##' internally during a call to the \code{ct.generateResults()} function. Also performs some minor functionality checking, 
##' and ensures that the reagent identifiers are present as an `ID` column (if absent, the row.names are used).
##' 
##' Valid annotations contain both `geneID` and `geneSymbol` columns. This is because there is often a distinction between
##' the official gene that is being targeted and a coherent set of gRNAs that make up a testing cohort. For example, 
##' multiple sets of guides may target distinct promoters, exons, or other entities that are expected to produce distinct 
##' biological phenomena related to the gene that should be interpreted separately. For this reason, the `geneID` column 
##' encodes the official gene designation (typically an ensembl or entrez gene identifier) while the `geneSymbol` column
##' contains a human-readable descriptor of the gRNA target (such as a gene symbol or promoter name). This mapping can be 
##' further expanded to incorporate mapping ambiguity via the `ct.expandAnnotation()` function.
##' 
##' @param ann A \code{data.frame} containing an annotation object with gRNA-level information encoded as rows. The 
##' \code{row.names} attribute should correspond to the individual gRNAs, and it should at minimum contain columns 
##' named 'geneID' and 'geneSymbol' indicating the corresponding gRNA target gene ID and symbol, respectively. 
##' @param object If supplied, an object with \code{row.names} to be used to subset the supplied annotation frame
##' for downstream analysis.
##' @param controls The name of a value in the \code{geneSymbol} column of \code{ann} that corresponds to nontargeting 
##' control gRNAs. May also be supplied as a logical value, in which case the function will try to identify and format 
##' nontargeting guides. 
##' @param throw.error Logical indicating whether to throw an error when \code{controls} is \code{TRUE} but no nontargeting
##' gRNAs are detected. 
##' @return A new annotation data frame, usually with nontargeting controls and NA values reformatted to \code{NoTarget} 
##' (and \code{geneID} set to \code{'no_gid'}),  and the 'geneSymbol' column of \code{ann} factorized. If supplied with 
##' an \code{object}, the gRNAs not present in the \code{object} will be omitted. 
##' @author Russell Bainer
##' @examples 
##' data('ann')
##' data('es')
##' es <- ct.filterReads(es)
##' newann <- ct.prepareAnnotation(ann, es)
##' @export

ct.prepareAnnotation <- function(ann, object = NULL, controls = TRUE, throw.error = TRUE) {
    if (!(length(setdiff(c("geneSymbol", "geneID"), colnames(ann))) == 0)) {
        stop("The annotation object must contain a geneSymbol column.")
    }


    exception <- ifelse(throw.error, stop, warning)

    # Add an `ID` column if not present
    if (!("ID" %in% names(ann))) {
        ann$ID <- row.names(ann)
        message("Adding row.names as \"ID\".")
    }

    # Convert the geneID column to a charvec if it isn't already.
    if (!is.character(ann$geneID)) {
        ann$geneID <- as.character(ann$geneID)
    }
    if (any(is.na(ann$geneID))) {
        warning("NA detected within the geneID column; setting to no_gid...")
        ann$geneID[is.na(ann$geneID)] <- "no_gid"
    }



    # If supplied, trim out the gRNAs not present in the object.
    if (!is.null(object)) {

        if (length(row.names(object)) > 0) {

            if (any(!is.element(row.names(object), row.names(ann)))) {
                stop("The supplied object contains rows not present in the annotation file. Please omit these elements prior to downstream analyses.")
            }

            omit <- length(setdiff(row.names(ann), row.names(object)))
            if (omit > 0) {
                message(omit, " elements defined in the annotation file are not present in row names of the specified object. Omitting.")
            }

            ann <- ann[row.names(object), ]

        } else {
            warning("The supplied object has no row.names! Ignorning.")
        }
    }

    if (!is.character(controls)) {
        geneSymb <- "NoTarget"
    } else {
        geneSymb <- as.character(controls)
        controls <- TRUE
    }

    if (controls) {
        ntc <- NULL
        if (any(geneSymb %in% ann$geneSymbol)) {
            ntc <- row.names(ann)[ann$geneSymbol %in% geneSymb]
        } else {
            message(geneSymb, " is not present in the geneSymbol column of the specified annotation file; trying to find something nontargeting...")

            if ((sum(is.na(ann$geneSymbol)) > 0) && (sum(ann$geneID %in% "no_gid") > 0)) {
                message("NA and \"no_gid\" elements are both present in the supplied annotation, so I am using the \"no_gid\" elements. If you wish to select another set of gRNAs, please change geneSymb.")
            }

            if (sum(ann$geneID %in% "no_gid") > 0) {
                ntc <- row.names(ann)[ann$geneID %in% "no_gid"]
                message("I found some gRNAs targeting \"no_gid\". Let's use that.")
            } else if (sum(is.na(ann$geneSymbol)) > 0) {
                ntc <- row.names(ann)[is.na(ann$geneSymbol)]
                message("No \"no_gid\" geneIDs in the annotation file, Using gRNAs targeting geneSymbol NA.")
            } else {
                exception("I cannot find any obvious control guides in the supplied annotation, so I am assuming that they are absent. Please specify a geneSymbol if you know something I do not.")
                NULL
            }
        }
        # Compel the NTCs to the proper values
        if (!is.null(ntc)) {
            ann[ntc, "geneSymbol"] <- "NoTarget"
            ann[ntc, "geneID"] <- "no_gid"
        }

    }

    # Plug any remaining holes.
    if (sum(is.na(ann[, "geneSymbol"])) > 0) {
        warning("NAs present in the annotation geneSymbol column. These will be collected into an element called \"Unknown\".", call. = TRUE)
        ann[is.na(ann[, "geneSymbol"]), "geneSymbol"] <- "Unknown"
    }
    ann$geneSymbol <- as.factor(ann$geneSymbol)
    ann <- droplevels(ann)
    return(ann)
}


##' @title Expand an annotation object to allow annotations of reagents to multiple targets
##' @description This function takes a gCrisprTools annotation object and expands it to allow 1:many mappings of reagents. 
##' This mostly is used for internal processing, and users should interact with the wrapper functions that call it (e.g., `ct.generateResults`). 
##' 
##' Libraries targeting ambiguous biological elements (e.g., alternative promoters to a gene where the boundaries between
##' elements is contested) may contain reagents that are plausibly annotated to a finite set of possible targets. To accomodate this, users may 
##' supply an alternative reagent annotation in the form of a named list of vectors, where the names correspond to reagent `ID`s in the annotation 
##' object and each list element corresponds something coercible to a to a character vector of associated targets that will ultimately be assembled
##' into the `geneSymbol` column of the annotation object. It is assumed that the `geneID` values are assigned unambiguously to the reagents, 
##' and are passed through directly. 
##'
##' @param ann A \code{data.frame} containing an annotation object with gRNA-level information encoded as rows, typically produced by 
##' `ct.prepareAnnotation`. The `ID` column should correspond to the individual reagent identifiers. 
##' @param alt.annotation A named list of character vectors, which should be named identically to a value in the `ID` column of the supplied 
##' annotation object. The values in the character vectors will eventually form the `geneSymbol` column of the annotation file.
##' @return A new annotation data frame, expanded as described above.
##' @author Russell Bainer
##' @examples 
##' data('ann')
##' alt.annotation <- list('Target2089_b' = c('foo', 'bar'), 'Target2089_c' = 'foo', 'Target2089_a' = 'bar')
##' ct.expandAnnotation(ann, alt.annotation)
##' @export
ct.expandAnnotation <- function(ann, alt.annotation) {
    # input check
    ann <- ct.prepareAnnotation(ann)
    if (!("ID" %in% names(ann))) {
        stop("Annotation must contain a reagent-level \"ID\" column to enable expansion.")
    }
    stopifnot(is.list(alt.annotation), all(names(alt.annotation) %in% ann$ID))
    alt.annotation <- lapply(alt.annotation, as.character)

    aa.len <- lengths(alt.annotation)

    if (sum(aa.len == 0) > 0) {
        message("Removing ", (sum(aa.len == 0) > 0), " reagents that were not assigned to a target.")
        alt.annotation <- alt.annotation[aa.len > 0]
    }

    # Subselect relevant annotation rows, and then synchronize rows with alt.ann names
    out <- ann[ann$ID %in% names(alt.annotation), ]
    alt.annotation <- alt.annotation[out$ID]

    # Expand the annotation and update the geneSymbol column
    out <- out[rep(seq_len(nrow(out)), lengths(alt.annotation)), ]
    out$geneSymbol <- unlist(alt.annotation)

    return(out)
}


##' @title Parse `geneSymbol` values to construct an alternative annotation list
##' @description This is an accessory function to `ct.expandAnnotation()` function, which enables users to expand annotation objects 
##' to accomodate reagent libraries where reagents are expected to impact a set of known targets. See documentation for that function for 
##' additional details. 
##' 
##' Often, libraries that contain multiply-targeting reagents are annotated using a structured format that can be decomposed by regex matching. 
##' This function takes in an annotation object containing an `ID` column indicating the reagent ID and a `geneSymbol` column containing the 
##' target mappings, and parses the target mappings according to a known annotation format. Currently supported formats are 'cellecta' 
##' (e.g., 'TARGET_P1P2P3' indicating multiple promoters associated with a known target), and 'underscore', where different targets are 
##' concatenated using the underscore separator (e.g., 'TARGET1_TARGET2_TARGET3').
##' 
##' Returns an `alt.annotation`-type list of character vectors encoding the target mappings for each reagent. 
##'
##' @param ann A \code{data.frame} containing reagent-level information encoded as rows. The `ID` column should correspond to the individual 
##' reagent identifiers, and the 'geneSymbol' column should contain target annotation strings to be parsed (both are coerced to strings). 
##' Does not, strictly speaking, need to be a proper annotation object, but one of those will work. 
##' @param format Format of the geneSymbol column strings.
##' @return A named `alt.annotation`-type list of character vectors encoding the target mappings for each reagent
##' @author Russell Bainer
##' @examples 
##' fakeann <- data.frame('ID' = LETTERS[1:4], 'geneSymbol' = c('T1_P1', 'T1_P1P2', 'T1_P2P1', 'T1_P2'))
##' ct.parseGeneSymbol(fakeann, 'cellecta')
##' ct.parseGeneSymbol(fakeann, 'underscore')
##' @export
ct.parseGeneSymbol <- function(ann, format = c("cellecta", "underscore")) {

    format <- match.arg(format)
    stopifnot(all(c("ID", "geneSymbol") %in% names(ann)))

    reagents <- as.character(ann$ID)
    symbols <- as.character(ann$geneSymbol)

    if (format %in% "cellecta") {

        # Cellecta is dumb and sometimes annotate a single set of guides to multiple promoters
        core <- vapply(symbols, function(x) {
            strsplit(x, split = "_")[[1]][1]
        }, character(1))
        ntarg <- tapply(ann$geneSymbol, core, function(x) {
            length(unique(x))
        })
        unary <- names(ntarg)[ntarg == 1]
        pass <- core %in% unary

        out <- lapply(seq.int(1, length(symbols)), function(x) {

            if (pass[x]) {
                return(symbols[x])
            }

            splut <- strsplit(symbols[x], split = "_")[[1]]

            if (splut[1] == symbols[1]) 
                {
                  return(x)
                }  #Return the original genesymbol if no underscores present

            prom <- strsplit(splut[2], split = "P")[[1]]
            prom <- prom[prom != ""]

            return(paste0(splut[1], "_P", prom))
        })
    }
    if (format %in% "underscore") {
        out <- lapply(symbols, function(x) {
            return(strsplit(x, split = "_")[[1]])
        })
    }

    names(out) <- reagents
    return(out)
}

## ----setup, eval = TRUE-------------------------------------------------------
suppressPackageStartupMessages(library(Biobase))
suppressPackageStartupMessages(library(limma))
suppressPackageStartupMessages(library(gCrisprTools))

data("es", package = "gCrisprTools")
data("ann", package = "gCrisprTools")
data("aln", package = "gCrisprTools")
knitr::opts_chunk$set(message = FALSE, fig.width = 8, fig.height = 8, warning = FALSE)

## ----eval = TRUE--------------------------------------------------------------
sk <- relevel(as.factor(pData(es)$TREATMENT_NAME), "ControlReference")
names(sk) <- row.names(pData(es))

## ----eval = TRUE--------------------------------------------------------------
design <- model.matrix(~ 0 + REPLICATE_POOL + TREATMENT_NAME, pData(es))
colnames(design) <- gsub('TREATMENT_NAME', '', colnames(design))
contrasts <-makeContrasts(DeathExpansion - ControlExpansion, levels = design)

## ----eval = TRUE, fig.width = 8, fig.height = 10------------------------------
es <- ct.filterReads(es, trim = 1000, sampleKey = sk)

## ----eval = TRUE, fig.width = 6, fig.height = 12------------------------------
es <- ct.normalizeGuides(es, method = "scale", plot.it = TRUE) #See man page for other options
vm <- voom(exprs(es), design)

fit <- lmFit(vm, design)
fit <- contrasts.fit(fit, contrasts)
fit <- eBayes(fit)

## ----eval = TRUE--------------------------------------------------------------
ann <- ct.prepareAnnotation(ann, fit, controls = "NoTarget")

## ----eval = TRUE--------------------------------------------------------------
resultsDF <-
  ct.generateResults(
    fit,
    annotation = ann,
    RRAalphaCutoff = 0.1,
    permutations = 1000,
    scoring = "combined", 
    permutation.seed = 2
  )

## ----eval = TRUE--------------------------------------------------------------

# Create random alternative target associations 

altann <- sapply(ann$ID, 
                 function(x){
                   out <- as.character(ann$geneSymbol)[ann$ID %in% x]
                   if(runif(1) < 0.01){out <- c(out, sample(as.character(ann$geneSymbol), size = 1))}
                   return(out)
                 }, simplify = FALSE)

resultsDF <-
  ct.generateResults(
    fit,
    annotation = ann,
    RRAalphaCutoff = 0.1,
    permutations = 1000,
    scoring = "combined", 
    alt.annotation = altann,
    permutation.seed = 2
  )

## ----eval = TRUE--------------------------------------------------------------
data("fit", package = "gCrisprTools")
data("resultsDF", package = "gCrisprTools")

fit <- fit[(row.names(fit) %in% row.names(ann)),]
resultsDF <- resultsDF[(row.names(resultsDF) %in% row.names(ann)),]

targetResultDF <- ct.simpleResult(resultsDF) #For a simpler target-level result object

## ----eval = TRUE--------------------------------------------------------------
ct.alignmentChart(aln, sk)
ct.rawCountDensities(es, sk)

## ----eval = TRUE--------------------------------------------------------------
ct.gRNARankByReplicate(es, sk) 
ct.gRNARankByReplicate(es, sk, annotation = ann, geneSymb = "NoTarget")  #Show locations of NTC gRNAs

## ----eval = TRUE--------------------------------------------------------------
ct.viewControls(es, ann, sk, normalize = FALSE)
ct.viewControls(es, ann, sk, normalize = TRUE)

## ----eval = TRUE, fig.width = 8, fig.height = 12------------------------------
ct.GCbias(es, ann, sk)
ct.GCbias(fit, ann, sk)

## ----eval = TRUE--------------------------------------------------------------
ct.stackGuides(es,
               sk,
               plotType = "gRNA",
               annotation = ann,
               nguides = 40)

## ----eval = TRUE--------------------------------------------------------------
ct.stackGuides(es, 
               sk, 
               plotType = "Target", 
               annotation = ann)

## ----eval = TRUE--------------------------------------------------------------
ct.stackGuides(es,
               sk,
               plotType = "Target",
               annotation = ann,
               subset = names(sk)[grep('Expansion', sk)])

## ----eval = TRUE--------------------------------------------------------------
ct.guideCDF(es, sk, plotType = "gRNA")
ct.guideCDF(es, sk, plotType = "Target", annotation = ann)

## ----eval = TRUE--------------------------------------------------------------
ct.contrastBarchart(resultsDF)

## ----eval = TRUE--------------------------------------------------------------
ct.topTargets(fit,
              resultsDF,
              ann,
              targets = 10,
              enrich = TRUE)
ct.topTargets(fit,
              resultsDF,
              ann,
              targets = 10,
              enrich = FALSE)

## ----eval = TRUE, fig.width = 8, fig.height = 10------------------------------
ct.viewGuides("Target1633", fit, ann)
ct.gRNARankByReplicate(es, sk, annotation = ann, geneSymb = "Target1633")

## ----eval = TRUE--------------------------------------------------------------
ct.signalSummary(resultsDF,
                 targets = list('TargetSetA' = c(sample(unique(resultsDF$geneSymbol), 3)),
                                'TargetSetB' = c(sample(unique(resultsDF$geneSymbol), 2))))

## ----eval = TRUE--------------------------------------------------------------
data("essential.genes", package = "gCrisprTools")
ct.targetSetEnrichment(resultsDF, essential.genes)

## ----rocprc, eval = TRUE------------------------------------------------------
ROC <- ct.ROC(resultsDF, essential.genes, direction = "deplete")
PRC <- ct.PRC(resultsDF, essential.genes, direction = "deplete")
show(ROC) # show(PRC) is equivalent for the PRC analysis

## ----eval = TRUE, warning=FALSE, message = FALSE------------------------------
#Create a geneset database using one of the many helper functions
genesetdb <- sparrow::getMSigGeneSetDb(collection = 'h', species = 'human', id.type = 'entrez')

ct.seas(resultsDF, gdb = genesetdb)

# If you have a library that targets elements unevenly (e.g., variable numbers of 
# elements/promoters per genes), you can conform it via `sparrow::convertIdentifiers()`

genesetdb.GREAT <- sparrow::convertIdentifiers(genesetdb, 
                                               from = 'geneID', 
                                               to = 'geneSymbol', 
                                               xref = ann)
ct.seas(resultsDF, gdb = genesetdb.GREAT)

## ----eval = FALSE-------------------------------------------------------------
# path2report <-      #Make a report of the whole experiment
#   ct.makeReport(fit = fit,
#                 eset = es,
#                 sampleKey = sk,
#                 annotation = ann,
#                 results = resultsDF,
#                 aln = aln,
#                 outdir = ".")
# 
# path2QC <-          #Or one focusing only on experiment QC
#   ct.makeQCReport(es,
#                   trim = 1000,
#                   log2.ratio = 0.05,
#                   sampleKey = sk,
#                   annotation = ann,
#                   aln = aln,
#                   identifier = 'Crispr_QC_Report',
#                   lib.size = NULL
#                   )
# 
# path2Contrast <-    #Or Contrast-specific one
#   ct.makeContrastReport(eset = es,
#                         fit = fit,
#                         sampleKey = sk,
#                         results = resultsDF,
#                         annotation = ann,
#                         comparison.id = NULL,
#                         identifier = 'Crispr_Contrast_Report')

## -----------------------------------------------------------------------------
sessionInfo()

##' gCrisprTools
##'
##' Pipeline for using CRISPR screen data
##'
##' @docType package
##' @name gCrisprTools-package
NULL

##' @import Biobase
##' @import limma
##' @import ggplot2
##' @import parallel
##' @import grid
##' @importFrom grDevices colorRampPalette rgb
##' @importFrom graphics abline axis barplot layout legend lines mtext par plot points polygon segments hist text
##' @importFrom stats density lm median na.omit p.adjust pbeta phyper predict pt smooth.spline spline qnorm
##' @importFrom utils capture.output getFromNamespace combn
##' @importFrom rmarkdown render draft 
##' @importFrom ComplexHeatmap UpSet HeatmapAnnotation decorate_annotation %v% anno_barplot anno_points order.comb_mat
##' @importFrom methods is
NULL

##' @name es
##' @aliases es
##' @docType data
##' @title ExpressionSet of count data from a Crispr screen with strong selection
##' @description
##' Expressionset of raw counts from a screen in mouse cells performed at Genentech, Inc. 
##' All sample, gRNA, and Gene information has been anonymized and randomized. 
##' @examples
##' data('es')
##' print(es)
##' @seealso Please see \file{vignettes/Crispr_example_workflow.R} for details.
##' @source Genentech, Inc.
NULL

##' @name ann
##' @aliases ann
##' @docType data
##' @title Annotation file for a mouse Crispr library
##' @description
##' Example annotation file for the screen data provided in \code{es}. 
##' All sample, gRNA, and Gene information has been anonymized and randomized. 
##' @examples
##' data('ann')
##' head(ann)
##' @seealso Please see \file{vignettes/Crispr_example_workflow.R} for details.
##' @source Genentech, Inc.
NULL

##' @name fit
##' @aliases fit
##' @docType data
##' @title Precalculated contrast fit from a Crispr screen 
##' @description A precalculated fit object (class \code{MArrayLM}) comparing the death 
##' and control expansion arms of a crispr screen performed at Genentech, Inc. 
##' All sample, gRNA, and Gene information has been anonymized and randomized. 
##' @examples
##' data('fit')
##' show(fit)
##' @seealso Please see \file{vignettes/Crispr_example_workflow.R} for model details.
##' @source Genentech, Inc.
NULL

##' @name resultsDF
##' @aliases resultsDF
##' @docType data
##' @title Precalculated gene-level summary of a crispr screen 
##' @description A precalculated summary Dataframe comparing the death and control expansion arms of 
##' the provided example Crispr screen (using 8 cores, seed = 2). 
##' All sample, gRNA, and Gene information has been anonymized and randomized. 
##' @examples
##' data('resultsDF')
##' head(resultsDF)
##' @seealso Please see \file{vignettes/Crispr_example_workflow.R} for model details.
##' @source Genentech, Inc.
NULL

##' @name aln
##' @aliases aln
##' @docType data
##' @title Precalculated alignment statistics of a crispr screen 
##' @description Example alignment matrix file for the provided example Crispr screen.
##' All sample, gRNA, and Gene information has been anonymized and randomized. 
##' @examples
##' data('aln')
##' head(aln)
##' @seealso Please see \file{vignettes/Crispr_example_workflow.R} for details.
##' @source Genentech, Inc.
NULL

##' @name essential.genes
##' @aliases essential.genes
##' @docType data
##' @title Artificial list of 'essential' genes in the example Crispr screen 
##' included for plotting purposes 
##' @description Example gene list, designed to demonstrate functions using gene lists.
##' All sample, gRNA, and Gene information has been anonymized and randomized. 
##' @examples
##' data('essential.genes')
##' essential.genes
##' @seealso Please see \file{vignettes/Crispr_example_workflow.R} for details.
##' @source Russell Bainer
NULL

##' @title View nontargeting guides within an experiment
##' @description This function tries to identify, and then plot the abundance of, the full set of non-targeting controls from an ExpressionSet
##' object. Ideally, the user will supply a geneSymbol present in the appropriate annotation file that uniquely identifies the nontargeting gRNAs.
##' Absent this, the the function will search for common identifier used by nontargeting controls (geneID 'no_gid', or geneSymbol NA).
##' @param eset An ExpressionSet  object containing, at minimum, a matrix of gRNA abundances extractable with the \code{exprs} function.
##' @param annotation An annotation data.frame for the experiment. gRNAs are annotated by
##' row, and must minimally contain columns \code{geneSymbol} and \code{geneID}.
##' @param sampleKey A sample key, supplied as an ordered factor linking the samples to experimental
##' variables. The \code{names} attribute should exactly match those present in \code{eset}, and the control condition is assumed to be
##' the first \code{level}.
##' @param geneSymb The \code{geneSymbol} identifier in \code{annotation} that corresponds to nontargeting gRNAs. If absent, \code{ct.ViewControls} will
##' attempt to infer nontargeting guides by searching for \code{'no_gid'} or \code{NA} in the appropriate columns.
##' @param normalize Logical indicating whether to attempt to normalize the data in the \code{eset} by DESeq size factors present in the metadata. If \code{TRUE},
##' then the metadata must contain a column containing these factors, named \code{sizeFactor.crispr-gRNA}.
##' @param lib.size An optional vector of voom-appropriate library size adjustment factors, usually calculated with \code{\link[edgeR]{calcNormFactors}} 
##' and transformed to reflect the appropriate library size. These adjustment factors are interpreted as the total library sizes for each sample, 
##' and if absent will be extrapolated from the columnwise count sums of the \code{exprs} slot of the \code{eset}.
##' @return An image of nontargeting control gRNA abundances on the default device.
##' @author Russell Bainer
##' @examples 
##' data('es')
##' data('ann')
##' 
##' #Build the sample key
##' library(Biobase)
##' sk <- ordered(relevel(as.factor(pData(es)$TREATMENT_NAME), 'ControlReference'))
##' names(sk) <- row.names(pData(es))
##' 
##' ct.viewControls(es, ann, sk, geneSymb = NULL, normalize = FALSE)
##' ct.viewControls(es, ann, sk, geneSymb = NULL, normalize = TRUE)
##' @export

ct.viewControls <- function(eset, annotation, sampleKey, geneSymb = NULL, normalize = TRUE, lib.size = NULL) {
    # current.graphic.params <- par(no.readonly = TRUE) on.exit(suppressWarnings(par(current.graphic.params)))

    annotation <- ct.prepareAnnotation(annotation, object = eset, throw.error = FALSE)
    sampleKey <- ct.keyCheck(sampleKey, eset)

    if (is.null(lib.size)) {
        lib.size <- colSums(exprs(eset))
    } else if (!is.numeric(lib.size) | (length(lib.size) != ncol(eset))) {
        stop("If specified, lib.size must be a numeric vector of length equal to the number of samples.")
    }

    # Find the row.names that correspond to the guides.
    if (!is.null(geneSymb)) {
        if (!(geneSymb %in% annotation$geneSymbol)) {
            geneSymb <- NULL
        }
    }

    if (is.null(geneSymb)) {
        message("No control geneSymbol supplied, so I'll use the default of 'NoTarget'.")
        ntc <- row.names(annotation)[annotation$geneSymbol == "NoTarget"]
    } else {
        ntc <- row.names(annotation)[annotation$geneSymbol == geneSymb]
    }

    if (length(ntc) < 1) {
        stop("No controls detected.")
    }

    colorSpace <- colorRampPalette(c("lightblue", "darkred"))(length(ntc))
    plottitle <- paste0(geneSymb, " Guide Abundance (Raw Reads)")

    if (normalize) {
        message("Normalizing gRNAs by median scaling.")
        if (is.null(annotation)) {
            eset <- ct.normalizeGuides(eset, "scale", sampleKey = sampleKey, lib.size = lib.size, plot.it = FALSE)
        } else {
            eset <- ct.normalizeGuides(eset, "scale", annotation = annotation, sampleKey = sampleKey, lib.size = lib.size, plot.it = FALSE)
        }
        plottitle <- paste0(geneSymb, " Guide Abundance (Median Scaled)")
    }

    counts <- exprs(eset)[ntc, names(sampleKey)[order(sampleKey)]]
    counts <- (log2(t(counts + 0.5)/(lib.size + 1) * 1e+06))
    counts <- counts[, order(colMeans(counts))]

    # Set up and draw the plot
    ylimit <- range(counts) + c(-1, 1)
    xlimit <- nrow(counts)

    par(mar = c(10, 4, 4, 6), xpd = TRUE)
    plot(seq_len(xlimit), counts[, 1], main = plottitle, ylab = "Log2 Normalized Counts", xlab = "", xaxt = "n", xlim = c(1, xlimit), ylim = ylimit, type = "l", lwd = 2, 
        col = colorSpace[1])
    for (q in 2:ncol(counts)) {
        lines(seq_len(xlimit), counts[, q], lwd = 2, col = colorSpace[q])
    }
    axis(side = 1, labels = sampleKey[order(sampleKey)], at = seq_len(xlimit), las = 3)
    legend(xlimit + 1, ylimit[2], legend = colnames(counts), fill = colorSpace, cex = 0.5)
}

## ----eval = FALSE-------------------------------------------------------------
# if (!requireNamespace("BiocManager", quietly=TRUE))
#     install.packages("BiocManager")
# BiocManager::install("gCrisprTools")

## ----message=FALSE, warning=FALSE---------------------------------------------
library(Biobase)
library(limma)
library(gCrisprTools)

## -----------------------------------------------------------------------------
data("es", package = "gCrisprTools")
es
head(exprs(es))

## -----------------------------------------------------------------------------
data("ann", package = "gCrisprTools")
head(ann)

## -----------------------------------------------------------------------------
sk <- relevel(as.factor(pData(es)$TREATMENT_NAME), "ControlReference")
names(sk) <- row.names(pData(es))
sk

## ----fig.width = 7, fig.height = 5--------------------------------------------
data("aln", package = "gCrisprTools")
head(aln)
ct.alignmentChart(aln, sk)

## ----fig.width=6, fig.height = 8----------------------------------------------
es.floor <- ct.filterReads(es, read.floor = 30, sampleKey = sk)
es <- ct.filterReads(es, trim = 1000, log2.ratio = 4, sampleKey = sk)

##Convenience function for conforming the annotation object to exclude the trimmed gRNAs
ann <- ct.prepareAnnotation(ann, es, controls = "NoTarget")

## ----fig.width=6, fig.height = 8----------------------------------------------

es <- ct.normalizeGuides(es, 'scale', annotation = ann, sampleKey = sk, plot.it = TRUE)

timepoints <- gsub('^(Control|Death)', '', pData(es)$TREATMENT_NAME)
names(timepoints) <- colnames(es)
es.norm <- ct.normalizeGuides(es, 'FQ', annotation = ann, sampleKey = timepoints, plot.it = TRUE)

es.norm <- ct.normalizeGuides(es, 'slope', annotation = ann, sampleKey = sk, plot.it = TRUE)
es.norm <- ct.normalizeGuides(es, 'controlScale', annotation = ann, sampleKey = sk, plot.it = TRUE, geneSymb = 'NoTarget')
es.norm <- ct.normalizeGuides(es, 'controlSpline', annotation = ann, sampleKey = sk, plot.it = TRUE, geneSymb = 'NoTarget')

## ----eval= FALSE--------------------------------------------------------------
# #Not run:
# path2QC <- ct.makeQCReport(es,
#                  trim = 1000,
#                  log2.ratio = 0.05,
#                  sampleKey = sk,
#                  annotation = ann,
#                  aln = aln,
#                  identifier = 'Crispr_QC_report',
#                  lib.size = NULL
#                  )

## ----fig.width=6, fig.height=6------------------------------------------------
ct.rawCountDensities(es, sk)

## ----fig.width=6, fig.height = 6----------------------------------------------
ct.gRNARankByReplicate(es, sk)  #Visualization of gRNA abundance distribution

## ----fig.width=6, fig.height = 6----------------------------------------------
ct.gRNARankByReplicate(es, sk, annotation = ann, geneSymb = "Target1633")

## ----fig.width=6, fig.height = 6----------------------------------------------
ct.viewControls(es, ann, sk, normalize = FALSE, geneSymb = 'NoTarget')

## ----fig.width=6, fig.height = 4----------------------------------------------
ct.guideCDF(es, sk, plotType = "gRNA")

## -----------------------------------------------------------------------------
design <- model.matrix(~ 0 + REPLICATE_POOL + TREATMENT_NAME, pData(es))
colnames(design) <- gsub('TREATMENT_NAME', '', colnames(design))
contrasts <-makeContrasts(DeathExpansion - ControlExpansion, levels = design)

vm <- voom(exprs(es), design)

fit <- lmFit(vm, design)
fit <- contrasts.fit(fit, contrasts)
fit <- eBayes(fit)

## ----message=FALSE, warning=FALSE---------------------------------------------
resultsDF <-
  ct.generateResults(
    fit,
    annotation = ann,
    RRAalphaCutoff = 0.1,
    permutations = 1000,
    scoring = "combined"
  )

## ----fig.width=6, fig.height = 6----------------------------------------------
ct.topTargets(fit,
              resultsDF,
              ann,
              targets = 10,
              enrich = TRUE)

## ----fig.width=6, fig.height = 8----------------------------------------------
ct.stackGuides(
  es,
  sk,
  plotType = "Target",
  annotation = ann,
  subset = names(sk)[grep('Expansion', sk)]
)

## ----fig.width=6, fig.height = 4----------------------------------------------
ct.viewGuides("Target1633", fit, ann)

## ----fig.width=6, fig.height = 4----------------------------------------------
ct.signalSummary(resultsDF,
                 targets = list('TargetSetA' = c(sample(unique(resultsDF$geneSymbol), 3)),
                                'TargetSetB' = c(sample(unique(resultsDF$geneSymbol), 2))))


## ----eval= FALSE--------------------------------------------------------------
# #Not run:
# path2Contrast <-
#   ct.makeContrastReport(eset = es,
#                         fit = fit,
#                         sampleKey = sk,
#                         results = resultsDF,
#                         annotation = ann,
#                         comparison.id = NULL,
#                         identifier = 'Crispr_Contrast_Report')

## ----eval=FALSE---------------------------------------------------------------
# #Not run:
# path2report <-
#   ct.makeReport(fit = fit,
#                 eset = es,
#                 sampleKey = sk,
#                 annotation = ann,
#                 results = resultsDF,
#                 aln = aln,
#                 outdir = ".")

## ----eval= FALSE--------------------------------------------------------------
# #Not run:
# genesetdb <- sparrow::getMSigGeneSetDb(collection = 'h', species = 'human', id.type = 'entrez')
# 
# # If you have a library that targets elements unevenly (e.g., variable numbers of
# # elements/promoters per genes), you can conform it via GREAT
# genesetdb.GREAT <- ct.GREATdb(ann, gsdb = genesetdb)
# 
# ct.seas(resultsDF, gdb = genesetdb)
# #ct.seas(resultsDF, gdb = genesetdb.GREAT)

## ----fig.width=6, fig.height = 6, warning=FALSE-------------------------------
data("essential.genes", package = "gCrisprTools")  #Artificial list created for demonstration
data("resultsDF", package = "gCrisprTools")
ROC <- ct.ROC(resultsDF, essential.genes, 'enrich')
str(ROC)

## ----fig.width=6, fig.height = 6, warning=FALSE-------------------------------
PRC <- ct.PRC(resultsDF, essential.genes, 'enrich')
str(PRC)

## ----fig.width=6, fig.height = 6, warning=FALSE-------------------------------
##' tar <-  sample(unique(resultsDF$geneSymbol), 20)
##' res <- ct.targetSetEnrichment(resultsDF, tar)

targetsTest <- ct.targetSetEnrichment(resultsDF, essential.genes, enrich = FALSE)
str(targetsTest)

## -----------------------------------------------------------------------------
sessionInfo()

##' @title Generate a cumulative tally of reads by guide rank
##' @description This function returns a numeric vector of the same length as the input, where each element \code{n} contains the proportion
##' the sum of the full vector that is captured by its first \code{1-n} elements (arranged in descending order).  
##' @param vector An input numeric vector to be aggregated. 
##' @return A numeric vector of the cumulative sum
##' @author Russell Bainer
##' @keywords internal
ct.ecdf <- function(vector) {
    sorted <- as.numeric(sort(vector, decreasing = TRUE))
    out <- unlist(lapply(seq_along(sorted), function(x) {
        sum(sorted[seq_len(x)])
    }))/sum(sorted)
    return(out)
}

##' @title View CDFs of the ranked gRNAs or Targets present in a crispr screen
##' @description This function generates a plot relating the cumulative proportion of reads in each sample of a crispr screen to the abundance rank of the 
##' underlying guides (or Targets). The purpose of this algorithm is to detect potential distortions in the library composition 
##' that might not be properly controlled by sample normalization (see also: \code{ct.stackedGuides()}).
##' @param eset An ExpressionSet  object containing, at minimum, a matrix of gRNA abundances extractable with the exprs() function.
##' @param sampleKey An optional sample key, supplied as an ordered factor linking the samples to experimental 
##' variables. The \code{names} attribute should exactly match those present in \code{eset}, and the control set is assumed to be 
##' the first \code{level}.
##' @param plotType A string indicating whether the individual guides should be displayed ('\code{gRNA}'), or if they should be aggregated into target-level
##' estimates ('\code{Target}') according to the \code{geneSymbol} column in the \code{annotation} object.  
##' @param annotation An optional data.frame containing an annotation object to be used to aggregate the guides into targets. gRNAs are annotated by row, 
##' and must minimally contain a column \code{geneSymbol} indicating the target elements.
##' @return A CDF plot displaying the appropriate CDF curves on the default device. 
##' @author Russell Bainer
##' @examples data('es')
##' ct.guideCDF(es)
##' @export

ct.guideCDF <- function(eset, sampleKey = NULL, plotType = "gRNA", annotation = NULL) {

    current.graphic.params <- par(no.readonly = TRUE)
    on.exit(suppressWarnings(par(current.graphic.params)))

    if (!methods::is(eset, "ExpressionSet")) {
        stop("eset must be an expressionset object.")
    }
    if (!(plotType %in% c("gRNA", "Target"))) {
        stop("Please specify \"gRNA\" or \"Target\" to be displayed.")
    }

    # Extract and preprocess data
    d <- exprs(eset)
    legendnames <- colnames(d)

    if (!is.null(sampleKey)) {
         sampleKey <- ct.keyCheck(sampleKey, eset)
         d <- d[, names(sampleKey)[order(sampleKey)]]
         legendnames <- paste(sampleKey[colnames(d)], colnames(d), sep = "_")
        } 

    if (plotType == "Target") {
        if (is.null(annotation) | !("geneSymbol" %in% names(annotation))) {
            stop("An annotation object containing a \"geneSymbol\" column must be supplied 
           to display target-level representation.")
        }

        annotation <- ct.prepareAnnotation(annotation, eset, throw.error = FALSE)

        message("Summarizing gRNA counts into targets.")

        genects <- lapply(unique(annotation$geneSymbol), function(x) {
            if (sum(annotation$geneSymbol %in% x) > 1) {
                colSums(d[row.names(annotation)[annotation$geneSymbol %in% x], ])
            } else {
                d[row.names(annotation)[annotation$geneSymbol %in% x], ]
            }
        })
        d <- data.frame(t(simplify2array(genects)))
        row.names(d) <- unique(annotation$geneSymbol)
    }

    d.rank <- apply(d, 2, ct.ecdf)

    # plot it
    colorSpace <- colorRampPalette(c("blue", "lightblue", "darkred"))(ncol(d.rank))

    plot(seq_len(nrow(d)), d.rank[, 1], pch = 20, col = colorSpace[1], xlim = c(0, nrow(d.rank)), xlab = paste(plotType, "Abundance Rank"), ylab = "Cumulative Proportion of Reads", 
        main = paste("Cumulative Proportion of Reads by", plotType, "Rank"))

    for (z in 2:ncol(d.rank)) {
        lines(seq_len(nrow(d)), d.rank[, z], pch = 20, col = colorSpace[z], new = FALSE)
    }
    legend("bottomright", legend = legendnames, fill = colorSpace, ncol = 2, cex = 0.5)
}

##' @title Assign Colors Based on the Position of a Value in a Distribution
##' @description This is a function to generate colors for plot elements on the basis of the position of a value within a distribution. 
##' Called internally by ct.viewGuides. 
##' @param exprs The value whose color is to be returned. 
##' @param rankedexprs A vector of values the length of cols that corresponds to the values in the distribution.
##' @param colors The vector of colors to be used as a reference. 
##' @return A value contained in cols. 
##' @keywords internal
##' @author Russell Bainer
ct.exprsColor <- function(exprs, rankedexprs, colors) {
    colors[which(abs(rankedexprs - exprs) == min(abs(rankedexprs - exprs)))]
}

##' @title Draw a horizontal line of a specified color.
##' @description This is a function called internally by ct.viewGuides to generate the color legend. End users should not use it. 
##' @param x,y Minimal coordinates to specify the line, which is drawn from the Y axis. 
##' @param color Guess!
##' @param width Line width. 
##' @return A line on an open device. 
##' @keywords internal
##' @author Russell Bainer
ct.drawFlat <- function(x, y, color, width = 1) {
    lines(c(0, x), c(y, y), col = color, lwd = width)
}

##' @title Draw a density color legend. 
##' @description This is a function called internally by ct.viewGuides to generate the color legend. End users should not use it. 
##' @param dens A density object. 
##' @param colorscale A vector of colors to draw behind the density. 
##' @return A color legend on the current graphics device. 
##' @keywords internal
##' @author Russell Bainer
ct.drawColorLegend <- function(dens, colorscale) {
    yrange <- (rep(max(abs(range(dens$x))), 2) * c(-1, 1))

    plot(NA, xlim = c(0, max(dens$y)), ylim = range(dens$x), xaxt = "n", xlab = "", ylab = "Log2 Normalized Reads", bty = "n")
    invisible(mapply(ct.drawFlat, x = rep(max(dens$y), length(colorscale)), y = seq(yrange[2], yrange[1], length.out = length(colorscale)), width = 2, color = colorscale))
    polygon(x = dens$y, y = dens$x, col = "black")
}

##' @title Generate a Plot of individual gRNA Pair Data in a Crispr Screen
##' @description This function generates a visualization of the effect estimates from a MArrayLM model result for all of the 
##' individual guides targeting a particular element, specified somewhere in the library annotation file. The estimated effect 
##' size and variance is plotted relative to zero for the specified contrast, with the color of the dot indicating the relative scale of the
##' of the guide intercept within the model framework, with warmer colors indicating lowly expressed guides. For comparison, the density of gRNA 
##' fold change estimates is privided in a pane on the right, with white lines indicating the exact levels of the individual guides. 
##' @param gene the name of the target element of interest, contained within the 'type' column of the annotation file.
##' @param fit An object of class MArrayLM containing, at minimum, an 'Amean' slot containing the guide level abundances, 
##' a 'coefficients' slot containing the effect estimates for each guide, and an 'stdev.unscaled' slot giving the coefficient standard Deviations. 
##' @param ann A data.frame object containing the gRNA annotations. 
##' At mimimum, it should have a column with the name specified by the \code{type} argument, containing the element targeted by each guide. 
##' @param type A character string indicating the column in ann containing the target of interest. 
##' @param contrast.term If a fit object with multiple coefficients is passed in, a string indiating the coefficient of interest.   
##' @param ylims An optional numeric vector of length 2 indicating the extremes of the y-axis scale. 
##' @return An image summarizing gRNA behavior within the specifed gene on the default device. 
##' @author Russell Bainer
##' @examples
##' data('fit')
##' data('ann')
##' ct.viewGuides('Target1633', fit, ann)
##' @export
ct.viewGuides <- function(gene, fit, ann, type = "geneSymbol", contrast.term = NULL, ylims = NULL) {
    current.graphic.params <- par(no.readonly = TRUE)
    on.exit(suppressWarnings(par(current.graphic.params)))

    par(xpd = FALSE)

    if (ncol(fit$coefficients) > 1) {
        if (is.null(contrast.term)) {
            stop("The fit object contains multiple coefficients. Please specify a contrast.term.")
        }
        fit <- ct.preprocessFit(fit, contrast.term)
    }



    # testing
    if (!methods::is(fit, "MArrayLM")) {
        stop(deparse(substitute(eset)), " is not an MArrayLM.")
    }

    # Find the gRNAs targeting the gene from the annotation, and order them
    options(warn = -1)
    ann <- ct.prepareAnnotation(ann, fit, controls = FALSE)
    options(warn = 0)

    if (!(sum(ann[, type] %in% gene))) {
        stop(gene, " is not present in the annotation file.")
    }

    grna.inx <- row.names(ann)[(ann[, type] %in% gene)]
    grna.inx <- sort(grna.inx)

    # Set up the color palette and the legend first:
    day3Density <- density(fit$coefficients)

    if (is.null(ylims)) {
        ylimit <- max(fit$coefficients)
        ylims <- range(c(min(0, (fit$coefficients[grna.inx, 1] - fit$stdev.unscaled[grna.inx, 1])), max(0, (fit$coefficients[grna.inx, 1] + fit$stdev.unscaled[grna.inx, 
            1]))))
    } else {
        if (any(length(na.omit(ylims)) != 2, !is.numeric(ylims), sum(is.infinite(ylims)) > 0)) {
            stop("ylims must be a numeric vector of length 2 containing finite values.")
        }
    }

    # Set up the guide colors based on their overall expression
    cols <- colorRampPalette(c("red", "orange", "white", "blue", "purple"))(1000)
    rankexprscolors <- seq(from = max(fit$Amean), to = min(fit$Amean), length.out = 1000)

    # Set up a couple of panes:
    layout(matrix(c(1, 2), ncol = 2, byrow = TRUE), widths = c(5, 0.5), heights = 3, respect = TRUE)
    par(mar = c(5, 4, 4, 2))

    plot(seq_len(length(grna.inx)), fit$coefficients[grna.inx, 1], ylab = "Log2(Fold Change)", main = gene, xlab = "", ylim = sort(ylims), col = vapply(fit$coefficients[grna.inx, 
        1], ct.exprsColor, character(1), rankedexprs = rankexprscolors, colors = cols), xaxt = "n", pch = 18)
    segments(seq_len(length(grna.inx)), fit$coefficients[grna.inx, 1], seq_len(length(grna.inx)), (fit$coefficients[grna.inx, 1] - fit$stdev.unscaled[grna.inx, 1]))
    segments(seq_len(length(grna.inx)), fit$coefficients[grna.inx, 1], seq_len(length(grna.inx)), (fit$coefficients[grna.inx, 1] + fit$stdev.unscaled[grna.inx, 1]))


    axis(1, at = seq_len(length(grna.inx)), labels = grna.inx, las = 2)
    abline(h = 0, lty = 4, col = "red")
    abline(v = (seq_len(length(grna.inx)) + 0.5), col = "grey")
    # title(main = )
    if (!is.null(contrast.term)) {
        mtext(contrast.term, side = 3, line = 0)
    }
    # Plop in the legend:
    par(mar = c(5, 1, 4, 1))

    ct.drawColorLegend(dens = day3Density, colorscale = cols)
    mapply(ct.drawFlat, x = rep(max(day3Density$y), length(grna.inx)), y = fit$coefficients[grna.inx, 1], width = 0.5, color = "black")
    lines(c(0, max(day3Density$y)), c(0, 0), col = "red", lty = "dashed")
    return(invisible(TRUE))
}

## ----setup--------------------------------------------------------------------
library(Biobase)
library(gCrisprTools)
knitr::opts_chunk$set(message = FALSE, fig.width = 8, fig.height = 8)

data(resultsDF)

head(resultsDF)


## -----------------------------------------------------------------------------
res <- ct.simpleResult(resultsDF, collapse = 'geneSymbol')
head(res)

## -----------------------------------------------------------------------------
# Make "another" result
res2 <- res
res2$best.p <- res2$best.p * runif(nrow(res2)) 
res2$direction[sample(1:nrow(res), 500)] <- res2$direction[sample(1:nrow(res), 500)]


regularized <- ct.regularizeContrasts(dflist = list('Experiment1' = res[1:1500,], 
                                                    'Experiment2' = res2[1:1900,]), 
                                      collapse = 'geneSymbol')

str(regularized)


## -----------------------------------------------------------------------------
comparison <- ct.compareContrasts(dflist = regularized,
                                  statistics = c('best.q', 'best.p'), 
                                  cutoffs = c(0.5,0.05), 
                                  same.dir = rep(TRUE, length(regularized)))

head(comparison, 30)


## -----------------------------------------------------------------------------
ct.compareContrasts(dflist = regularized,
                    statistics = c('best.q', 'best.p'),
                    cutoffs = c(0.5,0.05), 
                    same.dir = rep(TRUE, length(regularized)),
                    return.stats = TRUE)

## ----contrastbarchart, fig.width=6, fig.height = 5----------------------------
ct.contrastBarchart(regularized, background = FALSE, statistic = 'best.p')

## ----fig.width = 5, fig.height = 5--------------------------------------------
scat <- ct.scatter(regularized, 
                   targets = 'geneSymbol', 
                   statistic = 'best.p', 
                   cutoff = 0.05)

## -----------------------------------------------------------------------------
head(scat)

## ----contrast interaction, message = FALSE, warning=FALSE, fig.width = 6, fig.height = 12----
library(Biobase)
library(limma)
library(gCrisprTools)

#Create a complex model design; removing the replicate term for clarity
data("es", package = "gCrisprTools")
data("ann", package = "gCrisprTools")

design <- model.matrix(~ 0 + TREATMENT_NAME, pData(es))
colnames(design) <- gsub('TREATMENT_NAME', '', colnames(design))
contrasts <-makeContrasts(ControlTime = ControlExpansion - ControlReference,
                          DeathOverTime = DeathExpansion - ControlReference,
                          Interaction = DeathExpansion - ControlExpansion, 
                          levels = design)

es <- ct.normalizeGuides(es, method = "scale") #See man page for other options
vm <- voom(exprs(es), design)

fit <- lmFit(vm, design)
fit <- contrasts.fit(fit, contrasts)
fit <- eBayes(fit)

allResults <- sapply(colnames(fit$coefficients), 
                     function(x){
                         ct.generateResults(fit,
                                            annotation = ann,
                                            RRAalphaCutoff = 0.1,
                                            permutations = 1000,
                                            scoring = "combined",
                                            permutation.seed = 2, 
                                            contrast.term = x)
                       }, simplify = FALSE)

allSimple <- ct.regularizeContrasts(allResults)

## -----------------------------------------------------------------------------

time.effect <- ct.compareContrasts(list("con" = allSimple$ControlTime,
                                        "tx" = allSimple$DeathOverTime))
summary(time.effect$replicated)

## -----------------------------------------------------------------------------
mod.control <- ct.compareContrasts(list("con" = allSimple$ControlTime,
                                        "Interaction" = allSimple$Interaction),
                                 same.dir = c(TRUE, FALSE))
summary(mod.control$replicated)

## ----fig.height= 6, fig.width = 8---------------------------------------------
upset <- ct.upSet(allSimple)

## -----------------------------------------------------------------------------
show(upset)

## ----fig.width=6, fig.height=6, warnings= FALSE-------------------------------
genesetdb <- sparrow::getMSigGeneSetDb(collection = 'h', species = 'human', id.type = 'entrez')

sparrowList <- ct.seas(allSimple, gdb = genesetdb)

show(sparrowList)

#Can use returned matrices to facilitate downstream comparisons: 

plot(-log10(sparrow::results(sparrowList$DeathOverTime, 'fgsea')$padj), 
     -log10(sparrow::results(sparrowList$Interaction, 'fgsea')$padj), 
     pch = 19, col = rgb(0,0,0.8,0.5), 
     ylab = "Pathway -log10(P), Treatment Over Time",
     xlab = "Pathway -log10(P), Marginal Time Effect, Treatment Arm",
     main = 'Evidence for Pathway Enrichment')
abline(0,1,lty = 2)


## -----------------------------------------------------------------------------
sessionInfo()

##' @title Visualization of Ranked gRNA Abundances by Replicate
##' @description This function median scales and log2 transforms the raw gRNA count data contained in an ExpressionSet, 
##' and then plots the ordered expression values within each replicate. The curve colors are assigned based on a user-
##' specified column of the pData contained in the ExpressionSet. Optionally, this function can plot the location of Nontargeting control 
##' guides (or any guides, really) within the distribution. 
##' @param eset An ExpressionSet object containing, at minimum, count data accessible by exprs() and some phenoData. 
##' @param sampleKey A sample key, supplied as a (possibly ordered) factor linking the samples to experimental 
##' variables. The \code{names} attribute should exactly match those present in \code{eset}, and the control set 
##' is assumed to be the first \code{level}.
##' @param annotation An annotation dataframe indicating the nontargeting controls in the geneID column. 
##' @param geneSymb The \code{geneSymbol} identifier(s) in \code{annotation} that corresponds to gRNAs to be plotted on the curves. 
##' If the provided value is not present in the \code{geneSymbol}, nontargeting controls will be plotted instead.
##' @param lib.size An optional vector of voom-appropriate library size adjustment factors, usually calculated with \code{\link[edgeR]{calcNormFactors}} 
##' and transformed to reflect the appropriate library size. These adjustment factors are interpreted as the total library sizes for each sample, 
##' and if absent will be extrapolated from the columnwise count sums of the \code{exprs} slot of the \code{eset}.
##' @return A waterfall plot as specified, on the default device.
##' @author Russell Bainer
##' @examples 
##' data('es')
##' data('ann')
##' 
##' #Build the sample key
##' library(Biobase)
##' sk <- ordered(relevel(as.factor(pData(es)$TREATMENT_NAME), 'ControlReference'))
##' names(sk) <- row.names(pData(es))
##' 
##' ct.gRNARankByReplicate(es, sk, ann, 'Target1377')
##' @export
ct.gRNARankByReplicate <- function(eset, sampleKey, annotation = NULL, geneSymb = NULL, lib.size = NULL) {
    # current.graphic.params <- par(no.readonly = TRUE) on.exit(suppressWarnings(par(current.graphic.params)))

    if (!methods::is(eset, "ExpressionSet")) {
        stop(deparse(substitute(eset)), "must be an ExpressionSet.")
    }

    if (is.null(sampleKey)) {
        sampleKey <- colnames(eset)
        names(sampleKey) <- sampleKey
    }
    
    sampleKey <- ct.keyCheck(sampleKey, eset)
    sampleKey <- sampleKey[order(sampleKey)]
    
    counts <- exprs(eset)

    if (is.null(lib.size)) {
        lib.size <- colSums(counts)
    } else if (!is.numeric(lib.size) | length(lib.size) != ncol(counts)) {
        stop("If specified, lib.size must be a numeric vector of the same 
         length as the number of samples in the eset.")
    }

    # Convert to CPM
    e.dat <- t(log2(t(counts + 0.5)/(lib.size + 1) * 1e+06))

    y <- range(e.dat)
    x <- c(1, nrow(e.dat))
    if (is.null(annotation) | is.null(geneSymb)) {
        plottitle <- ""
    } else if (geneSymb %in% annotation$geneSymbol) {
        plottitle <- geneSymb
    } else {
        plottitle <- "Nontargeting Controls"
    }

    plot(x[1], y[1], xlim = x, ylim = y, xlab = "gRNA Abundance Rank", ylab = "Log2 Counts", pch = NA, main = plottitle)

    colors <- colorRampPalette(c("blue", "red"), alpha = TRUE)(length(levels(sampleKey)))
    colors <- gsub("FF$", "99", colors, perl = TRUE)

    invisible(lapply(seq_len(ncol(e.dat)), function(x) {
        lines(seq_len(nrow(e.dat)), sort(e.dat[, names(sampleKey)[x]], decreasing = TRUE), col = colors[as.numeric(sampleKey)[x]])
    }))

    # Add the NTC locations if requested.
    if (!is.null(geneSymb)) {

        if (is.null(annotation) | !("geneSymbol" %in% names(annotation))) {
            stop("An annotation dataframe must be supplied if geneSymb is not NULL.")
        }

        annotation <- ct.prepareAnnotation(annotation, eset, throw.error = FALSE)

        if (any(geneSymb %in% annotation$geneSymbol)) {
            ntc <- row.names(annotation)[annotation$geneSymbol %in% geneSymb]
        } else {
            ntc <- row.names(annotation)[(annotation$geneSymbol %in% "NoTarget")]
        }

        if (length(ntc) == 0) {
            stop("No suitable elements are present in the supplied annotation file. 
                 Please specify a geneSymbol if you want to display individual guides.")
        }

        # make a table of the ntc locations and ranks
        ntc.ranks <- (apply(e.dat, 2, rank))
        ntc.ranks <- ntc.ranks[ntc, ]
        ntc.ranks <- nrow(e.dat) - ntc.ranks
        ntc.dat <- e.dat[ntc, ]

        rimcolors <- colorRampPalette(c("black", "blue", "green", "red", "yellow", "white"))(nrow(ntc.dat))

        invisible(lapply(seq_len(ncol(ntc.dat)), function(x) {
            points(ntc.ranks[, names(sampleKey)[x]], ntc.dat[, names(sampleKey)[x]], bg = rimcolors, col = colors[as.numeric(sampleKey[x])], pch = 23, lwd = 4)
        }))
    }
    legend("bottomleft", legend = levels(sampleKey), fill = colors, bty = "n")
}

##' @title Generate a Precision-Recall Curve from a CRISPR screen  
##' @description Given a set of targets of interest, this function generates a Precision Recall curve from the results of 
##' a CRISPR screen. Specifically, it orders the target elements in the screen in the specified direction, and then plots the recall 
##' rate (proportion of true targets identified) against the precision (proportion of identified targets that are true targets). 
##' 
##' Note that ranking statistics in CRISPR screens are (usually) permutation-based, and so some granularity in the rankings is expected. This 
##' function does a little extra work to ensure that hits are counted as soon as the requisite value of the ranking statistic is reached 
##' regardless of where the gene is located within the block of equally-significant genes. Functionally, this means that the drawn curve is
##' somewhat anticonservative in cases where the gene ranks are not well differentiated.  
##'
##' @param summaryDF A dataframe summarizing the results of the screen, returned by the function \code{\link{ct.generateResults}}. 
##' @param target.list A character vector containing the names of the targets to be tested; by default these are assumed to be `geneID`s, 
##' but specifying `collapse=geneSymbol` enables setting on `geneSymbol` by passing that value through to `ct.simpleResult`.
##' @param direction Direction by which to order target signals (`enrich` or `deplete`).  
##' @param plot.it Logical value indicating whether to plot the curves. 
##' @return A list containing the the x and y coordinates of the curve.
##' @author Russell Bainer
##' @examples data('resultsDF')
##' data('essential.genes') #Note that this is an artificial example.
##' pr <- ct.PRC(resultsDF, essential.genes, 'enrich')
##' str(pr)
##' @export
ct.PRC <- function(summaryDF, target.list, direction = c("enrich", "deplete"), plot.it = TRUE) {

    direction <- match.arg(direction)
    stopifnot(is(plot.it, "logical"))

    if (!is.character(target.list)) {
        warning("Supplied target.list is not a character vector. Coercing.")
        target.list <- as.character(target.list)
    }

    # Infer whether Gsdb is ID or feature centric
    gids <- sum(target.list %in% summaryDF$geneID)
    gsids <- sum(target.list %in% summaryDF$geneSymbol)

    if (all(c(gsids, gids) == 0)) {
        stop("None of the features in the GeneSetDb are present in either the geneID or geneSymbol slots of the first provided result.")
    }

    collapse <- ifelse(gids > gsids, "geneID", "geneSymbol")
    simpleDF <- ct.simpleResult(summaryDF, collapse)

    present <- intersect(target.list, row.names(simpleDF))

    if (length(present) != length(target.list)) {
        if (length(present) < 1) {
            stop(paste0("None of the genes in the input list are present in the ", collapse, " column of the input data.frame."))
        }
        warning(length(present), " of ", length(target.list), " genes are present in the supplied results data.frame. Ignoring the remainder of the target.list.")
    }

    # Subset signals
    values <- simpleDF[simpleDF$direction == direction, ]
    values <- c(values$best.p[order(values$best.p, decreasing = FALSE)], rep(1, times = sum(!(simpleDF$direction %in% direction))))

    targvals <- vapply(target.list, function(x) {
        ifelse(simpleDF[x, "direction"] %in% direction, simpleDF[x, "best.p"], 1)
    }, numeric(1))

    out <- list()
    out$precision <- c(1, unlist(lapply(unique(values), function(x) {
        sum(targvals <= x, na.rm = TRUE)/sum(values <= x, na.rm = TRUE)
    })), 0)
    out$recall <- c(0, unlist(lapply(unique(values), function(x) {
        sum(targvals <= x, na.rm = TRUE)/length(targvals)
    })), 1)

    enrich <- switch(direction, enrich = ct.targetSetEnrichment(simpleDF, target.list, enrich = TRUE, collapse = collapse), deplete = ct.targetSetEnrichment(simpleDF, 
        target.list, enrich = FALSE, collapse = collapse))
    out <- c(out, enrich)

    # Plot it?
    if (plot.it) {
        plot(out$recall, out$precision, xlim = c(0, 1), ylim = c(0, 1), type = "l", ylab = "Precision", xlab = "Recall", main = paste("Precision and Recall of", deparse(substitute(target.list))), 
            col = "blue", lwd = 3)
    }
    return(invisible(out))
}

##' @title Visualization of gRNA GC Content Trends
##' @description This function visualizes relationships between gRNA GC content and their measured abundance or 
##' various differential expression model estimates. 
##' @param data.obj An \code{ExpressionSet} or fit (\code{MArrayLM}) object to be analyzed for the presence of GC 
##' content bias. 
##' @param ann An annotation \code{data.frame}, used to estimate GC content for each guide. Guides are annotated by 
##' row, and the object must minimally contain a \code{target} column containing a character 
##' vector that indicates the corresponding nucleotide sequences.
##' @param sampleKey An optional sample key, supplied as a factor linking the samples to experimental 
##' variables. The \code{names} attribute should exactly match those present in \code{eset}, and the 
##' control set is assumed to be the first \code{level}. Ignored in the analysis of model fit objects. 
##' @param lib.size An optional vector of voom-appropriate library size adjustment factors, usually calculated with \code{\link[edgeR]{calcNormFactors}} 
##' and transformed to reflect the appropriate library size. These adjustment factors are interpreted as the total library sizes for each sample, 
##' and if absent will be extrapolated from the columnwise count sums of the \code{exprs} slot of the \code{eset}.
##' @return An image relating GC content to experimental observations on the default device. If the 
##' provided \code{data.obj} is an \code{ExpressionSet}, this takes the form of a scatter plot where the 
##' GC% and abundance estimates of each guide are represented as points overlaid
##' with a smoothed trendline within each sample. If \code{data.obj} is a fit object describing a linear model 
##' contrast, then four panels are returned describing the GC content distribution and its relationship 
##' to guide-level fold change, standard deviation, and P-value estimates.  
##' @author Russell Bainer
##' @examples 
##' data('es')
##' data('ann')
##' data('fit')
##' 
##' ct.GCbias(es, ann)
##' ct.GCbias(fit, ann)
##' @export

ct.GCbias <- function(data.obj, ann, sampleKey = NULL, lib.size = NULL) {

    # check inputs
    if (methods::is(data.obj, "ExpressionSet")) {
        is.fit <- FALSE
        d <- exprs(data.obj)

        if (is.null(lib.size)) {
            lib.size <- colSums(d)
        } else if (!is.numeric(lib.size) | (length(lib.size) != ncol(d))) {
            stop("If specified, lib.size must be a numeric vector of the same 
             length as the number of samples in the eset.")
        }

        d <- t(log2(t(d + 0.5)/(lib.size + 1) * 1e+06))

        if (is.null(sampleKey)) {
            sampleKey <- factor(colnames(d))
            names(sampleKey) <- colnames(d)
        }

        sampleKey <- ct.keyCheck(sampleKey, data.obj)
        ann <- ct.prepareAnnotation(ann, object = data.obj, throw.error = FALSE)

    } else if (is(data.obj, "MArrayLM")) {

        is.fit <- TRUE
        ann <- ct.prepareAnnotation(ann, object = data.obj, throw.error = FALSE)

    } else {
        stop("Please provide an Expressionset or MArrayLM object for GC analysis.")
    }

    if (!("target" %in% names(ann))) {
        stop("The provided annotation object does not contain a \"target\" column annotating the gRNA sequences.")
    } else if (!is.character(ann$target)) {
        message("The \"target\" column of the provided annotation object is not a character vector. Coercing.")
    }

    # Calculate GC
    seq <- toupper(ann$target)
    seqlen <- vapply(seq, nchar, numeric(1))
    gc <- vapply(gregexpr("[CG]", seq, perl = TRUE), length, integer(1))/seqlen

    if (any(seqlen == 0)) {
        gc[seqlen == 0] <- NA
        warning("Could not calculate GC% for ", sum(seqlen == 0), " guides. Omitting.")
    }

    # if a fit object, plot relationship between GC and P, coefficients, variance
    if (is.fit) {
        ltp <- -log10(data.obj$p.value)
        ylims <- range(c(ltp, data.obj$coefficients[, 1]))

        par(mfrow = c(2, 2))
        hist(gc, xlim = c(0, 1), xlab = "gRNA %GC", main = "GC Content by gRNA", breaks = max(seqlen))

        plot(gc, data.obj$coefficients[, 1], xlim = c(0, 1), xlab = "gRNA %GC", ylab = "", main = "Log2 Fold Change", pch = 16, col = rgb(0, 0, 1, 0.2))
        lines(spline(gc, data.obj$coefficients[, 1]), col = "black", lwd = 2)

        plot(gc, data.obj$stdev.unscaled[, 1], xlim = c(0, 1), xlab = "gRNA %GC", ylab = "", main = "Standard Deviation", pch = 16, col = rgb(1, 0, 0, 0.2))
        lines(spline(gc, data.obj$stdev.unscaled[, 1]), col = "black", lwd = 2)

        plot(gc, ltp, xlim = c(0, 1), xlab = "gRNA %GC", ylab = "", main = "-Log10 P-value", pch = 16, col = rgb(0, 1, 0, 0.2))
        lines(spline(gc, ltp), col = "black", lwd = 2)
        return(invisible())
    } else {
        colors <- colorRampPalette(c(rgb(1, 0, 0, 0.2), rgb(0, 0, 1, 0.2)), alpha = TRUE)(ncol(d))
        spline.color <- substr(colors, 1, 7)
        plot(NA, NA, xlab = "gRNA %GC", ylab = "Log2 Counts Per Million", main = "GC Content vs. Measured Abundance", ylim = range(d), xlim = c(0, 1))
        invisible(lapply(seq_len(ncol(d)), function(x) {
            points(gc, d[, x], pch = 16, col = colors[x])
            lines(spline(gc, d[, x]), col = spline.color[x], lwd = 4)
        }))
        legend("topleft", names(sampleKey), fill = spline.color)
    }
}

##' @title Run a (limited) Pathway Enrichment Analysis on the results of a Crispr experiment.
##' @description This function enables some limited geneset enrichment-type analysis of data derived from a pooled Crispr
##' screen using the PANTHER pathway database. Specifically, it identifies the set of targets significantly enriched or
##' depleted in a \code{summaryDF} object returned from \code{ct.generateResults} and compares that set to the remaining
##' targets in the screening library using a hypergeometric test.
##'
##' Note that many Crispr gRNA libraries specifically target biased sets of genes, often focusing on genes involved
##' in a particular pathway or encoding proteins with a shared biological property. Consequently, the enrichment results
##' returned by this function represent the pathways containing genes disproportionately targeted *within the context
##' of the screen*, and may or may not be informative of the underlying biology in question. This means that
##' pathways not targeted by a Crispr library will obviously never be enriched within the positive target set regardless of
##' their biological relevance, and pathways enriched within a focused library screen are similarly expected to partially
##' reflect the composition of the library and other confounding issues (e.g., number of targets within a pathway).
##' Analysts should therefore use this function with care. For example, it might be unsurprising to detect pathways related
##' to histone modification within a screen employing a crispr library targeting epigenetic regulators.
##'
##' @param summaryDF A dataframe summarizing the results of the screen, returned by the function \code{\link{ct.generateResults}}.
##' @param pvalue.cutoff A gene-level p-value cutoff defining targets of interest within the screen. Note that this is a
##' nominal p-value cutoff to preserve end-user flexibility.
##' @param enrich Logical indicating whether to consider guides that are enriched (default) or depleted within the screen.
##' @param organism The species of the cell line used in the screen; currently only 'human' or 'mouse' are supported.
##' @param db.cut Minimum number of genes annotated to a given to a pathway within the screen in order to consider it in the enrichment test.
##' @return A dataframe of enriched pathways.
##' @author Russell Bainer, Steve Lianoglou
##' @keywords internal
#ct.PantherPathwayEnrichment <- function(summaryDF, pvalue.cutoff = 0.01, enrich = TRUE, organism = 'human', db.cut = 10){
#  .Deprecated(msg = 'This function is on its way out in favor of the new functionality using sparrow. See ct.seas() and the gCrisprTools vignettes.')
#  
#  if (!requireNamespace("PANTHER.db")) {
#    stop("The PANTHER.db bioconductor package is required")
#  }
#  if (!requireNamespace("AnnotationDbi")) {
#    stop("The AnnotationDbi bioconductor package is required")
#  }
#
#  #Check the input:
#    organism <- match.arg(organism, c('human', 'mouse'))
#
#    if(!(enrich %in% c(TRUE, FALSE))){
#      stop('enrich must be either TRUE or FALSE.')
#    }
#
#    if(!ct.resultCheck(summaryDF)){
#      stop("Execution halted.")
#    }
#
#    if(!(pvalue.cutoff <= 1 & pvalue.cutoff >= 0 & is.numeric(pvalue.cutoff))){
#      stop("pvalue.cutoff must be a numeric value between 0 and 1.")
#    }
#
#    if(!(is.numeric(db.cut))){
#      stop("db.cut must be a numeric value.")
#    }
#
#
#    message("WARNING: The interpretation of gene set enrichment analyses in Crispr screens is tricky. See the man page for further details.")
#
#    #Condense the summary frame to gene-level estimates and isolate the ones that we are testing
#    summaryDF <- summaryDF[!duplicated(summaryDF$geneID),]
#    summaryDF <- summaryDF[!is.na(summaryDF$geneID),]
#    summaryDF <- summaryDF[!grepl('^[A-Za-z]+$', summaryDF$geneID),]
#    universe <- summaryDF$geneID
#    #Pull out the significant hits
#    selected <- summaryDF$geneID[summaryDF[,"Target-level Enrichment P"] <= pvalue.cutoff]#

#    if(enrich == FALSE){
#      selected <- summaryDF$geneID[summaryDF[,"Target-level Depletion P"] <= pvalue.cutoff]
#    }

    #make the database and conform it to the provided resultDF:
#    pdb <- suppressMessages(ct.getPanther(organism))
#    pathways <- names(pdb)
#    pdb.cut <- lapply(pdb, function(x){x[x %in% universe]})
#    genesInCats <- vapply(pdb.cut, length, numeric(1))
#    pdb.cut <- pdb.cut[genesInCats > db.cut]
#    genesInCats <- genesInCats[genesInCats > db.cut]

#    message(paste('Omitting PANTHER pathways containing fewer than', db.cut, 'genes.'))

#    if(length(pdb.cut) == 0){
#      stop(paste('No acceptable gene sets found; consider reducing db.cut? \nExiting.'))
#    }

#    message(paste('Performing Hypergeometric tests with', length(pdb.cut), 'gene sets...'))

#    #Set up the output and run the tests
#    out <- data.frame('PATHWAY' = names(pdb.cut),
#                      'nGenes' = genesInCats,
#                      'sigGenes' = vapply(pdb.cut, function(x){sum(x %in% selected, na.rm = TRUE)}, numeric(1)),
#                      stringsAsFactors = FALSE)
#    testResults <- t(mapply(.doHyperGInternal,
#                         'numW' = out$nGenes,
#                         'numB' = rep(length(universe), nrow(out)),
#                         'numDrawn' = rep(length(selected), nrow(out)),
#                         'numWdrawn' = out$sigGenes,
#                         'over' = rep(TRUE, nrow(out)),
#                         SIMPLIFY =TRUE))
#    out <- cbind(out, testResults[,3:1])
#    out[,'FDR'] <- p.adjust(out$p, 'BH')
#    out[,2:7] <- apply(out[,2:7], 2, as.numeric)
#    out <- out[order(out$p, decreasing = FALSE),]
#    row.names(out) <- 1:nrow(out)

#    return(out)
#    }

##' @title  Extract a Named List of Entrez IDs Annotated to Each Pathway in \code{PANTHER.db}
##' @description This is a function that invokes the \link[PANTHER.db]{PANTHER.db} Bioconductor library to extract a list of pathway mappings
##' to be used in gene set enrichment tests. Specifically, the function returns a named list of pathways, where each element contains
##' Entrez IDs. Users should not generally call this function directly as it is invoked internally by the higher-level
##' \code{ct.PantherPathwayEnrichment()} function.
##' @param species The species of the cells used in the screen. Currently only 'human' or 'mouse' are supported.
##' @return A named list of pathways from \code{PANTHER.db}.
##' @author Russell Bainer, Steve Lianoglou.
##' @keywords internal
#ct.getPanther <- function (species = c("human", "mouse")){
#  .Deprecated(msg = 'This function is on its way out in favor of the new functionality using sparrow. See ct.seas() and the gCrisprTools vignettes.')
#  species <- match.arg(species, c("human", "mouse"))
#
#  if (!requireNamespace("PANTHER.db")) {
#    stop("The PANTHER.db bioconductor package is required")
#  }
#  if (!requireNamespace("AnnotationDbi")) {
#    stop("The AnnotationDbi bioconductor package is required")
#  }
#  if (species == "human") {
#    org.pkg <- "org.Hs.eg.db"
#    xorg <- "Homo_sapiens"
#  }
#  else {
#    org.pkg <- "org.Mm.eg.db"
#    xorg <- "Mus_musculus"
#  }
#  if (!requireNamespace(org.pkg)) {
#    stop(org.pkg, " bioconductor package required for this species query")
#  }
#
#  p.db <- PANTHER.db
#
#  #This is a prefiltering step that appears to be unnecessary now
#  #but potentially breaks if the user doesn't have proper database permissions.
#  #pthOrganisms(p.db) <- toupper(species)

#  org.db <- getFromNamespace(org.pkg, org.pkg)

#  p.all <- select(p.db, keys(p.db, keytype="PATHWAY_ID"),
#                    columns=c("PATHWAY_ID", "PATHWAY_TERM", "UNIPROT"),
#                    'PATHWAY_ID')
#  # Map uniprot to entrez
#  umap <- suppressMessages(select(org.db, p.all$UNIPROT, c('UNIPROT', 'ENTREZID'), 'UNIPROT'))
#  m <- merge(p.all, umap, by='UNIPROT')
#  m <- subset(m, !is.na(m$ENTREZID))

#  paths <- split(m[,3:4], as.factor(m$PATHWAY_TERM))
#  lapply(paths, function(x){unique(x$ENTREZID)})
#}

##' @title Test Whether a Specified Target Set is Enriched Within a Pooled Screen
##' @description This function takes in a \code{resultsDF} and a vector of \code{targets} (contained in the \code{geneID} column of
##' \code{resultsDF}) and determines whether the specified targets are enriched within the set of all significantly altered targets.
##' It does this by iteratively testing whether \code{targets} are more likely to be among the set of enriched or depleted targets
##' at various significance thresholds using a hypergeometric test. Note that the returned Hypergeometric P-values are not corrected
##' for multiple testing.
##'
##' Returns a list detailing the \code{targets} used in the tests, and tables indicating the results of the hypergeometric test
##' at various significance thresholds.
##' @param summaryDF A dataframe summarizing the results of the screen, returned by the function \code{\link{ct.generateResults}}. 
##' Internally coerced via `ct.simpleResult()`.
##' @param targets A character vector containing the names of the targets to be tested; by default these are assumed to be `geneID`s, 
##' but specifying `collapse=geneSymbol` enables setting on `geneSymbol` by passing that value through to `ct.simpleResult`.
##' @param enrich Logical indicating whether to consider guides that are enriched (default) or depleted within the screen.
##' @param ignore Optionally, a character vector containing elements of the \code{summaryDF} that should be ignored in the analysis 
##' (e.g., unassignable or nonfunctional targets, such as nontargeting controls). By default, this function omits targets with 
##' \code{geneSymbol} 'NoTarget'.
##' @param ... Additional parameters to pass to `ct.simpleResult`.
##' @return A named list containing the tested target set and tables detailing the hypergeometric test results using various P-value and
##' Q-value thresholds.
##' @examples data(resultsDF)
##' tar <-  sample(unique(resultsDF$geneSymbol), 20)
##' res <- ct.targetSetEnrichment(resultsDF, tar)
##' @author Russell Bainer
##' @export
ct.targetSetEnrichment <- function(summaryDF, targets, enrich = TRUE, ignore = 'NoTarget', ...){

  #input checks
  stopifnot(is(enrich, 'logical'), is(ignore, 'character'))
  
  if(!is.character(targets)){
    warning("Supplied targets are not a character vector. Coercing.")
    targets <- as.character(targets)
  }
  
  #Infer whether Gsdb is ID or feature centric
  gids <- sum(targets %in% summaryDF$geneID)
  gsids <- sum(targets %in% summaryDF$geneSymbol)
  
  if(all(c(gsids, gids) == 0)){
    stop('None of the targets are present in either the geneID or geneSymbol slots of the first provided result.')
  }
  
  collapse <- ifelse(gids > gsids, 'geneID', 'geneSymbol')
  summaryDF <- ct.simpleResult(summaryDF, collapse)

  valid <- intersect(targets, row.names(summaryDF))

  if(length(setdiff(targets, valid)) != 0){
    warning('Not all of the supplied targets are present in the summary dataframe. Proceeding with ',
            length(valid), ' targets.')
  }

  #Condense the summary frame to gene-level estimates and isolate the ones that we are testing
  summaryDF <- summaryDF[setdiff(row.names(summaryDF), ignore),]  #Remove NoTarget Genes rather than constraining to Entrez

  #Pull out the P-values
  selected <- summaryDF[,c("best.p", "best.q")]
  
  if(enrich){
    selected[(summaryDF$direction %in% 'deplete'), ] <- c(1,1)
  } else {
    selected[(summaryDF$direction %in% 'enrich'), ] <- c(1,1)
  }

  #Set the cutoffs
  cuts <- c(0,1/(10^(5:1)), 0.5, 1)

  out <- list('targets' = valid)
  out$P.values <- cbind(cuts,
                        vapply(cuts, function(x){sum(selected[valid,1] <= x)}, numeric(1)),
                        vapply(cuts, function(x){
                                            .doHyperGInternal(length(valid),
                                                nrow(selected),
                                                sum(selected[,1] <= x),
                                                sum(selected[valid,1] <= x),
                                                TRUE)$p},
                                      numeric(1))

                          )
  out$Q.values <- cbind(cuts,
                        vapply(cuts, function(x){sum(selected[valid,2] <= x)}, numeric(1)),
                        vapply(cuts, function(x){
                          .doHyperGInternal(length(valid),
                                            nrow(selected),
                                            sum(selected[,2] <= x),
                                            sum(selected[valid,2] <= x),
                                            TRUE)$p},
                          numeric(1))
                        )


  colnames(out$P.values) <- colnames(out$Q.values) <- c('Cutoff', 'Sig', 'Hypergeometric_P')
  return(out)
}






## -----------------------------------------------------------------------------
## These were copied from the Bioconductor collection package

##' We envision the test as follows:
##'
##' The urn contains genes from the gene universe.  Genes annotated at a
##' given collection term are white and the rest black.
##'
##' The number drawn is the size of the selected gene list.  The
##' number of white drawn is the size of the intersection of the
##' selected list and the genes annotated at the collection.
##' Here's a diagram based on using GO as the collection:
##'
##'          inGO    notGO
##'          White   Black
##' selected  n11     n12
##' not       n21     n22
##'
##' numW: number of genes in GO category
##' numB: size of universe
##' numDrawn: number of differentially expressed genes
##' numWdrawn: the number of genes differentially expressed in category
##' @keywords internal
##' @noRd

.doHyperGInternal <- function(numW, numB, numDrawn, numWdrawn, over = TRUE) {
  n21 <- numW - numWdrawn
  n12 <- numDrawn - numWdrawn
  n22 <- numB - n12

  odds_ratio <-  (numWdrawn * n22) / (n12 * n21)

  expected <- (numWdrawn + n12) * (numWdrawn + n21)
  expected <- expected / (numWdrawn + n12 + n21 + n22)

  if (over) {
    ## take the -1 because we want evidence for as extreme or more
    pvals <- phyper(numWdrawn - 1L, numW, numB,
                    numDrawn, lower.tail=FALSE)
  } else {
    pvals <- phyper(numWdrawn, numW, numB,
                    numDrawn, lower.tail=TRUE)
  }

  list(p=pvals, odds=odds_ratio, expected=expected)
}

library(gCrisprTools)
library(RUnit)

test.RocPRC <- function() {
  data('resultsDF')
  data('essential.genes')

  rhp <- c(1.000000000, 1.000000000, 1.000000000, 1.000000000, 1.000000000, 0.977446507, 0.959707507, 0.009076336)
  
  prc <- ct.PRC(resultsDF, essential.genes, 'enrich.p')
  roc <- ct.ROC(resultsDF, essential.genes, 'enrich.p')  
    
  checkIdentical(round(roc$P.values[,3], 9), unlist(rhp))
  checkIdentical(round(prc$P.values[,3], 9), unlist(rhp))

  checkIdentical(prc$recall, roc$sensitivity)
}

##' @title Display the log2 fold change estimates and associated standard deviations of the guides targeting the top 
##' candidates in a crispr screen
##' @description This is a function for displaying candidates from a crispr screen, using the information summarized 
##' in the corresponding \code{fit} and the output from \code{ct.generateResults()}. The fold change and standard deviation 
##' estimates for each gRNA associated with each target (extracted from the \code{coefficients} and \code{stdev.unscaled} slot 
##' of \code{fit}) are plotted on the y axis. Targets are selected on the basis of their gene-level enrichment or depletion 
##' P-values; in the case of ties, they are ranked on the basis of their corresponding Rho statistics. 
##' @param fit An object of class \code{MArrayLM} containing, at minimum, a \code{coefficents} slot with coefficients from the comparison, 
##' and a \code{stdev.unscaled} slot with the corresponding standard deviation of the coefficent estimates. The \code{row.names} attribute 
##' should ideally match that which is found in \code{annotation}.
##' @param summaryDF A data.frame summarizing the results of the screen, returned by the function \code{\link{ct.generateResults}}. 
##' @param annotation An annotation object for the experiment. gRNAs are annotated by 
##' row, and must minimally contain a column \code{geneSymbol}. 
##' @param targets Either the number of top targets to display, or a list of \code{geneSymbol}s contained in the \code{geneSymbol} 
##' slot of the \code{annotation} object. 
##' @param enrich Logical indicating whether to display guides that are enriched (default) or depleted within the screen. If a vector of 
##' \code{geneSymbol}s is specified, this controls the left-t0-right ordering of the corresponding gRNAs. 
##' @param contrast.term If a fit object with multiple coefficients is passed in, a string indiating the coefficient of interest.   
##' @return An image on the default device indicating each gRNA's log2 fold change and the unscaled standard deviation of the effect estimate, 
##' derived from the \code{MArrayLM} object.
##' @author Russell Bainer
##' @examples 
##' data('fit')
##' data('resultsDF')
##' data('ann')
##' 
##' ct.topTargets(fit, resultsDF, ann) 
##' @export

ct.topTargets <- function(fit, summaryDF, annotation, targets = 10, enrich = TRUE, contrast.term = NULL) {
    current.graphic.params <- par(no.readonly = TRUE)
    on.exit(suppressWarnings(par(current.graphic.params)))

    if (ncol(fit$coefficients) > 1) {
        if (is.null(contrast.term)) {
            stop("The fit object contains multiple coefficients. Please specify a contrast.term.")
        }
        fit <- ct.preprocessFit(fit, contrast.term)
    }


    # Test input: testing
    if (!methods::is(fit, "MArrayLM")) {
        stop(deparse(substitute(eset)), " is not an MArrayLM.")
    }

    if (!setequal(row.names(annotation), row.names(fit))) {
        warning("row.names of the fit object and the annotation file are not identical. Using the intersection only.")
        grnas <- intersect(row.names(fit), row.names(annotation))
        fit <- fit[grnas, ]
        annotation <- annotation[grnas, ]
    }

    if (!(enrich %in% c(TRUE, FALSE))) {
        stop("enrich must be either TRUE or FALSE.")
    }

    if (!ct.resultCheck(summaryDF)) {
        stop("Execution halted.")
    }


    # Identify the top targets from the summary DF; order and group gRNAs within a target, then rank targets
    summaryDF$geneSymbol <- as.character(summaryDF$geneSymbol)
    summaryDF <- summaryDF[with(summaryDF, order(summaryDF[, "Target-level Enrichment P"], summaryDF[, "Rho_enrich"], summaryDF[, "geneSymbol"], -summaryDF[, "gRNA Log2 Fold Change"])), 
        ]
    plottitle <- "Enriched Targets"

    if (enrich == FALSE) {
        summaryDF <- summaryDF[with(summaryDF, order(summaryDF[, "Target-level Depletion P"], summaryDF[, "Rho_deplete"], summaryDF[, "geneSymbol"], summaryDF[, "gRNA Log2 Fold Change"])), 
            ]
        plottitle <- "Depleted Targets"
    }

    if (is.character(targets)) {
        toptargets <- intersect(targets, annotation$geneSymbol)
        ntargets <- length(toptargets)
        plottitle <- ""
    } else {
        if ((length(targets) != 1) | !is.numeric(targets)) {
            stop("\"targets\" must be specified as a single number or a vector of elements in the geneSymbol column of the annotation object.")
        }
        ntargets <- targets
        plottitle <- paste("Top", ntargets, plottitle)
        toptargets <- unique(summaryDF$geneSymbol)[seq_len(ntargets)]
    }
    if (ntargets <= 0) {
        stop("No valid targets were specified.")
    }

    targetrows <- row.names(summaryDF)[(summaryDF$geneSymbol %in% toptargets)]
    nguides <- unlist(lapply(toptargets, function(x) {
        sum(summaryDF$geneSymbol %in% x, na.rm = TRUE)
    }))

    lfc <- fit$coefficients[targetrows, 1]
    sdu <- fit$stdev.unscaled[targetrows, 1] + fit$coefficients[targetrows, 1]
    sdl <- fit$coefficients[targetrows, 1] - fit$stdev.unscaled[targetrows, 1]

    ylimit <- c(min(0, min(sdl)), max(0, max(sdu)))

    # Compose a vector of the x locations
    xloc <- as.vector(unlist(mapply(function(start, numguides) {
        if (numguides > 1) {
            seq(start, start + 1, length.out = numguides)
        } else {
            start + 0.5
        }
    }, start = seq(1, by = 2, length.out = ntargets), numguides = nguides, SIMPLIFY = TRUE)))

    sddf <- cbind(xloc, sdu, sdl)

    # make the plot
    plot(xloc, lfc, xaxt = "n", main = plottitle, ylim = ylimit, xlab = "", ylab = "Log2 gRNA Abundance Change", pch = 18, col = "darkred")
    suppress <- apply(sddf, 1, function(x) {
        lines(c(x[1], x[1]), c(x[2], x[3]), col = rgb(0, 0, 0, 0.3), lwd = 4)
    })
    points(xloc, lfc, pch = 18, col = "darkred")
    suppress <- capture.output(lapply(seq(2.5, by = 2, length.out = (ntargets - 1)), function(x) {
        abline(v = x, lty = "dotted", col = "gray")
    }))
    abline(h = 0)
    # Add the labels
    axis(1, at = seq(1.5, by = 2, length.out = ntargets), labels = toptargets, las = 3)
    if (!is.null(contrast.term)) {
        mtext(contrast.term, side = 3, line = 0)
    }
}

##' @title Compare Two CRISPR Screens via a CAT plot 
##' @description This is a function for comparing the results of two screening experiments. Given two \code{summaryDF}, 
##' the function places them in register with one another, generates a Concordance At The Top (CAT) plot, and returns an 
##' invisible dataframe containing the relevant gene-level signals. Signals are aggregated by P-value threshold, such 
##' that the concordance is represented as the portion of shared values meeting or exceeding that significance threshold.
##' 
##' This function is conceptually similar to the `ct.ROC` and `ct.PRC()` functions, but is appropriate when considering 
##' consistency of ranked values rather than an interchangeable set; the most common use case is for comparing primary 
##' and replication screens, where the underlying technology and selection criteria are expected to be highly similar. 
##' CAT plots are fundamentally about comparing rankings, and so only targets in common between the two provided 
##' screens are considered. If the totality of list overlap is important, consider using `ct.PRC()` or `ct.ROC()`.
##'
##' @param dflist A list of results dataframes. Names will be preserved, and the enrichment calculation is conditioned on 
##' the first element of the list.
##' @param targets Column of the provided \code{summaryDF} to consider. Must be \code{geneID} or \code{geneSymbol}.
##' @param switch.dir Logical indicating whether to test overlap of signals in the same direction, or whether the 
##' directionality is expected to reverse. `same.dir = FALSE` looks at the consistency between depleted signals in `df1` and 
##' enriched signals in `df2`.
##' @param plot.it Logical indicating whether to compose the plots on the default device. Two CAT plots summarizing overlap in 
##' both enrichment directions are drawn. 
##' @return Invisibly, a data.frame containing the relevant summary stats for each target in both screens. 
##' @author Russell Bainer
##' @examples 
##' data('resultsDF')
##' cat <- ct.CAT(list('first' = resultsDF, 'second' = resultsDF[1:2000,]))
##' head(cat)
##' @export
ct.CAT <- function(dflist, targets = c("geneSymbol", "geneID"), switch.dir = FALSE, plot.it = TRUE) {

    # Check the input:
    stopifnot(is(switch.dir, "logical"), is(plot.it, "logical"), is(dflist, "list"), length(dflist) == 2)
    targets <- match.arg(targets)
    dflist <- ct.regularizeContrasts(dflist, collapse = targets)
    titles <- paste0(names(dflist)[2], " signal by ", names(dflist)[1], ", ", c("Enrichment", "Depletion"))
    cuts <- c(min(sum(dflist[[1]]$direction %in% "enrich"), sum(dflist[[2]]$direction %in% "enrich")), min(sum(dflist[[2]]$direction %in% "deplete"), sum(dflist[[2]]$direction %in% 
        "deplete")))
    cuts <- cuts/nrow(dflist[[1]])

    # Order is out, rank is in
    r1 <- ct.rankSimple(dflist[[1]])

    if (switch.dir) {
        titles <- paste0(names(dflist)[2], c(" Depletion", " Enrichment"), " by ", names(dflist)[1], c(" Enrichment", " Depletion"))
        r2 <- ct.rankSimple(dflist[[2]], top = "deplete")
    } else {
        r2 <- ct.rankSimple(dflist[[2]])
    }

    # Calculate overlaps by rank
    enrich.over <- vapply(sort(unique(r1), decreasing = FALSE)[], function(x) {
        return(sum(r2[r1 <= x] <= x)/sum(r1 <= x))
    }, numeric(1))

    # standardize the backend
    r2 <- r2 + (max(r1) - max(r2))

    deplete.over <- vapply(sort(unique(r1), decreasing = TRUE), function(x) {
        return(sum(r2[r1 >= x] >= x)/sum(r1 >= x))
    }, numeric(1))
    # Plot it
    if (plot.it) {

        plot(sort(unique(r1), decreasing = FALSE)/max(r1), enrich.over, main = titles[1], xlab = paste0(names(dflist)[1], " Signal Rank"), ylab = "Concordance", xlim = c(0, 
            cuts[1]), ylim = c(0, 1), pch = 19, col = rgb(0, 0, 0.7), type = "l")
        abline(0, 1, col = "red")

        plot(sort(unique(r1), decreasing = FALSE)/max(r1), deplete.over, main = titles[2], xlab = paste0(names(dflist)[1], " Signal Rank"), ylab = "Concordance", xlim = c(0, 
            cuts[2]), ylim = c(0, 1), pch = 19, col = rgb(0, 0, 0.7), type = "l")
        abline(0, 1, col = "red")
    }
    return(invisible(data.frame(Enrich = enrich.over, Deplete = deplete.over)))
}

##' @title View a stacked representation of the most variable targets or individual guides within an experiment, 
##' as a percentage of the total aligned reads
##' @description This function identifies the gRNAs or targets that change the most from sample to sample within an experiment as a percentage of 
##' the entire library. It then plots the abundance of the top \code{nguides} as a stacked barplot for all samples in the experiment. The purpose of this 
##' algorithm is to detect potential distortions in the library composition that might not be properly controlled by sample normalization, and so 
##' the most variable entites are defined by calculating the percent of aligned reads that they contribute to each sample, and then ranking each entity
##' by the range of these percentages across all samples. Consequently, gRNAs or Targets that are highly abundant in at least one condition will be 
##' are more likely to be identified. 
##' @param eset An ExpressionSet  object containing, at minimum, a matrix of gRNA abundances extractable with the exprs() function, and a metadata 
##' object containing a column named \code{SAMPLE_LABEL} containing unique identifers for each sample. The \code{colnames} should be syntactically 
##' @param sampleKey An optional sample key, supplied as an ordered factor linking the samples to experimental 
##' variables. The \code{names} attribute should exactly match those present in \code{eset}, and the control set is assumed to be 
##' the first \code{level}.
##' @param nguides The number of guides (or targets) to display.    
##' @param plotType A string indicating whether the individual guides should be displayed ('\code{gRNA}'), or if they should be aggregated into target-level
##' estimates ('\code{Target}') according to the \code{geneSymbol} column in the \code{annotation} object.  
##' @param annotation An optional data.frame containing an annotation object to be used to aggregate the guides into targets. gRNAs are annotated by row, 
##' and must minimally contain a column \code{geneSymbol} indicating the target elements.
##' @param ylimit An optional numeric vector of length 2 specifying the y limits for the plot, useful in comparin across studies. 
##' @param subset An optional character vector containing the sample labels to be used in the analysis; all elements must be contained in the \code{colnames} of the specified \code{eset}. 
##' @return A stacked barplot displaying the appropriate entities on the default device. 
##' @author Russell Bainer
##' @import ggplot2
##' @examples 
##' data('es')
##' data('ann')
##' ct.stackGuides(es, nguides = 20, plotType = 'Target', annotation = ann, ylimit = NULL, subset = NULL)
##' @export

ct.stackGuides <- function(eset, sampleKey = NULL, nguides = 20, plotType = "gRNA", annotation = NULL, ylimit = NULL, subset = NULL) {
    current.graphic.params <- par(no.readonly = TRUE)
    on.exit(suppressWarnings(par(current.graphic.params)))

    if (!requireNamespace("ggplot2")) {
        stop("The ggplot2 package is required")
    }
    if (!is.numeric(nguides)) {
        stop("Please specify a numeric number of guides to display.")
    }
    if (!methods::is(eset, "ExpressionSet")) {
        stop("eset must be an expressionset object.")
    }
    if (!(plotType %in% c("gRNA", "Target"))) {
        stop("Please specify \"gRNA\" or \"Target\" to be displayed.")
    }

    # Check eset colnames
    d <- exprs(eset)

    if (is.null(sampleKey)) {
        sampleKey <- ordered(rep("", ncol(d)))
        names(sampleKey) <- colnames(d)
    }

    if (any(make.names(colnames(d)) != colnames(d))) {
        warning("Some of the sample names are not syntactically valid. Coercing.")
        sampleKey <- sampleKey[colnames(d)]
        names(sampleKey) <- make.names(colnames(d))
        colnames(d) <- make.names(colnames(d))
    }

    # If a fit is included, check to see if it's valid and then subset the expression and pheno data appropriately.
    if (!is.null(subset)) {
        if (!is.character(subset)) {
            stop("subset should be a character vector containing the labels of the samples that you wish to analyze.")
        }
        subset <- make.names(subset)

        if (length(setdiff(subset, colnames(d))) != 0) {
            stop("Not all of the samples in subset are present in the specified eset.")
        }

        d <- d[, subset]
        sampleKey <- sampleKey[subset]
    }
    
    sampleKey <- ct.keyCheck(sampleKey, d)
    
    # idiosyncracies of ggplot forces rearrangement of factor labels for proper plotting.
    sampleKey <- sampleKey[order(sampleKey)]



    # Everything ok, moving on.
    plottitle <- paste0("Top ", nguides, " Most Variable ", plotType, "s Across Experimental Condition")

    if (plotType == "Target") {
        if (is.null(annotation)) {
            stop("An annotation object containing a \"geneSymbol\" column must be supplied to 
           display target-level representation.")
        }

        annotation <- ct.prepareAnnotation(annotation, throw.error = FALSE)

        if (sum(is.na(annotation$geneSymbol)) > 0) {
            message("Converting missing values in the annotation file to \"NoTarget\".")
            annotation$geneSymbol[is.na(annotation$geneSymbol)] <- "NoTarget"
        }

        # Convert all gRNA abundance to % representation
        message("Summarizing gRNA counts into targets.")
        d <- t(vapply(levels(annotation$geneSymbol), function(x) {
            if (sum(annotation$geneSymbol %in% x) > 1) {
                colSums(d[row.names(annotation)[annotation$geneSymbol %in% x], ])
            } else {
                d[row.names(annotation)[annotation$geneSymbol %in% x], ]
            }
        }, numeric(ncol(d))))

    }

    d <- apply(d, 2, function(x) {
        x/sum(x, na.rm = TRUE)
    })
    d <- d[order(apply(d, 1, function(x) {
        range(x, na.rm = TRUE)[2] - range(x, na.rm = TRUE)[1]
    }), decreasing = TRUE), names(sampleKey)[order(sampleKey)]]
    d <- d[seq_len(nguides), ]

    plotframe <- data.frame(gRNA = rep(row.names(d), ncol(d)), Condition = rep(paste0(colnames(d), "_", sampleKey[colnames(d)]), each = nrow(d)), ReadProportion = as.numeric(d))

    colorScale <- colorRampPalette(c("white", "red", "blue", "black"))(nguides)

    # as requested by Sarah, highlight the NTCs if they are present.
    if (is.element("NoTarget", levels(plotframe$gRNA))) {
        colorScale[is.element(levels(plotframe$gRNA), "NoTarget")] <- "forestgreen"
    }

    # also scale the legend as appropriate for the number of guides:
    legend.scale.factor <- 15/nguides

    if (!is.null(ylimit)) {
        if (!is.numeric(ylimit) | (length(ylimit) != 2)) {
            stop("The ylimit variable must be NULL, or a numeric vector of length 2.")
        }
        ggplot(plotframe, aes_string(x = "Condition", y = "ReadProportion", fill = "gRNA")) + geom_bar(stat = "identity", position = "stack") + theme(axis.text.x = element_text(angle = 90, 
            hjust = 1)) + scale_fill_manual(values = colorScale) + ggtitle(plottitle) + coord_cartesian(ylim = c(ylimit[1], ylimit[2])) + ylab("Proportion of Total Reads") + 
            theme(legend.key.size = unit(legend.scale.factor, "cm"), legend.title = element_blank())

    } else {
        ggplot(plotframe, aes_string(x = "Condition", y = "ReadProportion", fill = "gRNA")) + geom_bar(stat = "identity", position = "stack") + theme(axis.text.x = element_text(angle = 90, 
            hjust = 1)) + scale_fill_manual(values = colorScale) + ggtitle(plottitle) + ylab("Proportion of Total Reads") + theme(legend.key.size = unit(legend.scale.factor, 
            "cm"), legend.title = element_blank())
    }
}

##' @title Remove low-abundance elements from an ExpressionSet object
##' @description This function removes gRNAs only present in very low abundance across all samples of a pooled Crispr
##' screening experiment. In most cases very low-abundance guides are the
##' result of low-level contamination from other libraries, and often distort standard normalization approaches. This
##' function trims gRNAs in a largely heuristic way, assuming that the majority of 'real' gRNAs within the library are
##' comparably abundant in at least some of the samples (such as unexpanded controls), and that contaminants are
##' present at negligible levels. Specifically, the function trims the \code{trim}
##' most abundant guides from the upper tail of each log-transformed sample distribution, and then omits gRNAs whose
##' abundances are always less than 1/(2^\code{log2.ratio}) of this value.
##' @param eset An unnormalized \code{ExpressionSet} object containing, at minimum, a matrix of gRNA counts accessible with \code{exprs()}.
##' @param trim The number of gRNAs to be trimmed from the top of the distribution before estimating the abundance range. Empirically, this usually should be equal to about 2 to 5 percent of the guides in the library.
##' @param log2.ratio Maximum abundance of contaminant gRNAs, expressed on the log2 scale from the top of the trimmed range 
##' of each sample. That is, \code{log2.ratio = 4} means to discard all gRNAs whose abundance is (1/2)^4 of the trimmed maximum. 
##' @param sampleKey An (optional) sample key, supplied as an ordered factor linking the samples to experimental
##' variables. The \code{names} attribute should exactly match those present in \code{eset}, and the control set is assumed to be
##' the first \code{level}.
##' @param plot.it Logical value indicating whether to plot the adjusted gRNA densities on the default device.
##' @param read.floor Optionally, the minimum number of reads required for each gRNA.
##' @return An \code{ExpressionSet} object, with trace-abundance gRNAs omitted.
##' @author Russell Bainer
##' @examples data('es')
##' ct.filterReads(es)
##' @export
ct.filterReads <- function(eset, trim = 1000, log2.ratio = 4, sampleKey = NULL, plot.it = TRUE, read.floor = NULL) {

    if (!methods::is(eset, "ExpressionSet")) {
        stop(deparse(substitute(eset)), " is not an ExpressionSet.")
    }
    if (!is.numeric(trim)) {
        stop("trim is not a numeric value.")
    }
    if (!is.numeric(log2.ratio)) {
        stop("log2.ratio is not a numeric value.")
    }
    if (!is.null(read.floor) & (!is.numeric(read.floor) | (length(read.floor) > 1))) {
        stop("If provided, read.floor must be a numeric value of length 1.")
    }

    e <- log2(exprs(eset) + 1)
    trim < nrow(e) || stop("'trim' must be less than the total number of features in the 'eset': ", "trim:", trim, ", total number of features: ", nrow(e), ".")
    if (!is.null(sampleKey)) {
        sampleKey <- ct.keyCheck(sampleKey, eset)
        control.samples <- names(sampleKey)[sampleKey == levels(sampleKey)[1]]
        e <- e[, control.samples]
    }
    

    # Trim and discard the elements that never cross the minimum threshold
    e.cuts <- apply(e, 2, sort, decreasing = TRUE)[trim, ] - log2.ratio
    if (!is.null(read.floor)) {
        message("Using the supplied minimum threshold of ", read.floor, " reads for each guide.")
        read.floor <- log2(read.floor)
        newcuts <- vapply(e.cuts, function(x) {
            ifelse(x < read.floor, read.floor, x)
        }, numeric(1))
        names(newcuts) <- names(e.cuts)
        e.cuts <- newcuts
    }

    whitelist <- row.names(e)[colSums(apply((t(e) - e.cuts), 2, sign)) != -ncol(e)]

    new.es <- eset[whitelist, ]

    # Raw
    if (plot.it) {
        par(mfrow = c(2, 1))
        ds <- apply(log2(exprs(eset) + 1), 2, density)
        ymax <- max(unlist(lapply(ds, function(x) {
            x$y
        })))
        xr <- range(unlist(lapply(ds, function(d) {
            d$x
        })))
        plot(ds[[1]], main = "Untrimmed gRNA Density", ylim = c(0, ymax), xlim = xr, xlab = "Raw Log2 gRNA Count", ylab = "Density")
        invisible(lapply(ds, lines))
        if (!is.null(sampleKey)) {
            ds <- apply(log2(exprs(eset))[, control.samples], 2, density)
            invisible(lapply(ds, lines, col = "red"))
            legend("topright", "Control", fill = "red")
        }

        # corrected
        ds <- apply(log2(exprs(new.es) + 1), 2, density)
        ymax <- max(unlist(lapply(ds, function(x) {
            x$y
        })))
        xr <- range(unlist(lapply(ds, function(d) {
            d$x
        })))
        plot(ds[[1]], main = "Trimmed gRNA Density", ylim = c(0, ymax), xlim = xr, xlab = "Trimmed Log2 gRNA Count", ylab = "Density")
        invisible(lapply(ds, lines))
        if (!is.null(sampleKey)) {
            ds <- apply(log2(exprs(new.es))[, control.samples], 2, density)
            invisible(lapply(ds, lines, col = "red"))
            legend("topright", "Control", fill = "red")
        }
    }

    return(new.es)
}

##' @title Update a gene-centric msdb object for GREAT-style enrichment analysis using a specified CRISPR annotation.
##'
##' @description Update a gene-centric `GeneSetDb` object for GREAT-style enrichment analysis using a specified annotation.
##' 
##' Often, pooled screening libraries are constructed such that the gene targets of interest are associated 
##' with variable numbers of semi-independent screen signals (associated with, e.g., sets of alternative promoters 
##' or cis regulatory units). Such an arrangement is often unavoidable but produces to complications when 
##' performing gene set enrichent analyses. This function conforms a standard `GeneSetDb` object to appropriately 
##' consider this form of ultiple testing during ontological enrichment analyses according to the GREAT strategy
##' outlined by [McLean et al. (2009)](https://doi.org/10.1038/nbt.1630).
##' 
##' Operationally, this means that genewise sets in the provided object will be translated to the corresponding 
##' `geneSymbol` sets provided in the annotation file. 
##' 
##' @param annotation an annotation object returned by \code{ct.prepareAnnotation()}. 
##' @param gsdb A gene-centric \code{GeneSetDb} object to conform to the relevant peakwise dataset.
##' @param minsize Minimum number of targets required to consider a geneset valid for analysis.
##' @param ... Additional arguments to be passed to `ct.prepareAnnotation()`.
##' @return A new \code{GeneSetDb} object with the features annotated genewise to pathways.
##' @examples 
##' data(resultsDF)
##' data(ann)
##' gsdb <- ct.GREATdb(ann, gsdb = sparrow::getMSigGeneSetDb(collection = 'h', species = 'human', id.type = 'entrez'))
##' show(sparrow::featureIds(gsdb))
##' @export
ct.GREATdb <- function(annotation, gsdb = sparrow::getMSigGeneSetDb(collection = c("h", "c2"), species = "human", id.type = "ensembl"), minsize = 10, ...) {

    .Deprecated('convertIdentifiers', package = 'sparrow', 
                msg = 'Consider using sparrow for collapsing targets to genes (see sparrow::convertIdentifiers()).')
    
    # input check
    if (!is(gsdb, "GeneSetDb")) {
        if (is(gsdb, "GeneSetCollection") || is(gsdb, "GeneSet")) {
            stop("A GeneSetDb is required. GeneSetCollections can be converted to a ", "GeneSetDb via the GeneSetDb constructor, or a call to ", "`as(gene_set_collection, 'GeneSetDb')`. See ?GeneSetDb for more ", 
                "details.")
        }
        stop("GeneSetDb required. Please see `?GeneSetDb` for ways to turn your ", "gene sets into a GeneSetDb, or ")
    }
    stopifnot(is(gsdb, "GeneSetDb"), is(minsize, "numeric"), (length(minsize) == 1))

    # check the annotation object
    annotation <- ct.prepareAnnotation(annotation, ...)

    # Check to make sure that the geneID column values are present in the provided gsdb
    genes <- na.omit(unique(annotation$geneID))
    message(length(intersect(sparrow::featureIds(gsdb), genes)), " valid genes found in the supplied gene database (of ", length(genes), ")")

    # Tabulate targets per gene
    targetsPerGene <- lapply(genes, function(x) {
        return(as.character(unique(annotation$geneSymbol[annotation$geneID %in% x])))
    })
    names(targetsPerGene) <- genes
    minsetsize <- floor(minsize/max(unlist(lapply(targetsPerGene, length))))

    # Pull the lists from the gsdb
    gsdb <- sparrow::conform(gsdb, target = sparrow::featureIds(gsdb), min.gs.size = minsetsize)
    gsdb_list <- as.list(gsdb)

    new_gs <- lapply(gsdb_list, function(x) {
        return(as.character(unique(unlist(targetsPerGene[x]))))
    })
    message(length(new_gs), " adjusted genesets created.")
    if (length(new_gs) == 0) {
        stop("Exiting.")
    }

    collections <- vapply(names(new_gs), function(x) {
        strsplit(x, split = ";;")[[1]][1]
    }, character(1))
    sets <- vapply(names(new_gs), function(x) {
        strsplit(x, split = ";;")[[1]][2]
    }, character(1))
    names(new_gs) <- sets

    out <- lapply(unique(collections), function(z) {
        new_gs[collections %in% z]
    })
    out_gdb <- sparrow::GeneSetDb(out, ...)
    out_gdb <- sparrow::conform(out_gdb, target = sparrow::featureIds(out_gdb), min.gs.size = minsize)

    return(out_gdb)
}

##' @title Prepare one or more resultsDF objects for analysis via Sparrow. 
##' 
##' @description Take in a list of results objects and return an equivalently-named list of input `data.frames` appropriate for `sparrow::seas()`. 
##' By construction, the relevant target unit is extracted from the `geneSymbol` column of the provided results objects, which may. Note that the 
##' genewise `@logFC` slot in the returned object will contain the appropriately-signed Z transformation of the P-value 
##' assigned to the target. In most applications this is arguably more interpretable than e.g., the median gRNA log2 fold change.  
##'  
##' @param dflist A list of gCrisprTools results `data.frames` to be formatted.
##' @param collapse.on Should targets be annotated as `geneSymbol`s or `geneID`s (default)? 
##' @param cutoff Numeric maximum value of `statistic` to define significance.
##' @param statistic Should cutoffs be calculated based on FDR (`best.q`) or P-value (`best.p`)?
##' @param regularize Logical indicating whether to regularize the result objects in `dflist` (e.g., use intersection set of 
##' all targets), or keep as-is. 
##' @param gdb Optionally, a `GeneSetDb` object to enable proper registration of the output. If provided, the 
##' collapsing features in the provided `simpleDF`s must be present in the `gsd@db$feature_id` slot. Note that a GREAT-style `GeneSetDb` that 
##' has been conformed via `ct.GREATdb()` will use `geneID`s as the `feature_id`.
##' @param active Optionally, the name of a logical column present in the provided result that will be used to define significant signals. 
##' This is set to `replicated` by default to If a valid column name is provided, this overrides the specification of `cutoff` and `statistic`.
##' @return A list of `data.frames` formatted for evaluation with `sparrow::seas()`. 
##' @examples 
##' data(resultsDF)
##' ct.seasPrep(list('longer' = resultsDF, 'shorter' = resultsDF[1:10000,]), collapse.on = 'geneSymbol')
##' @export
ct.seasPrep <- function(dflist, collapse.on = c("geneID", "geneSymbol"), cutoff = 0.1, statistic = c("best.q", "best.p"), regularize = FALSE, gdb = NULL, active = 'replicated') {
    # Input check
    collapse.on <- match.arg(collapse.on)
    stopifnot(is(cutoff, "numeric"), cutoff <= 1, cutoff >= 0, is(regularize, "logical"), is.character(active))

    if (regularize) {
        dflist <- ct.regularizeContrasts(dflist, collapse = collapse.on)
    } else {
        dflist <- lapply(dflist, ct.simpleResult, collapse = collapse.on)
    }

    statistic <- match.arg(statistic)

    if (!is.null(gdb)) {
        dflist <- lapply(dflist, function(x) {
            x[(row.names(x) %in% sparrow::featureIds(gdb)), ]
        })
        message("Removed genes absent from the provided GeneSetDb.")
    }
    
    if (any(unlist(lapply(dflist, nrow)) == 0)) {
        stop("No valid `feature_id`s observed for one or more of the provided contrasts! check `collapse.on`?")
    }

    out <- lapply(dflist, function(x) {
        z <- 10^-(ct.softLog(x$best.p))
        z <- qnorm(z/2) * ifelse(x$direction == "enrich", -1, 1)
        sig <- (x[, statistic] <= cutoff)
 
        if(active %in% names(x)){
            stopifnot(is(x[,active], 'logical'))
            sig <- x[,active]
            message("Using provided active set: ", active)
        } 
        
        df <- data.frame(feature_id = row.names(x), logFC = z, significant = sig, direction = x$direction, rank_by = z, stringsAsFactors = FALSE)
        return(df)
    })

    names(out) <- names(dflist)
    return(out)

}

##' @title Geneset Enrichment within a CRISPR screen using `sparrow`
##' 
##' @description This function is a wrapper for the `sparrow::seas()` function, which identifies differentially enriched/depleted ontological 
##' categories within the hits identified by a pooled screening experiment, given a provided `GenseSetDb()` object and a list of 
##' results objects created by `ct.generateResults()`. By default testing is performed using `fgsea` and a hypergeometric test 
##' (`sparrow::ora()`), and results are returned as a `SparrowResult` object. 
##' 
##' This function will attempt to coerce them into inputs appropriate for the above analyses via `ct.seasPrep()`, after checking 
##' the relevant parameters within the provided `GeneSetDb`. This is generally easier than going through the individual steps yourself, 
##' especially when the user is minimally postprocessing the contrast results in question. 
##' 
##' Sometimes, it can be useful to directly indicate the set of targets to be included in an enrichment analysis (e.g., if you wish to expand
##' or contract the set of active targets based on signal validation or other secondary information about the experiment). To accomodate this 
##' use case, users may include a logical column in the provided result object(s) indicating which elements should be included among the 
##' positive signals exposed to the test. 
##' 
##' Note that many pooled libraries specifically target biased sets of genes, often focusing on genes involved
##' in a particular pathway or encoding proteins with a shared biological property. Consequently, the enrichment results
##' returned by this function represent the disproportionate enrichment or depletion of targets annotated to pathways *within the context
##' of the screen*, and may or may not be informative of the underlying biology in question. This means that
##' pathways not targeted by a library will obviously never be enriched a positive target set regardless of
##' their biological relevance, and pathways enriched within a focused library screen are similarly expected to partially
##' reflect the composition of the library and other confounding issues (e.g., number of targets within a pathway).
##' Analysts should therefore use this function with care. For example, it might be unsurprising to detect pathways related
##' to histone modification within a screen employing a crispr library primarily targeting epigenetic regulators.
##'  
##' @param dflist A result object created by `ct.generateResults()`, or a named list containing many of them; will be passed as a list to 
##' `ct.seasPrep()` with the associated `...` arguments.
##' @param gdb A `GenseSetDb` object containing annotations for the targets specified in `result`.
##' @param active Name of a column in the supplied result(s) that should be used to indicate active/selected targets.  
##' @param ... Additional arguments to pass to `ct.seasPrep()` or `sparrow::seas()`. 
##' @return A named list of `SparrowResults` objects.
##' @examples 
##' data('resultsDF')
##' gdb <- sparrow::getMSigGeneSetDb(collection = 'h', species = 'human', id.type = 'entrez')
##' ct.seas(list('longer' = resultsDF, 'shorter' = resultsDF[1:10000,]), gdb)
##' @author Steve Lianoglou for seas; Russell Bainer for GeneSetDb processing and wrapping functions.
##' @export
ct.seas <- function(dflist, gdb, active = 'replicated', ...) {

    # Check GSDB and determine feature set
    stopifnot(is(gdb, "GeneSetDb"))

    # listify results as needed
    if (!is(dflist, "list")) {
        if (ct.resultCheck(dflist)) {
            dflist <- list(result = dflist)
        }
    }


    # Infer whether Gsdb is ID or feature centric
    gids <- sum(sparrow::featureIdMap(gdb)$feature_id %in% dflist[[1]]$geneID)
    gsids <- sum(sparrow::featureIdMap(gdb)$feature_id %in% dflist[[1]]$geneSymbol)

    if (all(c(gsids, gids) == 0)) {
        stop("None of the features in the GeneSetDb are present in either the geneID or geneSymbol slots of the first provided result.")
    }

    identifier <- ifelse(gids > gsids, "geneID", "geneSymbol")
    message("GeneSetDb feature_ids coded as ", identifier, "s.")
    if (identifier %in% "geneID") {
        message("Depending on the composition of your library, you might consider switching to a target-level analysis; see ?ct.GREATdb() for details.")
    }

    # Check that all provided objects are keyed to the proper values
    ipts <- ct.seasPrep(dflist, collapse.on = identifier, gdb = gdb, active = active)

    outs <- lapply(ipts, function(ipt) {
        sparrow::seas(x = ipt, gsd = gdb, methods = c("ora", "fgsea"), rank_by = "rank_by", selected = "significant", groups = "direction", ...)
    })
    return(outs)
}

---
title: CRISPR Report
output: 
  html_document:
    fig_caption: yes
params:
  eset: !r Biobase::ExpressionSet()
  fit: !r data.frame()
  sampleKey: !r factor()
  results: !r data.frame()
  annotation: !r data.frame()
  aln: !r matrix()
---


This is a report visualizing the overall dynamics of a single contrast in a pooled CRISPR-based screening experiment. See the vignettes folder of the `gCrisprTools` R package for further discussion of the proper analysis and interpretation of these experiments. For analysts, the manual pages of the various functions provide further detail about the analytical approaches employed and computational considerations relevant to their interpretation; most of the functions used in this report can also be extended in various ways to clarify more specific experimental questions that may arise during the analysis of a CRISPR screen. 

### Section 1: Experiment Overview 

#### gRNA Alignment Overview

In a high-quality library the overwhelming majority of reads will contain valid gRNA target sequences (>80%). Reads not matching the gRNA library may correspond to experimental contamination by lentivirus derived from other libraries. Rejected reads contain to sequences not derived from the lentiviral cassette and may reflect problems with cassette isolation, library prep, or sequencing quality. Reads that "double match" contain apparent gRNA sequences in both mate pairs of a single paired-end read; this shouldn't happen given the structure of the lentiviral cassette, but may be rarely produced as an artifact of the library construction process. 

```{r, echo=FALSE, warning=FALSE, message=FALSE, fig.height=6, fig.width=10, fig.cap= "Figure 1: Sample-Level gRNA Aligment Profile"}
if(!is.null(params$aln)){
  ct.alignmentChart(aln = params$aln, sampleKey = params$sampleKey)
} else {
  print("No alignment matrix provided.")
}
```

<br/>
<br/>
<br/>

#### Raw gRNA Read Counts

In most CRISPR libraries the majority of gRNA abundances will form a relatively smooth distribution distributed about the median count, often with a long tail. Sample libraries may be undersequenced if the raw number of read counts per gRNA is low, and PCR artifacts may be present if the sample contains a subset of extremely abundant guides or the distribution is jagged or contains multiple modes. In most well-executed experiments the majority of gRNAs in the control samples will form a tight distribution around some reasonably high average read count (hundreds of reads, *X* axis). Excessively low raw count values can compromise normalization steps and subsequent estimation of gRNA levels, which is typically a problem in screens where identification of disproportionately depleted gRNAs is important. 

```{r, echo=FALSE, warning=FALSE, message=FALSE, fig.height=10, fig.width=10, fig.cap= "Figure 2: Raw gRNA Count Densities"}
ct.rawCountDensities(params$eset, params$sampleKey)
```

<br/>
<br/>
<br/>

##### GC Content and gRNA Abundance

GC content can influence PCR efficiency, and a strong relationship between GC content and gRNA abundance may be evidence of poor viral library quality or sample preparation in CRISPR screens. Ideally, there should be no clear relationship between GC content and a gRNA's measured abundance. Keep in mind that some libraries may contain important subsets of gRNAs that have systematic differences in GC content (e.g., nontargeting controls) which may affect this.  

```{r, echo=FALSE, warning=FALSE, message=FALSE, fig.height=10, fig.width=10, fig.cap="Figure 3: GC content and gRNA Abundance"}
if (is.null(params$sampleKey)) {
  ct.GCbias(data.obj = params$eset, 
            ann = params$annotation, 
            lib.size = params$lib.size
            )
} else {
   ct.GCbias(data.obj = params$eset, 
            ann = params$annotation, 
            lib.size = params$lib.size,
            sampleKey = params$sampleKey
            )
}
```

<br/>
<br/>
<br/>

### Section 2: Library-level Distortion of gRNA Abundances

Pooled CRISPR screens are fundamentally dynamic experiments, in which the measured abundance of a particular gRNA is fundamentally dependent on the scale of selection observed throughout the remaining gRNAs present in the screen. In general, rigorous statistical methods perform well in screens where most cells survive the selection event and the gRNA distributions remain relatively stable throughout the experiment (i.e., dropout screens); more heuristic approaches are preferable in screens where most cells are affected and the resulting library only contains a small subset of gRNAs of extremely high abundance. The primary goal of this section is to determine the extent to which selection has distorted your gRNA library to guide downstream analyses.

##### Ranked and Scaled gRNA Abundance Distributions 
Strong selection in a CRISPR screen will distort the gRNAs such that the "slope" of the middle of the distribution changes relative to what is observed in the control samples. This can lead to spurious inferences of gRNA depletion in some cases, and it may be useful to correct this with the `ct.normalizeBySlope()` function in the `gCrisprTools` R package prior to downstream analyses. Alternatively, experiments involving treatments where most cells are affected may have failed if library-level distortion is not readily apparent. The locations of nontargeting control guides are indicated as diamonds along each distribution.

```{r, echo=FALSE, warning=FALSE, message=FALSE, fig.height=10, fig.width=10, fig.cap= "Figure 4: Ranked gRNA Distributions by Replicate"}
ct.gRNARankByReplicate(params$eset, params$sampleKey, params$annotation, geneSymb = "NTC")  
```

<br/>
<br/>
<br/>



##### Cumulative Target-level Read Abundance
A simple way to quantify the extent of distortion in a CRISPR screen is to observe the proportion of reads within each library that are derived from gRNA cassettes targeting each genomic element. By ranking the targets by their abundance within the library (*X* axis) and plotting the cumulative proportion of reads that the top *N* targets represent (*Y* axis), we can tell if the treatment libraries essentially only contain cassettes targeting a small number of genes, or if most of the cells survive the selection step. 

```{r, echo=FALSE, warning=FALSE, message=FALSE, fig.height=10, fig.width=10, fig.cap= "Figure 5: Per-Replicate gRNA Cumulative Distributions"}
ct.guideCDF(params$eset, params$sampleKey, plotType = "Target", annotation = params$annotation)
```


<br/>
<br/>
<br/>

##### Nontargeting Control Guides

The behavior of nontargeting control guides can give some sense of the consistency of the gRNA abundances within experimental cultures and the likely effect of normalization on the gRNA abundance estimation. Note that it is not necessarily critical that the relative abundances of nontargeting gRNAs remain superficially stable across treatments, but extremely large changes may indicate that individual gRNA levels are not likely to be well estimated. 

```{r, echo=FALSE, warning=FALSE, message=FALSE, fig.height=10, fig.width=10, fig.cap="Figure 6: Nontargeting Control Behavior Before and After Median Scaling"}
ct.viewControls(params$eset, params$annotation, params$sampleKey, normalize = FALSE) 
ct.viewControls(params$eset, params$annotation, params$sampleKey, normalize = TRUE)
```

<br/>
<br/>
<br/>


### Section 3: Results Overview

##### GC Content and Estimated Model Effects

GC content can influence PCR efficiency, and strong GC-related effects may be evidence of poor library quality in  screens. Ideally, there should be no clear relationship between GC content and a gRNA's variance, fold change, or evidence for differential abundance. Keep in mind that some libraries may contain important subsets of gRNAs that have systematic differences in GC content, however (e.g., nontargeting controls).  

```{r, echo=FALSE, warning=FALSE, message=FALSE, fig.height=10, fig.width=10, fig.cap="Figure 7: GC Content and Model Estimates"}
if (is.null(params$sampleKey)) {
  ct.GCbias(data.obj = params$fit, 
            ann = params$annotation
            )
} else {
  ct.GCbias(data.obj = params$fit, 
            ann = params$annotation, 
            sampleKey = params$sampleKey
            )
}
```

<br/>
<br/>
<br/>

##### Most Variable Genes and gRNAs as a Proportion of the Libraries

In experiments that include highly distorted libraries, it can be useful to identify the genes or gRNAs that change the most across the experiment as a heuristic way of identifying gRNAs of interest in situations where standard statistical approaches are not likely to function well. Note that the indicated genes and gRNAs are the most variable across all samples in the experiment; if desired, similar graphs displaying the most variable genes within a subset of samples may be generated by the analyst by invoking the `ct.stackGuides()` function in the `gCrisprTools` package.

```{r, echo=FALSE, warning=FALSE, message=FALSE, fig.height=10, fig.width=10, fig.cap="Figure 8: Stacked Barplot of the Most Variable Genes"}
ct.stackGuides(params$eset, params$sampleKey, plotType = "Target", annotation = params$annotation)
```

<br/>
<br/>
<br/>
```{r, echo=FALSE, warning=FALSE, message=FALSE, fig.height=10, fig.width=10, fig.cap="Figure 9: Stacked Barplot of the Most Variable Genes"}
ct.stackGuides(params$eset, params$sampleKey, plotType = "gRNA", annotation = params$annotation)
```

<br/>
<br/>
<br/>



### Top Signals of Target Enrichment and Depletion

Below are plots indicating the targets with the most evidence for enrichment and depletion within the indicated contrast. Genes are ranked by aggregating the signal for depletion or enrichment across all gRNAs targeting the corresponding element. Briefly, individual gRNAs are assigned a *P*-value quantifying the evidence for enrichment or depletion within a linear model contrast. The *P*-values of all the gRNAs in the experiment are transformed into a ranking, and genes are assigned a score based on the distribution of the ranks of the *P*-values observed among the guides targeting it, ignoring gRNAs with *P*-values above a nominal significance threshold (*P*= 0.1 by default). These scores are transformed into a *P*-value via permutation; genes targeted by lots of guides with the highest overall evidence for abundance changes will be top ranked. Genes with identical *P*-values are ordered by their median gRNA abundance change within the contrast (log2 fold change within the framework of the linear model). This method of gRNA signal aggregation is identical to that employed by the MAGeCK algorithm (Li et al., *Genome Research* 2014). 

Within each plot, candidates are ordered by the evidence for enrichment or depletion. Each gRNA targeting the gene is plotted as a point, with the estimated log2 fold change  indicated on the *Y*-axis and the standard deviation of the estimate shown as a gray bar. 


```{r, echo=FALSE, warning=FALSE, message=FALSE, fig.height= 5, fig.width= 10, fig.cap="Figure 10: Top 20 Enriched Targets"}
enrich <- ct.topTargets(params$fit, params$results, params$annotation, targets = 20, enrich = TRUE)
```
<br/>
<br/>
<br/>


```{r, echo=FALSE, warning=FALSE, message=FALSE, fig.height= 5, fig.width= 10, fig.cap="Figure 11: Top 20 Depleted Targets"}
deplete <- ct.topTargets(params$fit, params$results, params$annotation, targets = 20, enrich = FALSE)
```
<br/>
<br/>
<br/>

---
title: "gCrisprTools and the Analysis of Pooled Screening Data"
author: "Russell Bainer"
output:
  html_vignette:
    toc: true
    depth: 3
vignette: >
  %\VignetteIndexEntry{gCrisprTools_Vignette}
  %\VignetteEngine{knitr::knitr}
  %\VignetteEncoding{UTF-8}
---
### 1.0 Overview of gCrisprTools

Competitive screening experiments, in which bulk cell cultures infected with a heterogeneous viral library are experimentally manipulated to identify guide RNAs or shRNAs that influence cell viability, are conceptually straightforward but often challenging to implement. Here, we present gCrisprTools, an R/Bioconductor analysis suite facilitating quality assessment, target prioritization, and interpretation of arbitrarily complex competitive screening experiments. gCrisprTools provides functionalities for detailed and principled ana lysis of diverse aspects of these experiments both as a standalone pipeline or as an extension to alternative analytical approaches.

#### 1.1 Installation

Install gCrisprTools in the usual way:

```{r, eval = FALSE}
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("gCrisprTools")
```

#### 1.4 Explore the Vignettes Folder

This vignette is only one of the resources provided in `gCrisprTools` to help you understand, analyse, and explore pooled screening data. As appropriate, please see the `/vignettes` subdirectory for additional documentation describing example code, and the `/inst` directory for more information about algorithm implementation and package layout.

#### 1.3 Dependencies

`gCrisprTools` uses the existing `Biobase` framework for data storage and manipulation and consequently depends heavily on the `Biobase` and `limma` packages.

```{r, message=FALSE, warning=FALSE}
library(Biobase)
library(limma)
library(gCrisprTools)
```


### 2.0 Inputs

#### 2.1 Counting Cassettes from Sequencing Data

To use the various methods available in this package, you will first need to conform your screen data into an `ExpressionSet` object containing cassette abundance counts in the assayData slot, retrievable with `exprs()`. This package assumes that end users are familiar enough with the R/Bioconductor framework and their own sequencing pipelines to extract raw cassette counts from FASTQ files and to compose them into an `ExpressionSet`. For newer users read counting may be facilitated with [cutadapt](https://cutadapt.readthedocs.io/en/stable/) or other software designed for these purposes; details about composition of `ExpressionSet` objects can be found in the  [Biobase](http://bioconductor.org/packages/release/bioc/manuals/Biobase/man/Biobase.pdf) vignette.

##### 2.2 An ExpressionSet of Cassette Counts

Raw cassette counts should be contained within an `ExpressionSet` object, with the counts retrievable with`exprs()`. The column names (`colnames()`) should correspond to unique sample identifiers, and the row names (`row.names()`) should correspond to identifiers uniquely specifying each cassette of interest.
```{r}
data("es", package = "gCrisprTools")
es
head(exprs(es))
```

##### 2.3 An Annotation Object

gCrisprTools requires an annotation object mapping the individual cassettes to genes or other genomic features for most applications. The annotation object should be provided as a named `data.frame`, with columns describing the '`geneID`' and '`geneSymbol`' of the target elements to which each cassette is annotated. These columns should contain character vectors with elements that uniquely describe the targets in the screen; by convention, the `geneID` field contains an official identifier that unambiguously describes each target element in a manner suitable for external software (e.g., an Entrez ID). The `geneSymbol` column indicates a more human-readable descriptor, such as a gene symbol.

The annotation object may optionally contain other columns with additional information about the corresponding cassettes.

```{r}
data("ann", package = "gCrisprTools")
head(ann)
```

#### 2.4 A Sample Key

Many `gCrisprTools` functions require or are enhanced by a sample key detailing the experimental groups of the functions included in the study. This key should be provided as a named factor, with `names` perfectly matching the `colnames` of the ExpressionSet. The first level of the sample key should correspond to the 'control' condition, indexing samples whose cassette distributions are expected to be the minimally distorted by experimental treatments.

```{r}
sk <- relevel(as.factor(pData(es)$TREATMENT_NAME), "ControlReference")
names(sk) <- row.names(pData(es))
sk
```

#### 2.5 Alignment Statistics

Users may provide a matrix of alignment statistics to enhance some applications, including QC reporting. These should be provided as a numeric matrix in which rows correspond to `targets` (reads containing a target cassette), `nomatch` (reads containing a cassette sequence but not a known target sequence), `rejections` (reads not containg a cassette sequence), and `double_match` (reads derived from multiple cassettes). The column names should exactly match the `colnames()` of the ExpressionSet object. Simple charting functionality is also provided to inspect the alignment rates of each sample.

```{r, fig.width = 7, fig.height = 5}
data("aln", package = "gCrisprTools")
head(aln)
ct.alignmentChart(aln, sk)
```

### 3.0 Preprocess Raw Data

`gCrisprTools` provides tools for common data preprocessing steps, including eliminating underinfected or contaminant cassettes and sample-level normalization.

##### 3.1 ct.filterReads

Low abundance cassettes can be removed by specifying a minimum number of counts or a level relative to the trimmed distribution maximum.

```{r, fig.width=6, fig.height = 8}
es.floor <- ct.filterReads(es, read.floor = 30, sampleKey = sk)
es <- ct.filterReads(es, trim = 1000, log2.ratio = 4, sampleKey = sk)

##Convenience function for conforming the annotation object to exclude the trimmed gRNAs
ann <- ct.prepareAnnotation(ann, es, controls = "NoTarget")
```

##### 3.2 ct.normalizeGuides

A suite of normalization tools are provided with the `ct.normalizeGuides()` wrapper function; see the relevant manual pages for further details about these methods.

```{r, fig.width=6, fig.height = 8}

es <- ct.normalizeGuides(es, 'scale', annotation = ann, sampleKey = sk, plot.it = TRUE)

timepoints <- gsub('^(Control|Death)', '', pData(es)$TREATMENT_NAME)
names(timepoints) <- colnames(es)
es.norm <- ct.normalizeGuides(es, 'FQ', annotation = ann, sampleKey = timepoints, plot.it = TRUE)

es.norm <- ct.normalizeGuides(es, 'slope', annotation = ann, sampleKey = sk, plot.it = TRUE)
es.norm <- ct.normalizeGuides(es, 'controlScale', annotation = ann, sampleKey = sk, plot.it = TRUE, geneSymb = 'NoTarget')
es.norm <- ct.normalizeGuides(es, 'controlSpline', annotation = ann, sampleKey = sk, plot.it = TRUE, geneSymb = 'NoTarget')
```

##### 3.3 ct.makeQCReport

For convenience, experiment-level dynamics and the effects of various preprocessing steps may be automatically summarized in the form of a report. The following code isn't run as part of this vignette, but if run from the terminal `path2QC` will indicate the path to an html Quality Control report.

```{r, eval= FALSE}
#Not run:
path2QC <- ct.makeQCReport(es,
                 trim = 1000,
                 log2.ratio = 0.05,
                 sampleKey = sk,
                 annotation = ann, 
                 aln = aln,
                 identifier = 'Crispr_QC_report',
                 lib.size = NULL
                 )
```

### 4.0 Quality Assessment

The `gCrisprTools` package provides a series of functions for assessing distributional and technical properties of sequencing libraries. Please see additional details about all of these methods on their respective manual pages.

##### 4.1 ct.rawCountDensities

The raw cassette count distributions can be visualized to determine whether samples were inadequately sequenced or if PCR amplification artifacts might be present.

```{r, fig.width=6, fig.height=6}
ct.rawCountDensities(es, sk)
```

##### 4.2 ct.gRNARankByReplicate

Aspects of cassette distributions are often better visualized with a 'waterfall' plot than a standard density estimate, which can clarify the ranking relationships in specific parts of the distribution.

```{r, fig.width=6, fig.height = 6}
ct.gRNARankByReplicate(es, sk)  #Visualization of gRNA abundance distribution
```

These plots also enable explicit visualization of cassettes of interest in the context of the experimental distribution.

```{r, fig.width=6, fig.height = 6}
ct.gRNARankByReplicate(es, sk, annotation = ann, geneSymb = "Target1633")
```

##### 4.3 ct.viewControls

`gCrisprTools` provides tools for visualizing the behavior of control gRNAs across experimental conditions.

```{r, fig.width=6, fig.height = 6}
ct.viewControls(es, ann, sk, normalize = FALSE, geneSymb = 'NoTarget')
```

##### 4.4 ct.guideCDF

Depending on the screen in question, it can be useful to quantify the extent to which experimental libraries have been distorted by experimental treatments. `gCrisprTools` provides tools to estimate an empirical cumulative distribution function describing the cassettes or (targets) within a screen.

```{r, fig.width=6, fig.height = 4}
ct.guideCDF(es, sk, plotType = "gRNA")
```


### 5.0 Identifying Candidate Targets

The core analytical machinery of gCrisprTools is built on the linear modelling framework implemented in the `limma` package. Specifically, users employ `limma/voom` to generate an experimental contrast of interest at the gRNA level. The model coefficent and P-value estimates may be subsequently processed with the infrastructure provided by `gCrisprTools`.

```{r}
design <- model.matrix(~ 0 + REPLICATE_POOL + TREATMENT_NAME, pData(es))
colnames(design) <- gsub('TREATMENT_NAME', '', colnames(design))
contrasts <-makeContrasts(DeathExpansion - ControlExpansion, levels = design)

vm <- voom(exprs(es), design)

fit <- lmFit(vm, design)
fit <- contrasts.fit(fit, contrasts)
fit <- eBayes(fit)
```

##### 5.1 ct.generateResults

After generating a fit object (class `MArrayLM`) for a contrast of interest, we may summarize the signals from the various cassettes annotated to each target via RRA$\alpha$ aggregation. The core algorithm is described in detail in the original publication on Robust Rank Aggregation[^1] and has been implemented according to the $\alpha$ thresholding modification proposed by Li et al.[^2] Briefly, gRNA signals contained in the specified fit object are ranked and normalized, and these ranks are grouped by the associated target and assigned a score ($\rho$) on the basis of the skewness of the gRNA signal ranks. The statistical significance of each target-level score is then assessed by permutation of the gRNA target assignments. *Q*-values are computed directly from the resulting *P*-value distributions using the FDR approach described by Benjamini and Hochberg.[^3]

A more extensive treatment of RRA$\alpha$ and comparisons to MAGeCK may be found in `inst/Mageck_&_gCrisprTools.html`.

```{r, message=FALSE, warning=FALSE}
resultsDF <-
  ct.generateResults(
    fit,
    annotation = ann,
    RRAalphaCutoff = 0.1,
    permutations = 1000,
    scoring = "combined"
  )
```

The resulting dataframe contains columns passing some of the information from the fit and annotation objects, as well as a number of statistics describing the evidence for a target's depletion or enrichment within the context of the screen. These include the Target-level *P* and *Q* values quantifying the evidence for enrichment or depletion, the median log2 fold change of all of the gRNAs associated with each target, and the rankings of the target-level $/rho$ statistics (gene-level scores may be useful for ranking targets with equivalent *P*-values).

### 6.0 Visualization of Results

After identifying candidate targets, various aspects of the contrast may be visualized with `gCrisprTools`.

##### 6.1 ct.topTargets

The `ct.topTargets` function enables simple visualization of the model effect estimates (log2 fold changes) and associated uncertainties of all cassettes associated with the top-ranking targets.

```{r, fig.width=6, fig.height = 6}
ct.topTargets(fit,
              resultsDF,
              ann,
              targets = 10,
              enrich = TRUE)
```

##### 6.2 ct.stackGuides

In some screens it can be useful to visualize the degree of library distortion associated with the strongest signals. Such an approach can supply additional confidence in a particular candidate of interest by showing that clear differences are evident outside of the linear modeling framework (which may be inaccurate in heavily distorted libraries).

```{r, fig.width=6, fig.height = 8}
ct.stackGuides(
  es,
  sk,
  plotType = "Target",
  annotation = ann,
  subset = names(sk)[grep('Expansion', sk)]
)
```

##### 6.3 ct.viewGuides

`gCrisprTools` provides methods to visualize the behavior of individual cassettes annotated to target of interest, and positions these within the observed distribution of effect sizes across all cassettes within the experiment.

```{r, fig.width=6, fig.height = 4}
ct.viewGuides("Target1633", fit, ann)
```

##### 6.3 ct.signalSummary

Sometimes it can be useful to visualize known sets of targets together in the context of the full screen contrast: 

```{r, fig.width=6, fig.height = 4}
ct.signalSummary(resultsDF,
                 targets = list('TargetSetA' = c(sample(unique(resultsDF$geneSymbol), 3)),
                                'TargetSetB' = c(sample(unique(resultsDF$geneSymbol), 2))))

```


#### 6.4 ct.makeContrastReport and ct.makeReport
As with the Quality Control components of an individual screen, `gCrisprTools` provides functionality to automatically generate contrast-level reports.

```{r, eval= FALSE}
#Not run:
path2Contrast <-
  ct.makeContrastReport(eset = es,
                        fit = fit,
                        sampleKey = sk,
                        results = resultsDF,
                        annotation = ann,
                        comparison.id = NULL,
                        identifier = 'Crispr_Contrast_Report')
```

If you wish, you can also make a single report encompassing both quality control and the contrast of interest.

```{r, eval=FALSE}
#Not run:
path2report <-
  ct.makeReport(fit = fit,
                eset = es,
                sampleKey = sk,
                annotation = ann,
                results = resultsDF,
                aln = aln,
                outdir = ".")
```

### 7.0 Hypothesis Testing

In addition to identifying targets of interest within a screen, it may be worthwhile to ask more comprehensive questions about the targets identified. `gCrisprTools` provides a series of basic functions for determining the enrichment of known or unknown target groups within the context of a screen.

##### 7.1 ct.seas

If a screen was performed with a library targeting genes, `gCrisprTools` can provide basic ontological enrichment testing by leveraging the various functions available in the `sparrow` package. 
```{r, eval= FALSE}
#Not run:
genesetdb <- sparrow::getMSigGeneSetDb(collection = 'h', species = 'human', id.type = 'entrez')

# If you have a library that targets elements unevenly (e.g., variable numbers of 
# elements/promoters per genes), you can conform it via GREAT
genesetdb.GREAT <- ct.GREATdb(ann, gsdb = genesetdb)

ct.seas(resultsDF, gdb = genesetdb)
#ct.seas(resultsDF, gdb = genesetdb.GREAT)
```

The `sparrow` package is quite rich, and the the possible applications and extensions of geneset testing in crispr screens are detailed in the `Crispr_example_workflow`  and `Contrast_Comparisons` vignettes, and in the vignettes of the `sparrow` package. 

##### 7.2 ct.targetSetEnrichment, ct.signalSummary, ct.ROC, and ct.PRC

In some cases, it may be useful to ask whether a set of known targets is disproportionately enriched or depleted within a screen. `gCrisprTools` provides functions for answering these sorts of questions with `ct.ROC()`, which generates Reciever-Operator Characteristics for a specified gene set within a screen, and `ct.PRC()`, which draws precision-recall curves.  When called, both functions return the raw data necessary to reproduce or combine these results, along with appropriate statistics for assessing the significance of the overall signal within the specified target set (via a hypergeometric test).

```{r, fig.width=6, fig.height = 6, warning=FALSE}
data("essential.genes", package = "gCrisprTools")  #Artificial list created for demonstration
data("resultsDF", package = "gCrisprTools")
ROC <- ct.ROC(resultsDF, essential.genes, 'enrich')
str(ROC)
```

```{r, fig.width=6, fig.height = 6, warning=FALSE}
PRC <- ct.PRC(resultsDF, essential.genes, 'enrich')
str(PRC)
```

Alternatively, the significance of the enrichment within the target set may be assessed directly with `ct.targetSetEnrichment`.

```{r, fig.width=6, fig.height = 6, warning=FALSE}
##' tar <-  sample(unique(resultsDF$geneSymbol), 20)
##' res <- ct.targetSetEnrichment(resultsDF, tar)

targetsTest <- ct.targetSetEnrichment(resultsDF, essential.genes, enrich = FALSE)
str(targetsTest)
```

[^1]: Kolde R, Laur S, Adler P, Vilo J. Robust rank aggregation for gene list integration and meta-analysis. Bioinformatics. 2012;28(4):573-80. PMID:22247279

[^2]: Li W, Xu H, Xiao T, Cong L, Love MI, Zhang F, Irizarry RA, Liu JS, Brown M, Liu XS. MAGeCK enables robust identification of essential genes from genome-scale CRISPR/Cas9 knockout screens. Genome Biol. 2014;15(12):554. PMID:25476604

[^3]:Benjamini Y, Hochberg Y. Controlling the false discovery rate: a practical and powerful approach to multiple testing. Journal of the Royal Statistical Society, Series B. 1995;57(1):289–300. MR 1325392.

```{r}
sessionInfo()
```

---
title: CRISPR QC Report
output: 
  html_document:
    fig_caption: yes
params:
  eset: !r Biobase::ExpressionSet()
  trim: !r numeric()
  log2.ratio: !r numeric()
  sampleKey: !r factor()
  geneSymb: !r character()
  annotation: !r data.frame()
  aln: !r matrix()
  lib.size: !r numeric()
---

This is a report detailing experiment-level properties of a pooled CRISPR screening experiment. For information about individual contrasts, please consult the dedicated contrast report. 

### Section 1: Experiment Overview 

#### gRNA Alignment

In a high-quality library the overwhelming majority of reads will contain valid
gRNA target sequences (>80%). Reads not matching the gRNA library may correspond
to experimental contamination by lentivirus derived from other libraries.
Rejected reads correspond to sequences not derived from the lentiviral cassette and
may reflect problems with cassette isolation, library prep, or sequencing
quality. Reads that "double match" contain apparent gRNA sequences in both mate
pairs of a single paired-end read; this shouldn't happen given the structure of
the lentiviral cassette, but may be rarely produced as an artifact of the
library construction process.

```{r, echo=FALSE, warning=FALSE, message=FALSE, fig.height=6, fig.width=10, fig.cap= "Figure 1: Sample-Level gRNA Aligment Profile"}
if(!is.null(params$aln)){
  ct.alignmentChart(aln = params$aln, sampleKey = params$sampleKey)
} else {
  print("No alignment matrix provided.")
}
```

<br/>
<br/>
<br/>

#### Raw gRNA Read Counts

In most CRISPR libraries the majority of gRNA abundances will form a relatively
smooth distribution about the median count, often with a long tail.
Sample libraries may be undersequenced if the raw number of read counts per gRNA
is low, and PCR artifacts may be present if the sample contains a subset of
extremely abundant guides, or if the distribution is jagged or contains multiple
modes. In most well-executed experiments the majority of gRNAs in the control
samples will form a tight distribution around some reasonably high average read
count (e.g., hundreds of reads, *X* axis). Excessively low raw count values can
compromise normalization steps and subsequent estimation of gRNA levels, which
is typically a problem in screens where identification of disproportionately
depleted gRNAs is important.

```{r, echo=FALSE, warning=FALSE, message=FALSE, fig.height=6, fig.width=10, fig.cap= "Figure 2: Raw gRNA Count Densities"}
ct.rawCountDensities(eset = params$eset, sampleKey = params$sampleKey)
```

<br/>
<br/>
<br/>

#### The Effect of Filtering on Read Density

Most pooled CRISPR screening experiments include gRNA cassettes whose abundance 
is extremely low, either because of low-level sample contamination from other 
libraries, because certain constructs influenbce the lentivirus' infection efficiency, 
or because the corresponding cassettes are simply lowly abundant in the original 
plasmid or lentiviral libraries. If a very large number of lowly abundant gRNAs are present 
in a screen, they can distort the overall gRNA distributions and destabilize normalization 
procedures. In the following images, the trimmed gRNA distributions are shown 
for each sample; after trimming, the abundances in each sample should form a gaussian-like 
distribution centered about the sample median. If some of the samples, and especially the 
control samples, are not of the expected shape it may be necessary to rerun the filtering algorithm 
with different parameter choices (see `ct.filterReads()` manual page for details). Note that 
the subsequent analyses reported in this document are conducted after low-abundance gRNAs 
have been omitted during this step. 

```{r, echo=FALSE, warning=FALSE, message=FALSE, fig.height=10, fig.width=10, fig.cap="Figure 3: gRNA Density Before and After Filtering with the Default Parameters"}
filt.eset <- ct.filterReads(
  eset = params$eset,
  trim = params$trim,
  log2.ratio = params$log2.ratio,
  sampleKey = params$sampleKey,
  plot.it = TRUE
)
```

<br/>
<br/>
<br/>

##### The Effect of Normalization on Read Density

The $\alpha$-RRA algorithm estimates the significance of a target's enrichment or depletion 
on the basis of the experiment-level ranks of the associated gRNA-level signals.
Proper normalization can in principle improve the accuracy of the algorithm by eliminating sample-level biases that are likely to reflect technical artifacts rather than biological signals. In many screening experiments, the gRNA abundances in each sample should form a smooth distribution centered about the same median after normalization, and the overall distributions should be similar within replicate groups. 

There is not currently a strong literature regarding normalization in pooled screening experiments, however, and to some extent the definition of successful normalization is linked to experimental expectations about the composition of the screening library and the outcome of the screen. The images below are provided to inform users about the effects of two major normalizing transformations on the sample count distributions to inform downstream processing decisions, but the specific choices are left up to the user. Consequently, the normalized data are not used elsewhere in this document. 

```{r, echo=FALSE, warning=FALSE, message=FALSE, fig.height=10, fig.width=10, fig.cap="Figure 4: gRNA Density Before and After Median Scaling Normalization"}
scale.eset <- ct.normalizeGuides(
  eset = filt.eset,
  method = 'scale',
  annotation = params$annotation,
  sampleKey = params$sampleKey,
  lib.size = params$lib.size,
  plot.it = TRUE
)

```

```{r, echo=FALSE, warning=FALSE, message=FALSE, fig.height=10, fig.width=10, fig.cap="Figure 5: gRNA Density Before and After Slope Normalization"}
slope.eset <- ct.normalizeGuides(
  eset = filt.eset,
  method = 'slope',
  annotation = params$annotation,
  sampleKey = params$sampleKey,
  lib.size = params$lib.size,
  plot.it = TRUE
)

```

<br/>
<br/>
<br/>


##### GC Content and gRNA Abundance

GC content can influence PCR efficiency, and a strong relationship between GC content and gRNA abundance may be evidence of poor viral library quality or sample preparation in CRISPR screens. Ideally, there should be no clear relationship between GC content and a gRNA's measured abundance. Keep in mind that some libraries may contain important subsets of gRNAs that have systematic differences in GC content (e.g., nontargeting controls) which may affect this.  

```{r, echo=FALSE, warning=FALSE, message=FALSE, fig.height=10, fig.width=10, fig.cap="Figure 6: GC content and gRNA Abundance"}
if (is.null(params$sampleKey)) {
  ct.GCbias(data.obj = filt.eset, 
            ann = params$annotation, 
            lib.size = params$lib.size
            )
} else {
   ct.GCbias(data.obj = filt.eset, 
            ann = params$annotation, 
            lib.size = params$lib.size,
            sampleKey = params$sampleKey
            )
}
```

<br/>
<br/>
<br/>

### Section 2: Library-level Distortion of gRNA Abundances

Pooled CRISPR screens are fundamentally dynamic experiments, in which the
measured abundance of a particular gRNA is fundamentally dependent on the scale
of selection observed throughout the rest of the screen. In general, rigorous
statistical methods perform well in screens where most cells survive the
selection event and the gRNA distributions remain relatively stable throughout
the experiment (i.e., dropout screens); more heuristic approaches are preferable
in screens where most cells are affected and the resulting library only contains
a small subset of gRNAs of extremely high abundance. The primary goal of this
section is to determine the extent to which selection has distorted your gRNA
library to guide downstream analyses.

##### Ranked and Scaled gRNA Abundance Distributions 
Strong selection in a CRISPR screen will distort the gRNAs such that the "slope"
of the middle of the distribution changes relative to what is observed in the
control samples. This can lead to spurious inferences of gRNA depletion in some
cases, and it may be useful to correct this with the `ct.normalizeBySlope()`
function in the `gCrisprTools` R package prior to downstream analyses.
Alternatively, experiments involving treatments where most cells are affected
may have failed if library-level distortion is not readily apparent. If provided, the
locations of guides associated with a specified `geneSymbol` are indicated as diamonds along each sample
distribution (typically nontargeting controls).

```{r, echo=FALSE, warning=FALSE, message=FALSE, fig.height=6, fig.width=10, fig.cap= "Figure 7: Ranked gRNA Distributions by Replicate"}
ct.gRNARankByReplicate(
  eset = filt.eset, 
  sampleKey = params$sampleKey, 
  annotation = params$annotation, 
  geneSymb = params$geneSymb,
  lib.size = params$lib.size
)  
```

<br/>
<br/>
<br/>

##### Cumulative Target-level Read Abundance
A simple way to quantify the extent of distortion in a CRISPR screen is to
observe the proportion of reads within each library that are derived from gRNA
cassettes targeting each genomic element. By ranking the targets by their
abundance within the library (*X* axis) and plotting the cumulative proportion
of reads that the top *N* targets represent (*Y* axis), we can tell if the
treatment libraries essentially only contain cassettes targeting a small number
of genes, or if most of the cells survive the selection step.

```{r, echo=FALSE, warning=FALSE, message=FALSE, fig.height=10, fig.width=10, fig.cap= "Figure 8: Per-Replicate gRNA Cumulative Distributions"}
ct.guideCDF(
  eset = filt.eset,
  sampleKey = params$sampleKey,
  plotType = "Target",
  annotation = params$annotation
)
```


<br/>
<br/>
<br/>

##### Nontargeting Control Guides

The behavior of nontargeting control guides can give some sense of the
consistency of the gRNA abundances within experimental cultures and the likely
effect of normalization on the gRNA abundance estimation. Note that it is not
necessarily critical that the relative abundances of nontargeting gRNAs remain
superficially identical across treatments, but extremely large changes may
indicate that individual gRNA levels are not likely to be well estimated.

```{r, echo=FALSE, warning=FALSE, message=FALSE, fig.height=10, fig.width=10, fig.cap="Figure 9: Nontargeting Control Behavior Before and After Median Scaling"}
tryCatch(
  ct.viewControls(
    eset = filt.eset,
    annotation = params$annotation,
    geneSymb = params$geneSymb,
    sampleKey = params$sampleKey,
    lib.size = params$lib.size,
    normalize = FALSE
  ),
  error = function(e) {
    paste0("Failed to generate control plot: \n", 
           e$message)
  }
)
tryCatch(
  ct.viewControls(
    eset = filt.eset,
    annotation = params$annotation,
    geneSymb = params$geneSymb,
    sampleKey = params$sampleKey,
    normalize = TRUE, 
    lib.size = params$lib.size

  ),
  error = function(e) {
    paste0("Failed to generate control plot: \n", 
           e$message)
  }
)
```

---
title: CRISPR Contrast Report
output: 
  html_document:
    fig_caption: yes
params:
  eset: !r Biobase::ExpressionSet()
  fit: !r data.frame()
  sampleKey: !r factor()
  results: !r data.frame()
  annotation: !r data.frame()
  comparison.id: !r character()
  contrast.subset: !r character()
---

#Contrast: `r params$comparison.id`

This is a report visualizing the overall dynamics of a single contrast in a pooled CRISPR-based screening experiment. See the vignettes folder of the `gCrisprTools` R package for further discussion of the proper analysis and interpretation of these experiments. For analysts, the manual pages of the various functions provide further detail about the analytical approaches employed and computational considerations relevant to their interpretation; most of the functions used in this report can also be extended in various ways to clarify more specific experimental questions that may arise during the analysis of a CRISPR screen. 

##### GC Content and Estimated Model Effects

GC content can influence PCR efficiency, and strong GC-related effects may be evidence of poor library quality in CRISPR screens. Ideally, there should be no clear relationship between GC content and a gRNA's variance, fold change, or evidence for differential abundance. Keep in mind that some libraries may contain important subsets of gRNAs that have systematic differences in GC content, however (e.g., nontargeting controls).  

```{r, echo=FALSE, warning=FALSE, message=FALSE, fig.height=10, fig.width=10, fig.cap="Figure 6: Stacked Barplot of the Most Variable Genes"}
if (is.null(params$sampleKey)) {
  ct.GCbias(data.obj = params$fit, 
            ann = params$annotation
            )
} else {
  ct.GCbias(data.obj = params$fit, 
            ann = params$annotation, 
            sampleKey = params$sampleKey
            )
}
```

<br/>
<br/>
<br/>

##### Most Variable Genes and gRNAs as a Proportion of the Libraries

In experiments that include highly distorted libraries, it can be useful to identify the genes or gRNAs that change the most across the experiment as a heuristic way of identifying gRNAs of interest in situations where standard statistical approaches are not likely to function well. 

```{r, echo=FALSE, warning=FALSE, message=FALSE, fig.height=10, fig.width=10, fig.cap="Figure 6: Stacked Barplot of the Most Variable Genes"}
if (is.null(params$sampleKey)) {
  ct.stackGuides(
    eset = params$eset, 
    plotType = "Target", 
    annotation = params$annotation,
    subset = params$contrast.subset
  )
} else {
  ct.stackGuides(
    eset = params$eset,
    sampleKey = params$sampleKey,
    plotType = "Target", 
    annotation = params$annotation,
    subset = params$contrast.subset
  )
}
```

<br/>
<br/>
<br/>
```{r, echo=FALSE, warning=FALSE, message=FALSE, fig.height=10, fig.width=10, fig.cap="Figure 7: Stacked Barplot of the Most Variable gRNAs"}
if (is.null(params$sampleKey)) {
  ct.stackGuides(
    eset = params$eset, 
    plotType = "gRNA", 
    annotation = params$annotation,
    subset = params$contrast.subset
  )
} else {
  ct.stackGuides(
    eset = params$eset,
    sampleKey = params$sampleKey,
    plotType = "gRNA", 
    annotation = params$annotation,
    subset = params$contrast.subset
  )
}
```

<br/>
<br/>
<br/>



### Top Signals of Target Enrichment and Depletion

Below are plots indicating the targets with the most evidence for enrichment and depletion within the indicated contrast. Genes are ranked by aggregating the signal for depletion or enrichment across all gRNAs targeting the corresponding element according to the method specified in the call to `ct.generateResults()`. Within each plot, candidates are ordered by the evidence for enrichment or depletion. Each gRNA targeting the gene is plotted as a point, with the estimated log2 fold change within the contrast indicated on the *Y*-axis and the standard deviation of the estimate shown as a blue bar. 


```{r, echo=FALSE, warning=FALSE, message=FALSE, fig.height= 5, fig.width= 10, fig.cap="Figure 8: Top 20 Enriched Targets"}
enrich <- ct.topTargets(params$fit, params$results, params$annotation, targets = 20, enrich = TRUE, contrast.term=params$comparison.id)
```
<br/>
<br/>
<br/>


```{r, echo=FALSE, warning=FALSE, message=FALSE, fig.height= 5, fig.width= 10, fig.cap="Figure 9: Top 20 Depleted Targets"}
deplete <- ct.topTargets(params$fit, params$results, params$annotation, targets = 20, enrich = FALSE, contrast.term=params$comparison.id)
```
<br/>
<br/>
<br/>

---
title: "Example Workflow For Processing a Single Pooled Screen"
author: "Russell Bainer"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Example_Workflow_gCrisprTools}
  %\VignetteEngine{knitr::knitr}
  %\VignetteEncoding{UTF-8}
---

### Example Workflow For Processing a Single Screen

This is an example workflow for processing a pooled screening eperiment using the provided sample data. See the various manpages for additional visualization options and algorithmic details. 

Note that what follows describes a very basic analysis. If you are considering integrating the results of many different screen contrasts or even different experiments and/or technologies, refer to the `Advanced Screen Analysis: Contrast Comparisons` vignette. 

Load dependencies and data
```{r setup, eval = TRUE}
suppressPackageStartupMessages(library(Biobase))
suppressPackageStartupMessages(library(limma))
suppressPackageStartupMessages(library(gCrisprTools))

data("es", package = "gCrisprTools")
data("ann", package = "gCrisprTools")
data("aln", package = "gCrisprTools")
knitr::opts_chunk$set(message = FALSE, fig.width = 8, fig.height = 8, warning = FALSE)
```

Make a sample key, structured as a factor with control samples in the first level
```{r, eval = TRUE}
sk <- relevel(as.factor(pData(es)$TREATMENT_NAME), "ControlReference")
names(sk) <- row.names(pData(es))
```

Generate a contrast of interest using voom/limma; pairing replicates is a good idea if that information is available. 
```{r, eval = TRUE}
design <- model.matrix(~ 0 + REPLICATE_POOL + TREATMENT_NAME, pData(es))
colnames(design) <- gsub('TREATMENT_NAME', '', colnames(design))
contrasts <-makeContrasts(DeathExpansion - ControlExpansion, levels = design)
```

Optionally, trim of trace reads from the unnormalized object (see man page for details)
```{r, eval = TRUE, fig.width = 8, fig.height = 10}
es <- ct.filterReads(es, trim = 1000, sampleKey = sk)
```

Normalize, convert to a voom object, and generate a contrast
```{r, eval = TRUE, fig.width = 6, fig.height = 12}
es <- ct.normalizeGuides(es, method = "scale", plot.it = TRUE) #See man page for other options
vm <- voom(exprs(es), design)

fit <- lmFit(vm, design)
fit <- contrasts.fit(fit, contrasts)
fit <- eBayes(fit)
```

Edit the annotation file if you used `ct.filterReads` above
```{r, eval = TRUE}
ann <- ct.prepareAnnotation(ann, fit, controls = "NoTarget")
```

Summarize gRNA signals to identify target genes of interest

```{r, eval = TRUE}
resultsDF <-
  ct.generateResults(
    fit,
    annotation = ann,
    RRAalphaCutoff = 0.1,
    permutations = 1000,
    scoring = "combined", 
    permutation.seed = 2
  )
```

#### Alternative Annotations

In some cases, reagents might target multiple known elements (e.g., gRNAs in a CRISPRi library that target multiple promoters of the same gene). In such cases, you can specify this via the `alt.annotation` argument to `ct.generateResults()`. Alternative annotations are supplied as a list of character vectors named for the reagents.

```{r, eval = TRUE}

# Create random alternative target associations 

altann <- sapply(ann$ID, 
                 function(x){
                   out <- as.character(ann$geneSymbol)[ann$ID %in% x]
                   if(runif(1) < 0.01){out <- c(out, sample(as.character(ann$geneSymbol), size = 1))}
                   return(out)
                 }, simplify = FALSE)

resultsDF <-
  ct.generateResults(
    fit,
    annotation = ann,
    RRAalphaCutoff = 0.1,
    permutations = 1000,
    scoring = "combined", 
    alt.annotation = altann,
    permutation.seed = 2
  )
```


Optionally, just load an example results object for testing purposes (trimming out reads as necessary)
```{r, eval = TRUE}
data("fit", package = "gCrisprTools")
data("resultsDF", package = "gCrisprTools")

fit <- fit[(row.names(fit) %in% row.names(ann)),]
resultsDF <- resultsDF[(row.names(resultsDF) %in% row.names(ann)),]

targetResultDF <- ct.simpleResult(resultsDF) #For a simpler target-level result object
```

### Quality Control

gCrisprTools contains a variety of pooled screen-specific quality control and visualization tools (see man pages for details):
```{r, eval = TRUE}
ct.alignmentChart(aln, sk)
ct.rawCountDensities(es, sk)
```

Visualize gRNA abundance distributions
```{r, eval = TRUE}
ct.gRNARankByReplicate(es, sk) 
ct.gRNARankByReplicate(es, sk, annotation = ann, geneSymb = "NoTarget")  #Show locations of NTC gRNAs
```

Visualize control guide behavior across conditions
```{r, eval = TRUE}
ct.viewControls(es, ann, sk, normalize = FALSE)
ct.viewControls(es, ann, sk, normalize = TRUE)
```

Visualize GC bias across samples, or within an experimental contrast
```{r, eval = TRUE, fig.width = 8, fig.height = 12}
ct.GCbias(es, ann, sk)
ct.GCbias(fit, ann, sk)
```

View most variable gRNAs/Genes (as % of sequencing library)
```{r, eval = TRUE}
ct.stackGuides(es,
               sk,
               plotType = "gRNA",
               annotation = ann,
               nguides = 40)
```

```{r, eval = TRUE}
ct.stackGuides(es, 
               sk, 
               plotType = "Target", 
               annotation = ann)
```

```{r, eval = TRUE}
ct.stackGuides(es,
               sk,
               plotType = "Target",
               annotation = ann,
               subset = names(sk)[grep('Expansion', sk)])
```
               
               
View a CDF of genes/guides
```{r, eval = TRUE}
ct.guideCDF(es, sk, plotType = "gRNA")
ct.guideCDF(es, sk, plotType = "Target", annotation = ann)
```

#### Target-Level Visualization and Analysis

View the overall enrichment and depletion trends identified in the screen: 
```{r, eval = TRUE}
ct.contrastBarchart(resultsDF)
```

View top enriched/depleted candidates
```{r, eval = TRUE}
ct.topTargets(fit,
              resultsDF,
              ann,
              targets = 10,
              enrich = TRUE)
ct.topTargets(fit,
              resultsDF,
              ann,
              targets = 10,
              enrich = FALSE)
```

View the behavior of reagents targeting a particular gene of interest
```{r, eval = TRUE, fig.width = 8, fig.height = 10}
ct.viewGuides("Target1633", fit, ann)
ct.gRNARankByReplicate(es, sk, annotation = ann, geneSymb = "Target1633")
```

Observe the effects detected for sets of targets within a screen contrast

```{r, eval = TRUE}
ct.signalSummary(resultsDF,
                 targets = list('TargetSetA' = c(sample(unique(resultsDF$geneSymbol), 3)),
                                'TargetSetB' = c(sample(unique(resultsDF$geneSymbol), 2))))
```

You could test a known gene set for enrichment within target candidates:

```{r, eval = TRUE}
data("essential.genes", package = "gCrisprTools")
ct.targetSetEnrichment(resultsDF, essential.genes)
```

Or optionally add a visualization:
```{r rocprc, eval = TRUE}
ROC <- ct.ROC(resultsDF, essential.genes, direction = "deplete")
PRC <- ct.PRC(resultsDF, essential.genes, direction = "deplete")
show(ROC) # show(PRC) is equivalent for the PRC analysis
```

Or alternatively you could test for ontological enrichment within the depleted/enriched targets via the `sparrow` package: 

```{r, eval = TRUE, warning=FALSE, message = FALSE}
#Create a geneset database using one of the many helper functions
genesetdb <- sparrow::getMSigGeneSetDb(collection = 'h', species = 'human', id.type = 'entrez')

ct.seas(resultsDF, gdb = genesetdb)

# If you have a library that targets elements unevenly (e.g., variable numbers of 
# elements/promoters per genes), you can conform it via `sparrow::convertIdentifiers()`

genesetdb.GREAT <- sparrow::convertIdentifiers(genesetdb, 
                                               from = 'geneID', 
                                               to = 'geneSymbol', 
                                               xref = ann)
ct.seas(resultsDF, gdb = genesetdb.GREAT)
```

See the `Contrast_Comparisons` vignette for more advanced use cases of gCrisprTools and extension to complex experiments and study designs. 


Finally, you can make reports in a directory of interest: 

```{r, eval = FALSE}
path2report <-      #Make a report of the whole experiment
  ct.makeReport(fit = fit, 
                eset = es, 
                sampleKey = sk, 
                annotation = ann, 
                results = resultsDF, 
                aln = aln, 
                outdir = ".") 

path2QC <-          #Or one focusing only on experiment QC
  ct.makeQCReport(es, 
                  trim = 1000, 
                  log2.ratio = 0.05, 
                  sampleKey = sk, 
                  annotation = ann, 
                  aln = aln, 
                  identifier = 'Crispr_QC_Report',
                  lib.size = NULL
                  )                

path2Contrast <-    #Or Contrast-specific one
  ct.makeContrastReport(eset = es, 
                        fit = fit, 
                        sampleKey = sk, 
                        results = resultsDF, 
                        annotation = ann, 
                        comparison.id = NULL, 
                        identifier = 'Crispr_Contrast_Report')            
```

```{r}
sessionInfo()
```

---
title: "Advanced Screen Analysis: Contrast Comparisons"
author: "Russell Bainer"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Contrast_Comparisons_gCrisprTools}
  %\VignetteEngine{knitr::knitr}
  %\VignetteEncoding{UTF-8}
---

This is a companion vignette briefly describing the advanced capabilites available for comparing, summarizing, and integrating screening contrasts with gCrisprTools, introduced with version 2.0. 

#### Simplified Results Objects

Historically, gCrisprTools was focused on making results data.frames, which exhaustively summarize the results of a screen contrast. They look like this: 

```{r setup}
library(Biobase)
library(gCrisprTools)
knitr::opts_chunk$set(message = FALSE, fig.width = 8, fig.height = 8)

data(resultsDF)

head(resultsDF)

```

In many applications, there are limitations to these objects. For example: 

- They are reagent-focused, but many downstream applications are focused on Targets
- The `colnames` are human-readable instead of machine readable
- The distinction between `geneID` and `geneSymbol` is not clear
- Many columns are not informative for the majority of modern applications/screens
- Historically, they are sorted to put the strongest signals at the top (this is not the case now)

To help with downstream analyses, we introduce the `simpleResult` object

```{r}
res <- ct.simpleResult(resultsDF, collapse = 'geneSymbol')
head(res)
```

These objects are simpler representations of target signals that are applicable for "most" situations (e.g., when the gRNAs associated with a target have similar effects). They are:

- Target focused, but target signals are collapsed to single directional P/Q stats
- Collapsed on a user-specified identifier to enable comparisons across screening technologies
- Both human-readable and machine-readable
- Consistently ordered, and may be easily placed in register with one another

This format enables better comparisons between screens, and we have some helper functions to support this: 

```{r}
# Make "another" result
res2 <- res
res2$best.p <- res2$best.p * runif(nrow(res2)) 
res2$direction[sample(1:nrow(res), 500)] <- res2$direction[sample(1:nrow(res), 500)]


regularized <- ct.regularizeContrasts(dflist = list('Experiment1' = res[1:1500,], 
                                                    'Experiment2' = res2[1:1900,]), 
                                      collapse = 'geneSymbol')

str(regularized)

```

The above function takes in a (named) list of results objects and creates a list of `simpleResult`s with the same names that are "in register" with one another, using the shared elements specified by `collapse`. 

The main utility of this function is twofold. First, it enables comparison of lightweight results objects that are derived from screens that could have been executed with different libraries, systems, or technologies by focusing on the targets and their directional significance measures. Second, this "named list of standardized results" can become a standard structure for encoding grouped contrasts for comparison purposes, allowing us to do more sophisticated comparisons between and across contrasts. 

### Testing Overlaps Between Two or More Screens

The standardized format allows straightforward identification of signal overlaps observed within multiple screens via `ct.compareContrasts()`. By default, these comparisons are done conditionally, but users may specify more rigid criteria. 

```{r}
comparison <- ct.compareContrasts(dflist = regularized,
                                  statistics = c('best.q', 'best.p'), 
                                  cutoffs = c(0.5,0.05), 
                                  same.dir = rep(TRUE, length(regularized)))

head(comparison, 30)

```

This function returns a `simplifiedResult` version of the `mainresult` argument, appended with a logical column indicating whether signals in the `mainresult` contrast passing the first significance cutoff are replicated in the `validationresult` contrast at the second significance cutoff. This sort of conditional scoring was shown previously to be useful in interpreting the results of validation and counterscreens.   

For convenience, we can also return summary statistics characterizing the overlap between the screens: 

```{r}
ct.compareContrasts(dflist = regularized,
                    statistics = c('best.q', 'best.p'),
                    cutoffs = c(0.5,0.05), 
                    same.dir = rep(TRUE, length(regularized)),
                    return.stats = TRUE)
```

This can be useful when exploring appropriate cutoff thresholds, or when asking broader questions about overall congruence. 

### Visualization of Screen Enrichment and Depletion Dynamics

We provide a number of methods for visualizing and contextualizing the overall signals present within sets of screens. One of the simplest is the cointrast barcharts, which represent the number of observed enrichment and depletion signals in each screen according to specified significance criteria: 

```{r contrastbarchart, fig.width=6, fig.height = 5}
ct.contrastBarchart(regularized, background = FALSE, statistic = 'best.p')
```

In the above figure, each contrast is represented as a horizontal bar, and targets enriched and depleted are represented as bars extending to the right and the left of the vertical dotted line, respectively. 

We can also compare the signals observed in two screens directly in a scatterplot: 

```{r, fig.width = 5, fig.height = 5}
scat <- ct.scatter(regularized, 
                   targets = 'geneSymbol', 
                   statistic = 'best.p', 
                   cutoff = 0.05)
```

This provides a scatter plot of the indicated statistic, with quadrants defined according to the user-specified cutoff. The number of targets in each of the quadrants is indicated in grey, and quadrants are keyed like this: 

1 2 3 
4 5 6 
7 8 9


A more complete genewise picture can be achieved by examining the returned invisible object, which appends the relevant quadrants to assist in in focusing on particular targets of interest: 

```{r}
head(scat)
```

As an aside, this simplified infrastructure allows straightforward dissection of interaction effects as well. Often, it is helpful to identify targets that are enriched or depleted with respect to one contrast but inactive with respect to another (e.g., to identify genes that impact a screening phenotype but do not deplete over time).  

```{r contrast interaction, message = FALSE, warning=FALSE, fig.width = 6, fig.height = 12}
library(Biobase)
library(limma)
library(gCrisprTools)

#Create a complex model design; removing the replicate term for clarity
data("es", package = "gCrisprTools")
data("ann", package = "gCrisprTools")

design <- model.matrix(~ 0 + TREATMENT_NAME, pData(es))
colnames(design) <- gsub('TREATMENT_NAME', '', colnames(design))
contrasts <-makeContrasts(ControlTime = ControlExpansion - ControlReference,
                          DeathOverTime = DeathExpansion - ControlReference,
                          Interaction = DeathExpansion - ControlExpansion, 
                          levels = design)

es <- ct.normalizeGuides(es, method = "scale") #See man page for other options
vm <- voom(exprs(es), design)

fit <- lmFit(vm, design)
fit <- contrasts.fit(fit, contrasts)
fit <- eBayes(fit)

allResults <- sapply(colnames(fit$coefficients), 
                     function(x){
                         ct.generateResults(fit,
                                            annotation = ann,
                                            RRAalphaCutoff = 0.1,
                                            permutations = 1000,
                                            scoring = "combined",
                                            permutation.seed = 2, 
                                            contrast.term = x)
                       }, simplify = FALSE)

allSimple <- ct.regularizeContrasts(allResults)
```

Using the logical columns we can Identify relevant sets of targets. For example, the number of targets changing over time in both timecourses:

```{r}

time.effect <- ct.compareContrasts(list("con" = allSimple$ControlTime,
                                        "tx" = allSimple$DeathOverTime))
summary(time.effect$replicated)
```

or targets with a toxicity modifying effect that compromise intrinsic viability:

```{r}
mod.control <- ct.compareContrasts(list("con" = allSimple$ControlTime,
                                        "Interaction" = allSimple$Interaction),
                                 same.dir = c(TRUE, FALSE))
summary(mod.control$replicated)
```

#### More Comparisons

Sometimes you might be curious about the relationship between many contrasts. You can accomplish this by making an UpSet plot: 

```{r, fig.height= 6, fig.width = 8}
upset <- ct.upSet(allSimple)
```

In addition to constructing the UpSet plot above, by default we include fold enrichment and p-value estimates to help interpret the various bars in the context of the nominal or conditional expected values. 

Finally, the above function returns a combination matrix containing the overlap values and associated targets, which can be useful for interrogating intersection sets of interest.  

```{r}
show(upset)
```

See the documentation about combination matrices provided in the `ComplexHeatmap` package for accessor functions and additional information about the structure and use of this object. 


#### Ontological Enrichment

Though not subject to specific set-level analyses yet, the `ct.seas()` function can be likewise extended to use lists of results. The standardized objects can then be consolidated to ask broader questions about enrichment and depletion using standard methods:  

```{r, fig.width=6, fig.height=6, warnings= FALSE}
genesetdb <- sparrow::getMSigGeneSetDb(collection = 'h', species = 'human', id.type = 'entrez')

sparrowList <- ct.seas(allSimple, gdb = genesetdb)

show(sparrowList)

#Can use returned matrices to facilitate downstream comparisons: 

plot(-log10(sparrow::results(sparrowList$DeathOverTime, 'fgsea')$padj), 
     -log10(sparrow::results(sparrowList$Interaction, 'fgsea')$padj), 
     pch = 19, col = rgb(0,0,0.8,0.5), 
     ylab = "Pathway -log10(P), Treatment Over Time",
     xlab = "Pathway -log10(P), Marginal Time Effect, Treatment Arm",
     main = 'Evidence for Pathway Enrichment')
abline(0,1,lty = 2)

```

```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generateReports.R
\name{ct.makeContrastReport}
\alias{ct.makeContrastReport}
\title{Generate a Contrast report from a pooled CRISPR screen}
\usage{
ct.makeContrastReport(
  eset,
  fit,
  sampleKey,
  results,
  annotation,
  comparison.id,
  identifier,
  contrast.subset = colnames(eset),
  outdir = NULL
)
}
\arguments{
\item{eset}{An ExpressionSet object containing, at minimum, a matrix of gRNA
abundances extractable with the \code{exprs()} function and some named 
phenodata extractable with \code{pData()}.}

\item{fit}{A fit object for the contrast of interest, usually generated with
\code{lmFit}.}

\item{sampleKey}{A sample key, supplied as an ordered factor linking the 
samples to experimental variables. The \code{names} attribute should 
exactly match those present in \code{eset}, and the control set is assumed
to be the first \code{level}.}

\item{results}{A data.frame summarizing the results of the screen, returned 
by the function \code{\link{ct.generateResults}}.}

\item{annotation}{An annotation object for the experiment. See the man page 
for \code{ct.prepareAnnotation()} for details and example format.}

\item{comparison.id}{character with a name of the comparison.}

\item{identifier}{A character string to name the report and corresponding 
subdirectories. If provided, the final report will be called 
'\code{identifier}.html' and will be located in a directory called 
\code{identifier} in the \code{outdir}. If \code{NULL}, a generic name}

\item{contrast.subset}{character vector containing the sample
labels to be used in the analysis; all elements must be contained in the
\code{colnames} of the specified \code{eset}. including the timestamp will
be generated. Default: \code{colnames(eset)}.}

\item{outdir}{An optional character string indicating the directory in which to 
generate the report. If \code{NULL}, a temporary directory will be automatically 
generated.}
}
\value{
The path to the generated html report.
}
\description{
This is a function to generate an html Contrast report for a 
  CRISPR screen, focusing on contrast-level analyses collected from other 
  functions in \code{gCrisprTools}. It is designed to be used 'as-is', and 
  analysts interested in using different functionalities of the various 
  functions should do that outside of this wrapper script.
}
\examples{
data('es')
data('fit')
data('ann')
data('resultsDF')

##' #Build the sample key
library(Biobase)
sk <- ordered(relevel(as.factor(pData(es)$TREATMENT_NAME), 'ControlReference'))
names(sk) <- row.names(pData(es))

path2report <- ct.makeContrastReport(es, fit, sk, resultsDF, ann, comparison.id = NULL, outdir = '.') 
}
\author{
Russell Bainer, Dariusz Ratman
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gCrisprTools.R
\docType{data}
\name{fit}
\alias{fit}
\title{Precalculated contrast fit from a Crispr screen}
\source{
Genentech, Inc.
}
\description{
A precalculated fit object (class \code{MArrayLM}) comparing the death 
and control expansion arms of a crispr screen performed at Genentech, Inc. 
All sample, gRNA, and Gene information has been anonymized and randomized.
}
\examples{
data('fit')
show(fit)
}
\seealso{
Please see \file{vignettes/Crispr_example_workflow.R} for model details.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/StackedGuides.R
\name{ct.stackGuides}
\alias{ct.stackGuides}
\title{View a stacked representation of the most variable targets or individual guides within an experiment, 
as a percentage of the total aligned reads}
\usage{
ct.stackGuides(
  eset,
  sampleKey = NULL,
  nguides = 20,
  plotType = "gRNA",
  annotation = NULL,
  ylimit = NULL,
  subset = NULL
)
}
\arguments{
\item{eset}{An ExpressionSet  object containing, at minimum, a matrix of gRNA abundances extractable with the exprs() function, and a metadata 
object containing a column named \code{SAMPLE_LABEL} containing unique identifers for each sample. The \code{colnames} should be syntactically}

\item{sampleKey}{An optional sample key, supplied as an ordered factor linking the samples to experimental 
variables. The \code{names} attribute should exactly match those present in \code{eset}, and the control set is assumed to be 
the first \code{level}.}

\item{nguides}{The number of guides (or targets) to display.}

\item{plotType}{A string indicating whether the individual guides should be displayed ('\code{gRNA}'), or if they should be aggregated into target-level
estimates ('\code{Target}') according to the \code{geneSymbol} column in the \code{annotation} object.}

\item{annotation}{An optional data.frame containing an annotation object to be used to aggregate the guides into targets. gRNAs are annotated by row, 
and must minimally contain a column \code{geneSymbol} indicating the target elements.}

\item{ylimit}{An optional numeric vector of length 2 specifying the y limits for the plot, useful in comparin across studies.}

\item{subset}{An optional character vector containing the sample labels to be used in the analysis; all elements must be contained in the \code{colnames} of the specified \code{eset}.}
}
\value{
A stacked barplot displaying the appropriate entities on the default device.
}
\description{
This function identifies the gRNAs or targets that change the most from sample to sample within an experiment as a percentage of 
the entire library. It then plots the abundance of the top \code{nguides} as a stacked barplot for all samples in the experiment. The purpose of this 
algorithm is to detect potential distortions in the library composition that might not be properly controlled by sample normalization, and so 
the most variable entites are defined by calculating the percent of aligned reads that they contribute to each sample, and then ranking each entity
by the range of these percentages across all samples. Consequently, gRNAs or Targets that are highly abundant in at least one condition will be 
are more likely to be identified.
}
\examples{
data('es')
data('ann')
ct.stackGuides(es, nguides = 20, plotType = 'Target', annotation = ann, ylimit = NULL, subset = NULL)
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Normalization.R
\name{ct.normalizeMedians}
\alias{ct.normalizeMedians}
\title{Normalize sample abundance estimates by median gRNA counts}
\usage{
ct.normalizeMedians(eset, lib.size = NULL)
}
\arguments{
\item{eset}{An \code{ExpressionSet} containing, at minimum, count data accessible by \code{exprs}.}

\item{lib.size}{An optional vector of voom-appropriate library size adjustment factors, usually calculated with \code{\link[edgeR]{calcNormFactors}} 
and transformed to reflect the appropriate library size. These adjustment factors are interpreted as the total library sizes for each sample, 
and if absent will be extrapolated from the columnwise count sums of the \code{exprs} slot of the \code{eset}.}
}
\value{
A renormalized ExpressionSet object of the same type as the provided object.
}
\description{
This function normalizes Crispr gRNA abundance estimates by equalizing the median gRNA abundance values after
correcting for library size. It does this by converting raw count values to log2 counts per million and optionally adjusting further in 
the usual way by dividing these values by user-specified library size factors. THis method should be more stable than the endogenous 
scaling functions used in \code{voom} in th especific case of Crispr screens or other cases where the median number of observed counts may be low.
}
\examples{
data('es')

#Build the sample key and library sizes for visualization
library(Biobase)
sk <- ordered(relevel(as.factor(pData(es)$TREATMENT_NAME), 'ControlReference'))
names(sk) <- row.names(pData(es))
ls <- colSums(exprs(es))

es.norm <- ct.normalizeMedians(es, lib.size= ls)
ct.gRNARankByReplicate(es, sampleKey = sk, lib.size= ls)
ct.gRNARankByReplicate(es.norm, sampleKey = sk, lib.size= ls)
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sparrow_integration.R
\name{ct.seasPrep}
\alias{ct.seasPrep}
\title{Prepare one or more resultsDF objects for analysis via Sparrow.}
\usage{
ct.seasPrep(
  dflist,
  collapse.on = c("geneID", "geneSymbol"),
  cutoff = 0.1,
  statistic = c("best.q", "best.p"),
  regularize = FALSE,
  gdb = NULL,
  active = "replicated"
)
}
\arguments{
\item{dflist}{A list of gCrisprTools results `data.frames` to be formatted.}

\item{collapse.on}{Should targets be annotated as `geneSymbol`s or `geneID`s (default)?}

\item{cutoff}{Numeric maximum value of `statistic` to define significance.}

\item{statistic}{Should cutoffs be calculated based on FDR (`best.q`) or P-value (`best.p`)?}

\item{regularize}{Logical indicating whether to regularize the result objects in `dflist` (e.g., use intersection set of 
all targets), or keep as-is.}

\item{gdb}{Optionally, a `GeneSetDb` object to enable proper registration of the output. If provided, the 
collapsing features in the provided `simpleDF`s must be present in the `gsd@db$feature_id` slot. Note that a GREAT-style `GeneSetDb` that 
has been conformed via `ct.GREATdb()` will use `geneID`s as the `feature_id`.}

\item{active}{Optionally, the name of a logical column present in the provided result that will be used to define significant signals. 
This is set to `replicated` by default to If a valid column name is provided, this overrides the specification of `cutoff` and `statistic`.}
}
\value{
A list of `data.frames` formatted for evaluation with `sparrow::seas()`.
}
\description{
Take in a list of results objects and return an equivalently-named list of input `data.frames` appropriate for `sparrow::seas()`. 
By construction, the relevant target unit is extracted from the `geneSymbol` column of the provided results objects, which may. Note that the 
genewise `@logFC` slot in the returned object will contain the appropriately-signed Z transformation of the P-value 
assigned to the target. In most applications this is arguably more interpretable than e.g., the median gRNA log2 fold change.
}
\examples{
data(resultsDF)
ct.seasPrep(list('longer' = resultsDF, 'shorter' = resultsDF[1:10000,]), collapse.on = 'geneSymbol')
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GenerateSignalSummary.R
\name{ct.contrastBarchart}
\alias{ct.contrastBarchart}
\title{Visualize Signal Across A List of Contrasts}
\usage{
ct.contrastBarchart(
  dflist,
  background = TRUE,
  statistic = c("best.q", "best.p"),
  ...
)
}
\arguments{
\item{dflist}{A named list of `data.frame`s summarizing the results of one or more screen contrasts, returned by the function 
\code{\link{ct.generateResults}}.}

\item{background}{Logical indicating whether to represent the nonsignificant hits in the barchart.}

\item{statistic}{Should cutoffs be calculated based on FDR (`best.q`) or P-value (`best.p`)?}

\item{...}{Other parameters to lower functions, especially `ct.simpleResult()`}
}
\value{
A summary plot on the current device. Invisibly, the data.frame tallying signals at various thresholds.
}
\description{
Given a list of provided results `data.frame`s summarizing a series of contrasts from one or more pooled screens, 
this function visualizes their respective signals as a series of stacked barcharts. Enriched signals 
are represented in the positive direction, and depleted signals are represented in the negative direction.  Note that the 
provided contrast results are not regularized by this function.

This function may be used to compare signals across different screen contrasts, or to compare signals within interesting 
subsets of targets ascertained within a single experiment.
}
\examples{
data('resultsDF')
ct.contrastBarchart(list('FirstResult' = resultsDF, 'SecondResult' = resultsDF))
ct.contrastBarchart(list('FirstResult' = resultsDF, 'SecondResult' = resultsDF), background = FALSE)
ct.contrastBarchart(list('FirstResult' = resultsDF[1:1000,], 'SecondResult' = resultsDF))
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/processFit.R
\name{ct.preprocessFit}
\alias{ct.preprocessFit}
\title{Preprocess a 'MArrayLM' model fit object to include only one contrast.}
\usage{
ct.preprocessFit(fit, modelTerm)
}
\arguments{
\item{fit}{An object of class MArrayLM to be processed.}

\item{modelTerm}{The model coefficient to be isolated for downstream analyses.}
}
\value{
A \code{MArrayLM} object for downstream processing.
}
\description{
This function preprocesses a fit object returned from eBayes to include only the values relevant to the
\code{modelTerm} specified.
}
\examples{

#Load and preprocess data
data('es')
library(Biobase)
library(limma)

#Make a multi-level contrast
design <- model.matrix(~ 0 + TREATMENT_NAME, pData(es))
colnames(design) <- gsub('TREATMENT_NAME', '', colnames(design))
contrasts <- makeContrasts((ControlExpansion - ControlReference), (DeathExpansion - ControlExpansion), levels = design)

#Make a multi-level fit object
vm <- voom(exprs(es), design)
fit <- lmFit(vm, design)
fit <- contrasts.fit(fit, contrasts)
fit <- eBayes(fit)  

#And trim it
fit2  <- ct.preprocessFit(fit, modelTerm = '(DeathExpansion - ControlExpansion)')

ncol(fit)
ncol(fit2)
}
\author{
Russell Bainer
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generateCAT.R
\name{ct.CAT}
\alias{ct.CAT}
\title{Compare Two CRISPR Screens via a CAT plot}
\usage{
ct.CAT(
  dflist,
  targets = c("geneSymbol", "geneID"),
  switch.dir = FALSE,
  plot.it = TRUE
)
}
\arguments{
\item{dflist}{A list of results dataframes. Names will be preserved, and the enrichment calculation is conditioned on 
the first element of the list.}

\item{targets}{Column of the provided \code{summaryDF} to consider. Must be \code{geneID} or \code{geneSymbol}.}

\item{switch.dir}{Logical indicating whether to test overlap of signals in the same direction, or whether the 
directionality is expected to reverse. `same.dir = FALSE` looks at the consistency between depleted signals in `df1` and 
enriched signals in `df2`.}

\item{plot.it}{Logical indicating whether to compose the plots on the default device. Two CAT plots summarizing overlap in 
both enrichment directions are drawn.}
}
\value{
Invisibly, a data.frame containing the relevant summary stats for each target in both screens.
}
\description{
This is a function for comparing the results of two screening experiments. Given two \code{summaryDF}, 
the function places them in register with one another, generates a Concordance At The Top (CAT) plot, and returns an 
invisible dataframe containing the relevant gene-level signals. Signals are aggregated by P-value threshold, such 
that the concordance is represented as the portion of shared values meeting or exceeding that significance threshold.

This function is conceptually similar to the `ct.ROC` and `ct.PRC()` functions, but is appropriate when considering 
consistency of ranked values rather than an interchangeable set; the most common use case is for comparing primary 
and replication screens, where the underlying technology and selection criteria are expected to be highly similar. 
CAT plots are fundamentally about comparing rankings, and so only targets in common between the two provided 
screens are considered. If the totality of list overlap is important, consider using `ct.PRC()` or `ct.ROC()`.
}
\examples{
data('resultsDF')
cat <- ct.CAT(list('first' = resultsDF, 'second' = resultsDF[1:2000,]))
head(cat)
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AlignmentBarchart.R
\name{ct.alignmentChart}
\alias{ct.alignmentChart}
\title{View a Barchart Summarizing Alignment Statistics for a Crispr Screen}
\usage{
ct.alignmentChart(aln, sampleKey = NULL)
}
\arguments{
\item{aln}{A numeric matrix of alignment statistics for a Crispr experiment. Corresponds to a 4xN matrix of read counts, with columns indicating 
samples and rows indicating the number of 'targets', 'nomatch', 'rejections', and 'double_match' reads. Details about these classes may be found 
in the best practices vignette or as part of the report generated with \code{ct.makeReport()}.}

\item{sampleKey}{An optional ordered factor linking the samples to experimental variables. The \code{names} attribute should exactly match those present in \code{aln}.}
}
\value{
A grouped barplot displaying the alignment statistics for each sample included in the alignment matrix, which usually corresponds to all of 
the samples in the experiment.
}
\description{
This function displays the alignemnt statistics for a pooled Crispr screen, reported directly from an alignment statistic matrix.
}
\examples{
data('aln')
ct.alignmentChart(aln)
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/compareContrasts.R
\name{ct.upSet}
\alias{ct.upSet}
\title{Consolidate shared signals across many contrasts in an UpSet Plot}
\usage{
ct.upSet(dflist, add.stats = TRUE, nperm = 10000, ...)
}
\arguments{
\item{dflist}{a named list of (possibly simplified) `resultsDf`s.}

\item{add.stats}{Logical indicating whether the significance of set overlaps should be included in the visualization.}

\item{nperm}{Number of permutations for P-value generation. Ignored if `add.stats` is `FALSE`.}

\item{...}{Other named arguments to `ComplexHeatmap::UpSet()`, `ct.compareContrasts`, or `ct.simpleResult()`.}
}
\value{
An UpSet plot on the current device. Silently, a combination matrix appropriate for plotting that plot, 
containing useful information about the observed intersections.
}
\description{
This function takes in a named list of `results` dataframes produced by `ct.generateResults()` or similar, 
harmonizes them, and identifies overlaps between them using the logic implemented in `ct.compareContrasts()`. It then uses the
overlaps of these sets to compose an UpSet plot summarizing shared overlaps of the provided contrasts. These overlaps can be 
specified with some detail via arguments passed to the `ct.compareContrasts()` function; see documentation for more details.

Note that the UpSet plot is constructed to respect signal directionality, and by default constructs overlaps conditionally, 
but in a *bidirectional* manner. That is, a signal is considered observed in two (or more) contrasts regardless of the 
contrast from which the stringent signal is observed, so a signal replicated in three contrasts is interpreted as a target 
for which the evidence crosses the stringent threshold in one or more of the contrasts and passes the lax contrast in the others. 

Note that multiple important parameters are passed directly to `ct.compareContrasts()` if not specified in the command. Users 
are advised to study the corresponding manual page to better understand their options regarding contrast thresholding, 
orientation, etc.
}
\examples{
data('resultsDF')
sets <- ct.upSet(list('first' = resultsDF, 'second' = resultsDF[1:5000,]))
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GenerateROC.R
\name{ct.ROC}
\alias{ct.ROC}
\title{Generate a Receiver-Operator Characteristic (ROC) Curve from a CRISPR screen}
\usage{
ct.ROC(
  summaryDF,
  target.list,
  direction = c("enrich", "deplete"),
  condense = TRUE,
  plot.it = TRUE,
  ...
)
}
\arguments{
\item{summaryDF}{A dataframe summarizing the results of the screen, returned by the function \code{\link{ct.generateResults}}.}

\item{target.list}{A character vector containing the names of the targets to be tested. Only targets contained in the \code{geneSymbol}
column of the provided \code{summaryDF} are considered.}

\item{direction}{Direction by which to order target signals (`enrich` or `deplete`).}

\item{condense}{Logical indicating whether the returned x and y coordinates should be 'condensed', returning only the points at which
the detected proportion of \code{target.list} changes. If set to \code{FALSE}, the returned \code{x} and \code{y} vectors will explicitly
indicate the curve value at every position (useful for performing curve arithmetic downstream).}

\item{plot.it}{Logical value indicating whether to plot the curves.}

\item{...}{Additional parameters for `ct.simpleResult()`}
}
\value{
A list containing the the x and y coordinates of the curve, and the AUC statistic (invisibly).
}
\description{
Given a set of targets of interest, this function generates a ROC curve and associated statistics from the results of
a CRISPR screen. Specifically, it orders the elements targeted in the screen in the specified direction, and then plots the cumulative
proportion of positive hits on the y-axis. The corresponding vectors and Area Under the Curve (AUC) statistic are returned as a list.

Note that ranking statistics in CRISPR screens are (usually) permutation-based, and so some granularity is expected. This
function does a little extra work to ensure that hits are counted as soon as the requisite value of the ranking statistic is reached
regardless of where the gene is located within the block of equally-significant genes. Functionally, this means that the drawn curve is
somewhat anticonservative in cases where the gene ranks are not well differentiated.
}
\examples{
data('resultsDF')
data('essential.genes') #Note that this is an artificial example.
roc <- ct.ROC(resultsDF, essential.genes, direction = 'deplete')
str(roc)
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fileutilities.R
\name{ct.inputCheck}
\alias{ct.inputCheck}
\title{Check compatibility of a sample key with a supplied object}
\usage{
ct.inputCheck(sampleKey, object)
}
\arguments{
\item{sampleKey}{A named factor, where the \code{levels} indicate the experimental replicate 
groups and the \code{names} match the \code{colnames} of the expression matrix contained in \code{object}. 
The first \code{level} should correspond to the control samples, but obviously there is no 
way to algorithmically control this.}

\item{object}{An \code{ExpressionSet}, \code{EList}, or matrix.}
}
\value{
A logical indicating whether the objects are compatible.
}
\description{
For many gCrisprTools functions, a sample key must be provided that specifies 
sample mapping to experimental groups. The sample key should be provided as a single, named factor whose  
names exactly correspond to the `colnames()` of the `ExpressionSet` containing the count data to be 
processed (or coercible as such). By convention, the first level corresponds to the control sample group.
 
This function checks whether the specified sample key is of the proper format and has 
properties consistent with the specified object.
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GenePvalsFromEset.R
\name{ct.generateResults}
\alias{ct.generateResults}
\title{Calculate results of a crispr screen from a contrast}
\usage{
ct.generateResults(
  fit,
  annotation,
  RRAalphaCutoff = 0.1,
  permutations = 1000,
  contrast.term = NULL,
  scoring = c("combined", "pvalue", "fc"),
  alt.annotation = NULL,
  permutation.seed = NULL
)
}
\arguments{
\item{fit}{An object of class \code{MArrayLM} containing, at minimum, a \code{t} slot with t-statistics from the comparison, 
a \code{df.residual} slot with the corresponding residuals fo the model fits, and an \code{Amean} slot with the respective mean abundances.}

\item{annotation}{An annotation file for the experiment. gRNAs are annotated by 
row, and must minimally contain columns \code{geneSymbol} and \code{geneID}.}

\item{RRAalphaCutoff}{A cutoff to use when defining gRNAs with significantly altered abundance during the RRAa aggregation step, which may be specified
as a single numeric value on the unit interval or as a logical vector. When supplied as a logical vector (of length equal to \code{nrows(fit)}), 
this parameter directly indicates the gRNAs to include during RRAa aggregation. Otherwise, if \code{scoring} is set 
to \code{pvalue} or \code{combined}, this parameter is interpreted as the maximum nominal p-value required to consider a gRNA's abundance meaningfully 
altered during the aggregation step. If \code{scoring} is \code{fc}, this parameter is interpreted as the proportion of the list to be considered 
meaningfully altered in the experiment (e.g., if \code{RRAalphaCutoff} is set to 0.05, only consider the rankings of the 5% most upregulated 
(or downregulated) gRNAs for the purposes of RRAa calculations).

Note that this function uses directional tests to identify enriched or depleted targets, and when RRAalphaCutoff is 
provided as a logical vector the interpretation of the various aggregation statistics is going to be dependent on the specific criteria 
used to select reagents for inclusion.}

\item{permutations}{The number of permutations to use during the RRAa aggregation step.}

\item{contrast.term}{If a fit object with multiple coefficients is passed in, a string indiating the coefficient of interest.}

\item{scoring}{The gRNA ranking method to use in RRAa aggregation. May take one of three values: \code{pvalue}, \code{fc},
or '\code{combined}'. \code{pvalue} indicates that the gRNA ranking statistic should be created from the (one-sided) p-values in the 
fit object. \code{fc} indicates that the ranks of the gRNA coefficients should be used instead, and \code{combined} indicates that 
that the coefficents should be used as the ranking statistic but gRNAs are discarded in the aggregation step based on the corresponding nominal 
p-value in the fit object.}

\item{alt.annotation}{Libraries targeting ambiguous biological elements (e.g., alternative promoters to a gene where the boundaries between
elelments is contested) may contain reagents that are plausibly annotated to a finite set of possible targets. To accomodate this, users may 
supply an alternative reagent annotation in the form of a named list of vectors, where each list element corresponds something coercible to a to
a character vector of associated targets that will ultimately be assembled into the `geneSymbol` column of the `resultsDF` object. Each of these 
character vectors should be named identically to a row of the supplied fit object (e.g., the `row.names`). It is assumed that the `geneID` values 
are assigned unambiguously to the reagents, and are passed through directly.}

\item{permutation.seed}{numeric seed for permutation reproducibility. 
Default: \code{NULL} means to not set any seed. This argument is passed
through to \code{\link{ct.RRAaPvals}}.}
}
\value{
A dataframe containing gRNA-level and target-level statistics. In addition to the information present in the supplied annotation object, 
the returned object indicates P-values and Q-values for the depletion and enrichment of each gRNA and associated target, the median log2 fold 
change estimate among all gRNAs associated with the target, and Rho statistics that are calculated internally by the RRAa algorithm that may be 
useful in ranking targets that are considered significant at a given alpha or false discovery threshold.

A `resultsDF` formatted dataframe containing gene-level statistics.
}
\description{
This is a wrapper function that enables direct generation of target-level p-values from a crispr screen.
}
\examples{
data('fit')
data('ann')
output <- ct.generateResults(fit, ann, permutations = 10)
head(output)
  p = seq(0, 1, length.out=20)
  fc = seq(-3, 3, length.out=20)
  fc[2] = NA
  fc[3] = -20
  stats = data.frame(
    Depletion.P=p,
    Enrichment.P=rev(p),
    fc=fc
  )
  ct.applyAlpha(stats,scoring='combined')
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RRAalpha.R
\name{ct.RRAalphaBatch}
\alias{ct.RRAalphaBatch}
\title{Create Batches of Null Permutations for a Crispr Screen}
\usage{
ct.RRAalphaBatch(
  p,
  g.key,
  result.environment,
  batch.size = 100,
  permutation.seed = NULL
)
}
\arguments{
\item{p}{A single column matrix of rank statistics, with row.names indicating the gRNA labels.}

\item{g.key}{data.frame with guide and gene names}

\item{result.environment}{The target environment containing the quasi-global variables incremented during the permutations in the child functions.}

\item{batch.size}{Number of iterations to deploy to each daughter process.}

\item{permutation.seed}{numeric seed for permutation reproducibility. Default is \code{NULL}, in which case no seed is set.}
}
\value{
An integer vector indicating the number of iterations in which each gene's score was better than those indicated in \code{result.environment$obs}.
}
\description{
This is a wrapper function to partition batches of calls to \code{ct.RRAalpha()} for multicore processing. 
It is called internally as a single instance of the beta aggregation step in RRAa. Users should not interact with it directly.
}
\author{
Russell Bainer
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fileutilities.R
\name{ct.softLog}
\alias{ct.softLog}
\title{Log10 transform empirical P-values with a pseudocount}
\usage{
ct.softLog(x)
}
\arguments{
\item{x}{numeric vector.}
}
\value{
-log10-transformed version of X.
}
\description{
This function -log10 transforms empirical P-values by adding a pseudocount of 1/2 the minimum nonzero value.
}
\examples{
ct.softLog(runif(20))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Normalization.R
\name{ct.normalizeBySlope}
\alias{ct.normalizeBySlope}
\title{Normalize sample abundance estimates by the slope of the values in the central range}
\usage{
ct.normalizeBySlope(ExpressionObject, trim = 0.25, lib.size = NULL, ...)
}
\arguments{
\item{ExpressionObject}{An ExpressionSet containing, at minimum, count data accessible by \code{exprs}, or an EList object with count data in the $E 
slot (usually returned by \link[limma]{voom}).}

\item{trim}{The proportion to be trimmed from each end of the distributionbefore performing the linear fit; algorithm defaults to 25% such that the
fit is performed on the interquartile range.}

\item{lib.size}{An optional vector of size factor adjusted library size. 
Default: \code{NULL} means to use sum of column counts as a lib.size.}

\item{...}{Other arguments to be passed to \code{ct.normalizeMedians()}, if desired.}
}
\value{
A renormalized object of the same type as the provided object.
}
\description{
This function normalizes Crispr gRNA abundance estimates by equalizing the slopes of the middle (logged) values of the
distribution across samples. Specifically, the algorithm ranks the gRNA abundance estimates within each sample and determines a relationship between
rank change and gRNA within a trimmed region of the distribution via a linear fit. It then adjusts each sample such that the center of the logged
abundance distribution is strictly horizontal and returns these values as median-scaled counts in the appropriate slot of the input ExpressionObject.
}
\examples{
data('es')
data('ann')

#Build the sample key and library sizes for visualization
library(Biobase)
sk <- ordered(relevel(as.factor(pData(es)$TREATMENT_NAME), 'ControlReference'))
names(sk) <- row.names(pData(es))
ls <- colSums(exprs(es))

es.norm <- ct.normalizeBySlope(es, lib.size= ls)
ct.gRNARankByReplicate(es, sk, lib.size= ls)
ct.gRNARankByReplicate(es.norm, sk, lib.size= ls)
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ViewControls.R
\name{ct.viewControls}
\alias{ct.viewControls}
\title{View nontargeting guides within an experiment}
\usage{
ct.viewControls(
  eset,
  annotation,
  sampleKey,
  geneSymb = NULL,
  normalize = TRUE,
  lib.size = NULL
)
}
\arguments{
\item{eset}{An ExpressionSet  object containing, at minimum, a matrix of gRNA abundances extractable with the \code{exprs} function.}

\item{annotation}{An annotation data.frame for the experiment. gRNAs are annotated by
row, and must minimally contain columns \code{geneSymbol} and \code{geneID}.}

\item{sampleKey}{A sample key, supplied as an ordered factor linking the samples to experimental
variables. The \code{names} attribute should exactly match those present in \code{eset}, and the control condition is assumed to be
the first \code{level}.}

\item{geneSymb}{The \code{geneSymbol} identifier in \code{annotation} that corresponds to nontargeting gRNAs. If absent, \code{ct.ViewControls} will
attempt to infer nontargeting guides by searching for \code{'no_gid'} or \code{NA} in the appropriate columns.}

\item{normalize}{Logical indicating whether to attempt to normalize the data in the \code{eset} by DESeq size factors present in the metadata. If \code{TRUE},
then the metadata must contain a column containing these factors, named \code{sizeFactor.crispr-gRNA}.}

\item{lib.size}{An optional vector of voom-appropriate library size adjustment factors, usually calculated with \code{\link[edgeR]{calcNormFactors}} 
and transformed to reflect the appropriate library size. These adjustment factors are interpreted as the total library sizes for each sample, 
and if absent will be extrapolated from the columnwise count sums of the \code{exprs} slot of the \code{eset}.}
}
\value{
An image of nontargeting control gRNA abundances on the default device.
}
\description{
This function tries to identify, and then plot the abundance of, the full set of non-targeting controls from an ExpressionSet
object. Ideally, the user will supply a geneSymbol present in the appropriate annotation file that uniquely identifies the nontargeting gRNAs.
Absent this, the the function will search for common identifier used by nontargeting controls (geneID 'no_gid', or geneSymbol NA).
}
\examples{
data('es')
data('ann')

#Build the sample key
library(Biobase)
sk <- ordered(relevel(as.factor(pData(es)$TREATMENT_NAME), 'ControlReference'))
names(sk) <- row.names(pData(es))

ct.viewControls(es, ann, sk, geneSymb = NULL, normalize = FALSE)
ct.viewControls(es, ann, sk, geneSymb = NULL, normalize = TRUE)
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gCrisprTools.R
\docType{data}
\name{es}
\alias{es}
\title{ExpressionSet of count data from a Crispr screen with strong selection}
\source{
Genentech, Inc.
}
\description{
Expressionset of raw counts from a screen in mouse cells performed at Genentech, Inc. 
All sample, gRNA, and Gene information has been anonymized and randomized.
}
\examples{
data('es')
print(es)
}
\seealso{
Please see \file{vignettes/Crispr_example_workflow.R} for details.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/contrastScatter.R
\name{ct.scatter}
\alias{ct.scatter}
\title{Compare Two CRISPR Screen Contrasts via a Scatter Plot}
\usage{
ct.scatter(
  dflist,
  targets = c("geneSymbol", "geneID"),
  statistic = c("best.p", "best.q"),
  cutoff = 0.05,
  plot.it = TRUE
)
}
\arguments{
\item{dflist}{A (named) list of results dataframes, of length 2. See \code{\link{ct.generateResults}}.}

\item{targets}{Column of the provided \code{summaryDF} to consider. Must be \code{geneID} or \code{geneSymbol}.}

\item{statistic}{Statistic to plot on each axis (after -log10 transformation). Must be 'p', 'q', or 'rho'.}

\item{cutoff}{significance cutoff used to define the significance quadrants (cannot be exactly zero).}

\item{plot.it}{Logical indicating whether to compose the plot on the default device.}
}
\value{
Invisibly, a list of length 4 containing the genes passing significance for the respective quadrants.
}
\description{
This is a function for comparing the results of two screening experiments. Given two \code{summaryDF}, 
the function places them in register with one another, generates a simplified scatter plot where enrichment or depletion 
in each contrast is represented by the associated "signed" log10 (*P*/*Q*)-value (where enriched signals are represented 
in the positive direction and depleted signals are shown in the negative direction), and returns an invisible `data.frame`
containing the target X-axis and Y-axis coordinates and corresponding quadrant. 

This is a target-level analysis, and some minor simplifications are introduced to screen signals for the sake of clarity. 
Principal among these is the decision to collapse gene signals to a single directional enrichment statistic. Target-level
signals are typically aggregates of many guide-level signals, it is formally possible for targets to be both significantly 
enriched and significantly depleted within a single screen contrast as a result of substantially divergent reagent activity. 
This behavior is uncommon, however, and so targets are represented by selecting the direction of enrichment or depletion 
associated with the most significant (*P*/*Q*)-value. This directionality is then encoded into the X-axis and Y-axis 
position of the target as the sign of the signal as described above.
}
\examples{
data('resultsDF')
scat <- ct.scatter(list('FirstResult' = resultsDF[100:2100,], 'SecondResult' = resultsDF[1:2000,]))
head(scat)
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GenerateSignalSummary.R
\name{ct.signalSummary}
\alias{ct.signalSummary}
\title{Generate a Figure Summarizing Overall Signal for One or More Targets}
\usage{
ct.signalSummary(summaryDF, targets, callout = FALSE, ...)
}
\arguments{
\item{summaryDF}{A dataframe summarizing the results of the screen, returned by the function \code{\link{ct.generateResults}}.}

\item{targets}{A list or character vector containing the names of the targets to be displayed. Only targets contained in the column 
specified by the `collapse` parameter to `ct.simpleResult()` will be displayed; default is `geneSymbol`. Plotting priority (e.g., 
the points to plot last in the case of overlapping signals) is given to earlier elements in the list.}

\item{callout}{Logical indicating whether lines should be plotted indicating individual gene sets to augment the point highlighting.}

\item{...}{Additional optional arguments to `ct.simpleResult()`}
}
\value{
A summary plot on the current device.
}
\description{
Given one or more targets of interest, this function generates a summary image contextualizing the 
corresponding signals within the provided contrast. This takes the form of an annotated ranking 
curve of target-level signals, supplemented with horizontal Q-value cutoffs and an inset volcano plot of gRNA 
behavior. 

Limited annotation is provided for the specified targets using the following logic: 

- If a character vector is provided, up to five targets are annotated; longer lists are highlighted without specifying individual elements.  
- If a list is provided, the `names` element is used as the annotation. This is similarly constrained to a total of 5 annotated elements.
}
\examples{
data('resultsDF')
ct.signalSummary(resultsDF, list('CandidateA' = 'Target229', 'Pathway3' = resultsDF$geneSymbol[c(42,116,1138,5508)]))
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RRAalpha.R
\name{ct.numcores}
\alias{ct.numcores}
\title{Checks and Possibly Sets the Number of Cores to be Used in Parallel Processing}
\usage{
ct.numcores()
}
\value{
Nothing, but invisibly sets \code{options(mc.cores)} if currently \code{NULL}.
}
\description{
This function determines the number of cores that the user is expecting to 
use during parallel processing operations, and if absent, sets the \code{mc.cores} option
to the maximum value. Users who do not wish to use all available cores during parallel 
processing should do so by invoking \code{options()} from the command line prior to analysis.
}
\author{
Russell Bainer, Pete Haverty
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Normalization.R
\name{ct.normalizeGuides}
\alias{ct.normalizeGuides}
\title{Normalize an ExpressionSet Containing a Crispr Screen}
\usage{
ct.normalizeGuides(
  eset,
  method = c("scale", "FQ", "slope", "controlScale", "controlSpline"),
  annotation = NULL,
  sampleKey = NULL,
  lib.size = NULL,
  plot.it = FALSE,
  ...
)
}
\arguments{
\item{eset}{An ExpressionSet object with integer count data extractable with \code{exprs()}.}

\item{method}{The normalization method to use.}

\item{annotation}{The annotation object for the library, required for the methods employing nontargeting controls.}

\item{sampleKey}{An (optional) sample key, supplied as an ordered factor linking the samples to experimental
variables. The \code{names} attribute should exactly match those present in \code{eset}, and the control set is assumed to be
the first \code{level}. If `method` = `FQ`, the sampleKey is taken as the `sets` argument (and its format requirements are similarly 
relaxed; see `?ct.normalizeFC`).}

\item{lib.size}{An optional vector of voom-appropriate library size adjustment factors, usually calculated with \code{\link[edgeR]{calcNormFactors}} 
and transformed to reflect the appropriate library size. These adjustment factors are interpreted as the total library sizes for each sample, 
and if absent will be extrapolated from the columnwise count sums of the \code{exprs} slot of the \code{eset}.}

\item{plot.it}{Logical indicating whether to plot the ranked log2 gRNA count distributions before and after normalization.}

\item{...}{Other parameters to be passed to the individual normalization methods.}
}
\value{
A renormalized ExpressionSet. If specified, the sample level counts will be scaled so as to maintain the validity 
of the specified \code{lib.size} values.
}
\description{
This function normalizes Crispr gRNA abundance estimates contained in an \code{ExpressionSet} object.
Currently four normalization methods are implemented: median scaling (via \code{normalizeMedianValues}), slope-based
normalization (via \code{ct.normalizeBySlope()}), scaling to the median of the nontargeting control values (via 
\code{ct.normalizeNTC()}), factored quantile normalization (via \code{ct.normalizeFQ()}), and spline fitting to the distribution of 
selected gRNAs (via \code{ct.normalizeSpline()}). Because of the peculiarities of pooled Crispr screening data, these 
implementations may be more stable than the endogenous methods used downstream by \link[limma]{voom}. See the respective 
man pages for further details about specific normalization approaches.
}
\examples{
data('es')
data('ann')

#Build the sample key as needed
library(Biobase)
sk <- ordered(relevel(as.factor(pData(es)$TREATMENT_NAME), 'ControlReference'))
names(sk) <- row.names(pData(es))

es.norm <- ct.normalizeGuides(es, 'scale', annotation = ann, sampleKey = sk, plot.it = TRUE)
es.norm <- ct.normalizeGuides(es, 'slope', annotation = ann, sampleKey = sk, plot.it = TRUE)
es.norm <- ct.normalizeGuides(es, 'controlScale', annotation = ann, sampleKey = sk, plot.it = TRUE, geneSymb = 'NoTarget')
es.norm <- ct.normalizeGuides(es, 'controlSpline', annotation = ann, sampleKey = sk, plot.it = TRUE, geneSymb = 'NoTarget')
}
\seealso{
\code{\link{ct.normalizeMedians}}, \code{\link{ct.normalizeBySlope}}, \code{\link{ct.normalizeNTC}}, \code{\link{ct.normalizeSpline}}
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Normalization.R
\name{ct.normalizeSpline}
\alias{ct.normalizeSpline}
\title{Normalize sample abundance estimates by a spline fit to specific shared elements}
\usage{
ct.normalizeSpline(eset, annotation, geneSymb = NULL, lib.size = NULL)
}
\arguments{
\item{eset}{An ExpressionSet object containing, at minimum, count data accessible by \code{exprs}.}

\item{annotation}{An annotation dataframe indicating the nontargeting controls in the geneID column.}

\item{geneSymb}{The \code{geneSymbol} identifier(s) in \code{annotation} that corresponds to the "anchor" gRNAs. If absent, the method will
attempt to infer nontargeting guides by searching for \code{'no_gid'} or \code{NA} in the appropriate columns.}

\item{lib.size}{An optional vector of voom-appropriate library size adjustment factors, usually calculated with \code{\link[edgeR]{calcNormFactors}} 
and transformed to reflect the appropriate library size. These adjustment factors are interpreted as the total library sizes for each sample, 
and if absent will be extrapolated from the columnwise count sums of the \code{exprs} slot of the \code{eset}.}
}
\value{
A normalized \code{eset}.
}
\description{
This function normalizes Crispr gRNA abundance estimates by fiting a smoothed spline to a subset of the gRNAs within each sample
and then equalizing these curves across the experiment. Specifically, the algorithm ranks the gRNA abundance estimates within each sample and 
uses a smoothed spline to determine a relationship between the ranks of the "anchor" guides and their abundance estimates. It then adjusts the 
spline trends from each sample to the mean of all of the sample spline fits in a manner analogous to quantile normalization, interpolating the
gRNA abundance values between the anchor points; these values are returned as normalized counts in the '\code{exprs}' slot of the input eset.
}
\examples{
data('es')
data('ann')

#Build the sample key and library sizes for visualization
library(Biobase)
sk <- (relevel(as.factor(pData(es)$TREATMENT_NAME), 'ControlReference'))
names(sk) <- row.names(pData(es))
ls <- colSums(exprs(es))

es.norm <- ct.normalizeSpline(es, ann, 'NoTarget', lib.size = ls)
ct.gRNARankByReplicate(es, sk, lib.size = ls)
ct.gRNARankByReplicate(es.norm, sk, lib.size = ls)
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RRAalpha.R
\name{ct.makeRhoNull}
\alias{ct.makeRhoNull}
\title{Make null distribution for RRAalpha tests}
\usage{
ct.makeRhoNull(n, p, nperm)
}
\arguments{
\item{n}{single integer, number of guides per gene}

\item{p}{numeric vector of rank statistics}

\item{nperm}{single integer, how many random samples to take.}
}
\value{
numeric vector of Rho values
}
\description{
Makes random distribution of Rho value by taking nperm random samples of n rank stats, p.
}
\examples{
ct.makeRhoNull(3, 1:9, 5)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fileutilities.R
\name{ct.simpleResult}
\alias{ct.simpleResult}
\title{Convert a verbose results DF object to a gene-level result object}
\usage{
ct.simpleResult(summaryDF, collapse = c("geneSymbol", "geneID"))
}
\arguments{
\item{summaryDF}{A \code{data.frame}, usually returned by \code{ct.generateResults}. 
if you need to generate one of these by hand for some reason, see the example 
\code{resultsDF} object loaded in the example below.}

\item{collapse}{Column of the provided resultsDF on which to collapse values; in most cases this should be 
`geneSymbol` or `geneID`.}
}
\value{
A gene-level `data.frame`, with guide-level information omitted
}
\description{
Convenience function to reduce a full results object to a gene-level object 
that retains minimal statistics (or alternatively, check that a provided simple result object is valid).
}
\examples{
data('resultsDF')
ct.simpleResult(resultsDF)
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RRAalpha.R
\name{ct.RRAaPvals}
\alias{ct.RRAaPvals}
\title{gRNA signal aggregation via RRAa}
\usage{
ct.RRAaPvals(p, g.key, permute, permutation.seed = NULL, multi.core = NULL)
}
\arguments{
\item{p}{A single column matrix of ranking scores, with row.names indicating the gRNA labels}

\item{g.key}{An annotation data frame of gRNAs, minimally containing a factorized 'geneSymbol' column indicating the target names. This is typically generated by 
calling the \code{ct.buildKeyFromAnnotation()} function.}

\item{permute}{Number of permutations to be used during empirical p-value estimation.}

\item{permutation.seed}{numeric seed for permutation reproducibility.
Default: \code{NULL} means to not set any seed.}

\item{multi.core}{Deprecated, does nothing}
}
\value{
A named list of target-level empirical P-values.
}
\description{
This is a wrapper function implementing the RRAalpha p-value aggregation algorithm. Takes in a set of gRNA rank scores (formatted as a single-column 
numeric matrix with row.names indicating the guide names) and a list object of gRNA annotations (names are the gene targets, and each element of the list contains 
a vector of the corresponding guide names). The rank scores are converted to gene-level statistics that are thenm transformed into empirical p-values by permutation.
}
\examples{
data('fit')
data('ann')
genePvals <- ct.RRAaPvals(fit$p.value, ann, permute = 100)
}
\author{
Russell Bainer
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gCrisprTools.R
\docType{package}
\name{gCrisprTools-package}
\alias{gCrisprTools-package}
\title{gCrisprTools}
\description{
Pipeline for using CRISPR screen data
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RRAalpha.R
\name{ct.RRAalpha}
\alias{ct.RRAalpha}
\title{Aggregation of P-value Ranks using a Beta Distribution and Alpha Cutoff}
\usage{
ct.RRAalpha(p, g.key, shuffle = FALSE)
}
\arguments{
\item{p}{A single column matrix of rank statistics.}

\item{g.key}{data.frame with guide and gene names}

\item{shuffle}{Logical indicating whether to shuffle the rank statistics prior to calculating the rho statistics (useful for permutation).}
}
\value{
Nothing, or a named list of target-level P-values, which are treated as a rho statistic in the permutation step.
}
\description{
This function is called internally as a single instance of the beta aggregation step in RRAa. Users should not interact with it directly. 
The expected input is a set of rank statistics, and a paired \code{alpha} argument defining which values to consider in downstream analyses (see below). 

As of gCrisprTools 2.0, this function does not consider `row.names` associated with the provided values, and the p-values are expected to be provided 
in register with the provided `g.key` object.
}
\examples{
data('fit')
data('ann')
geneScores <- ct.RRAalpha(fit$p.value, ann, shuffle = FALSE)
}
\author{
Russell Bainer
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ViewGuides.R
\name{ct.exprsColor}
\alias{ct.exprsColor}
\title{Assign Colors Based on the Position of a Value in a Distribution}
\usage{
ct.exprsColor(exprs, rankedexprs, colors)
}
\arguments{
\item{exprs}{The value whose color is to be returned.}

\item{rankedexprs}{A vector of values the length of cols that corresponds to the values in the distribution.}

\item{colors}{The vector of colors to be used as a reference.}
}
\value{
A value contained in cols.
}
\description{
This is a function to generate colors for plot elements on the basis of the position of a value within a distribution. 
Called internally by ct.viewGuides.
}
\author{
Russell Bainer
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fileutilities.R
\name{ct.rankSimple}
\alias{ct.rankSimple}
\title{Rank Signals in a Simplified Pooled Screen Result Object}
\usage{
ct.rankSimple(df, top = c("enrich", "deplete"))
}
\arguments{
\item{df}{A results data.frame, in either raw or simplified form. Will be converted to simplified form if necessary.}

\item{top}{Determines the directionality of the ranking. `enrich` defines ranks from the most enriched to the most 
depleted target; `deplete` does the opposite}
}
\value{
A numeric vector of ranks, with length equal to the number of rows in the simplified data.frame.
}
\description{
This function takes in a supplied results data.frame, optionally transforms it into a `simplifiedResult`, 
and returns the ranks of the target-level signals.
}
\examples{
data('resultsDF')
df.simple <- ct.simpleResult(resultsDF) 
sr <- ct.rankSimple(resultsDF)
all((df.simple$best.p[sr == 1] == 0), (df.simple$direction[sr == 1] == 'enrich'))

sr <- ct.rankSimple(resultsDF, 'deplete')
all((df.simple$best.p[sr == 1] == 0), (df.simple$direction[sr == 1] == 'deplete'))
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generateReports.R
\name{renderReport}
\alias{renderReport}
\title{Internal wrapper to generate html markdown reports from existing templates}
\usage{
renderReport(reportNameBase, templateName, rmdParamList, outdir = NULL)
}
\arguments{
\item{reportNameBase}{character - name of the report's file.}

\item{templateName}{character - name of the rmarkdown template file in the
standard location. Passed through to \code{template} argument of the
\code{\link[rmarkdown]{draft}}.}

\item{rmdParamList}{list of named report parameters. Passed through to
\code{params} argument of the \code{\link[rmarkdown]{render}}.}

\item{outdir}{An optional character string indicating the directory in which to 
generate the report. If \code{NULL}, a temporary directory will be automatically generated.}
}
\value{
character with a path to html report in the temporary directory.
}
\description{
Internal wrapper to generate html markdown reports from existing templates
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/annotations.R
\name{ct.expandAnnotation}
\alias{ct.expandAnnotation}
\title{Expand an annotation object to allow annotations of reagents to multiple targets}
\usage{
ct.expandAnnotation(ann, alt.annotation)
}
\arguments{
\item{ann}{A \code{data.frame} containing an annotation object with gRNA-level information encoded as rows, typically produced by 
`ct.prepareAnnotation`. The `ID` column should correspond to the individual reagent identifiers.}

\item{alt.annotation}{A named list of character vectors, which should be named identically to a value in the `ID` column of the supplied 
annotation object. The values in the character vectors will eventually form the `geneSymbol` column of the annotation file.}
}
\value{
A new annotation data frame, expanded as described above.
}
\description{
This function takes a gCrisprTools annotation object and expands it to allow 1:many mappings of reagents. 
This mostly is used for internal processing, and users should interact with the wrapper functions that call it (e.g., `ct.generateResults`). 

Libraries targeting ambiguous biological elements (e.g., alternative promoters to a gene where the boundaries between
elements is contested) may contain reagents that are plausibly annotated to a finite set of possible targets. To accomodate this, users may 
supply an alternative reagent annotation in the form of a named list of vectors, where the names correspond to reagent `ID`s in the annotation 
object and each list element corresponds something coercible to a to a character vector of associated targets that will ultimately be assembled
into the `geneSymbol` column of the annotation object. It is assumed that the `geneID` values are assigned unambiguously to the reagents, 
and are passed through directly.
}
\examples{
data('ann')
alt.annotation <- list('Target2089_b' = c('foo', 'bar'), 'Target2089_c' = 'foo', 'Target2089_a' = 'bar')
ct.expandAnnotation(ann, alt.annotation)
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GCbias.R
\name{ct.GCbias}
\alias{ct.GCbias}
\title{Visualization of gRNA GC Content Trends}
\usage{
ct.GCbias(data.obj, ann, sampleKey = NULL, lib.size = NULL)
}
\arguments{
\item{data.obj}{An \code{ExpressionSet} or fit (\code{MArrayLM}) object to be analyzed for the presence of GC 
content bias.}

\item{ann}{An annotation \code{data.frame}, used to estimate GC content for each guide. Guides are annotated by 
row, and the object must minimally contain a \code{target} column containing a character 
vector that indicates the corresponding nucleotide sequences.}

\item{sampleKey}{An optional sample key, supplied as a factor linking the samples to experimental 
variables. The \code{names} attribute should exactly match those present in \code{eset}, and the 
control set is assumed to be the first \code{level}. Ignored in the analysis of model fit objects.}

\item{lib.size}{An optional vector of voom-appropriate library size adjustment factors, usually calculated with \code{\link[edgeR]{calcNormFactors}} 
and transformed to reflect the appropriate library size. These adjustment factors are interpreted as the total library sizes for each sample, 
and if absent will be extrapolated from the columnwise count sums of the \code{exprs} slot of the \code{eset}.}
}
\value{
An image relating GC content to experimental observations on the default device. If the 
provided \code{data.obj} is an \code{ExpressionSet}, this takes the form of a scatter plot where the 
GC% and abundance estimates of each guide are represented as points overlaid
with a smoothed trendline within each sample. If \code{data.obj} is a fit object describing a linear model 
contrast, then four panels are returned describing the GC content distribution and its relationship 
to guide-level fold change, standard deviation, and P-value estimates.
}
\description{
This function visualizes relationships between gRNA GC content and their measured abundance or 
various differential expression model estimates.
}
\examples{
data('es')
data('ann')
data('fit')

ct.GCbias(es, ann)
ct.GCbias(fit, ann)
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gCrisprTools.R
\docType{data}
\name{resultsDF}
\alias{resultsDF}
\title{Precalculated gene-level summary of a crispr screen}
\source{
Genentech, Inc.
}
\description{
A precalculated summary Dataframe comparing the death and control expansion arms of 
the provided example Crispr screen (using 8 cores, seed = 2). 
All sample, gRNA, and Gene information has been anonymized and randomized.
}
\examples{
data('resultsDF')
head(resultsDF)
}
\seealso{
Please see \file{vignettes/Crispr_example_workflow.R} for model details.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generateReports.R
\name{appendDateAndExt}
\alias{appendDateAndExt}
\title{Add formatted timestamp and extension to a file name}
\usage{
appendDateAndExt(name, ext)
}
\arguments{
\item{name}{character}

\item{ext}{character - extension including a '.'.}
}
\value{
character
}
\description{
Add formatted timestamp and extension to a file name
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GenePvalsFromEset.R
\name{ct.applyAlpha}
\alias{ct.applyAlpha}
\title{Apply RRA 'alpha' cutoff to RRAalpha input}
\usage{
ct.applyAlpha(
  stats,
  RRAalphaCutoff = 0.1,
  scoring = c("combined", "pvalue", "fc")
)
}
\arguments{
\item{stats}{three-column numeric matrix with pvalues for down and up one-sided test with guide-level fold
changes (coefficients from the relevant contrast).}

\item{RRAalphaCutoff}{A cutoff to use when defining gRNAs with significantly altered abundance during the RRAa aggregation step, which may be specified
as a single numeric value on the unit interval or as a logical vector. When supplied as a logical vector (of length equal to \code{nrows(fit)}), 
this parameter directly indicates the gRNAs to include during RRAa aggregation. Otherwise, if \code{scoring} is set 
to \code{pvalue} or \code{combined}, this parameter is interpreted as the maximum nominal p-value required to consider a gRNA's abundance meaningfully 
altered during the aggregation step. If \code{scoring} is \code{fc}, this parameter is interpreted as the proportion of the list to be considered 
meaningfully altered in the experiment (e.g., if \code{RRAalphaCutoff} is set to 0.05, only consider the rankings of the 5% most upregulated 
(or downregulated) gRNAs for the purposes of RRAa calculations).}

\item{scoring}{The gRNA ranking method to use in RRAa aggregation. May take one of three values: \code{pvalue}, \code{fc},
or '\code{combined}'. \code{pvalue} indicates that the gRNA ranking statistic should be created from the (one-sided) p-values in the 
fit object. \code{fc} indicates that the ranks of the gRNA coefficients should be used instead, and \code{combined} indicates that 
that the coefficents should be used as the ranking statistic but gRNAs are discarded in the aggregation step based on the corresponding nominal 
p-value in the fit object.}
}
\value{
data.frame with guide-level pvals, fold change, and scores.deplete and scores.enrich which are the input the RRAalpha
}
\description{
The 'alpha' part of RRAalpha is used to consider only the top guide-level scores for gene-level
    statistics. Practically, all guides failing the cutoff get a pvalue of 1.  There are three ways of
    determining which guides fail. See 'scoring' below.
}
\examples{
fakestats <- matrix(runif(300), ncol = 3)
colnames(fakestats) = c('Depletion.P', 'Enrichment.P', 'lfc')
ct.applyAlpha(fakestats)
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Normalization.R
\name{ct.normalizeFQ}
\alias{ct.normalizeFQ}
\title{Apply Factored Quantile Normalization to an eset}
\usage{
ct.normalizeFQ(eset, sets, lib.size = NULL)
}
\arguments{
\item{eset}{An \code{ExpressionSet} containing, at minimum, count data accessible by \code{exprs}.}

\item{sets}{A character or factor object delineating which samples should be grouped together during the normalization step. Must 
be the same length as the number of columns in the provided eset, and cannot contain `NA` or `NULL` values.}

\item{lib.size}{An optional vector of voom-appropriate library size adjustment factors, usually calculated with \code{\link[edgeR]{calcNormFactors}} 
and transformed to reflect the appropriate library size. These adjustment factors are interpreted as the total library sizes for each sample, 
and if absent will be extrapolated from the columnwise count sums of the \code{exprs} slot of the \code{eset}.}
}
\value{
A renormalized ExpressionSet object of the same type as the provided object.
}
\description{
This function applies quantile normalization to subsets of samples defined by a provided factor, correcting for library size. 
It does this by converting raw count values to log2 counts per million and optionally adjusting further in 
the usual way by dividing these values by user-specified library size factors; then this matrix is split into groups according to the 
provided factor that are quantile normalized, and then the groups are median scaled to each other before conversion back into 
raw counts. This method is best used in comparisons for long timecourse screens, where groupwise differences in growth rate 
cause uneven intrinsic dialation of construct distributions.

Note that this normalization strategy is not appropriate for experiments where significant distortion of the libraries is expected as a 
consequence of the screening strategy (e.g., strong selection screens).
}
\examples{
data('es')

#Build the sample key and library sizes for visualization
library(Biobase)
sk <- relevel(as.factor(pData(es)$TREATMENT_NAME), 'ControlReference')
names(sk) <- row.names(pData(es))
ls <- colSums(exprs(es))

es.norm <- ct.normalizeFQ(es, sets = gsub('(Death|Control)', '', pData(es)$TREATMENT_NAME), lib.size= ls)
ct.gRNARankByReplicate(es, sampleKey = sk, lib.size= ls)
ct.gRNARankByReplicate(es.norm, sampleKey = sk, lib.size= ls)
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Raw_read_densities.R
\name{ct.rawCountDensities}
\alias{ct.rawCountDensities}
\title{Visualization of Raw gRNA Count Densities}
\usage{
ct.rawCountDensities(eset, sampleKey = NULL, lib.size = NULL)
}
\arguments{
\item{eset}{An ExpressionSet object containing, at minimum, count data accessible by exprs() and some phenoData.}

\item{sampleKey}{A sample key, supplied as a (possibly ordered) factor linking the samples to experimental 
variables. The \code{names} attribute should exactly match those present in \code{eset}, and the control set 
is assumed to be the first \code{level}.}

\item{lib.size}{Optional named vector of library sizes (total reads within the library) to enable normalization}
}
\value{
A density plot as specified on the default device.
}
\description{
This function plots the per-sample densities of raw gRNA read counts on the log10 scale. The curve colors are assigned based on a user-
specified sampleKey. This function is primarily useful to determine whether libraries are undersequenced (low mean raw gRNA counts), 
contaminated (many low-abundance gRNAs present), or if PCR artifacts may be present (subset of extremely abundant guides, multiple gRNA distribution modes). In most 
well-executed experiments the majority of gRNAs will form a tight distribution around some reasonably high average read count (hundreds of reads), 
at least among the control samples. Excessively low raw count values can compromise normalization steps and subsequent estimation of gRNA levels, especially 
in screens in which most gRNAs have minimal effects on cell viability.
}
\examples{
data('es')

#Build the sample key
library(Biobase)
sk <- relevel(as.factor(pData(es)$TREATMENT_NAME), 'ControlReference')
names(sk) <- row.names(pData(es))

ct.rawCountDensities(es, sk)
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ViewGuides.R
\name{ct.drawColorLegend}
\alias{ct.drawColorLegend}
\title{Draw a density color legend.}
\usage{
ct.drawColorLegend(dens, colorscale)
}
\arguments{
\item{dens}{A density object.}

\item{colorscale}{A vector of colors to draw behind the density.}
}
\value{
A color legend on the current graphics device.
}
\description{
This is a function called internally by ct.viewGuides to generate the color legend. End users should not use it.
}
\author{
Russell Bainer
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fileutilities.R
\name{ct.resultCheck}
\alias{ct.resultCheck}
\title{Determine whether a supplied object contains the results of a Pooled Screen}
\usage{
ct.resultCheck(summaryDF)
}
\arguments{
\item{summaryDF}{A \code{data.frame}, usually returned by \code{ct.generateResults}. 
if you need to generate one of these by hand for some reason, see the example 
\code{resultsDF} object loaded in the example below.}
}
\value{
A logical indicating whether the object is of the appropriate format.
}
\description{
Many gCrisprTools functions operate on a \code{data.frame} of results
generated by a CRISPR screen. This function takes in a supplied object and returns 
a logical indicating whether the object can be treated as one of these data.frames 
for the purposes of downstream analyses. This is largely used internally, but can 
be useful if a user needs to build a result object for some reason.
}
\examples{
data('resultsDF')
ct.resultCheck(resultsDF)
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fileutilities.R
\name{ct.buildSE}
\alias{ct.buildSE}
\title{Package Screen Data into a `SummarizedExperiment` Object}
\usage{
ct.buildSE(
  es,
  sampleKey = NULL,
  ann = NULL,
  vm = NULL,
  fit = NULL,
  summaryList = NULL
)
}
\arguments{
\item{es}{An `ExpressionSet` of screen data. Required.}

\item{sampleKey}{a gCrisprTools `sampleKey` object, to be added to the `colData`.}

\item{ann}{Annotation object to be packaged into the `rowData`}

\item{vm}{A `voom`-derived normalized object}

\item{fit}{a `MArrayLM` object containing the contrast information and model results}

\item{summaryList}{A named list of \code{data.frame}s, returned by \code{ct.generateResults}. 
if you need to generate one of these by hand for some reason, see the example 
\code{resultsDF} object loaded in the example below.}
}
\value{
A `SummarizedExperiment` object.
}
\description{
Convenience function to package major components of a screen into a `SummarizedExperiment` container
for downstream visualization and analysis. All arguments are optional except for `es`.
}
\examples{
data('ann', 'es', 'fit', 'resultsDF')
ct.buildSE(es, ann = ann, fit = 'fit', summaryList = list('resA' = resultsDF, 'resB' = resultsDF))
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/discardTraceReads.R
\name{ct.filterReads}
\alias{ct.filterReads}
\title{Remove low-abundance elements from an ExpressionSet object}
\usage{
ct.filterReads(
  eset,
  trim = 1000,
  log2.ratio = 4,
  sampleKey = NULL,
  plot.it = TRUE,
  read.floor = NULL
)
}
\arguments{
\item{eset}{An unnormalized \code{ExpressionSet} object containing, at minimum, a matrix of gRNA counts accessible with \code{exprs()}.}

\item{trim}{The number of gRNAs to be trimmed from the top of the distribution before estimating the abundance range. Empirically, this usually should be equal to about 2 to 5 percent of the guides in the library.}

\item{log2.ratio}{Maximum abundance of contaminant gRNAs, expressed on the log2 scale from the top of the trimmed range 
of each sample. That is, \code{log2.ratio = 4} means to discard all gRNAs whose abundance is (1/2)^4 of the trimmed maximum.}

\item{sampleKey}{An (optional) sample key, supplied as an ordered factor linking the samples to experimental
variables. The \code{names} attribute should exactly match those present in \code{eset}, and the control set is assumed to be
the first \code{level}.}

\item{plot.it}{Logical value indicating whether to plot the adjusted gRNA densities on the default device.}

\item{read.floor}{Optionally, the minimum number of reads required for each gRNA.}
}
\value{
An \code{ExpressionSet} object, with trace-abundance gRNAs omitted.
}
\description{
This function removes gRNAs only present in very low abundance across all samples of a pooled Crispr
screening experiment. In most cases very low-abundance guides are the
result of low-level contamination from other libraries, and often distort standard normalization approaches. This
function trims gRNAs in a largely heuristic way, assuming that the majority of 'real' gRNAs within the library are
comparably abundant in at least some of the samples (such as unexpanded controls), and that contaminants are
present at negligible levels. Specifically, the function trims the \code{trim}
most abundant guides from the upper tail of each log-transformed sample distribution, and then omits gRNAs whose
abundances are always less than 1/(2^\code{log2.ratio}) of this value.
}
\examples{
data('es')
ct.filterReads(es)
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DirTest.R
\name{ct.DirectionalTests}
\alias{ct.DirectionalTests}
\title{Compute Directional P-values from eBayes Output}
\usage{
ct.DirectionalTests(fit, contrast.term = NULL)
}
\arguments{
\item{fit}{An object of class MArrayLM containing, at minimum, a \code{df.residual} slot containing the appropriate degres of freedom for each test, and a \code{t} slot containing t statistics.}

\item{contrast.term}{If a fit object with multiple coefficients is passed in, a string indiating the coefficient of interest.}
}
\value{
A matrix object with two numeric columns, indicating the p-values quantifying the evidence for enrichment and depletion of each feature in the relevant model contrast.
}
\description{
This function produces two sets of one-sided P-values derived from the moderated t-statistics produced by eBayes.
}
\examples{
data('fit')
ct.DirectionalTests(fit)
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GuideCDF.R
\name{ct.ecdf}
\alias{ct.ecdf}
\title{Generate a cumulative tally of reads by guide rank}
\usage{
ct.ecdf(vector)
}
\arguments{
\item{vector}{An input numeric vector to be aggregated.}
}
\value{
A numeric vector of the cumulative sum
}
\description{
This function returns a numeric vector of the same length as the input, where each element \code{n} contains the proportion
the sum of the full vector that is captured by its first \code{1-n} elements (arranged in descending order).
}
\author{
Russell Bainer
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/compareContrasts.R
\name{ct.compareContrasts}
\alias{ct.compareContrasts}
\title{Identify Replicated Signals in Pooled Screens Using Conditional Scoring}
\usage{
ct.compareContrasts(
  dflist,
  statistics = c("best.q", "best.p"),
  cutoffs = c(0.1, 0.1),
  same.dir = rep(TRUE, length(dflist)),
  return.stats = FALSE,
  nperm = 10000,
  ...
)
}
\arguments{
\item{dflist}{A list of (possibly simplified) results data.frames produced by \code{\link{ct.generateResults}}.}

\item{statistics}{Statistics to use to define congruence; may be a single value, but internally coerced to a vector of length 2 where the first 
value corresponds to the stringent cutoff annd the second value is used for the relaxed cutoff. Must be 'best.p' or 'best.q'.}

\item{cutoffs}{Numeric value(s) corresponding to the significance cutoff(s) used to define stringent and relaxed values of `statistics`. 
Internally coerced to a vector of length 2.}

\item{same.dir}{Logical vector of the same length as `dflist` indicating whether replicating signals are expected to go in the same direction 
(e.g., enrich/deplete in their respective screens). For example, a `dflist` of length 3 could be specified as c(TRUE, TRUE, FALSE), indicating 
that replicating signals should be enriched in both of the first two contrasts and depleted in the third to be considered replicated (or 
vise-versa). Default is `rep(TRUE, length(dflist))`.}

\item{return.stats}{When TRUE, return the significance of overlap instead of the logical vector (by permutation).}

\item{nperm}{numeric indicating number of permutations when `return.stats` is true (default 10000).}

\item{...}{Other arguments to `ct.simpleResult()`, especially `collapse`.}
}
\value{
If `return.stats` is `FALSE`, returns the first contrast as a `simplifiedResult` data.frame, with a `replicated` logical column 
indicating whether each signal replicates in all of the provided screens according to the specified logic. 

If `return.stats` is `TRUE`, returns a dataframe indicating the permutation-based test statistics summarizing the evidence for significantly 
enriched signal replication across the provided contrasts (enrich, deplete, and all together).
}
\description{
This function identifies signals that are present in one or more screening experiment contrasts using a conditional 
strategy. Specifically, this function identifies all significant signals (according to user definitions) in a set of provided 
results DF and returns a `simplifiedResult` dataframe derived from the first provided contrast with an appended logical column 
indicating whether there is evidence for signal replication in the other provided resultsDFs.

Signals are considered replicated if they cross the specified stringent threshold (default: Q = 0.1) in one or more of the provided 
contrasts, and are similarly enriched or depleted at the relaxed threshold (default: P = 0.1) in all of the remaining contrasts. If 
a single contrast is provided, all signals crossing the stringent threshold are considered replicated.

Signals are compared across screens on the basis of \code{\link{ct.regularizeContrasts}}, so users must provide an identifier 
with which to standardize targets (`geneID` by default).
}
\examples{
data('resultsDF')
summary(ct.compareContrasts(list(resultsDF, resultsDF[1:5000,]))$replicated)
ct.compareContrasts(list(resultsDF, resultsDF[1:5000,]), return.stats = TRUE)
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sparrow_integration.R
\name{ct.seas}
\alias{ct.seas}
\title{Geneset Enrichment within a CRISPR screen using `sparrow`}
\usage{
ct.seas(dflist, gdb, active = "replicated", ...)
}
\arguments{
\item{dflist}{A result object created by `ct.generateResults()`, or a named list containing many of them; will be passed as a list to 
`ct.seasPrep()` with the associated `...` arguments.}

\item{gdb}{A `GenseSetDb` object containing annotations for the targets specified in `result`.}

\item{active}{Name of a column in the supplied result(s) that should be used to indicate active/selected targets.}

\item{...}{Additional arguments to pass to `ct.seasPrep()` or `sparrow::seas()`.}
}
\value{
A named list of `SparrowResults` objects.
}
\description{
This function is a wrapper for the `sparrow::seas()` function, which identifies differentially enriched/depleted ontological 
categories within the hits identified by a pooled screening experiment, given a provided `GenseSetDb()` object and a list of 
results objects created by `ct.generateResults()`. By default testing is performed using `fgsea` and a hypergeometric test 
(`sparrow::ora()`), and results are returned as a `SparrowResult` object. 

This function will attempt to coerce them into inputs appropriate for the above analyses via `ct.seasPrep()`, after checking 
the relevant parameters within the provided `GeneSetDb`. This is generally easier than going through the individual steps yourself, 
especially when the user is minimally postprocessing the contrast results in question. 

Sometimes, it can be useful to directly indicate the set of targets to be included in an enrichment analysis (e.g., if you wish to expand
or contract the set of active targets based on signal validation or other secondary information about the experiment). To accomodate this 
use case, users may include a logical column in the provided result object(s) indicating which elements should be included among the 
positive signals exposed to the test. 

Note that many pooled libraries specifically target biased sets of genes, often focusing on genes involved
in a particular pathway or encoding proteins with a shared biological property. Consequently, the enrichment results
returned by this function represent the disproportionate enrichment or depletion of targets annotated to pathways *within the context
of the screen*, and may or may not be informative of the underlying biology in question. This means that
pathways not targeted by a library will obviously never be enriched a positive target set regardless of
their biological relevance, and pathways enriched within a focused library screen are similarly expected to partially
reflect the composition of the library and other confounding issues (e.g., number of targets within a pathway).
Analysts should therefore use this function with care. For example, it might be unsurprising to detect pathways related
to histone modification within a screen employing a crispr library primarily targeting epigenetic regulators.
}
\examples{
data('resultsDF')
gdb <- sparrow::getMSigGeneSetDb(collection = 'h', species = 'human', id.type = 'entrez')
ct.seas(list('longer' = resultsDF, 'shorter' = resultsDF[1:10000,]), gdb)
}
\author{
Steve Lianoglou for seas; Russell Bainer for GeneSetDb processing and wrapping functions.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RRAalpha.R
\name{ct.alphaBeta}
\alias{ct.alphaBeta}
\title{Aggregation of P-value Ranks using a Beta Distribution and Alpha Cutoff}
\usage{
ct.alphaBeta(p.in)
}
\arguments{
\item{p.in}{A single column matrix of rank scores, with row.names indicating the gRNA labels.}
}
\value{
A numeric rho value corresponding to the minimum rank order P.
}
\description{
This function calculates an alpha-modified rho statistic from a set of normalized ranks by comparing them to a uniform distribution. 
Specifically, the ranks are ordered and p-values calculated at each position in the ordered vector by comparison to a Beta distribution. The rho value 
returned is the smallest p-value identified in this way across all scores. Should not be used by end users.
}
\examples{
testp <- runif(20)

ct.alphaBeta(testp)  
}
\author{
Russell Bainer, modified from code from the \code{RobustRankAggreg} package. 

Citation: 
Kolde, R. et al, Bioinformatics. 2012 Feb 15;28(4):573-80. doi: 10.1093/bioinformatics/btr709.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Normalization.R
\name{ct.normalizeNTC}
\alias{ct.normalizeNTC}
\title{Normalize sample abundance estimates by the median values of nontargeting control guides}
\usage{
ct.normalizeNTC(eset, annotation, lib.size = NULL, geneSymb = NULL)
}
\arguments{
\item{eset}{An ExpressionSet object containing, at minimum, count data accessible by \code{exprs}.}

\item{annotation}{An annotation dataframe indicating the nontargeting controls in the geneID column.}

\item{lib.size}{An optional vector of voom-appropriate library size adjustment factors, usually calculated with \code{\link[edgeR]{calcNormFactors}} 
and transformed to reflect the appropriate library size. These adjustment factors are interpreted as the total library sizes for each sample, 
and if absent will be extrapolated from the columnwise count sums of the \code{exprs} slot of the \code{eset}.}

\item{geneSymb}{The \code{geneSymbol} identifier in \code{annotation} that corresponds to nontargeting gRNAs. If absent, \code{ct.gRNARankByReplicate} will
attempt to infer nontargeting guides by searching for \code{'no_gid'} or \code{NA} in the appropriate columns via \code{ct.prepareAnnotation()}.}
}
\value{
A normalized \code{eset}.
}
\description{
This function normalizes Crispr gRNA abundance estimates by equalizing the median 
abundances of the nontargeting gRNAs within each sample. The normalized values are returned as normalized counts in 
the '\code{exprs}' slot of the input eset. Note that this method may be unstable if the screening library contains 
relatively few nontargeting gRNAs.
}
\examples{
data('es')
data('ann')

#Build the sample key and library sizes for visualization
library(Biobase)
sk <- ordered(relevel(as.factor(pData(es)$TREATMENT_NAME), 'ControlReference'))
names(sk) <- row.names(pData(es))
ls <- colSums(exprs(es))

es.norm <- ct.normalizeNTC(es, ann, lib.size = ls, geneSymb = 'NoTarget')

ct.gRNARankByReplicate(es, sk, lib.size = ls)
ct.gRNARankByReplicate(es.norm, sk, lib.size = ls)
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RankByRep.R
\name{ct.gRNARankByReplicate}
\alias{ct.gRNARankByReplicate}
\title{Visualization of Ranked gRNA Abundances by Replicate}
\usage{
ct.gRNARankByReplicate(
  eset,
  sampleKey,
  annotation = NULL,
  geneSymb = NULL,
  lib.size = NULL
)
}
\arguments{
\item{eset}{An ExpressionSet object containing, at minimum, count data accessible by exprs() and some phenoData.}

\item{sampleKey}{A sample key, supplied as a (possibly ordered) factor linking the samples to experimental 
variables. The \code{names} attribute should exactly match those present in \code{eset}, and the control set 
is assumed to be the first \code{level}.}

\item{annotation}{An annotation dataframe indicating the nontargeting controls in the geneID column.}

\item{geneSymb}{The \code{geneSymbol} identifier(s) in \code{annotation} that corresponds to gRNAs to be plotted on the curves. 
If the provided value is not present in the \code{geneSymbol}, nontargeting controls will be plotted instead.}

\item{lib.size}{An optional vector of voom-appropriate library size adjustment factors, usually calculated with \code{\link[edgeR]{calcNormFactors}} 
and transformed to reflect the appropriate library size. These adjustment factors are interpreted as the total library sizes for each sample, 
and if absent will be extrapolated from the columnwise count sums of the \code{exprs} slot of the \code{eset}.}
}
\value{
A waterfall plot as specified, on the default device.
}
\description{
This function median scales and log2 transforms the raw gRNA count data contained in an ExpressionSet, 
and then plots the ordered expression values within each replicate. The curve colors are assigned based on a user-
specified column of the pData contained in the ExpressionSet. Optionally, this function can plot the location of Nontargeting control 
guides (or any guides, really) within the distribution.
}
\examples{
data('es')
data('ann')

#Build the sample key
library(Biobase)
sk <- ordered(relevel(as.factor(pData(es)$TREATMENT_NAME), 'ControlReference'))
names(sk) <- row.names(pData(es))

ct.gRNARankByReplicate(es, sk, ann, 'Target1377')
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generateReports.R
\name{ct.makeReport}
\alias{ct.makeReport}
\title{Generate a full experimental report from a pooled CRISPR screen}
\usage{
ct.makeReport(
  fit,
  eset,
  sampleKey,
  annotation,
  results,
  aln,
  outdir = NULL,
  contrast.term = NULL,
  identifier = NULL
)
}
\arguments{
\item{fit}{An object of class \code{MArrayLM} containing, at minimum, a \code{coefficents} slot with coefficients from the comparison,
and a \code{stdev.unscaled} slot with the corresponding standard deviation of the coefficent estimates. The \code{row.names} attribute
should ideally match that which is found in \code{annotation}, but this will be checked internally.}

\item{eset}{An ExpressionSet object containing, at minimum, a matrix of gRNA abundances extractable with the \code{exprs()} function and some named
phenodata extractable with \code{pData()}.}

\item{sampleKey}{A sample key, supplied as an ordered factor linking the samples to experimental
variables. The \code{names} attribute should exactly match those present in \code{eset}, and the control set is assumed to be
the first \code{level}.}

\item{annotation}{An annotation object for the experiment. See the man page for \code{ct.prepareAnnotation()} for details and example format.}

\item{results}{A data.frame summarizing the results of the screen, returned by the function \code{\link{ct.generateResults}}.}

\item{aln}{A numeric alignment matrix, where rows correspond to 'targets', 'nomatch', 'rejections', and 'double_match', and where columns 
correspond to experimentasl samples. Users may also pass `NULL` to suppress evaluation of alignment.}

\item{outdir}{A directory in which to generate the report; if \code{NULL}, a temporary directory will be automatically generated. 
The report will be located in a subdirectory whose name is internally generated (see below). The path to the report itself is returned by the function.}

\item{contrast.term}{A parameter passed to \code{ct.preprocessFit} in the event that the fit object contains data from multiple contrasts. See
that man page for further details.}

\item{identifier}{A character string to name the report and corresponding subdirectories. If provided, the final report will be called
'\code{identifier}.html' and will be located in a directory called \code{identifier} in the \code{outdir}. If \code{NULL}, a generic name 
including the timestamp will be generated.}
}
\value{
The path to the generated html report.
}
\description{
This is a function to generate an html report for a CRISPR screen, incorporating information about a specified contrast. 
The report contains a combination of experiment-level and contrast-specific analyses, largely collected from other functions in 
\code{gCrisprTools}. It is designed to be used 'as-is', and analysts interested in using different functionalities of the various 
functions should do that outside of this wrapper script.
}
\examples{
data('fit')
data('es')

##' #Build the sample key
library(Biobase)
sk <- relevel(as.factor(pData(es)$TREATMENT_NAME), 'ControlReference')
names(sk) <- row.names(pData(es))

data('ann')
data('resultsDF')
data('aln')
path2report <- ct.makeReport(fit, es, sk, ann, resultsDF, aln, outdir = '.') 
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/annotations.R
\name{ct.parseGeneSymbol}
\alias{ct.parseGeneSymbol}
\title{Parse `geneSymbol` values to construct an alternative annotation list}
\usage{
ct.parseGeneSymbol(ann, format = c("cellecta", "underscore"))
}
\arguments{
\item{ann}{A \code{data.frame} containing reagent-level information encoded as rows. The `ID` column should correspond to the individual 
reagent identifiers, and the 'geneSymbol' column should contain target annotation strings to be parsed (both are coerced to strings). 
Does not, strictly speaking, need to be a proper annotation object, but one of those will work.}

\item{format}{Format of the geneSymbol column strings.}
}
\value{
A named `alt.annotation`-type list of character vectors encoding the target mappings for each reagent
}
\description{
This is an accessory function to `ct.expandAnnotation()` function, which enables users to expand annotation objects 
to accomodate reagent libraries where reagents are expected to impact a set of known targets. See documentation for that function for 
additional details. 

Often, libraries that contain multiply-targeting reagents are annotated using a structured format that can be decomposed by regex matching. 
This function takes in an annotation object containing an `ID` column indicating the reagent ID and a `geneSymbol` column containing the 
target mappings, and parses the target mappings according to a known annotation format. Currently supported formats are 'cellecta' 
(e.g., 'TARGET_P1P2P3' indicating multiple promoters associated with a known target), and 'underscore', where different targets are 
concatenated using the underscore separator (e.g., 'TARGET1_TARGET2_TARGET3').

Returns an `alt.annotation`-type list of character vectors encoding the target mappings for each reagent.
}
\examples{
fakeann <- data.frame('ID' = LETTERS[1:4], 'geneSymbol' = c('T1_P1', 'T1_P1P2', 'T1_P2P1', 'T1_P2'))
ct.parseGeneSymbol(fakeann, 'cellecta')
ct.parseGeneSymbol(fakeann, 'underscore')
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gCrisprTools.R
\docType{data}
\name{ann}
\alias{ann}
\title{Annotation file for a mouse Crispr library}
\source{
Genentech, Inc.
}
\description{
Example annotation file for the screen data provided in \code{es}. 
All sample, gRNA, and Gene information has been anonymized and randomized.
}
\examples{
data('ann')
head(ann)
}
\seealso{
Please see \file{vignettes/Crispr_example_workflow.R} for details.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GuideCDF.R
\name{ct.guideCDF}
\alias{ct.guideCDF}
\title{View CDFs of the ranked gRNAs or Targets present in a crispr screen}
\usage{
ct.guideCDF(eset, sampleKey = NULL, plotType = "gRNA", annotation = NULL)
}
\arguments{
\item{eset}{An ExpressionSet  object containing, at minimum, a matrix of gRNA abundances extractable with the exprs() function.}

\item{sampleKey}{An optional sample key, supplied as an ordered factor linking the samples to experimental 
variables. The \code{names} attribute should exactly match those present in \code{eset}, and the control set is assumed to be 
the first \code{level}.}

\item{plotType}{A string indicating whether the individual guides should be displayed ('\code{gRNA}'), or if they should be aggregated into target-level
estimates ('\code{Target}') according to the \code{geneSymbol} column in the \code{annotation} object.}

\item{annotation}{An optional data.frame containing an annotation object to be used to aggregate the guides into targets. gRNAs are annotated by row, 
and must minimally contain a column \code{geneSymbol} indicating the target elements.}
}
\value{
A CDF plot displaying the appropriate CDF curves on the default device.
}
\description{
This function generates a plot relating the cumulative proportion of reads in each sample of a crispr screen to the abundance rank of the 
underlying guides (or Targets). The purpose of this algorithm is to detect potential distortions in the library composition 
that might not be properly controlled by sample normalization (see also: \code{ct.stackedGuides()}).
}
\examples{
data('es')
ct.guideCDF(es)
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generateReports.R
\name{ct.makeQCReport}
\alias{ct.makeQCReport}
\title{Generate a QC report from a pooled CRISPR screen}
\usage{
ct.makeQCReport(
  eset,
  trim,
  log2.ratio,
  sampleKey,
  annotation,
  aln,
  identifier = NULL,
  lib.size,
  geneSymb = NULL,
  outdir = NULL
)
}
\arguments{
\item{eset}{An ExpressionSet object containing, at minimum, a matrix of gRNA
abundances extractable with the \code{exprs()} function and some named 
phenodata extractable with \code{pData()}.}

\item{trim}{The number of gRNAs to be trimmed from the top of the 
distribution before estimating the abundance range. Empirically, this 
usually should be equal to about 2 to 5 percent of the guides in the 
library.}

\item{log2.ratio}{Maximum abundance of contaminant gRNAs, expressed on the
log2 scale from the top of the trimmed range of each sample. That is,
\code{log2.ratio = 4} means to discard all gRNAs whose abundance is
(1/2)^4 of the trimmed maximum.}

\item{sampleKey}{A sample key, supplied as an ordered factor linking the 
samples to experimental variables. The \code{names} attribute should 
exactly match those present in \code{eset}, and the control set is assumed
to be the first \code{level}.}

\item{annotation}{An annotation object for the experiment. See the man page 
for \code{ct.prepareAnnotation} for details and example format.}

\item{aln}{A numeric alignment matrix, where rows correspond to 'targets', 
'nomatch', 'rejections', and 'double_match', and where columns correspond 
to experimentasl samples. May be `NULL`, to suppress alignment evaluation.}

\item{identifier}{A character string to name the report and corresponding 
subdirectories. If provided, the final report will be called 
'\code{identifier}.html' and will be located in a directory called 
\code{identifier}. If \code{NULL}, a generic name including the timestamp 
will be generated.}

\item{lib.size}{An optional vector of voom-appropriate library size adjustment factors, usually calculated with \code{\link[edgeR]{calcNormFactors}} 
and transformed to reflect the appropriate library size. These adjustment factors are interpreted as the total library sizes for each sample, 
and if absent will be extrapolated from the columnwise count sums of the \code{exprs} slot of the \code{eset}.}

\item{geneSymb}{The \code{geneSymbol} identifier(s) in \code{annotation} 
that corresponds to gRNAs to be plotted on the curves. Passed through to 
\code{\link{ct.gRNARankByReplicate}}, \code{\link{ct.viewControls}} and 
\code{\link{ct.prepareAnnotation}} (as \code{controls} argument if it's
not \code{NULL}). Default \code{NULL}.}

\item{outdir}{An optional character string indicating the directory in which
to generate the report. If \code{NULL}, a temporary directory will be
automatically generated.}
}
\value{
The path to the generated html report.
}
\description{
This is a function to generate an html QC report for a CRISPR 
  screen, focusing on experiment-level and library-level analyses collected 
  from other functions in \code{gCrisprTools}. It is designed to be used 
  'as-is', and analysts interested in using different functionalities of the
  various functions should do that outside of this wrapper script.
}
\examples{
data('es')
data('ann')
data('aln')

##' #Build the sample key
library(Biobase)
sk <- ordered(relevel(as.factor(pData(es)$TREATMENT_NAME), 'ControlReference'))
names(sk) <- row.names(pData(es))

path2report <- ct.makeQCReport(es, trim = 1000, log2.ratio = 0.0625, sk, ann, aln, identifier = NULL, lib.size = NULL, geneSymb = 'NoTarget', outdir = '.') 
}
\author{
Russell Bainer, Dariusz Ratman
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gCrisprTools.R
\docType{data}
\name{aln}
\alias{aln}
\title{Precalculated alignment statistics of a crispr screen}
\source{
Genentech, Inc.
}
\description{
Example alignment matrix file for the provided example Crispr screen.
All sample, gRNA, and Gene information has been anonymized and randomized.
}
\examples{
data('aln')
head(aln)
}
\seealso{
Please see \file{vignettes/Crispr_example_workflow.R} for details.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sparrow_integration.R
\name{ct.GREATdb}
\alias{ct.GREATdb}
\title{Update a gene-centric msdb object for GREAT-style enrichment analysis using a specified CRISPR annotation.}
\usage{
ct.GREATdb(
  annotation,
  gsdb = sparrow::getMSigGeneSetDb(collection = c("h", "c2"), species = "human", id.type
    = "ensembl"),
  minsize = 10,
  ...
)
}
\arguments{
\item{annotation}{an annotation object returned by \code{ct.prepareAnnotation()}.}

\item{gsdb}{A gene-centric \code{GeneSetDb} object to conform to the relevant peakwise dataset.}

\item{minsize}{Minimum number of targets required to consider a geneset valid for analysis.}

\item{...}{Additional arguments to be passed to `ct.prepareAnnotation()`.}
}
\value{
A new \code{GeneSetDb} object with the features annotated genewise to pathways.
}
\description{
Update a gene-centric `GeneSetDb` object for GREAT-style enrichment analysis using a specified annotation.

Often, pooled screening libraries are constructed such that the gene targets of interest are associated 
with variable numbers of semi-independent screen signals (associated with, e.g., sets of alternative promoters 
or cis regulatory units). Such an arrangement is often unavoidable but produces to complications when 
performing gene set enrichent analyses. This function conforms a standard `GeneSetDb` object to appropriately 
consider this form of ultiple testing during ontological enrichment analyses according to the GREAT strategy
outlined by [McLean et al. (2009)](https://doi.org/10.1038/nbt.1630).

Operationally, this means that genewise sets in the provided object will be translated to the corresponding 
`geneSymbol` sets provided in the annotation file.
}
\examples{
data(resultsDF)
data(ann)
gsdb <- ct.GREATdb(ann, gsdb = sparrow::getMSigGeneSetDb(collection = 'h', species = 'human', id.type = 'entrez'))
show(sparrow::featureIds(gsdb))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fileutilities.R
\name{initOutDir}
\alias{initOutDir}
\title{Initializes the output directory}
\usage{
initOutDir(outdir)
}
\arguments{
\item{outdir}{character vector pointing to a directory to check/create}
}
\value{
TRUE if the output directory was created, otherwise FALSE (it might
already exist).
}
\description{
If outdir is NULL, then no directory is checked/created. This also implies
that creating plots is not possible.
}
\author{
Steve Lianoglou, Russell Bainer
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ViewGuides.R
\name{ct.drawFlat}
\alias{ct.drawFlat}
\title{Draw a horizontal line of a specified color.}
\usage{
ct.drawFlat(x, y, color, width = 1)
}
\arguments{
\item{x, y}{Minimal coordinates to specify the line, which is drawn from the Y axis.}

\item{color}{Guess!}

\item{width}{Line width.}
}
\value{
A line on an open device.
}
\description{
This is a function called internally by ct.viewGuides to generate the color legend. End users should not use it.
}
\author{
Russell Bainer
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ViewGuides.R
\name{ct.viewGuides}
\alias{ct.viewGuides}
\title{Generate a Plot of individual gRNA Pair Data in a Crispr Screen}
\usage{
ct.viewGuides(
  gene,
  fit,
  ann,
  type = "geneSymbol",
  contrast.term = NULL,
  ylims = NULL
)
}
\arguments{
\item{gene}{the name of the target element of interest, contained within the 'type' column of the annotation file.}

\item{fit}{An object of class MArrayLM containing, at minimum, an 'Amean' slot containing the guide level abundances, 
a 'coefficients' slot containing the effect estimates for each guide, and an 'stdev.unscaled' slot giving the coefficient standard Deviations.}

\item{ann}{A data.frame object containing the gRNA annotations. 
At mimimum, it should have a column with the name specified by the \code{type} argument, containing the element targeted by each guide.}

\item{type}{A character string indicating the column in ann containing the target of interest.}

\item{contrast.term}{If a fit object with multiple coefficients is passed in, a string indiating the coefficient of interest.}

\item{ylims}{An optional numeric vector of length 2 indicating the extremes of the y-axis scale.}
}
\value{
An image summarizing gRNA behavior within the specifed gene on the default device.
}
\description{
This function generates a visualization of the effect estimates from a MArrayLM model result for all of the 
individual guides targeting a particular element, specified somewhere in the library annotation file. The estimated effect 
size and variance is plotted relative to zero for the specified contrast, with the color of the dot indicating the relative scale of the
of the guide intercept within the model framework, with warmer colors indicating lowly expressed guides. For comparison, the density of gRNA 
fold change estimates is privided in a pane on the right, with white lines indicating the exact levels of the individual guides.
}
\examples{
data('fit')
data('ann')
ct.viewGuides('Target1633', fit, ann)
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gCrisprTools.R
\docType{data}
\name{essential.genes}
\alias{essential.genes}
\title{Artificial list of 'essential' genes in the example Crispr screen 
included for plotting purposes}
\source{
Russell Bainer
}
\description{
Example gene list, designed to demonstrate functions using gene lists.
All sample, gRNA, and Gene information has been anonymized and randomized.
}
\examples{
data('essential.genes')
essential.genes
}
\seealso{
Please see \file{vignettes/Crispr_example_workflow.R} for details.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fileutilities.R
\name{ct.regularizeContrasts}
\alias{ct.regularizeContrasts}
\title{Regularize Two Screening Results Objects}
\usage{
ct.regularizeContrasts(dflist, collapse = c("geneSymbol", "geneID"))
}
\arguments{
\item{dflist}{A list of results dataframes. Names will be preserved.}

\item{collapse}{Column of the provided resultsDFs on which to collapse values; should be `geneSymbol` or `geneID`.}
}
\value{
A list of the in-register `simpleResult` objects, with length and names identical to `dflist`.
}
\description{
This function prepares multiple `gCrisprTools` results dataframes for comparison. Specifically, 
it checks that all provided data frames are valid result objects, converts each to the target-wise `simpleResult` format, 
removes signals that are not shared by all objects, places their rows in identical order, and then returns the simplified dataframes as a list. 

This function is largely meant to be used by other gCrisprtools functions, although there are occasions when an analyst may want to call it directly. 
Often, it is useful to pass the `collapse` argument to `ct.simpleresult()` in cases where libraries and technologies differ between screens.
}
\examples{
data('resultsDF')
lapply(ct.regularizeContrasts(list('df1' = resultsDF[1:300,], 'df2' = resultsDF[200:400,])), nrow)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ViewTopTargets.R
\name{ct.topTargets}
\alias{ct.topTargets}
\title{Display the log2 fold change estimates and associated standard deviations of the guides targeting the top 
candidates in a crispr screen}
\usage{
ct.topTargets(
  fit,
  summaryDF,
  annotation,
  targets = 10,
  enrich = TRUE,
  contrast.term = NULL
)
}
\arguments{
\item{fit}{An object of class \code{MArrayLM} containing, at minimum, a \code{coefficents} slot with coefficients from the comparison, 
and a \code{stdev.unscaled} slot with the corresponding standard deviation of the coefficent estimates. The \code{row.names} attribute 
should ideally match that which is found in \code{annotation}.}

\item{summaryDF}{A data.frame summarizing the results of the screen, returned by the function \code{\link{ct.generateResults}}.}

\item{annotation}{An annotation object for the experiment. gRNAs are annotated by 
row, and must minimally contain a column \code{geneSymbol}.}

\item{targets}{Either the number of top targets to display, or a list of \code{geneSymbol}s contained in the \code{geneSymbol} 
slot of the \code{annotation} object.}

\item{enrich}{Logical indicating whether to display guides that are enriched (default) or depleted within the screen. If a vector of 
\code{geneSymbol}s is specified, this controls the left-t0-right ordering of the corresponding gRNAs.}

\item{contrast.term}{If a fit object with multiple coefficients is passed in, a string indiating the coefficient of interest.}
}
\value{
An image on the default device indicating each gRNA's log2 fold change and the unscaled standard deviation of the effect estimate, 
derived from the \code{MArrayLM} object.
}
\description{
This is a function for displaying candidates from a crispr screen, using the information summarized 
in the corresponding \code{fit} and the output from \code{ct.generateResults()}. The fold change and standard deviation 
estimates for each gRNA associated with each target (extracted from the \code{coefficients} and \code{stdev.unscaled} slot 
of \code{fit}) are plotted on the y axis. Targets are selected on the basis of their gene-level enrichment or depletion 
P-values; in the case of ties, they are ranked on the basis of their corresponding Rho statistics.
}
\examples{
data('fit')
data('resultsDF')
data('ann')

ct.topTargets(fit, resultsDF, ann) 
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/annotations.R
\name{ct.prepareAnnotation}
\alias{ct.prepareAnnotation}
\title{Check and optionally subset an annotation file for use in a Crispr Screen}
\usage{
ct.prepareAnnotation(ann, object = NULL, controls = TRUE, throw.error = TRUE)
}
\arguments{
\item{ann}{A \code{data.frame} containing an annotation object with gRNA-level information encoded as rows. The 
\code{row.names} attribute should correspond to the individual gRNAs, and it should at minimum contain columns 
named 'geneID' and 'geneSymbol' indicating the corresponding gRNA target gene ID and symbol, respectively.}

\item{object}{If supplied, an object with \code{row.names} to be used to subset the supplied annotation frame
for downstream analysis.}

\item{controls}{The name of a value in the \code{geneSymbol} column of \code{ann} that corresponds to nontargeting 
control gRNAs. May also be supplied as a logical value, in which case the function will try to identify and format 
nontargeting guides.}

\item{throw.error}{Logical indicating whether to throw an error when \code{controls} is \code{TRUE} but no nontargeting
gRNAs are detected.}
}
\value{
A new annotation data frame, usually with nontargeting controls and NA values reformatted to \code{NoTarget} 
(and \code{geneID} set to \code{'no_gid'}),  and the 'geneSymbol' column of \code{ann} factorized. If supplied with 
an \code{object}, the gRNAs not present in the \code{object} will be omitted.
}
\description{
This function processes a supplied annotation object for use in a pooled screening experiment. 
Originally this was processed into something special, but now it essentially returns
the original annotation object in which the geneSymbol column has been factorized. This is primarily used 
internally during a call to the \code{ct.generateResults()} function. Also performs some minor functionality checking, 
and ensures that the reagent identifiers are present as an `ID` column (if absent, the row.names are used).

Valid annotations contain both `geneID` and `geneSymbol` columns. This is because there is often a distinction between
the official gene that is being targeted and a coherent set of gRNAs that make up a testing cohort. For example, 
multiple sets of guides may target distinct promoters, exons, or other entities that are expected to produce distinct 
biological phenomena related to the gene that should be interpreted separately. For this reason, the `geneID` column 
encodes the official gene designation (typically an ensembl or entrez gene identifier) while the `geneSymbol` column
contains a human-readable descriptor of the gRNA target (such as a gene symbol or promoter name). This mapping can be 
further expanded to incorporate mapping ambiguity via the `ct.expandAnnotation()` function.
}
\examples{
data('ann')
data('es')
es <- ct.filterReads(es)
newann <- ct.prepareAnnotation(ann, es)
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fileutilities.R
\name{dir.writable}
\alias{dir.writable}
\title{Checks that the directory provided is writable by the current user}
\usage{
dir.writable(path)
}
\arguments{
\item{path}{The path to a directory to check.}
}
\value{
\code{logical}, \code{TRUE} if \code{path} is writable by the
current user, otherise \code{FALSE}
}
\description{
This works by testing to put a temporary file into an already existing
directory
}
\author{
Steve Lianoglou
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GeneratePRC.R
\name{ct.PRC}
\alias{ct.PRC}
\title{Generate a Precision-Recall Curve from a CRISPR screen}
\usage{
ct.PRC(
  summaryDF,
  target.list,
  direction = c("enrich", "deplete"),
  plot.it = TRUE
)
}
\arguments{
\item{summaryDF}{A dataframe summarizing the results of the screen, returned by the function \code{\link{ct.generateResults}}.}

\item{target.list}{A character vector containing the names of the targets to be tested; by default these are assumed to be `geneID`s, 
but specifying `collapse=geneSymbol` enables setting on `geneSymbol` by passing that value through to `ct.simpleResult`.}

\item{direction}{Direction by which to order target signals (`enrich` or `deplete`).}

\item{plot.it}{Logical value indicating whether to plot the curves.}
}
\value{
A list containing the the x and y coordinates of the curve.
}
\description{
Given a set of targets of interest, this function generates a Precision Recall curve from the results of 
a CRISPR screen. Specifically, it orders the target elements in the screen in the specified direction, and then plots the recall 
rate (proportion of true targets identified) against the precision (proportion of identified targets that are true targets). 

Note that ranking statistics in CRISPR screens are (usually) permutation-based, and so some granularity in the rankings is expected. This 
function does a little extra work to ensure that hits are counted as soon as the requisite value of the ranking statistic is reached 
regardless of where the gene is located within the block of equally-significant genes. Functionally, this means that the drawn curve is
somewhat anticonservative in cases where the gene ranks are not well differentiated.
}
\examples{
data('resultsDF')
data('essential.genes') #Note that this is an artificial example.
pr <- ct.PRC(resultsDF, essential.genes, 'enrich')
str(pr)
}
\author{
Russell Bainer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Crispr_Enrichment_test.R
\name{ct.targetSetEnrichment}
\alias{ct.targetSetEnrichment}
\title{Run a (limited) Pathway Enrichment Analysis on the results of a Crispr experiment.}
\usage{
ct.targetSetEnrichment(
  summaryDF,
  targets,
  enrich = TRUE,
  ignore = "NoTarget",
  ...
)
}
\arguments{
\item{summaryDF}{A dataframe summarizing the results of the screen, returned by the function \code{\link{ct.generateResults}}. 
Internally coerced via `ct.simpleResult()`.}

\item{targets}{A character vector containing the names of the targets to be tested; by default these are assumed to be `geneID`s, 
but specifying `collapse=geneSymbol` enables setting on `geneSymbol` by passing that value through to `ct.simpleResult`.}

\item{enrich}{Logical indicating whether to consider guides that are enriched (default) or depleted within the screen.}

\item{ignore}{Optionally, a character vector containing elements of the \code{summaryDF} that should be ignored in the analysis 
(e.g., unassignable or nonfunctional targets, such as nontargeting controls). By default, this function omits targets with 
\code{geneSymbol} 'NoTarget'.}

\item{...}{Additional parameters to pass to `ct.simpleResult`.}

\item{pvalue.cutoff}{A gene-level p-value cutoff defining targets of interest within the screen. Note that this is a
nominal p-value cutoff to preserve end-user flexibility.}

\item{organism}{The species of the cell line used in the screen; currently only 'human' or 'mouse' are supported.}

\item{db.cut}{Minimum number of genes annotated to a given to a pathway within the screen in order to consider it in the enrichment test.}

\item{species}{The species of the cells used in the screen. Currently only 'human' or 'mouse' are supported.}
}
\value{
A dataframe of enriched pathways.

A named list of pathways from \code{PANTHER.db}.

A named list containing the tested target set and tables detailing the hypergeometric test results using various P-value and
Q-value thresholds.
}
\description{
This function enables some limited geneset enrichment-type analysis of data derived from a pooled Crispr
screen using the PANTHER pathway database. Specifically, it identifies the set of targets significantly enriched or
depleted in a \code{summaryDF} object returned from \code{ct.generateResults} and compares that set to the remaining
targets in the screening library using a hypergeometric test.

Note that many Crispr gRNA libraries specifically target biased sets of genes, often focusing on genes involved
in a particular pathway or encoding proteins with a shared biological property. Consequently, the enrichment results
returned by this function represent the pathways containing genes disproportionately targeted *within the context
of the screen*, and may or may not be informative of the underlying biology in question. This means that
pathways not targeted by a Crispr library will obviously never be enriched within the positive target set regardless of
their biological relevance, and pathways enriched within a focused library screen are similarly expected to partially
reflect the composition of the library and other confounding issues (e.g., number of targets within a pathway).
Analysts should therefore use this function with care. For example, it might be unsurprising to detect pathways related
to histone modification within a screen employing a crispr library targeting epigenetic regulators.

This is a function that invokes the \link[PANTHER.db]{PANTHER.db} Bioconductor library to extract a list of pathway mappings
to be used in gene set enrichment tests. Specifically, the function returns a named list of pathways, where each element contains
Entrez IDs. Users should not generally call this function directly as it is invoked internally by the higher-level
\code{ct.PantherPathwayEnrichment()} function.

This function takes in a \code{resultsDF} and a vector of \code{targets} (contained in the \code{geneID} column of
\code{resultsDF}) and determines whether the specified targets are enriched within the set of all significantly altered targets.
It does this by iteratively testing whether \code{targets} are more likely to be among the set of enriched or depleted targets
at various significance thresholds using a hypergeometric test. Note that the returned Hypergeometric P-values are not corrected
for multiple testing.

Returns a list detailing the \code{targets} used in the tests, and tables indicating the results of the hypergeometric test
at various significance thresholds.
}
\examples{
data(resultsDF)
tar <-  sample(unique(resultsDF$geneSymbol), 20)
res <- ct.targetSetEnrichment(resultsDF, tar)
}
\author{
Russell Bainer, Steve Lianoglou

Russell Bainer, Steve Lianoglou.

Russell Bainer
}
\keyword{internal}
